(* ::Package:: *)

(* ::Title:: *)
(*AlignedGraphicsGrid*)


(* ::Section:: *)
(*Reference*)


(* ::Subsection:: *)
(*Title*)


(* ::Text:: *)
(*AlignedGraphicsGrid.m*)


(* ::Subsection:: *)
(*Author*)


(* ::Text:: *)
(*Simon Rochester (simonkeys@yahoo.com)*)


(* ::Subsection:: *)
(*Summary*)


(* ::Text:: *)
(**)


(* ::Subsection:: *)
(*Copyright*)


(* ::Text:: *)
(*\[Copyright] Copyright 2007, Simon Rochester*)


(* ::Subsection:: *)
(*Notebook Version*)


(* ::Text:: *)
(*1.0*)


(* ::Subsection:: *)
(*Mathematica version*)


(* ::Text:: *)
(*6.0*)


(* ::Subsection:: *)
(*History*)


(* ::Text:: *)
(*Created 2007-9-17*)


(* ::Subsection:: *)
(*Keywords*)


(* ::Text:: *)
(**)


(* ::Section:: *)
(*Interface*)


(* ::Text:: *)
(*This part declares publicly visible symbols.*)


(* ::Subsection:: *)
(*Begin package context*)


BeginPackage["Graphics`AlignedGraphicsGrid`"]


(* ::Subsection:: *)
(*Usage messages*)


AlignedGraphicsGrid::usage=""


InnerPadding::usage=""


OuterPadding::usage=""


GridLabel::usage=""


GridLabelStyle::usage=""


GridLabelSpacing::usage=""


GridPlotLabel::usage=""


GridPlotLabelStyle::usage="The format is {labels,{x,y}}, where labels has the same dimensions as the array of plots."


MakeGridPlotLabel::usage=""


MassageGridLabels::usage=""


MakeGridLabel::usage=""


(* ::Subsection:: *)
(*Error messages*)


(* ::Section:: *)
(*Implementation*)


(* ::Subsection:: *)
(*Begin private context*)


Begin["`Private`"]


(* ::Subsection:: *)
(*AlignedGraphicsGrid*)


Options[AlignedGraphicsGrid]=Join[{InnerPadding->{{5.,5.},{5.,5.}},OuterPadding->{{72.,5.},{36.,5.}},ImageSize->3 72,Spacings->12,GridLabel->None,GridLabelStyle->{},GridLabelSpacing->{{50,5},{50,5}},GridPlotLabel->None,GridPlotLabelStyle->{}},DeleteCases[Options[Graphics],ImageSize]]


MassageGridLabels[gl_,{nx_,ny_}]:=Module[{gl1},
gl1=Replace[gl,{
b_/;Head[b]=!=List->{{b,Bottom}},
{b_,l_}/;(And@@((Head[#]=!=List)&/@{b,l}))&&!MemberQ[{Bottom,Top,Left,Right},l]->{{b,Bottom},{l,Left}},
{{l_,r_},{b_,t_}}/;(And@@((Head[#]=!=List)&/@{l,r,b,t}))&&And@@((!MemberQ[{Bottom,Top,Left,Right},#]&)/@{r,t})->{{b,Bottom},{l,Left},{t,Top},{r,Right}},
{b_,l_}/;(And@@((Head[#]=!=List)&/@{b,l}))&&MemberQ[{Bottom,Top,Left,Right},l]->{{b,l}}
}
];
gl1=Replace[#,{{l_,s:Bottom|Top}->{l,s,{1,nx}},{l_,s:Left|Right}->{l,s,{1,ny}}}]&/@gl1;
gl1=Replace[#,{{l_,s_,r_}->{l,s,r,0,0},{l_,s_,r_,p1_}->{l,s,r,p1,0}}]&/@gl1;
gl1=Replace[#,{l_,s_,r_/;Head[r]=!=List,p_,o_}->{l,s,{r,r},p,o}]&/@gl1;
gl1=Replace[#,{l_,s_,r_,p_/;Head[p]=!=List,o_}->{l,s,r,{p,0},o}]&/@gl1;
gl1=Replace[#,{l_,s_,r_,p_,o_/;Head[o]=!=List}->{l,s,r,p,{o,0}}]&/@gl1
]



MakeGridLabel[{lab_,side_,{r1_,r2_},{pos1_,pos2_},{off1_,off2_}},{{xl_,xr_},{yb_,yt_}},{{loff_,roff_},{boff_,toff_}}]:=Module[{p,dir},
{p,dir}=Switch[side,
Left,{{First[xl]-loff-off1,(yb[[r1]]+yt[[r2]])/2-pos1 (yb[[r1]]-yt[[r2]])/2},{0,1}},
Right,{{Last[xr]+roff+off1,(yb[[r1]]+yt[[r2]])/2-pos1 (yb[[r1]]-yt[[r2]])/2},{0,1}},
Bottom,{{(xl[[r1]]+xr[[r2]])/2-pos1 (xl[[r1]]-xr[[r2]])/2,First[yb]-boff-off1},{1,0}},
Top,{{(xl[[r1]]+xr[[r2]])/2-pos1 (xl[[r1]]-xr[[r2]])/2,Last[yt]+toff+off1},{1,0}}
];
Text[lab,p,{pos2,off2},dir]
]


MakeGridPlotLabel[{lab_,{x_,y_},align_:{0,0}},{{xl_,xr_},{yb_,yt_}}]:=Table[Text[lab[[j,i]],{xl[[i]]+x (xr[[i]]-xl[[i]]),yb[[j]]+y (yt[[j]]-yb[[j]])},align],{i,Length[xl]},{j,Length[yb]}]


AlignedGraphicsGrid[input_,opts:OptionsPattern[]]:=Module[{gr,ar,is,w,h,nx,ny,s,sx,sy,lab,pr,ol,or,ob,ot,il,ir,ib,it,yb,yt,xl,xr,iis,ip,gplab},
	{gr,op}=Transpose[Map[If[Head[#]=!=List,{#,{}},{First[#],Rest[#]}]&,Reverse[input],{2}],{2,3,1}];
	{ny,nx}=Dimensions[gr];
	(*ar--2d array of aspect ratios*)
	ar=Map[AspectRatio/.AbsoluteOptions[#,AspectRatio]&,gr,{2}];
	(*pr--array of PlotRanges*)
	pr=Map[(PlotRange/.AbsoluteOptions[#,PlotRange])&,gr,{2}];
	(*sx (sy)--list of nx-1 x (ny-1 y) spacings*)
	s=OptionValue@Spacings;
	{sx,sy}=If[NumericQ[s],{s,s},s];
	{sx,sy}=MapThread[If[NumericQ[#1],Table[#1,{#2-1}],#1]&,{{sx,sy},{nx,ny}}];
	(*is--total image width, currently needs to be given explicitly*)
	is=OptionValue@ImageSize;
	lab=OptionValue@GridLabel;
	gplab=OptionValue@GridPlotLabel;
	{{ol,or},{ob,ot}}=OptionValue@OuterPadding;
	{{il,ir},{ib,it}}=OptionValue@InnerPadding;
	(*iis--image width minus left and right padding*)
	iis=is-ol-or;
	(*w--list of widths of the plots in each row. They're all the same: total width minus all horizontal padding and spacing and divided by nx*)
	w=(iis-Total[sx])/nx Table[1,{nx}];
	(*h--list of heights of the plots in each column. Use the aspect ratios of the first column and the width of the first column.*)
	h=ar[[All,1]] w[[1]];
	(*Find outer coordinates of each plot.*)
	yb=Prepend[Accumulate[Most[h]+sy],0];
	yt=Accumulate[h+Prepend[sy,0]];
	xl=Prepend[Accumulate[Most[w]+sx],0];
	xr=Accumulate[w+Prepend[sx,0]];
	Graphics[
	MapIndexed[(ip=Padding/.op[[#2[[1]],#2[[2]]]]/.Padding->{{If[#2[[2]]===1,ol,il],If[#2[[2]]===nx,or,ir]},{If[#2[[1]]===1,ob,ib],If[#2[[1]]===ny,ot,it]}};
	Inset[
	Show[#1,PlotRangePadding->None,ImagePadding->ip],{xl[[#2[[2]]]],yb[[#2[[1]]]]},pr[[Sequence@@#2,All,1]],w[[#2[[2]]]]+Total@ip[[1]]])&,
	gr,{2}],
	ImageSize->is,PlotRange->{{0,iis},{0,Last@yt}},AspectRatio->Last@yt/iis,ImagePadding->OptionValue[OuterPadding],
		Epilog->{
			OptionValue[Epilog],
			Style[If[lab=!=None,MakeGridLabel[#,Evaluate@{{xl,xr},{yb,yt}},OptionValue[GridLabelSpacing]]&/@MassageGridLabels[lab,{nx,ny}],{}],OptionValue[GridLabelStyle]],
			Style[If[gplab=!=None,MakeGridPlotLabel[MapAt[Reverse,gplab,1],Evaluate@{{xl,xr},{yb,yt}}],{}],OptionValue[GridPlotLabelStyle]]
		},
	FilterRules[{opts},Options[Graphics]]]
]


(* ::Subsection:: *)
(*End the private context*)


End[]


(* ::Section:: *)
(*Epilog*)


(* ::Text:: *)
(*This section protects exported symbols and ends the package.*)


(* ::Subsection:: *)
(*Protect exported symbols*)


(*Protect[Evaluate[$Context<>"*"]]*)


(* ::Subsection:: *)
(*End the package context*)


EndPackage[]
