(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     51656,       1581]
NotebookOptionsPosition[     43119,       1298]
NotebookOutlinePosition[     43520,       1315]
CellTagsIndexPosition[     43477,       1312]
WindowFrame->Normal
ContainsDynamic->False*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Usage Messages", "Title"],

Cell[CellGroupData[{

Cell["Reference", "Section"],

Cell["Title", "Subsection"],

Cell["Authors", "Subsection"],

Cell["Summary", "Subsection"],

Cell["Copyright", "Subsection"],

Cell["Notebook Version", "Subsection"],

Cell[TextData[{
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " version"
}], "Subsection"],

Cell["History", "Subsection"],

Cell["Keywords", "Subsection"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Messing with System` symbols", "Section"],

Cell[CellGroupData[{

Cell["Information[] bug", "Subsection"],

Cell[TextData[{
 "Fix for general ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " bug in Information[]. "
}], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"System`Dump`fixmessagestring", "[", "System`Dump`s_", "]"}], ":=", 
  
  RowBox[{"ToString", "@", 
   RowBox[{"InputForm", "@", "System`Dump`s"}]}]}]], "Input",
 InitializationCell->True],

Cell["Original Definition:", "Text"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{"System`Dump`fixmessagestring", "[", "System`Dump`s_", "]"}], ":=",
    
   RowBox[{"\"\<\\\"\>\"", "<>", 
    RowBox[{"StringReplace", "[", 
     RowBox[{"System`Dump`s", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"\"\<\\n\>\"", "\[Rule]", "\"\<\\\\n\>\""}], ",", 
        RowBox[{"\"\<\\\\\>\"", "\[Rule]", "\"\<\\\\\\\\\>\""}], ",", 
        RowBox[{"\"\<\\\"\>\"", "\[Rule]", "\"\<\\\\\\\"\>\""}]}], "}"}]}], 
     "]"}], "<>", "\"\<\\\"\>\""}]}], "*)"}]], "Input",
 InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Overload WignerD", "Subsection"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{"Unprotect", " ", "WignerD", " ", "if", " ", "defined"}], 
  "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"If", "[", 
  RowBox[{
   RowBox[{"$VersionNumber", "\[GreaterEqual]", "8."}], ",", 
   RowBox[{
    RowBox[{"Unprotect", "[", "WignerD", "]"}], ";", 
    RowBox[{"WignerD", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "1", ",", "1"}], "}"}], ",", "0"}], "]"}]}], ",", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"DownValues", "[", "WignerD", "]"}], "\[Equal]", 
      RowBox[{"{", "}"}]}], ",", 
     RowBox[{"Remove", "[", "WignerD", "]"}]}], "]"}]}], "]"}]], "Input",
 InitializationCell->True]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Interface", "Section"],

Cell["This part declares publicly visible symbols.", "Text"],

Cell[CellGroupData[{

Cell["Begin package context", "Subsection"],

Cell[BoxData[
 RowBox[{"BeginPackage", "[", "\"\<AtomicDensityMatrix`\>\"", "]"}]], "Input",\

 InitializationCell->True],

Cell[BoxData[
 RowBox[{"Unprotect", "[", 
  RowBox[{"Evaluate", "[", 
   RowBox[{"$Context", "<>", "\"\<*\>\""}], "]"}], "]"}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{"Needs", "[", "\"\<VectorAnalysis`\>\"", "]"}], "*)"}]], "Input",
 InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Usage messages for AtomicData.m", "Subsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"AtomicData", "::", "usage"}], "=", 
   "\"\<AtomicData[state,type] gives data of the requested type for the \
atomic state specified. AtomicData[type] gives a list of atomic states in the \
database for which information of the specified type is available.  \
AtomicData[state] gives any information on state of types specified in the \
global variable $AtomicDataFields.\>\""}], "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"AtomicTransition", "::", "usage"}], "=", 
   "\"\<AtomicTransition[\\!\\(\\*\nStyleBox[\\\"atom\\\", \\\"TI\\\"]\\),\\!\
\\(\\*\nStyleBox[\\\"line\\\", \\\"TI\\\"]\\)]\n returns the designations of \
the two states involved in the transition specified by the strings \\!\\(\\*\n\
StyleBox[\\\"atom\\\", \\\"TI\\\"]\\) and \\!\\(\\*\nStyleBox[\\\"line\\\", \
\\\"TI\\\"]\\).\>\""}], "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"$AtomicDataFields", "::", "usage"}], "=", 
   "\"\<$AtomicDataFields contains a list of data types (fields) in the \
AtomicData database.\>\""}], "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ElementName", "::", "usage"}], "=", 
  "\"\<ElementName is a type of data for AtomicData, giving the name of the \
element.\>\""}]}], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"ElementSymbol", "::", "usage"}], "=", "\"\<\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"AtomicNumber", "::", "usage"}], "=", "\"\<\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"AtomicWeight", "::", "usage"}], "=", "\"\<\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"Abundance", "::", "usage"}], "=", "\"\<\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"Wavenumber", "::", "usage"}], "=", 
  "\"\<Wavenumber[state] returns the spectroscopic wavenumber \
\!\(\*OverscriptBox[\(\[Nu]\), \(_\)]\) = \[Omega]/(2\[Pi]c).\>\""}]], "Input",\

 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"DopplerWidth", "::", "usage"}], "=", "\"\<\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"MostProbableSpeed", "::", "usage"}], "=", "\"\<\>\""}]], "Input",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Usage messages for AtomicSystem.m", "Subsection",
 InitializationGroup -> True],

Cell[BoxData[
 RowBox[{
  RowBox[{"AtomicState", "::", "usage"}], "=", 
  "\"\<AtomicState[\\!\\(\\*\nStyleBox[\\\"label\\\", \\\"TI\\\"]\\)] \
represents an atomic state labeled by \\!\\(\\*\nStyleBox[\\\"label\\\", \
\\\"TI\\\"]\\).\nAtomicState[\\!\\(\\*\nStyleBox[\\\"label\\\", \
\\\"TI\\\"]\\),\\!\\(\\*SubscriptBox[\nStyleBox[\\\"param\\\", \\\"TI\\\"], \
\\\"1\\\"]\\)->\\!\\(\\*SubscriptBox[\nStyleBox[\\\"value\\\", \\\"TI\\\"], \
\\\"1\\\"]\\),\\!\\(\\*SubscriptBox[\nStyleBox[\\\"param\\\", \\\"TI\\\"], \\\
\"2\\\"]\\)->\\!\\(\\*SubscriptBox[\nStyleBox[\\\"value\\\", \\\"TI\\\"], \
\\\"2\\\"]\\),\[Ellipsis]] represents an atomic state with specified values \
for one or more state parameters.\nPossible state parameters are S, L, J, \
NuclearSpin, F, M, Parity, Energy, NaturalWidth, GFactor, BranchingRatio, \
HyperfineA, HyperfineB, and Polarizability.\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"GroundStates", "::", "usage"}], "=", "\"\<GroundStates[\!\(\*
StyleBox[\"sys\", \"TI\"]\)] returns the list of AtomicState objects from \
atomic system \!\(\*
StyleBox[\"sys\", \"TI\"]\) for which GroundStateQ gives True.\>\""}]], \
"Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"ExcitedStates", "::", "usage"}], "=", "\"\<ExcitedStates[\!\(\*
StyleBox[\"sys\", \"TI\"]\)] returns the list of AtomicState objects from \
atomic system \!\(\*
StyleBox[\"sys\", \"TI\"]\) for which GroundStateQ gives False.\>\""}]], \
"Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"StateMatchQ", "::", "usage"}], "=", "\"\<\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"StatePosition", "::", "usage"}], "=", "\"\<StatePosition[\!\(\*
StyleBox[\"sys\", \"TI\"]\),\!\(\*
StyleBox[\"crit\", \"TI\"]\)] returns the positions of the AtomicState \
objects in the atomic system \!\(\*
StyleBox[\"sys\", \"TI\"]\) whose parameters satisfy the boolean expression \
\!\(\*
StyleBox[\"crit\", \"TI\"]\). The parameter \!\(\*
StyleBox[\"crit\", \"TI\"]\) is specified in the form, e.g, \
StateLabel==2&&F==3. If all the states with a particular label are desired, \
the shorthand StatePosition[sys,label] can be used.\>\""}], 
  " "}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"True", " ", "but", " ", 
    RowBox[{
    "deprecated", ":", " ", 
     "\"\<The criteria can also be specified using Rule in place of Equal, \
and if multiple criteria are specified they must all be satisfied. Thus, for \
example, StatePosition[sys,StateLabel==2&&F==3], \
StatePosition[sys,StateLabel->2&&F->3], and \
StatePosition[sys,StateLabel->2,F->3] are all equivalent.\>\""}]}], 
   "*)"}]}]}], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"SelectStates", "::", "usage"}], "=", "\"\<SelectStates[\!\(\*
StyleBox[\"sys\", \"TI\"]\),\!\(\*
StyleBox[\"crit\", \"TI\"]\)] returns the list of the AtomicState objects in \
the atomic system \!\(\*
StyleBox[\"sys\", \"TI\"]\) whose parameters satisfy the boolean expression \
\!\(\*
StyleBox[\"crit\", \"TI\"]\). The parameter \!\(\*
StyleBox[\"crit\", \"TI\"]\) is specified in the form, e.g, \
StateLabel==2&&F==3. If all the states with a particular label are desired, \
the shorthand StatePosition[sys,label] can be used.\n\nSelectStates[\!\(\*
StyleBox[\"sys\", \"TI\"]\),\!\(\*
StyleBox[\"crit\", \"TI\"]\),\!\(\*
StyleBox[\"n\", \"TI\"]\)] returns the first \!\(\*
StyleBox[\"n\", \"TI\"]\) AtomicStates whose parameters satisfy \!\(\*
StyleBox[\"crit\", \"TI\"]\).\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"SelectState", "::", "usage"}], "=", "\"\<SelectState[\!\(\*
StyleBox[\"sys\", \"TI\"]\),\!\(\*
StyleBox[\"crit\", \"TI\"]\)] is equivalent to SelectStates[\!\(\*
StyleBox[\"sys\", \"TI\"]\),\!\(\*
StyleBox[\"crit\", \"TI\"]\),1\!\(\*
StyleBox[\"]\", \"TI\"]\).\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"DeleteStates", "::", "usage"}], "=", "\"\<DeleteStates[\!\(\*
StyleBox[\"sys\", \"TI\"]\),\!\(\*
StyleBox[\"crit\", \"TI\"]\)] deletes the AtomicState objects from the atomic \
system \!\(\*
StyleBox[\"sys\", \"TI\"]\) whose parameters satisfy the boolean expression \
\!\(\*
StyleBox[\"crit\", \"TI\"]\). The parameter \!\(\*
StyleBox[\"crit\", \"TI\"]\) is specified in the form, e.g, \
StateLabel==2&&F==3. If all the states with a particular label are desired, \
the shorthand StatePosition[sys,label] can be used.\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"SublevelMultiplicity", "::", "usage"}], "=", 
  "\"\<SublevelMultiplicity[\!\(\*
StyleBox[\"state\", \"TI\"]\)], where \!\(\*
StyleBox[\"state\", \"TI\"]\) is an AtomicState object, returns the number of \
magnetic sublevels corresponding to the F, J, and NuclearSpin quantum numbers \
of \!\(\*
StyleBox[\"state\", \"TI\"]\). If F is defined, (2F+1) is returned; otherwise \
(2J+1)(2NuclearSpin+1) is returned, where NuclearSpin is assumed to be zero \
if it is not defined.\n\nSublevelMultiplicity[\!\(\*
StyleBox[\"system\", \"TI\"]\)], where \!\(\*
StyleBox[\"system\", \"TI\"]\) is a list of AtomicState objects, returns the \
total number of unique magnetic sublevels of all of the states, as given by J \
and NuclearSpin of each AtomicState. Any F quantum numbers that may be \
defined are ignored, and only one AtomicState corresponding to each unique \
StateLabel is considered.\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"F", "::", "usage"}], "=", 
  "\"\<F is a parameter specified in an AtomicState expression that specifies \
the total angular momentum (electronic plus nuclear) for the state. The value \
must be integer or half-integer.\nF[\\!\\(\\*\nStyleBox[\\\"state\\\", \\\"TI\
\\\"]\\)] returns the value specified for F in AtomicState \\!\\(\\*\n\
StyleBox[\\\"state\\\", \\\"TI\\\"]\\), or J[\\!\\(\\*\n\
StyleBox[\\\"state\\\", \\\"TI\\\"]\\)] if it is not specified.\>\""}]], \
"Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"M", "::", "usage"}], "=", 
  "\"\<M is a parameter specified in an AtomicState expression that specifies \
the z-projection of the total angular momentum for the state. The value must \
be integer or half-integer.\nM[\\!\\(\\*\nStyleBox[\\\"state\\\", \\\"TI\\\"]\
\\)] returns the value specified for M in AtomicState \\!\\(\\*\n\
StyleBox[\\\"state\\\", \\\"TI\\\"]\\), or M[StateLabel[\\!\\(\\*\n\
StyleBox[\\\"state\\\", \\\"TI\\\"]\\)]] if it is not specified.\>\""}]], \
"Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"Polarizability", "::", "usage"}], "=", 
  "\"\<Polarizability[\\!\\(\\*\nStyleBox[\\\"k\\\", \\\"TI\\\"]\\)] is a \
parameter specified in an AtomicState expression that specifies the scalar \
(\\!\\(\\*\nStyleBox[\\\"k\\\", \\\"TI\\\"]\\)=0), vector (\\!\\(\\*\n\
StyleBox[\\\"k\\\", \\\"TI\\\"]\\)=1), or tensor (\\!\\(\\*\nStyleBox[\\\"k\\\
\", \\\"TI\\\"]\\)=2) polarizability for the state. The value can be numeric \
or symbolic. \nPolarizability[\\!\\(\\*\nStyleBox[\\\"k\\\", \\\"TI\\\"]\\)][\
\\!\\(\\*\nStyleBox[\\\"state\\\", \\\"TI\\\"]\\)] returns the corresponding \
specified value for the polarizability of AtomicState \\!\\(\\*\n\
StyleBox[\\\"state\\\", \\\"TI\\\"]\\), or Polarizability[\\!\\(\\*\n\
StyleBox[\\\"k\\\", \\\"TI\\\"]\\)][StateLabel[\\!\\(\\*\n\
StyleBox[\\\"state\\\", \\\"TI\\\"]\\)]] if it is not specified.\>\""}]], \
"Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"GFactor", "::", "usage"}], "=", 
  "\"\<GFactor is a parameter specified in an AtomicState expression that \
specifies the g-factor for the state.\nGFactor[\\!\\(\\*\n\
StyleBox[\\\"state\\\", \\\"TI\\\"]\\)] returns the value specified for F in \
AtomicState \\!\\(\\*\nStyleBox[\\\"state\\\", \\\"TI\\\"]\\), or \
GFactor[StateLabel[\\!\\(\\*\nStyleBox[\\\"state\\\", \\\"TI\\\"]\\)]] if it \
is not specified.\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"TransitionPolarizability", "::", "usage"}], "=", 
  "\"\<\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"BranchingRatio", "::", "usage"}], "=", 
  "\"\<BranchingRatio[\\!\\(\\*\nStyleBox[\\\"label\\\", \\\"TI\\\"]\\)] is a \
parameter specified in an AtomicState expression that specifies the branching \
ratio to another state with label \\!\\(\\*\nStyleBox[\\\"label\\\", \\\"TI\\\
\"]\\).\nBranchingRatio[\\!\\(\\*\nStyleBox[\\\"label\\\", \
\\\"TI\\\"]\\)][\\!\\(\\*\nStyleBox[\\\"state\\\", \\\"TI\\\"]\\)] returns \
the value specified for the branching ratio to the state with label \\!\\(\\*\
\nStyleBox[\\\"label\\\", \\\"TI\\\"]\\)\\!\\(\\*\nStyleBox[\\\" \\\", \\\"TI\
\\\"]\\)in AtomicState \\!\\(\\*\nStyleBox[\\\"state\\\", \\\"TI\\\"]\\), or \
BranchingRatio[\\!\\(\\*\nStyleBox[\\\"label\\\", \\\"TI\\\"]\\)][StateLabel[\
\\!\\(\\*\nStyleBox[\\\"state\\\", \\\"TI\\\"]\\)]] if it is not specified.\>\
\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"GroundStateQ", "::", "usage"}], "=", 
  "\"\<GroundStateQ[\\!\\(\\*\nStyleBox[\\\"state\\\", \\\"TI\\\"]\\)] \
returns True if NaturalWidth[\\!\\(\\*\nStyleBox[\\\"state\\\", \
\\\"TI\\\"]\\)] is zero, and False otherwise.\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"LevelPosition", "::", "usage"}], "=", "\"\<\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"t", "::", "usage"}], "=", 
  "\"\<t is the default value for the option TimeVariable in DensityMatrix \
and other functions.\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"StateLabel", "::", "usage"}], "=", 
  "\"\<StateLabel[\\!\\(\\*\nStyleBox[\\\"state\\\", \\\"TI\\\"]\\)] returns \
the label (the first argument) for the AtomicState \\!\\(\\*\n\
StyleBox[\\\"state\\\", \\\"TI\\\"]\\).\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"StateParameters", "::", "usage"}], "=", 
  "\"\<StateParameters[\\!\\(\\*\nStyleBox[\\\"state\\\", \\\"TI\\\"]\\)] \
returns the state parameters of the AtomicState \\!\\(\\*\nStyleBox[\\\"state\
\\\", \\\"TI\\\"]\\).\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"MapOnParameters", "::", "usage"}], "=", "\"\<\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"StateParameterPattern", "::", "usage"}], "=", 
  "\"\<\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"StateParameterQ", "::", "usage"}], "=", 
  "\"\<StateParameterQ[\\!\\(\\*\nStyleBox[\\\"expr\\\", \\\"TI\\\"]\\)] \
returns True if \\!\\(\\*\nStyleBox[\\\"expr\\\", \\\"TI\\\"]\\) is a valid \
parameter for an AtomicState expression, and False otherwise.\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"AtomicSystemQ", "::", "usage"}], "=", 
  "\"\<AtomicSystemQ[\\!\\(\\*\nStyleBox[\\\"expr\\\", \\\"TI\\\"]\\)] \
returns True if \\!\\(\\*\nStyleBox[\\\"expr\\\", \\\"TI\\\"]\\) is a list of \
AtomicState objects, and False otherwise.\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"DefinedQ", "::", "usage"}], "=", 
  "\"\<DefinedQ[\\!\\(\\*\nStyleBox[\\\"state\\\", \\\"TI\\\"]\\),\\!\\(\\*\n\
StyleBox[\\\"param\\\", \\\"TI\\\"]\\)] returns True if state parameter \
\\!\\(\\*\nStyleBox[\\\"param\\\", \\\"TI\\\"]\\) is specified in AtomicState \
\\!\\(\\*\nStyleBox[\\\"state\\\", \\\"TI\\\"]\\), and False otherwise.\n\
DefinedQ[\\!\\(\\*\nStyleBox[\\\"state\\\", \
\\\"TI\\\"]\\),{\\!\\(\\*SubscriptBox[\nStyleBox[\\\"param\\\", \\\"TI\\\"], \
\\\"1\\\"]\\),\\!\\(\\*SubscriptBox[\nStyleBox[\\\"param\\\", \\\"TI\\\"], \\\
\"2\\\"]\\),\[Ellipsis]}] returns True if all of the \\!\\(\\*\n\
StyleBox[SubscriptBox[\\\"param\\\", \\\"i\\\"], \\\"TI\\\"]\\) are specified \
in \\!\\(\\*\nStyleBox[\\\"state\\\", \\\"TI\\\"]\\), and False otherwise.\n\
DefinedQ[{\\!\\(\\*SubscriptBox[\nStyleBox[\\\"state\\\", \\\"TI\\\"], \
\\\"1\\\"]\\),\\!\\(\\*SubscriptBox[\nStyleBox[\\\"state\\\", \\\"TI\\\"], \\\
\"2\\\"]\\),\[Ellipsis]},\\!\\(\\*\nStyleBox[\\\"param\\\", \\\"TI\\\"]\\)] \
checks if \\!\\(\\*\nStyleBox[\\\"param\\\", \\\"TI\\\"]\\) is specified in \
all of the states.\nDefinedQ behaves analogously with region parameters and \
regions in place of state parameters and states.\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"DeleteParameter", "::", "usage"}], "=", 
  "\"\<DeleteParameter[\\!\\(\\*\nStyleBox[\\\"state\\\", \
\\\"TI\\\"]\\),\\!\\(\\*\nStyleBox[\\\"param\\\", \\\"TI\\\"]\\)] deletes any \
specification for state parameter \\!\\(\\*\nStyleBox[\\\"param\\\", \\\"TI\\\
\"]\\) from the AtomicState \\!\\(\\*\nStyleBox[\\\"state\\\", \
\\\"TI\\\"]\\).\nIf a list of states is supplied, the parameter is deleted \
from all of the states. If a list of parameters is supplied, all of the \
parameters are deleted.\nDeleteParameter behaves analogously with region \
parameters and regions in place of state parameters and states.\>\""}]], \
"Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"AddParameter", "::", "usage"}], "=", 
  "\"\<AddParameter[\\!\\(\\*\nStyleBox[\\\"state\\\", \
\\\"TI\\\"]\\),\\!\\(\\*\nStyleBox[\\\"param\\\", \\\"TI\\\"]\\)->\\!\\(\\*\n\
StyleBox[\\\"value\\\", \\\"TI\\\"]\\)] adds the supplied parameter \
specification to AtomicState \\!\\(\\*\nStyleBox[\\\"state\\\", \
\\\"TI\\\"]\\), or replaces the existing specification.\nAddParameter behaves \
analogously with region parameters and regions in place of state parameters \
and states.\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"ReplaceMatrixElement", "::", "usage"}], "\"\<\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetSystemType", "::", "usage"}], "=", "\"\<\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"AtomicSystemType", "::", "usage"}], "=", "\"\<\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"LevelLabel", "::", "usage"}], "=", "\"\<\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"SublevelLabel", "::", "usage"}], "=", "\"\<\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"HyperfineSublevels", "::", "usage"}], "=", 
  "\"\<HyperfineSublevels[{\\!\\(\\*SubscriptBox[\nStyleBox[\\\"state\\\", \\\
\"TI\\\"], \\\"1\\\"]\\),\\!\\(\\*SubscriptBox[\nStyleBox[\\\"state\\\", \
\\\"TI\\\"], \\\"2\\\"]\\),\[Ellipsis]}] returns a list of AtomicState \
objects in which each \\!\\(\\*\nStyleBox[SubscriptBox[\\\"state\\\", \\\"i\\\
\"], \\\"TI\\\"]\\) that has a specified J and NuclearSpin parameter has been \
expanded into states representing each hyperfine sublevel of the \
state.\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"ZeemanSublevels", "::", "usage"}], "=", 
  "\"\<Sublevels[{\\!\\(\\*SubscriptBox[\nStyleBox[\\\"state\\\", \
\\\"TI\\\"], \\\"1\\\"]\\),\\!\\(\\*SubscriptBox[\nStyleBox[\\\"state\\\", \\\
\"TI\\\"], \\\"2\\\"]\\),\[Ellipsis]}] returns a list of AtomicState objects \
in which each \\!\\(\\*\nStyleBox[SubscriptBox[\\\"state\\\", \\\"i\\\"], \
\\\"TI\\\"]\\) that has a specified J or F parameter has been expanded into \
states representing each Zeeman sublevel of the state.\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"Sublevels", "::", "usage"}], "=", 
  "\"\<Sublevels[{\\!\\(\\*SubscriptBox[\nStyleBox[\\\"state\\\", \
\\\"TI\\\"], \\\"1\\\"]\\),\\!\\(\\*SubscriptBox[\nStyleBox[\\\"state\\\", \\\
\"TI\\\"], \\\"2\\\"]\\),\[Ellipsis]}] returns a list of AtomicState objects \
in which each \\!\\(\\*\nStyleBox[SubscriptBox[\\\"state\\\", \\\"i\\\"], \
\\\"TI\\\"]\\) that has a specified J and NuclearSpin parameter has been \
expanded into states representing each hyperfine sublevel of the state, and \
each state that has a specified J or F parameter has been expanded into \
states representing each Zeeman sublevel of the state.\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"RemoveZeemanSublevels", "::", "usage"}], "=", 
  "\"\<RemoveZeemanSublevels[\\!\\(\\*\nStyleBox[\\\"syst\\\", \
\\\"TI\\\"]\\)] replaces sublists of the atomic system (list of AtomicState \
objects) \\!\\(\\*\nStyleBox[\\\"syst\\\", \\\"TI\\\"]\\) that are identical \
apart from their M value with a single state with no M value \
specified.\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"ZeemanSystem", "::", "usage"}], "=", 
  "\"\<ZeemanSystem[\\!\\(\\*\nStyleBox[\\\"j\\\", \\\"TI\\\"]\\)] returns a \
list of AtomicState objects describing the Zeeman sublevels of an atomic \
system with angular momentum \\!\\(\\*\nStyleBox[\\\"j\\\", \\\"TI\\\"]\\).\n\
ZeemanSystem[\\!\\(\\*\nStyleBox[\\\"label\\\", \\\"TI\\\"]\\),\\!\\(\\*\n\
StyleBox[\\\"j\\\", \\\"TI\\\"]\\)] provides a specific label for the \
AtomicState objects.\>\""}]], "Input",
 InitializationCell->True],

Cell[CellGroupData[{

Cell["Other messages for AtomicSystem.m", "Subsubsection",
 InitializationGroup -> True],

Cell[BoxData[
 RowBox[{
  RowBox[{"AtomicSystemType", "::", "difftypes"}], "=", 
  "\"\<All atomic states in the system are not of the same type, `1`, as the \
first state.\>\""}]], "Input",
 InitializationCell->True]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Usage messages for DensityMatrix.m", "Subsection",
 InitializationGroup -> True],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"DMElementPattern", "::", "usage"}], "=", "\"\<\>\""}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"DMElementPartPattern", "::", "usage"}], "=", "\"\<\>\""}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"DMElement", "::", "usage"}], "=", "\"\<\>\""}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"DMElementPart", "::", "usage"}], "=", "\"\<\>\""}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Subscripts", "::", "usage"}], "=", "\"\<\>\""}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"M1", "::", "usage"}], "=", "\"\<\>\""}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"M2", "::", "usage"}], "=", "\"\<\>\""}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"F1", "::", "usage"}], "=", "\"\<\>\""}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"F2", "::", "usage"}], "=", "\"\<\>\""}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"DMLabel", "::", "usage"}], "=", "\"\<\>\""}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"TimeDerivative", "::", "usage"}], "=", "\"\<\>\""}], 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"StateLabel1", "::", "usage"}], "=", "\"\<\>\""}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StateLabel2", "::", "usage"}], "=", "\"\<\>\""}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"ReImPart", "::", "usage"}], "=", "\"\<\>\""}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"State1", "::", "usage"}], "=", "\"\<\>\""}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"State2", "::", "usage"}], "=", "\"\<\>\""}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Time", "::", "usage"}], "=", "\"\<\>\""}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"LevelLabelPattern", "::", "usage"}], "=", "\"\<\>\""}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"LevelLabelPattern1", "::", "usage"}], "=", "\"\<\>\""}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"LevelLabelPattern2", "::", "usage"}], "=", "\"\<\>\""}], 
  "\[IndentingNewLine]", "\n", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"LabelPattern", "::", "usage"}], "=", "\"\<\>\""}], "*)"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Ket", "::", "usage"}], "=", "\"\<\>\""}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"TimeDependence", "::", "usage"}], "=", "\"\<\>\""}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"DensityMatrix", "::", "usage"}], "=", 
   "\"\<DensityMatrix[sys] forms the density matrix for an atomic system \
(list of AtomicState objects) sys.\>\""}], "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"DMSymbol", "::", "usage"}], "=", "\"\<\>\""}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"ComplexExpandVariables", "::", "usage"}], "=", "\"\<\>\""}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"\[Rho]", "::", "usage"}], "=", 
   "\"\<Default variable used for the density matrix.\>\""}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"TimeVariable", "::", "usage"}], "=", "\"\<\>\""}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"DMVariables", "::", "usage"}], "=", "\"\<\>\""}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"ExpandDMVariablesRule", "::", "usage"}], "=", "\"\<\>\""}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"ExprToReIm", "::", "usage"}], "=", "\"\<\>\""}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Representation", "::", "usage"}], "=", "\"\<\>\""}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"ReImToSubscriptRule", "::", "usage"}], "=", "\"\<\>\""}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"ReImFromSubscriptRule", "::", "usage"}], "=", "\"\<\>\""}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{"ERI", "::", "usage"}], "=", "\"\<\>\""}], "\n"}], "Input",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Usage messages for PolarizationMoments.m", "Subsection",
 InitializationGroup -> True],

Cell[CellGroupData[{

Cell["Tensor decomposition", "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Decomposition", "::", "usage"}], "=", "\"\<\>\""}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Recomposition", "::", "usage"}], "=", "\"\<\>\""}], "\n"}], "\n", 
 RowBox[{
  RowBox[{"PolarizationMatrices", "::", "usage"}], "=", 
  "\"\<\>\""}]}], "Input",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Angular momentum probability distribution", "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"\[Rho]JJ", "::", "usage"}], "=", "\"\<\>\""}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"MaxProjectionProbability", "::", "usage"}], "=", "\"\<\>\""}], 
  "\n"}], "\n", 
 RowBox[{
  RowBox[{"AMPSPlot", "::", "usage"}], "=", "\"\<\>\""}], "\n"}], "Input",
 InitializationCell->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Usage messages for OpticalField.m", "Subsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"standardizeField", "::", "usage"}], "=", "\"\<\>\""}], 
  "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"OpticalField", "::", "usage"}], "=", "\"\<\>\""}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"PolarizationVector", "::", "usage"}], "=", "\"\<\>\""}], 
  "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"PropagationVector", "::", "usage"}], "=", "\"\<\>\""}], 
  "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"CartesianCoordinates", "::", "usage"}], "=", "\"\<\>\""}], 
  "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Parameterization", "::", "usage"}], "=", "\"\<\>\""}], 
  "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"ReparameterizeField", "::", "usage"}], "=", "\"\<\>\""}], 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{"If", "[", 
  RowBox[{
   RowBox[{"!", 
    RowBox[{"MemberQ", "[", 
     RowBox[{
      RowBox[{"Contexts", "[", "]"}], ",", "\"\<VectorAnalysis`\>\""}], 
     "]"}]}], ",", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Xx", "::", "usage"}], "=", "\"\<\>\""}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Yy", "::", "usage"}], "=", "\"\<\>\""}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Zz", "::", "usage"}], "=", "\"\<\>\""}], ";"}]}], 
  "\[IndentingNewLine]", "]"}]}], "Input",
 InitializationCell->True],

Cell[CellGroupData[{

Cell["Other messages for OpticalField.m", "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"OpticalField", "::", "trans"}], "=", 
  "\"\<PolarizationVector `1` must be transverse to PropagationVector \
`2`.\>\""}]], "Input"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Usage messages for Hamiltonian.m", "Subsection",
 InitializationGroup -> True],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Energies", "::", "usage"}], "=", "\"\<\>\""}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"TransitionFrequencies", "::", "usage"}], "=", "\"\<\>\""}], 
  "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Hamiltonian", "::", "usage"}], "=", "\"\<\>\""}], "\n", "\n", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"ElectricField", "::", "usage"}], "=", 
    RowBox[{
    "\"\<\>\"", " ", "Declaration", " ", "moved", " ", "to", " ", 
     "Common`"}]}], "*)"}], "\n", "\n", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"MagneticField", "::", "usage"}], "=", 
    RowBox[{
    "\"\<\>\"", " ", "Declaration", " ", "moved", " ", "to", " ", 
     "Common`"}]}], "*)"}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Interaction", "::", "usage"}], "=", "\"\<\>\""}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Internal", "::", "usage"}], "=", "\"\<\>\""}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"E1", "::", "usage"}], "=", "\"\<\>\""}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Magnetic", "::", "usage"}], "=", "\"\<\>\""}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"InternalHamiltonian", "::", "usage"}], "=", "\"\<\>\""}], 
  "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"E1Hamiltonian", "::", "usage"}], "=", "\"\<\>\""}], "\n"}], "\n", 

 RowBox[{
  RowBox[{
   RowBox[{"MagneticHamiltonian", "::", "usage"}], "=", "\"\<\>\""}], 
  "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"PolarizabilityHamiltonian", "::", "usage"}], "=", "\"\<\>\""}], 
  "\n"}], "\n", 
 RowBox[{
  RowBox[{"TransitionPolarizabilityHamiltonian", "::", "usage"}], "=", 
  "\"\<\>\""}], "\n"}], "Input",
 InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Usage messages for RotatingWaveApproximation.m", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"EffectiveHamiltonian", "::", "usage"}], "=", 
  "\"\<EffectiveHamiltonian[h,u,t] returns the effective Hamiltonian \
corresponding to the Hamiltonian h under a (possibly time dependent) \
transformation u, assuming time variable t.\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"DropFastTerms", "::", "usage"}], "=", 
  "\"\<DropFastTerms[expr,omega,t] sets terms in expr sinusoidally \
oscillating at twice the frequency omega (assuming time variable t) to zero.\n\
DropFastTerms[expr,{\!\(\*SubscriptBox[\(omega\), \
\(1\)]\),\!\(\*SubscriptBox[\(omega\), \(2\)]\),...},t] drops terms \
oscillating at twice any of the \!\(\*SubscriptBox[\(omega\), \
\(i\)]\).\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"ReturnFrequencyReplacements", "::", "usage"}], 
  "\"\<\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"RotatingWaveTransformMatrix", "::", "usage"}], "=", 
  "\"\<\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"RotatingWaveTransform", "::", "usage"}], "=", 
  "\"\<\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"TransformMatrix", "::", "usage"}], "=", 
  "\"\<TransformMatrix is an option for RotatingWaveApproximation and related \
functions that can be used to explicitly specify the unitary transformation \
to the rotating frame.\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"DMFromRotatingDM", "::", "usage"}], "=", "\"\<\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"RotatingWaveApproximation", "::", "usage"}], "=", 
  "\"\<RotatingWaveApproximation[sys,h,{\[Omega],tr}] performs the \
rotating-wave approximation on a Hamiltonian h for an atomic system sys \
subject to an optical field with angular frequency \[Omega] acting on \
transitions tr. Transitions are specified by \!\(\*SubscriptBox[\(crit\), \
\(lower\)]\)\[Rule]\!\(\*SubscriptBox[\(crit\), \(upper\)]\), where \
\!\(\*SubscriptBox[\(crit\), \(lower\)]\) and \!\(\*SubscriptBox[\(crit\), \
\(upper\)]\) are state selection criteria for the lower and upper states in \
the optical transition, specified as in the documentation for StatePosition. \
Each transition specification also accepts a list of transitions.\n\
RotatingWaveApproximation[sys,h,{{\!\(\*SubscriptBox[\(\[Omega]\), \
\(1\)]\),\!\(\*SubscriptBox[\(tr\), \
\(1\)]\)},{\!\(\*SubscriptBox[\(\[Omega]\), \
\(2\)]\),\!\(\*SubscriptBox[\(tr\), \(2\)]\)},...}] performs the RWA assuming \
multiple optical fields with angular frequencies \
\!\(\*SubscriptBox[\(\[Omega]\), \(i\)]\), acting on transitions \
\!\(\*SubscriptBox[\(tr\), \(i\)]\).\n\
RotatingWaveApproximation[sys,h,{{\!\(\*SubscriptBox[\(\[Omega]\), \
\(1\)]\),\!\(\*SubscriptBox[\(tr\), \(1\)]\),\!\(\*SubscriptBox[\(\
\[CapitalDelta]\), \(1\)]\)},{\!\(\*SubscriptBox[\(\[Omega]\), \
\(2\)]\),\!\(\*SubscriptBox[\(tr\), \(2\)]\),\!\(\*SubscriptBox[\(\
\[CapitalDelta]\), \(2\)]\)},...}] writes optical frequencies in terms of \
their detunings \!\(\*SubscriptBox[\(\[CapitalDelta]\), \(i\)]\) from \
resonance after performing the RWA.\n\
RotatingWaveApproximation[sys,h,\[Omega]] performs the RWA using an \
automatically generated transformation appropriate for a single optical \
field.\nRotatingWaveApproximation[sys,h,{\!\(\*SubscriptBox[\(\[Omega]\), \(1\
\)]\),\!\(\*SubscriptBox[\(\[Omega]\), \(2\)]\),...},TransformMatrix->u] \
performs the RWA using an explicity specified unitary transformation \
matrix.\>\""}]], "Input",
 InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Usage messages for LiouvilleEquation.m", "Subsection",
 InitializationGroup -> True],

Cell[CellGroupData[{

Cell["Relaxation and repopulation", "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"IntrinsicRelaxation", "::", "usage"}], "=", "\"\<\>\""}], 
  "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"TransitRelaxation", "::", "usage"}], "=", "\"\<\>\""}], 
  "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Relaxation", "::", "usage"}], "=", "\"\<\>\""}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"TransitRepopulation", "::", "usage"}], "=", 
   "\"\<TransitRepopulation[\\!\\(\\*\nStyleBox[\\\"sys\\\", \
\\\"TI\\\"]\\),\\!\\(\\*\nStyleBox[\\\"gamma\\\", \\\"TI\\\"]\\)] returns a \
matrix describing the appearence of unpolarized atoms in the ground state of \
atomic system \\!\\(\\*\nStyleBox[\\\"sys\\\", \\\"TI\\\"]\\) due to transit \
into the experimental volume at rate \\!\\(\\*\nStyleBox[\\\"gamma\\\", \
\\\"TI\\\"]\\). The ground states of sys are assumed to be those that have \
NaturalWidth->0. This matrix is suitable for use as an argument in the \
function LiouvileEquation.\>\""}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"OpticalRepopulationOperator", "::", "usage"}], "=", "\"\<\>\""}], 
  "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"OpticalRepopulation", "::", "usage"}], "=", "\"\<\>\""}], 
  "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"OpticalRepopulationPM", "::", "usage"}], "=", "\"\<\>\""}], 
  "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"OpticalRepopulationZ", "::", "usage"}], "=", "\"\<\>\""}], 
  "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"HyperfineCoherenceTransfer", "::", "usage"}], "=", "\"\<\>\""}], 
  "\n"}], "\n", 
 RowBox[{
  RowBox[{"Repopulation", "::", "usage"}], "=", "\"\<\>\""}], "\n"}], "Input",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["FluorescenceOperator", "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"FluorescenceOperator", "::", "\"\<usage\>\""}], "\n"}]], "Input",
 InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Density matrix evolution equation", "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"LiouvilleRHS", "::", "usage"}], "=", "\"\<\>\""}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"LiouvilleEquation", "::", "usage"}], "=", "\"\<\>\""}], 
  "\n"}], "\n", 
 RowBox[{
  RowBox[{"InitialConditions", "::", "usage"}], "=", 
  "\"\<\>\""}], "\n"}], "Input",
 InitializationCell->True]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Usage messages for Observables.m", "Subsection",
 InitializationGroup -> True],

Cell[CellGroupData[{

Cell["Solution of wave equation", "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"WaveEqnSolution", "::", "usage"}], "=", "\"\<\>\""}], 
  "\n"}]], "Input",
 InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Find dipole polarization", "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Observables", "::", "usage"}], "=", "\"\<\>\""}], "\n"}], "\n", 
 RowBox[{
  RowBox[{"PolarizationComponents", "::", "usage"}], "=", 
  "\"\<\>\""}], "\[IndentingNewLine]"}], "Input",
 InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["LinearAbsorption", "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Voigt", "::", "usage"}], "=", "\"\<\>\""}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"InternalEnergy", "::", "usage"}], "=", "\"\<\>\""}], 
  "\n"}], "\n", 
 RowBox[{
  RowBox[{"LinearAbsorption", "::", "usage"}], "=", 
  "\"\<\>\""}], "\n"}], "Input",
 InitializationCell->True]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Usage messages for ExperimentalSystem.m", "Subsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Region", "::", "usage"}], "=", "\"\<\>\""}], 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"TransitRate", "::", "usage"}], "=", "\"\<\>\""}], 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Void", "::", "usage"}], "=", "\"\<\>\""}], 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Density", "::", "usage"}], "=", "\"\<\>\""}], 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"OpticalParameters", "::", "usage"}], "=", "\"\<\>\""}], 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"RegionParameters", "::", "usage"}], "=", "\"\<\>\""}], 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"RegionParameterPattern", "::", "usage"}], "=", "\"\<\>\""}], 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"RegionParameterQ", "::", "usage"}], "=", "\"\<\>\""}], 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ExperimentalSystemQ", "::", "usage"}], "=", "\"\<\>\""}], 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SelectRegions", "::", "usage"}], "=", "\"\<\>\""}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"RegionLabel", "::", "usage"}], "=", "\"\<\>\""}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"SelectRegion", "::", "usage"}], "=", "\"\<\>\""}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"DeleteRegions", "::", "usage"}], "=", "\"\<\>\""}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{"RegionPosition", "::", "usage"}], "=", "\"\<\>\""}]}], "Input",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Usage messages for AtomicDensityMatrix.m", "Subsection",
 InitializationGroup -> True],

Cell[CellGroupData[{

Cell["Meta info", "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"$ADMVersion", "::", "usage"}], "=", 
  "\"\<$ADMVersion returns the version number of the AtomicDensityMatrix \
package.\>\""}]], "Input",
 InitializationCell->True]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Implementation", "Section"],

Cell[BoxData[
 RowBox[{"Begin", "[", "\"\<`Private`\>\"", "]"}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{"$ADMVersion", "=", "\"\<14.02.28\>\""}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{"End", "[", "]"}]], "Input",
 InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Epilog", "Section"],

Cell["This section protects exported symbols and ends the package.", "Text"],

Cell[CellGroupData[{

Cell["Protect exported symbols", "Subsection"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{"Protect", "[", 
   RowBox[{"Evaluate", "[", 
    RowBox[{"$Context", "<>", "\"\<*\>\""}], "]"}], "]"}], "*)"}]], "Input",
 InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["End the package context", "Subsection"],

Cell[BoxData[
 RowBox[{"EndPackage", "[", "]"}]], "Input",
 InitializationCell->True]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
AutoGeneratedPackage->Automatic,
WindowSize->{815, 814},
WindowMargins->{{6, Automatic}, {Automatic, 38}},
TrackCellChangeTimes->False,
FrontEndVersion->"6.0 for Microsoft Windows (64-bit) (May 21, 2008)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[590, 23, 31, 0, 83, "Title"],
Cell[CellGroupData[{
Cell[646, 27, 28, 0, 71, "Section"],
Cell[677, 29, 27, 0, 36, "Subsection"],
Cell[707, 31, 29, 0, 28, "Subsection"],
Cell[739, 33, 29, 0, 28, "Subsection"],
Cell[771, 35, 31, 0, 28, "Subsection"],
Cell[805, 37, 38, 0, 28, "Subsection"],
Cell[846, 39, 94, 4, 28, "Subsection"],
Cell[943, 45, 29, 0, 28, "Subsection"],
Cell[975, 47, 30, 0, 28, "Subsection"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1042, 52, 47, 0, 71, "Section"],
Cell[CellGroupData[{
Cell[1114, 56, 39, 0, 36, "Subsection"],
Cell[1156, 58, 124, 5, 29, "Text"],
Cell[1283, 65, 222, 6, 31, "Input",
 InitializationCell->True],
Cell[1508, 73, 36, 0, 29, "Text"],
Cell[1547, 75, 563, 14, 52, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[2147, 94, 38, 0, 36, "Subsection"],
Cell[2188, 96, 118, 3, 31, "Input"],
Cell[2309, 101, 561, 16, 52, "Input",
 InitializationCell->True]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[2919, 123, 28, 0, 71, "Section"],
Cell[2950, 125, 60, 0, 29, "Text"],
Cell[CellGroupData[{
Cell[3035, 129, 43, 0, 36, "Subsection"],
Cell[3081, 131, 121, 3, 31, "Input",
 InitializationCell->True],
Cell[3205, 136, 164, 4, 31, "Input",
 InitializationCell->True],
Cell[3372, 142, 132, 3, 31, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[3541, 150, 53, 0, 36, "Subsection"],
Cell[3597, 152, 1308, 26, 392, "Input",
 InitializationCell->True],
Cell[4908, 180, 123, 3, 31, "Input",
 InitializationCell->True],
Cell[5034, 185, 122, 3, 31, "Input",
 InitializationCell->True],
Cell[5159, 190, 122, 3, 31, "Input",
 InitializationCell->True],
Cell[5284, 195, 119, 3, 31, "Input",
 InitializationCell->True],
Cell[5406, 200, 243, 6, 31, "Input",
 InitializationCell->True],
Cell[5652, 208, 122, 3, 31, "Input",
 InitializationCell->True],
Cell[5777, 213, 127, 3, 31, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[5941, 221, 85, 1, 28, "Subsection"],
Cell[6029, 224, 914, 14, 252, "Input",
 InitializationCell->True],
Cell[6946, 240, 303, 7, 72, "Input",
 InitializationCell->True],
Cell[7252, 249, 306, 7, 72, "Input",
 InitializationCell->True],
Cell[7561, 258, 121, 3, 31, "Input",
 InitializationCell->True],
Cell[7685, 263, 1109, 25, 232, "Input",
 InitializationCell->True],
Cell[8797, 290, 855, 17, 152, "Input",
 InitializationCell->True],
Cell[9655, 309, 340, 8, 31, "Input",
 InitializationCell->True],
Cell[9998, 319, 598, 12, 112, "Input",
 InitializationCell->True],
Cell[10599, 333, 967, 17, 212, "Input",
 InitializationCell->True],
Cell[11569, 352, 541, 10, 172, "Input",
 InitializationCell->True],
Cell[12113, 364, 547, 10, 172, "Input",
 InitializationCell->True],
Cell[12663, 376, 925, 15, 292, "Input",
 InitializationCell->True],
Cell[13591, 393, 492, 9, 152, "Input",
 InitializationCell->True],
Cell[14086, 404, 137, 4, 31, "Input",
 InitializationCell->True],
Cell[14226, 410, 890, 14, 272, "Input",
 InitializationCell->True],
Cell[15119, 426, 302, 6, 72, "Input",
 InitializationCell->True],
Cell[15424, 434, 123, 3, 31, "Input",
 InitializationCell->True],
Cell[15550, 439, 204, 5, 52, "Input",
 InitializationCell->True],
Cell[15757, 446, 298, 6, 72, "Input",
 InitializationCell->True],
Cell[16058, 454, 297, 6, 72, "Input",
 InitializationCell->True],
Cell[16358, 462, 125, 3, 31, "Input",
 InitializationCell->True],
Cell[16486, 467, 134, 4, 31, "Input",
 InitializationCell->True],
Cell[16623, 473, 335, 6, 92, "Input",
 InitializationCell->True],
Cell[16961, 481, 313, 6, 72, "Input",
 InitializationCell->True],
Cell[17277, 489, 1284, 19, 372, "Input",
 InitializationCell->True],
Cell[18564, 510, 696, 12, 192, "Input",
 InitializationCell->True],
Cell[19263, 524, 559, 10, 172, "Input",
 InitializationCell->True],
Cell[19825, 536, 125, 3, 31, "Input",
 InitializationCell->True],
Cell[19953, 541, 123, 3, 31, "Input",
 InitializationCell->True],
Cell[20079, 546, 126, 3, 31, "Input",
 InitializationCell->True],
Cell[20208, 551, 120, 3, 31, "Input",
 InitializationCell->True],
Cell[20331, 556, 123, 3, 31, "Input",
 InitializationCell->True],
Cell[20457, 561, 583, 10, 152, "Input",
 InitializationCell->True],
Cell[21043, 573, 555, 9, 132, "Input",
 InitializationCell->True],
Cell[21601, 584, 698, 11, 172, "Input",
 InitializationCell->True],
Cell[22302, 597, 422, 8, 112, "Input",
 InitializationCell->True],
Cell[22727, 607, 519, 9, 152, "Input",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[23271, 620, 88, 1, 28, "Subsubsection"],
Cell[23362, 623, 217, 5, 52, "Input",
 InitializationCell->True]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[23628, 634, 86, 1, 28, "Subsection"],
Cell[23717, 637, 4324, 141, 1452, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[28078, 783, 92, 1, 28, "Subsection"],
Cell[CellGroupData[{
Cell[28195, 788, 45, 0, 28, "Subsubsection"],
Cell[28243, 790, 335, 10, 112, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[28615, 805, 66, 0, 22, "Subsubsection"],
Cell[28684, 807, 335, 10, 132, "Input",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[29068, 823, 55, 0, 28, "Subsection"],
Cell[29126, 825, 1348, 45, 392, "Input",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[30499, 874, 58, 0, 28, "Subsubsection"],
Cell[30560, 876, 167, 4, 31, "Input"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[30776, 886, 84, 1, 28, "Subsection"],
Cell[30863, 889, 1675, 54, 572, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[32575, 948, 68, 0, 36, "Subsection"],
Cell[32646, 950, 311, 6, 72, "Input",
 InitializationCell->True],
Cell[32960, 958, 463, 9, 92, "Input",
 InitializationCell->True],
Cell[33426, 969, 135, 4, 31, "Input",
 InitializationCell->True],
Cell[33564, 975, 140, 4, 31, "Input",
 InitializationCell->True],
Cell[33707, 981, 134, 4, 31, "Input",
 InitializationCell->True],
Cell[33844, 987, 301, 6, 72, "Input",
 InitializationCell->True],
Cell[34148, 995, 126, 3, 31, "Input",
 InitializationCell->True],
Cell[34277, 1000, 2019, 32, 332, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[36333, 1037, 90, 1, 36, "Subsection"],
Cell[CellGroupData[{
Cell[36448, 1042, 52, 0, 28, "Subsubsection"],
Cell[36503, 1044, 1657, 45, 552, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[38197, 1094, 45, 0, 22, "Subsubsection"],
Cell[38245, 1096, 127, 3, 52, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[38409, 1104, 58, 0, 28, "Subsubsection"],
Cell[38470, 1106, 344, 11, 132, "Input",
 InitializationCell->True]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[38863, 1123, 84, 1, 28, "Subsection"],
Cell[CellGroupData[{
Cell[38972, 1128, 50, 0, 28, "Subsubsection"],
Cell[39025, 1130, 148, 5, 52, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[39210, 1140, 49, 0, 28, "Subsubsection"],
Cell[39262, 1142, 258, 7, 92, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[39557, 1154, 41, 0, 28, "Subsubsection"],
Cell[39601, 1156, 333, 11, 132, "Input",
 InitializationCell->True]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[39983, 1173, 61, 0, 28, "Subsection"],
Cell[40047, 1175, 1684, 55, 552, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[41768, 1235, 92, 1, 28, "Subsection"],
Cell[CellGroupData[{
Cell[41885, 1240, 34, 0, 28, "Subsubsection"],
Cell[41922, 1242, 200, 5, 31, "Input",
 InitializationCell->True]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[42183, 1254, 33, 0, 71, "Section"],
Cell[42219, 1256, 101, 2, 31, "Input",
 InitializationCell->True],
Cell[42323, 1260, 101, 2, 31, "Input",
 InitializationCell->True],
Cell[42427, 1264, 78, 2, 31, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[42542, 1271, 25, 0, 71, "Section"],
Cell[42570, 1273, 76, 0, 29, "Text"],
Cell[CellGroupData[{
Cell[42671, 1277, 46, 0, 36, "Subsection"],
Cell[42720, 1279, 189, 5, 31, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[42946, 1289, 45, 0, 36, "Subsection"],
Cell[42994, 1291, 85, 2, 31, "Input",
 InitializationCell->True]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
