(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     88148,       2541]
NotebookOptionsPosition[     80865,       2321]
NotebookOutlinePosition[     83267,       2378]
CellTagsIndexPosition[     83181,       2373]
WindowFrame->Normal
ContainsDynamic->True *)

(* Beginning of Notebook Content *)
Notebook[{
Cell[" ", "SymbolColorBar",
 CellMargins->{{Inherited, Inherited}, {-5, 0}}],

Cell[TextData[{
 ButtonBox["AtomicDensityMatrix Package",
  BaseStyle->{"Link", "LinkTrail"},
  ButtonData->"paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"],
 StyleBox[" > ", "LinkTrailSeparator"]
}], "LinkTrail"],

Cell[BoxData[GridBox[{
   {
    StyleBox[
     GraphicsBox[RasterBox[CompressedData["
1:eJy9lulTk1cUxp+Zfu+Xfu5MO9O/oF90povj0A6dVtupdRsBqwRCg+DCqCxF
LLIIoUAIyGLayqJCFZRYVJaAaDBsQkBCEhaVoCjEBAiLTSLJ7bmX0nEBhZZ6
5mbmTebN/d3nnOec930/cN+mwLcAvEefD+jDr9nrwul0DvabbdaxuwNm++Ox
197/r8PQrY/bLwnyxYFvEL0F8TtwOiNq9IHFYDC4XK5VBGmvaXasg/QLRH6H
xABkBiFXhvw9fCVJP7LZbKsFemwdC1gP2ZdcjnwXCvag9BAuxOByHC4dQUU0
dBfzV4vV0aoL+4orOv49ckNRHo3qeDQehy4NzWnQpvCv/W2aRf+70vSeK8o/
+C0vkDIEZYdx5SfclKM9Az05MOai9wQ6FahLwJT9ObeQkaqrq3t7e1fESo+W
/LgV8t1QhfPU1Seh5WfczoY5D4Mn0V/AoSSwNkfidjnpfofDUVVVpVKpFArF
5OTkiliZMZJ4PyiCceYg/ohDUyq6stCXhzsqziIicXVyXriyVMnQoHnt2rV+
fn5paWkmk2lFIAptrfqYHzceJZBy1ZaObiUGCjirL5/nsDWdl+yXvfw8R3e8
EyYLIVBhYSEJfMW25F6HCKeI+R+npxzJOzmLEtiQhFuZvEzEouzps9CQzN1C
5s8IQroE4VvWJB2NLsqKP3U8vCI7ytypm0/syzExMaFWqxMTE2NjY0NDQ6VS
aVNTk8vpVMVLToZxq9cnclZvLsd1KDiFtFA1Y7aAtKfuflsRFXA+YSMdifzT
ks7PdjXV1/7IspS69vZ2uVyeLYKqbLFYGmursqUoO8RzRSwqUJcSJRGcsssH
gZ/zYULaC/fzapJVhn7F47MYPw/b77CVYlCFe83qpXDUFw0NDSUlJZRPo9FY
U1OTk5kWfzjsVOQ6qg7t1piMw5uw/VPs/gx7N/JhQiBy42gJZi/iaS3YdTAd
WBtYEzwaTJbj0a0lcez5TrxvGcpOOFCsiCOxOTEBcdu5HN7jm3k7kG2ou20X
4KqDpxXsNlgPmAmsD6xfXLdh5jK8Txev3cthHbHkhWLfRq6FRhY1OMmZ92db
BkbPYk4LZgS7BzYMZhHr/sIaBNPDZX6VtGeDJvDWT3iBwjZwM5yQ8ZLdSMGA
CvZyeBrE+Qn0QLCGwO6KixGwh+JHwg0vi3X6t/xtArTvayT4o/gAauLRmYVH
xXBWgmnAOsEMYunBugSXEnhHqBsRi9Cji4/NZ6MgK3Xrx7xAVB3qIz7b0/jQ
mD4PTzXYNbBWjrBW4mExZtXw1nNLcKhRyLEIgXThMC8ndTvXI3Yb0gNx+Sjv
rNHT+FMN1igo3VzIXD0myjB5DtMV8F5ZOECXcMggF2hvW+OcedUkoYcXGTvY
lzucZi+BqLlmKjB3FV6dOLlZ7Ebb3oRXAzeZrUak9IYwPN3QK264jYfmG0ql
UqfTud3uRVl1V9TkOrKcUoq6YzDlwVEBz3V42xfyc0eUhjbsAGsB04qlE/QO
oYv8b5Iw19+KZmdnl9JVVX7m0CZkSXmNqP2fXIS3UezQt+DqAZFDk/BGm8A1
i9Uivhqj2IiGzS2rrcI30OjGuUgYcmAthUcr0jK44K57mGp511r1ITdDI7xa
Pi68VKkWibs5io3pl0mZj+wjkuwf+AgdL8VcrUiLSfTmiOigHlSejLTb7XNP
HJ6pMc+4hdFkWPZweCGMHbriCJjzMX1B2NggCjQkerYLTlufv79/T0/PUuVe
UdDTpzLJl56Jzkui3D0LxuuVOMctPj4+MpksOTlZr9f/dxbFU5dztFtjPcPN
7CUnd0cxq34+URERESEhISkpKTMzM6vC+ic8bucLg3p4eDgoKIjel1YXtGjQ
e0JwcDA94N4Ai6KoqGh8fPzNsFbFgf9r/AWVRIUY
       "], {{0, 0}, {36, 32}}, {0, 255},
       ColorFunction->RGBColor],
      ImageSize->{36, 32},
      PlotRange->{{0, 36}, {0, 32}}],
     Deployed->True,
     StripOnInput->False], Cell[
    "ATOMICDENSITYMATRIX PACLET SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "Zeeman Structure: Nonlinear Magneto-Optical Rotation", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/tutorial/\
ZeemanStructureNonlinearMagnetoOpticalRotation", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]]}, #, 2]& , Evaluator -> 
        Automatic], {
       1->"\<\"Zeeman Structure: Nonlinear Magneto-Optical Rotation\"\>"}, 
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "OpticalField", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/ref/OpticalField", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]], 
          StringReplace[
           "RotatingWaveApproximation", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/ref/RotatingWaveApproximation", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]]}, #, 2]& , Evaluator -> 
        Automatic], {1->"\<\"OpticalField\"\>", 
       2->"\<\"RotatingWaveApproximation\"\>"}, 
       FrameBox["\<\"See Also \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"See Also \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "AtomicDensityMatrix Package", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]]}, #, 2]& , Evaluator -> 
        Automatic], {1->"\<\"AtomicDensityMatrix Package\"\>"}, 
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"More About \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "AtomicDensityMatrix/ref/Observables", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> None, 
          StringReplace[
           "Copy Mathematica url", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> 
          Module[{DocumentationSearch`Private`nb$}, 
            DocumentationSearch`Private`nb$ = NotebookPut[
               Notebook[{
                 Cell[
                  StringReplace[
                  "AtomicDensityMatrix/ref/Observables", 
                   "http://reference.wolfram.com/mathematica/" -> 
                   "http://budker.berkeley.edu/ADM/"]]}, Visible -> False]]; 
            SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
            FrontEndTokenExecute[DocumentationSearch`Private`nb$, 
              StringReplace[
              "Copy", "http://reference.wolfram.com/mathematica/" -> 
               "http://budker.berkeley.edu/ADM/"]]; 
            NotebookClose[DocumentationSearch`Private`nb$]; Null], Delimiter, 
          StringReplace[
           "Copy web url", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> 
          Module[{DocumentationSearch`Private`nb$}, 
            DocumentationSearch`Private`nb$ = NotebookPut[
               Notebook[{
                 Cell[
                  BoxData[
                   MakeBoxes[
                    Hyperlink[
                    StringReplace[
                    "http://reference.wolfram.com/mathematica/\
AtomicDensityMatrix/ref/Observables.html", 
                    "http://reference.wolfram.com/mathematica/" -> 
                    "http://budker.berkeley.edu/ADM/"]], StandardForm]], 
                  StringReplace[
                  "Input", "http://reference.wolfram.com/mathematica/" -> 
                   "http://budker.berkeley.edu/ADM/"], TextClipboardType -> 
                  StringReplace[
                   "PlainText", "http://reference.wolfram.com/mathematica/" -> 
                    "http://budker.berkeley.edu/ADM/"]]}, Visible -> False]]; 
            SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
            FrontEndTokenExecute[DocumentationSearch`Private`nb$, 
              StringReplace[
              "Copy", "http://reference.wolfram.com/mathematica/" -> 
               "http://budker.berkeley.edu/ADM/"]]; 
            NotebookClose[DocumentationSearch`Private`nb$]; Null], 
          StringReplace[
           "Go to web url", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> FrontEndExecute[{
             NotebookLocate[{
               URL[
                StringJoin[
                 StringReplace[
                 "http://reference.wolfram.com/mathematica/", 
                  "http://reference.wolfram.com/mathematica/" -> 
                  "http://budker.berkeley.edu/ADM/"], 
                 StringReplace[
                 "AtomicDensityMatrix/ref/Observables", 
                  "http://reference.wolfram.com/mathematica/" -> 
                  "http://budker.berkeley.edu/ADM/"], 
                 StringReplace[
                 ".html", "http://reference.wolfram.com/mathematica/" -> 
                  "http://budker.berkeley.edu/ADM/"]]], None}]}]}, #, 2]& , 
        Evaluator -> Automatic], {
       1->"\<\"AtomicDensityMatrix/ref/Observables\"\>", 
       2->"\<\"Copy Mathematica url\"\>", Delimiter, 
       4->"\<\"Copy web url\"\>", 5->"\<\"Go to web url\"\>"}, 
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"URL \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxAlignment->{"Columns" -> {{Left, Left, Right}}},
 GridBoxItemSize->{"Columns" -> {
     Scaled[0.05], 
     Scaled[0.3], {
      Scaled[0.64]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[CellGroupData[{

Cell["Observables", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{
       ButtonBox["Observables",
        BaseStyle->"Link",
        ButtonData->"paclet:AtomicDensityMatrix/ref/Observables"], "[", 
       RowBox[{
        StyleBox["sys", "TI"], ",", " ", 
        StyleBox["\[Omega]", "TR"], ",", " ", 
        StyleBox["a", "TI"]}], "]"}]], "InlineFormula"],
     " \[LineSeparator]returns the differential change in optical parameters \
of probe light with frequency ",
     Cell[BoxData[
      StyleBox["\[Omega]", "TR"]], "InlineFormula"],
     " and amplitude ",
     Cell[BoxData[
      StyleBox["a", "TI"]], "InlineFormula"],
     " upon propagation through a medium described by atomic system ",
     Cell[BoxData[
      StyleBox["sys", "TI"]], "InlineFormula"],
     " in terms of the rotating-frame density-matrix elements, assuming \
default light polarization and rotating-wave transform.  "
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{
       ButtonBox["Observables",
        BaseStyle->"Link",
        ButtonData->"paclet:AtomicDensityMatrix/ref/Observables"], "[", 
       RowBox[{
        StyleBox["sys", "TI"], ",", 
        StyleBox["\[Omega]", "TR"], ",", " ", 
        StyleBox["a", "TI"], ",", " ", 
        StyleBox["pol", "TI"]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]returns the change in optical parameters for probe \
light of polarization specified by parameters ",
     Cell[BoxData[
      StyleBox["pol", "TI"]], "InlineFormula"],
     ". "
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          ButtonBox["Observables",
           BaseStyle->"Link",
           ButtonData->"paclet:AtomicDensityMatrix/ref/Observables"], "[", 
          RowBox[{
           StyleBox["sys", "TI"], ",", " ", 
           StyleBox["\[Omega]", "TR"], ",", " ", 
           RowBox[{"(", 
            RowBox[{
             StyleBox["a", "TI"], ",", " ", 
             StyleBox["\[CurlyPhi]", "TR"]}]}]}]}], "}"}], ",", " ", 
        StyleBox["pol", "TI"]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]returns the change in optical parameters for probe \
light with phase ",
     Cell[BoxData[
      StyleBox["\[CurlyPhi]", "TR"]], "InlineFormula"],
     ". "
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{
       ButtonBox["Observables",
        BaseStyle->"Link",
        ButtonData->"paclet:AtomicDensityMatrix/ref/Observables"], "[", 
       RowBox[{
        StyleBox["sys", "TI"], ",", " ", 
        StyleBox["\[Omega]", "TR"], ",", " ", 
        StyleBox["a", "TI"], ",", " ", 
        StyleBox["pol", "TI"], ",", " ", 
        RowBox[{
         ButtonBox["TransformMatrix",
          BaseStyle->"Link",
          ButtonData->"paclet:AtomicDensityMatrix/ref/TransformMatrix"], 
         "\[Rule]", 
         StyleBox["u", "TI"]}]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]returns the change in optical parameters in terms of \
rotating-frame density-matrix elements assuming the rotating-wave transform \
described by the matrix ",
     Cell[BoxData[
      StyleBox["u", "TI"]], "InlineFormula"],
     ". "
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, 
   "Rows" -> {None, None, None, {None}}, "RowsIndexed" -> {}}},
 CellID->982511436]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "NotesSection",
 CellElementSpacings->{"CellMinHeight"->3},
 CellGroupingRules->{"SectionGrouping", 50},
 CellFrameLabels->{{
    FEPrivate`If[
     FEPrivate`Or[
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 
     Cell[
      TextData[
       Cell[
        BoxData[
         ButtonBox[
          FrameBox[
           StyleBox[
            RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"], 
           StripOnInput -> False], BaseStyle -> None, ButtonFrame -> "None", 
          ButtonFunction :> (FrontEndExecute[{
             FrontEnd`SelectionMove[
              FrontEnd`SelectedNotebook[], All, ButtonCell], 
             FrontEndToken["OpenCloseGroup"], 
             FrontEnd`SelectionMove[
              FrontEnd`SelectedNotebook[], After, CellContents]}]& ), 
          Evaluator -> None, Method -> "Preemptive"]]]], "NotesSection", 
      CellSize -> {5000, Inherited}], 
     TextData[
      ButtonBox[
       Cell[
        TextData[{
          Cell[
           BoxData[
            InterpretationBox[
             StyleBox[
              
              GraphicsBox[{}, ImageSize -> {24, 0}, BaselinePosition -> 
               Baseline], "CacheGraphics" -> False], 
             Spacer[24]]]], "Details and Options"}], "NotesSection", 
        CellSize -> {5000, Inherited}], BaseStyle -> None, ButtonFrame -> 
       "None", ButtonFunction :> (FrontEndExecute[{
          FrontEnd`SelectionMove[
           FrontEnd`SelectedNotebook[], All, ButtonCell], 
          FrontEndToken["OpenCloseGroup"], 
          FrontEnd`SelectionMove[
           FrontEnd`SelectedNotebook[], After, CellContents]}]& ), Evaluator -> 
       None, Method -> "Preemptive"]]], None}, {None, None}},
 CellFrameLabelMargins->0,
 CellSize->{Inherited, 
   FEPrivate`If[
    FEPrivate`Or[
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 11, 14]},
 "WholeCellGroupOpener" -> True,
 CellID->2036815],

Cell["", "SectionHeaderSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]],

Cell[TextData[{
 Cell[BoxData[
  ButtonBox["Observables",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/Observables"]], 
  "InlineFormula"],
 " returns the thin-medium differential change in probe field amplitude, \
phase, and polarization per unit path length in the medium and unit atomic \
density. "
}], "Notes",
 CellID->1067943069],

Cell[TextData[{
 "For the default polarization parameterization ",
 Cell[BoxData["\"\<AngleEllipticity\>\""], "InlineFormula"],
 ", ",
 Cell[BoxData[
  ButtonBox["Observables",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/Observables"]], 
  "InlineFormula"],
 " returns ",
 Cell[BoxData[
  FormBox[
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       FractionBox[
        RowBox[{"d", "\[VeryThinSpace]", "a"}], 
        RowBox[{"n", " ", "a", " ", "d", "\[VeryThinSpace]", "\[ScriptL]"}]], 
       ",", 
       FractionBox[
        RowBox[{"d", "\[VeryThinSpace]", "\[CurlyPhi]"}], 
        RowBox[{"n", " ", "d", "\[VeryThinSpace]", "\[ScriptL]"}]]}], "}"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{
       FractionBox[
        RowBox[{"d", "\[VeryThinSpace]", "\[Alpha]"}], 
        RowBox[{"n", " ", "d", "\[VeryThinSpace]", "\[ScriptL]"}]], ",", 
       FractionBox[
        RowBox[{"d", "\[VeryThinSpace]", "\[Epsilon]"}], 
        RowBox[{"n", " ", "d", "\[VeryThinSpace]", "\[ScriptL]"}]]}], "}"}]}],
     "}"}], TraditionalForm]], "InlineMath"],
 ", where ",
 Cell[BoxData[
  RowBox[{
   StyleBox["d", "TI"], "\[VeryThinSpace]", "\[ScriptL]"}]], 
  "InlineFormula"],
 " is the infinitesimal optical path length, ",
 Cell[BoxData[
  StyleBox["a", "TI"]], "InlineFormula"],
 " is the electric-field amplitude, ",
 Cell[BoxData[
  StyleBox["\[CurlyPhi]", "TR"]], "InlineFormula"],
 " is the optical phase, ",
 Cell[BoxData[
  StyleBox["\[Alpha]", "TR"]], "InlineFormula"],
 " is the polarization angle, ",
 Cell[BoxData[
  StyleBox["\[Epsilon]", "TR"]], "InlineFormula"],
 " is the ellipticity, and ",
 Cell[BoxData[
  StyleBox["n", "TI"]], "InlineFormula"],
 " is the atomic density."
}], "Notes",
 CellID->526616807],

Cell[TextData[{
 "The expressions returned by ",
 Cell[BoxData[
  ButtonBox["Observables",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/Observables"]], 
  "InlineFormula"],
 " are valid under the slowly varying envelope approximation, i.e., the \
assumption that the fractional change in the optical parameters is small over \
the distance of an optical wavelength."
}], "Notes",
 CellID->647906718],

Cell[TextData[{
 "The following options for ",
 Cell[BoxData[
  ButtonBox["Observables",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/Observables"]], 
  "InlineFormula"],
 " are the same as those for ",
 Cell[BoxData[
  ButtonBox["OpticalField",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/OpticalField"]], 
  "InlineFormula"],
 ". A value of ",
 Cell[BoxData[
  ButtonBox["Automatic",
   BaseStyle->"Link",
   ButtonData->"paclet:ref/Automatic"]], "InlineFormula"],
 " means that the default value specified for ",
 Cell[BoxData[
  ButtonBox["OpticalField",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/OpticalField"]], 
  "InlineFormula"],
 " will be used:"
}], "Notes",
 CellID->459585102],

Cell[BoxData[GridBox[{
   {Cell["      ", "TableRowIcon"], 
    ButtonBox["PolarizationVector",
     BaseStyle->"Link",
     ButtonData->"paclet:AtomicDensityMatrix/ref/PolarizationVector"], 
    ButtonBox["Automatic",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/Automatic"], Cell[TextData[Cell[
    "reference polarization vector", "TableText"]], "TableText"]},
   {Cell["      ", "TableRowIcon"], 
    ButtonBox["PropagationVector",
     BaseStyle->"Link",
     ButtonData->"paclet:AtomicDensityMatrix/ref/PropagationVector"], 
    ButtonBox["Automatic",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/Automatic"], Cell[TextData[Cell[
    "unit wave vector", "TableText"]], "TableText"]},
   {Cell["      ", "TableRowIcon"], 
    ButtonBox["Parameterization",
     BaseStyle->"Link",
     ButtonData->"paclet:AtomicDensityMatrix/ref/Parameterization"], 
    ButtonBox["Automatic",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/Automatic"], Cell[TextData[Cell[
    "parameterization scheme for polarization", "TableText"]], "TableText"]},
   {Cell["      ", "TableRowIcon"], 
    ButtonBox["TimeVariable",
     BaseStyle->"Link",
     ButtonData->"paclet:AtomicDensityMatrix/ref/TimeVariable"], 
    ButtonBox["Automatic",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/Automatic"], Cell[TextData[Cell[
    "symbol used to represent time variable", "TableText"]], "TableText"]}
  }]], "3ColumnTableMod",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, 
   "Rows" -> {None, None, None, {None}}, "RowsIndexed" -> {}},
 GridBoxDividers->{"Rows" -> {{True, True, True, True, True}}}},
 CellID->105855555],

Cell[TextData[{
 "The following options for ",
 Cell[BoxData[
  ButtonBox["Observables",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/Observables"]], 
  "InlineFormula"],
 " are the same as those for ",
 Cell[BoxData[
  ButtonBox["DensityMatrix",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/DensityMatrix"]], 
  "InlineFormula"],
 ". A value of ",
 Cell[BoxData[
  ButtonBox["Automatic",
   BaseStyle->"Link",
   ButtonData->"paclet:ref/Automatic"]], "InlineFormula"],
 " means that the default value specified for ",
 Cell[BoxData[
  ButtonBox["DensityMatrix",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/DensityMatrix"]], 
  "InlineFormula"],
 " will be used:"
}], "Notes",
 CellID->52361245],

Cell[BoxData[GridBox[{
   {Cell["      ", "TableRowIcon"], 
    ButtonBox["TimeDependence",
     BaseStyle->"Link",
     ButtonData->"paclet:AtomicDensityMatrix/ref/TimeDependence"], 
    ButtonBox["Automatic",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/Automatic"], Cell[TextData[Cell["\<\
whether density matrix elements should have explicit time dependence\
\>", "TableText"]], "TableText"]},
   {Cell["      ", "TableRowIcon"], 
    ButtonBox["Representation",
     BaseStyle->"Link",
     ButtonData->"paclet:AtomicDensityMatrix/ref/Representation"], 
    ButtonBox["Automatic",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/Automatic"], Cell[TextData[Cell[TextData[{
     Cell[BoxData[
      ButtonBox["Zeeman",
       BaseStyle->"Link",
       ButtonData->"paclet:AtomicDensityMatrix/ref/Zeeman"]], 
      "InlineFormula"],
     " or polarization moment representation"
    }], "TableText"]], "TableText"]},
   {Cell["      ", "TableRowIcon"], 
    ButtonBox["DMSymbol",
     BaseStyle->"Link",
     ButtonData->"paclet:AtomicDensityMatrix/ref/DMSymbol"], 
    ButtonBox["Automatic",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/Automatic"], Cell[TextData[Cell[
    "symbol to use for density matrix elements", "TableText"]], 
     "TableText"]},
   {Cell["      ", "TableRowIcon"], 
    ButtonBox["DMLabel",
     BaseStyle->"Link",
     ButtonData->"paclet:AtomicDensityMatrix/ref/DMLabel"], 
    ButtonBox["Automatic",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/Automatic"], Cell[TextData[Cell[
    "additional label for density matrix elements", "TableText"]], 
     "TableText"]},
   {Cell["      ", "TableRowIcon"], 
    ButtonBox["ComplexExpandVariables",
     BaseStyle->"Link",
     ButtonData->"paclet:AtomicDensityMatrix/ref/ComplexExpandVariables"], 
    ButtonBox["Automatic",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/Automatic"], Cell[TextData[Cell["\<\
whether to express density matrix elements in terms of real and imaginary \
parts\
\>", "TableText"]], "TableText"]}
  }]], "3ColumnTableMod",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, 
   "Rows" -> {None, None, None, None, {None}}, "RowsIndexed" -> {}},
 GridBoxDividers->{"Rows" -> {{True, True, True, True, True, True}}}},
 CellID->9140984],

Cell["Observables takes the following additional options:", "Notes",
 CellID->89725684],

Cell[BoxData[GridBox[{
   {Cell["      ", "TableRowIcon"], 
    ButtonBox["ExpandDipoleRME",
     BaseStyle->"Link",
     ButtonData->"paclet:AtomicDensityMatrix/ref/ExpandDipoleRME"], 
    ButtonBox["True",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/True"], Cell[TextData[Cell["\<\
whether to write the reduced dipole matrix element in terms of of the natural \
line width and other parameters\
\>", "TableText"]], "TableText"]},
   {Cell["      ", "TableRowIcon"], 
    ButtonBox["TransformMatrix",
     BaseStyle->"Link",
     ButtonData->"paclet:AtomicDensityMatrix/ref/TransformMatrix"], 
    ButtonBox["Automatic",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/Automatic"], Cell[TextData[Cell["\<\
the unitary matrix used to transform from the laboratory frame to the \
rotating frame\
\>", "TableText"]], "TableText"]}
  }]], "3ColumnTableMod",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {None, {None}}, 
   "RowsIndexed" -> {}},
 GridBoxDividers->{"Rows" -> {{True, True, True}}}},
 CellID->73958713],

Cell["", "SectionFooterSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]]
}, Closed]],

Cell[CellGroupData[{

Cell["", "PrimaryExamplesSection",
 CellElementSpacings->{"CellMinHeight"->3},
 CellFrameLabels->{{
    FEPrivate`If[
     FEPrivate`Or[
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 
     Cell[
      TextData[
       ButtonBox[
       "EXAMPLES", BaseStyle -> None, Evaluator -> None, Method -> 
        "Preemptive", ButtonFunction :> (FrontEndExecute[{
           FrontEnd`SelectionMove[
            FrontEnd`SelectedNotebook[], All, ButtonCell], 
           FrontEndToken["OpenCloseGroup"], 
           FrontEnd`SelectionMove[
            FrontEnd`SelectedNotebook[], After, CellContents]}]& ), 
        ButtonFrame -> "None"]], "PrimaryExamplesSection", 
      CellSize -> {5000, Inherited}], 
     TextData[
      ButtonBox[
       Cell[
        TextData[{
          Cell[
           BoxData[
            InterpretationBox[
             StyleBox[
              
              GraphicsBox[{}, ImageSize -> {24, 0}, BaselinePosition -> 
               Baseline], "CacheGraphics" -> False], 
             Spacer[24]]]], "Examples", 
          "\[NonBreakingSpace]\[NonBreakingSpace]", 
          Cell["(4)", "ExampleCount"]}], "PrimaryExamplesSection", 
        CellSize -> {5000, Inherited}], BaseStyle -> None, Evaluator -> None, 
       Method -> "Preemptive", ButtonFunction :> (FrontEndExecute[{
          FrontEnd`SelectionMove[
           FrontEnd`SelectedNotebook[], All, ButtonCell], 
          FrontEndToken["OpenCloseGroup"], 
          FrontEnd`SelectionMove[
           FrontEnd`SelectedNotebook[], After, CellContents]}]& ), 
       ButtonFrame -> "None"]]], None}, {None, None}},
 CellFrameLabelMargins->0,
 CellSize->{Inherited, 
   FEPrivate`If[
    FEPrivate`Or[
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 11, 14]},
 "WholeCellGroupOpener" -> True,
 CellTags->"PrimaryExamplesSection",
 CellID->33338035],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(2)", "ExampleCount"]
}], "ExampleSection",
 "WholeCellGroupOpener" -> True,
 CellID->376094452],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<AtomicDensityMatrix`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->144993820],

Cell[TextData[{
 "Define a ",
 Cell[BoxData[
  RowBox[{
   ButtonBox["J",
    BaseStyle->"Link",
    ButtonData->"paclet:AtomicDensityMatrix/ref/J"], "=", 
   RowBox[{
    RowBox[{"1", "\[Rule]", 
     ButtonBox["J",
      BaseStyle->"Link",
      ButtonData->"paclet:AtomicDensityMatrix/ref/J"]}], "=", "0"}]}]], 
  "InlineFormula"],
 " system:"
}], "ExampleText",
 CellID->543065180],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"system", "=", 
  RowBox[{"Sublevels", "[", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"AtomicState", "[", 
      RowBox[{"1", ",", 
       RowBox[{"J", "\[Rule]", "1"}], ",", 
       RowBox[{"L", "\[Rule]", "1"}], ",", 
       RowBox[{"S", "\[Rule]", "0"}], ",", 
       RowBox[{"NaturalWidth", "\[Rule]", "0"}], ",", 
       RowBox[{"Energy", "\[Rule]", "0"}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"AtomicState", "[", 
      RowBox[{"2", ",", 
       RowBox[{"J", "\[Rule]", "0"}], ",", 
       RowBox[{"L", "\[Rule]", "0"}], ",", 
       RowBox[{"S", "\[Rule]", "0"}], ",", 
       RowBox[{
        RowBox[{"BranchingRatio", "[", "1", "]"}], "\[Rule]", "1"}], ",", 
       RowBox[{"NaturalWidth", "\[Rule]", "\[CapitalGamma]"}]}], "]"}]}], 
    "\[IndentingNewLine]", "}"}], "]"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->114432431],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"L", "\[Rule]", "1"}], ",", 
     RowBox[{"S", "\[Rule]", "0"}], ",", 
     RowBox[{"NaturalWidth", "\[Rule]", "0"}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{"M", "\[Rule]", "1"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"L", "\[Rule]", "1"}], ",", 
     RowBox[{"S", "\[Rule]", "0"}], ",", 
     RowBox[{"NaturalWidth", "\[Rule]", "0"}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"L", "\[Rule]", "1"}], ",", 
     RowBox[{"S", "\[Rule]", "0"}], ",", 
     RowBox[{"NaturalWidth", "\[Rule]", "0"}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "1"}]}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"2", ",", 
     RowBox[{"J", "\[Rule]", "0"}], ",", 
     RowBox[{"L", "\[Rule]", "0"}], ",", 
     RowBox[{"S", "\[Rule]", "0"}], ",", 
     RowBox[{
      RowBox[{"BranchingRatio", "[", "1", "]"}], "\[Rule]", "1"}], ",", 
     RowBox[{"NaturalWidth", "\[Rule]", "\[CapitalGamma]"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}]}], "}"}]], "Output",
 ImageSize->{553, 67},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->587053931]
}, Open  ]],

Cell[TextData[{
 "Expressions proportional to the fractional change in electric field \
amplitude, change of phase, change in polarization angle, and change in \
ellipticity of a field of frequency ",
 Cell[BoxData[
  StyleBox["\[Omega]", "TR"]], "InlineFormula"],
 " and amplitude ",
 Cell[BoxData[
  StyleBox["a", "TI"]], "InlineFormula"],
 ", in terms of the rotating-frame density-matrix elements. The field is \
assumed to have the default polarization (linear, along ",
 Cell[BoxData[
  StyleBox["x", "TI"]], "InlineFormula"],
 ") and propagation direction (along ",
 Cell[BoxData[
  StyleBox["z", "TI"]], "InlineFormula"],
 "), and a standard method is used to generate the rotating-wave transform."
}], "ExampleText",
 CellID->106371938],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Observables", "[", 
   RowBox[{"system", ",", "\[Omega]", ",", "a"}], "]"}], "//", 
  "FullSimplify"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->248409325],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     FractionBox[
      RowBox[{
       SqrtBox["2"], " ", "\[Pi]", " ", "\[Omega]", " ", 
       SqrtBox[
        FractionBox["\[CapitalGamma]", 
         SuperscriptBox[
          RowBox[{"Energy", "[", "2", "]"}], "3"]]], " ", 
       RowBox[{"Im", "[", 
        RowBox[{
         RowBox[{
          SubscriptBox["\[Rho]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", 
              RowBox[{"-", "1"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "0"}], "}"}]}]], "[", "t", "]"}], "-", 
         RowBox[{
          SubscriptBox["\[Rho]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "0"}], "}"}]}]], "[", "t", "]"}]}], "]"}]}], 
      "a"], ",", 
     FractionBox[
      RowBox[{
       SqrtBox["2"], " ", "\[Pi]", " ", "\[Omega]", " ", 
       SqrtBox[
        FractionBox["\[CapitalGamma]", 
         SuperscriptBox[
          RowBox[{"Energy", "[", "2", "]"}], "3"]]], " ", 
       RowBox[{"Re", "[", 
        RowBox[{
         RowBox[{
          SubscriptBox["\[Rho]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", 
              RowBox[{"-", "1"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "0"}], "}"}]}]], "[", "t", "]"}], "-", 
         RowBox[{
          SubscriptBox["\[Rho]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "0"}], "}"}]}]], "[", "t", "]"}]}], "]"}]}], 
      "a"]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{
        SqrtBox["2"], " ", "\[Pi]", " ", "\[Omega]", " ", 
        SqrtBox[
         FractionBox["\[CapitalGamma]", 
          SuperscriptBox[
           RowBox[{"Energy", "[", "2", "]"}], "3"]]], " ", 
        RowBox[{"Re", "[", 
         RowBox[{
          RowBox[{
           SubscriptBox["\[Rho]", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"1", ",", 
               RowBox[{"-", "1"}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "0"}], "}"}]}]], "[", "t", "]"}], "+", 
          RowBox[{
           SubscriptBox["\[Rho]", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"1", ",", "1"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "0"}], "}"}]}]], "[", "t", "]"}]}], "]"}]}], 
       "a"]}], ",", 
     FractionBox[
      RowBox[{
       SqrtBox["2"], " ", "\[Pi]", " ", "\[Omega]", " ", 
       SqrtBox[
        FractionBox["\[CapitalGamma]", 
         SuperscriptBox[
          RowBox[{"Energy", "[", "2", "]"}], "3"]]], " ", 
       RowBox[{"Im", "[", 
        RowBox[{
         RowBox[{
          SubscriptBox["\[Rho]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", 
              RowBox[{"-", "1"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "0"}], "}"}]}]], "[", "t", "]"}], "+", 
         RowBox[{
          SubscriptBox["\[Rho]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "0"}], "}"}]}]], "[", "t", "]"}]}], "]"}]}], 
      "a"]}], "}"}]}], "}"}]], "Output",
 ImageSize->{374, 226},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->115531579]
}, Open  ]],

Cell[TextData[{
 "We can simplify the expressions somewhat by assuming that the light \
frequency ",
 Cell[BoxData[
  StyleBox["\[Omega]", "TR"]], "InlineFormula"],
 " is approximately equal to the transition frequency ",
 Cell[BoxData[
  RowBox[{
   ButtonBox["Energy",
    BaseStyle->"Link",
    ButtonData->"paclet:AtomicDensityMatrix/ref/Energy"], "[", "2", "]"}]], 
  "InlineFormula"],
 ", by writing the electric-field amplitude ",
 Cell[BoxData[
  StyleBox["a", "TI"]], "InlineFormula"],
 " in terms of the Rabi frequency ",
 Cell[BoxData[
  RowBox[{
   StyleBox["\[CapitalOmega]R", "TI"], "=", 
   RowBox[{
    StyleBox["a", "TI"], "||", 
    StyleBox["d", "TI"], "||"}]}]], "InlineFormula"],
 ", and by writing the transition frequency in terms of the transition \
wavelength ",
 Cell[BoxData[
  RowBox[{
   StyleBox["\[Lambda]", "TR"], "=", 
   RowBox[{"2", 
    RowBox[{
     StyleBox["\[Pi]", "TR"], "/", 
     RowBox[{
      ButtonBox["Energy",
       BaseStyle->"Link",
       ButtonData->"paclet:AtomicDensityMatrix/ref/Energy"], "[", "2", 
      "]"}]}]}]}]], "InlineFormula"],
 ":"
}], "ExampleText",
 CellID->17349946],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Observables", "[", 
    RowBox[{"system", ",", 
     RowBox[{"Energy", "[", "2", "]"}], ",", 
     RowBox[{"\[CapitalOmega]R", "/", 
      RowBox[{"ReducedME", "[", 
       RowBox[{"1", ",", 
        RowBox[{"{", 
         RowBox[{"Dipole", ",", "1"}], "}"}], ",", "2"}], "]"}]}]}], "]"}], "/.",
    
   RowBox[{
    RowBox[{"Energy", "[", "2", "]"}], "\[Rule]", 
    RowBox[{"2", 
     RowBox[{"\[Pi]", "/", "\[Lambda]"}]}]}]}], "//", 
  "FullSimplify"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->7996356],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     FractionBox[
      RowBox[{
       SqrtBox[
        FractionBox["3", "2"]], " ", "\[CapitalGamma]", " ", 
       SuperscriptBox["\[Lambda]", "2"], " ", 
       RowBox[{"Im", "[", 
        RowBox[{
         RowBox[{
          SubscriptBox["\[Rho]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", 
              RowBox[{"-", "1"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "0"}], "}"}]}]], "[", "t", "]"}], "-", 
         RowBox[{
          SubscriptBox["\[Rho]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "0"}], "}"}]}]], "[", "t", "]"}]}], "]"}]}], 
      RowBox[{"4", " ", "\[Pi]", " ", "\[CapitalOmega]R"}]], ",", 
     FractionBox[
      RowBox[{
       SqrtBox[
        FractionBox["3", "2"]], " ", "\[CapitalGamma]", " ", 
       SuperscriptBox["\[Lambda]", "2"], " ", 
       RowBox[{"Re", "[", 
        RowBox[{
         RowBox[{
          SubscriptBox["\[Rho]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", 
              RowBox[{"-", "1"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "0"}], "}"}]}]], "[", "t", "]"}], "-", 
         RowBox[{
          SubscriptBox["\[Rho]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "0"}], "}"}]}]], "[", "t", "]"}]}], "]"}]}], 
      RowBox[{"4", " ", "\[Pi]", " ", "\[CapitalOmega]R"}]]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{
        SqrtBox[
         FractionBox["3", "2"]], " ", "\[CapitalGamma]", " ", 
        SuperscriptBox["\[Lambda]", "2"], " ", 
        RowBox[{"Re", "[", 
         RowBox[{
          RowBox[{
           SubscriptBox["\[Rho]", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"1", ",", 
               RowBox[{"-", "1"}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "0"}], "}"}]}]], "[", "t", "]"}], "+", 
          RowBox[{
           SubscriptBox["\[Rho]", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"1", ",", "1"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "0"}], "}"}]}]], "[", "t", "]"}]}], "]"}]}], 
       RowBox[{"4", " ", "\[Pi]", " ", "\[CapitalOmega]R"}]]}], ",", 
     FractionBox[
      RowBox[{
       SqrtBox[
        FractionBox["3", "2"]], " ", "\[CapitalGamma]", " ", 
       SuperscriptBox["\[Lambda]", "2"], " ", 
       RowBox[{"Im", "[", 
        RowBox[{
         RowBox[{
          SubscriptBox["\[Rho]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", 
              RowBox[{"-", "1"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "0"}], "}"}]}]], "[", "t", "]"}], "+", 
         RowBox[{
          SubscriptBox["\[Rho]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "0"}], "}"}]}]], "[", "t", "]"}]}], "]"}]}], 
      RowBox[{"4", " ", "\[Pi]", " ", "\[CapitalOmega]R"}]]}], "}"}]}], 
  "}"}]], "Output",
 ImageSize->{308, 230},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->210332409]
}, Open  ]],

Cell[TextData[{
 "In the above form, we can see that the expressions have the units of length \
squared (the units of the frequencies ",
 Cell[BoxData[
  StyleBox["\[CapitalGamma]", "TR"]], "InlineFormula"],
 " and ",
 Cell[BoxData[
  StyleBox["\[CapitalOmega]R", "TI"]], "InlineFormula"],
 " cancel, and the density-matrix elements are dimensionless). Thus by \
multiplying by a path length and the atomic density we obtain the changes in \
the dimensionless optical parameters."
}], "ExampleText",
 CellID->214192953],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->39714538],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<AtomicDensityMatrix`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->305214818],

Cell[TextData[{
 "In order to obtain correct results from a given calculation, it is vital \
that the light polarization and rotating-wave transformation used by ",
 Cell[BoxData[
  ButtonBox["Observables",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/Observables"]], 
  "InlineFormula"],
 " matches those used to produce the Hamiltonian used to generate the \
density-matrix evolution equations."
}], "ExampleText",
 CellID->273621177],

Cell[TextData[{
 "Define a ",
 Cell[BoxData[
  RowBox[{
   ButtonBox["J",
    BaseStyle->"Link",
    ButtonData->"paclet:AtomicDensityMatrix/ref/J"], "=", 
   RowBox[{
    RowBox[{"1", "\[Rule]", 
     ButtonBox["J",
      BaseStyle->"Link",
      ButtonData->"paclet:AtomicDensityMatrix/ref/J"]}], "=", "0"}]}]], 
  "InlineFormula"],
 " system:"
}], "ExampleText",
 CellID->635639878],

Cell[BoxData[
 RowBox[{
  RowBox[{"system", "=", 
   RowBox[{"Sublevels", "[", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"AtomicState", "[", 
       RowBox[{"1", ",", 
        RowBox[{"J", "\[Rule]", "1"}], ",", 
        RowBox[{"L", "\[Rule]", "1"}], ",", 
        RowBox[{"S", "\[Rule]", "0"}], ",", 
        RowBox[{"NaturalWidth", "\[Rule]", "0"}], ",", 
        RowBox[{"Energy", "\[Rule]", "0"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"AtomicState", "[", 
       RowBox[{"2", ",", 
        RowBox[{"J", "\[Rule]", "0"}], ",", 
        RowBox[{"L", "\[Rule]", "0"}], ",", 
        RowBox[{"S", "\[Rule]", "0"}], ",", 
        RowBox[{
         RowBox[{"BranchingRatio", "[", "1", "]"}], "\[Rule]", "1"}], ",", 
        RowBox[{"NaturalWidth", "\[Rule]", "\[CapitalGamma]"}]}], "]"}]}], 
     "\[IndentingNewLine]", "}"}], "]"}]}], ";"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->52825860],

Cell[TextData[{
 "Define an elliptically polarized optical field with reference polarization \
vector along ",
 Cell[BoxData[
  StyleBox["z", "TI"]], "InlineFormula"],
 ", propagating along ",
 Cell[BoxData[
  StyleBox["x", "TI"]], "InlineFormula"],
 "."
}], "ExampleText",
 CellID->157927092],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"field", "=", 
  RowBox[{"OpticalField", "[", 
   RowBox[{"\[Omega]", ",", 
    RowBox[{"\[CapitalOmega]R", "/", 
     RowBox[{"ReducedME", "[", 
      RowBox[{"1", ",", 
       RowBox[{"{", 
        RowBox[{"Dipole", ",", "1"}], "}"}], ",", "2"}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"0", ",", "\[Epsilon]"}], "}"}], ",", 
    RowBox[{"PolarizationVector", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1"}], "}"}]}], ",", 
    RowBox[{"PropagationVector", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "0"}], "}"}]}]}], "]"}]}]], "Input",
 CellLabel->"In[3]:=",
 CellID->108232262],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", 
   RowBox[{"-", 
    FractionBox[
     RowBox[{"\[ImaginaryI]", " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "\[ImaginaryI]"}], " ", "t", " ", "\[Omega]"}]], " ", 
      "\[CapitalOmega]R", " ", 
      RowBox[{"Sin", "[", "\[Epsilon]", "]"}]}], 
     RowBox[{"ReducedME", "[", 
      RowBox[{"1", ",", 
       RowBox[{"{", 
        RowBox[{"Dipole", ",", "1"}], "}"}], ",", "2"}], "]"}]]}], ",", 
   FractionBox[
    RowBox[{
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{
       RowBox[{"-", "\[ImaginaryI]"}], " ", "t", " ", "\[Omega]"}]], " ", 
     "\[CapitalOmega]R", " ", 
     RowBox[{"Cos", "[", "\[Epsilon]", "]"}]}], 
    RowBox[{"ReducedME", "[", 
     RowBox[{"1", ",", 
      RowBox[{"{", 
       RowBox[{"Dipole", ",", "1"}], "}"}], ",", "2"}], "]"}]]}], 
  "}"}]], "Output",
 ImageSize->{439, 36},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->57416189]
}, Open  ]],

Cell["\<\
The Hamiltonian for the atomic system subject to this optical field.\
\>", "ExampleText",
 CellID->346356808],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"h", "=", 
    RowBox[{"Hamiltonian", "[", 
     RowBox[{"system", ",", 
      RowBox[{"ElectricField", "\[Rule]", "field"}]}], "]"}]}], ")"}], "//", 
  "MatrixForm"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->128568647],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", 
      FractionBox[
       RowBox[{"\[ImaginaryI]", " ", "\[CapitalOmega]R", " ", 
        RowBox[{"Sin", "[", "\[Epsilon]", "]"}], " ", 
        RowBox[{"Sin", "[", 
         RowBox[{"t", " ", "\[Omega]"}], "]"}]}], 
       SqrtBox["6"]]},
     {"0", "0", "0", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"\[CapitalOmega]R", " ", 
         RowBox[{"Cos", "[", "\[Epsilon]", "]"}], " ", 
         RowBox[{"Cos", "[", 
          RowBox[{"t", " ", "\[Omega]"}], "]"}]}], 
        SqrtBox["3"]]}]},
     {"0", "0", "0", 
      FractionBox[
       RowBox[{"\[ImaginaryI]", " ", "\[CapitalOmega]R", " ", 
        RowBox[{"Sin", "[", "\[Epsilon]", "]"}], " ", 
        RowBox[{"Sin", "[", 
         RowBox[{"t", " ", "\[Omega]"}], "]"}]}], 
       SqrtBox["6"]]},
     {
      RowBox[{"-", 
       FractionBox[
        RowBox[{"\[ImaginaryI]", " ", "\[CapitalOmega]R", " ", 
         RowBox[{"Sin", "[", "\[Epsilon]", "]"}], " ", 
         RowBox[{"Sin", "[", 
          RowBox[{"t", " ", "\[Omega]"}], "]"}]}], 
        SqrtBox["6"]]}], 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"\[CapitalOmega]R", " ", 
         RowBox[{"Cos", "[", "\[Epsilon]", "]"}], " ", 
         RowBox[{"Cos", "[", 
          RowBox[{"t", " ", "\[Omega]"}], "]"}]}], 
        SqrtBox["3"]]}], 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"\[ImaginaryI]", " ", "\[CapitalOmega]R", " ", 
         RowBox[{"Sin", "[", "\[Epsilon]", "]"}], " ", 
         RowBox[{"Sin", "[", 
          RowBox[{"t", " ", "\[Omega]"}], "]"}]}], 
        SqrtBox["6"]]}], 
      RowBox[{"Energy", "[", "2", "]"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{434, 129},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]//MatrixForm=",
 CellID->73252563]
}, Open  ]],

Cell["\<\
The change in light parameters for light of this polarization.\
\>", "ExampleText",
 CellID->215977394],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Observables", "[", 
    RowBox[{"system", ",", 
     RowBox[{"Energy", "[", "2", "]"}], ",", 
     RowBox[{"\[CapitalOmega]R", "/", 
      RowBox[{"ReducedME", "[", 
       RowBox[{"1", ",", 
        RowBox[{"{", 
         RowBox[{"Dipole", ",", "1"}], "}"}], ",", "2"}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "\[Epsilon]"}], "}"}], ",", 
     RowBox[{"PolarizationVector", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "1"}], "}"}]}], ",", 
     RowBox[{"PropagationVector", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"1", ",", "0", ",", "0"}], "}"}]}]}], "]"}], "/.", 
   RowBox[{
    RowBox[{"Energy", "[", "2", "]"}], "\[Rule]", 
    RowBox[{"2", 
     RowBox[{"\[Pi]", "/", "\[Lambda]"}]}]}]}], "//", 
  "FullSimplify"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->706355312],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      FractionBox["1", 
       RowBox[{"8", " ", "\[Pi]", " ", "\[CapitalOmega]R"}]], 
      RowBox[{
       SqrtBox["3"], " ", "\[CapitalGamma]", " ", 
       SuperscriptBox["\[Lambda]", "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", " ", 
          RowBox[{"Cos", "[", "\[Epsilon]", "]"}], " ", 
          RowBox[{"Im", "[", 
           RowBox[{
            SubscriptBox["\[Rho]", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"1", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "0"}], "}"}]}]], "[", "t", "]"}], "]"}]}], 
         "-", 
         RowBox[{
          SqrtBox["2"], " ", 
          RowBox[{"Im", "[", 
           RowBox[{
            RowBox[{
             SubscriptBox["\[Rho]", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"1", ",", 
                 RowBox[{"-", "1"}]}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"2", ",", "0"}], "}"}]}]], "[", "t", "]"}], "+", 
            RowBox[{
             SubscriptBox["\[Rho]", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"1", ",", "1"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"2", ",", "0"}], "}"}]}]], "[", "t", "]"}]}], "]"}], 
          " ", 
          RowBox[{"Sin", "[", "\[Epsilon]", "]"}]}]}], ")"}]}]}], ",", 
     RowBox[{
      FractionBox["1", 
       RowBox[{"8", " ", "\[Pi]", " ", "\[CapitalOmega]R"}]], 
      RowBox[{
       SqrtBox["3"], " ", "\[CapitalGamma]", " ", 
       SuperscriptBox["\[Lambda]", "2"], " ", 
       RowBox[{"Sec", "[", 
        RowBox[{"2", " ", "\[Epsilon]"}], "]"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", " ", 
          RowBox[{"Cos", "[", "\[Epsilon]", "]"}], " ", 
          RowBox[{"Re", "[", 
           RowBox[{
            SubscriptBox["\[Rho]", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"1", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "0"}], "}"}]}]], "[", "t", "]"}], "]"}]}], 
         "+", 
         RowBox[{
          SqrtBox["2"], " ", 
          RowBox[{"Re", "[", 
           RowBox[{
            RowBox[{
             SubscriptBox["\[Rho]", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"1", ",", 
                 RowBox[{"-", "1"}]}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"2", ",", "0"}], "}"}]}]], "[", "t", "]"}], "+", 
            RowBox[{
             SubscriptBox["\[Rho]", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"1", ",", "1"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"2", ",", "0"}], "}"}]}]], "[", "t", "]"}]}], "]"}], 
          " ", 
          RowBox[{"Sin", "[", "\[Epsilon]", "]"}]}]}], ")"}]}]}]}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      FractionBox["1", 
       RowBox[{"8", " ", "\[Pi]", " ", "\[CapitalOmega]R"}]], 
      RowBox[{
       SqrtBox["3"], " ", "\[CapitalGamma]", " ", 
       SuperscriptBox["\[Lambda]", "2"], " ", 
       RowBox[{"Sec", "[", 
        RowBox[{"2", " ", "\[Epsilon]"}], "]"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          SqrtBox["2"], " ", 
          RowBox[{"Cos", "[", "\[Epsilon]", "]"}], " ", 
          RowBox[{"Re", "[", 
           RowBox[{
            RowBox[{
             SubscriptBox["\[Rho]", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"1", ",", 
                 RowBox[{"-", "1"}]}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"2", ",", "0"}], "}"}]}]], "[", "t", "]"}], "+", 
            RowBox[{
             SubscriptBox["\[Rho]", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"1", ",", "1"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"2", ",", "0"}], "}"}]}]], "[", "t", "]"}]}], "]"}]}],
          "+", 
         RowBox[{"2", " ", 
          RowBox[{"Re", "[", 
           RowBox[{
            SubscriptBox["\[Rho]", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"1", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "0"}], "}"}]}]], "[", "t", "]"}], "]"}], " ",
           
          RowBox[{"Sin", "[", "\[Epsilon]", "]"}]}]}], ")"}]}]}], ",", 
     RowBox[{"-", 
      RowBox[{
       FractionBox["1", 
        RowBox[{"8", " ", "\[Pi]", " ", "\[CapitalOmega]R"}]], 
       RowBox[{
        SqrtBox["3"], " ", "\[CapitalGamma]", " ", 
        SuperscriptBox["\[Lambda]", "2"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           SqrtBox["2"], " ", 
           RowBox[{"Cos", "[", "\[Epsilon]", "]"}], " ", 
           RowBox[{"Im", "[", 
            RowBox[{
             RowBox[{
              SubscriptBox["\[Rho]", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"1", ",", 
                  RowBox[{"-", "1"}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"2", ",", "0"}], "}"}]}]], "[", "t", "]"}], "+", 
             RowBox[{
              SubscriptBox["\[Rho]", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"2", ",", "0"}], "}"}]}]], "[", "t", "]"}]}], 
            "]"}]}], "+", 
          RowBox[{"2", " ", 
           RowBox[{"Im", "[", 
            RowBox[{
             SubscriptBox["\[Rho]", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"1", ",", "0"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"2", ",", "0"}], "}"}]}]], "[", "t", "]"}], "]"}], 
           " ", 
           RowBox[{"Sin", "[", "\[Epsilon]", "]"}]}]}], ")"}]}]}]}]}], 
    "}"}]}], "}"}]], "Output",
 ImageSize->{578, 168},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->645925858]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "Options",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSection"],
  $Line = 0; Null]], "ExampleSection",
 "WholeCellGroupOpener" -> True,
 CellID->10282375],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "ExpandDipoleRME",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSubsection"],
  $Line = 0; Null]], "ExampleSubsection",
 "WholeCellGroupOpener" -> True,
 CellID->337009752],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<AtomicDensityMatrix`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->346500437],

Cell[TextData[{
 "Define a ",
 Cell[BoxData[
  RowBox[{
   ButtonBox["J",
    BaseStyle->"Link",
    ButtonData->"paclet:AtomicDensityMatrix/ref/J"], "=", 
   RowBox[{
    RowBox[{"1", "\[Rule]", 
     ButtonBox["J",
      BaseStyle->"Link",
      ButtonData->"paclet:AtomicDensityMatrix/ref/J"]}], "=", "0"}]}]], 
  "InlineFormula"],
 " system:"
}], "ExampleText",
 CellID->309781151],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"system", "=", 
  RowBox[{"Sublevels", "[", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"AtomicState", "[", 
      RowBox[{"1", ",", 
       RowBox[{"J", "\[Rule]", "1"}], ",", 
       RowBox[{"L", "\[Rule]", "1"}], ",", 
       RowBox[{"S", "\[Rule]", "0"}], ",", 
       RowBox[{"NaturalWidth", "\[Rule]", "0"}], ",", 
       RowBox[{"Energy", "\[Rule]", "0"}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"AtomicState", "[", 
      RowBox[{"2", ",", 
       RowBox[{"J", "\[Rule]", "0"}], ",", 
       RowBox[{"L", "\[Rule]", "0"}], ",", 
       RowBox[{"S", "\[Rule]", "0"}], ",", 
       RowBox[{
        RowBox[{"BranchingRatio", "[", "1", "]"}], "\[Rule]", "1"}], ",", 
       RowBox[{"NaturalWidth", "\[Rule]", "\[CapitalGamma]"}]}], "]"}]}], 
    "\[IndentingNewLine]", "}"}], "]"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->412071112],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"L", "\[Rule]", "1"}], ",", 
     RowBox[{"S", "\[Rule]", "0"}], ",", 
     RowBox[{"NaturalWidth", "\[Rule]", "0"}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{"M", "\[Rule]", "1"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"L", "\[Rule]", "1"}], ",", 
     RowBox[{"S", "\[Rule]", "0"}], ",", 
     RowBox[{"NaturalWidth", "\[Rule]", "0"}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"1", ",", 
     RowBox[{"J", "\[Rule]", "1"}], ",", 
     RowBox[{"L", "\[Rule]", "1"}], ",", 
     RowBox[{"S", "\[Rule]", "0"}], ",", 
     RowBox[{"NaturalWidth", "\[Rule]", "0"}], ",", 
     RowBox[{"Energy", "\[Rule]", "0"}], ",", 
     RowBox[{"M", "\[Rule]", 
      RowBox[{"-", "1"}]}]}], "]"}], ",", 
   RowBox[{"AtomicState", "[", 
    RowBox[{"2", ",", 
     RowBox[{"J", "\[Rule]", "0"}], ",", 
     RowBox[{"L", "\[Rule]", "0"}], ",", 
     RowBox[{"S", "\[Rule]", "0"}], ",", 
     RowBox[{
      RowBox[{"BranchingRatio", "[", "1", "]"}], "\[Rule]", "1"}], ",", 
     RowBox[{"NaturalWidth", "\[Rule]", "\[CapitalGamma]"}], ",", 
     RowBox[{"M", "\[Rule]", "0"}]}], "]"}]}], "}"}]], "Output",
 ImageSize->{553, 67},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->11095354]
}, Open  ]],

Cell["\<\
Expressions for observables, written in terms of the reduced dipole matrix \
element:\
\>", "ExampleText",
 CellID->48646922],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Observables", "[", 
   RowBox[{"system", ",", "\[Omega]", ",", "a", ",", 
    RowBox[{"ExpandDipoleRME", "\[Rule]", "False"}]}], "]"}], "//", 
  "Simplify"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->25711507],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     FractionBox[
      RowBox[{"2", " ", 
       SqrtBox[
        FractionBox["2", "3"]], " ", "\[Pi]", " ", "\[Omega]", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Im", "[", 
          RowBox[{
           SubscriptBox["\[Rho]", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"1", ",", 
               RowBox[{"-", "1"}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "0"}], "}"}]}]], "[", "t", "]"}], "]"}], "-", 
         
         RowBox[{"Im", "[", 
          RowBox[{
           SubscriptBox["\[Rho]", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"1", ",", "1"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "0"}], "}"}]}]], "[", "t", "]"}], "]"}]}], 
        ")"}], " ", 
       RowBox[{"ReducedME", "[", 
        RowBox[{"1", ",", 
         RowBox[{"{", 
          RowBox[{"Dipole", ",", "1"}], "}"}], ",", "2"}], "]"}]}], "a"], ",",
      
     FractionBox[
      RowBox[{"2", " ", 
       SqrtBox[
        FractionBox["2", "3"]], " ", "\[Pi]", " ", "\[Omega]", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Re", "[", 
          RowBox[{
           SubscriptBox["\[Rho]", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"1", ",", 
               RowBox[{"-", "1"}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "0"}], "}"}]}]], "[", "t", "]"}], "]"}], "-", 
         
         RowBox[{"Re", "[", 
          RowBox[{
           SubscriptBox["\[Rho]", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"1", ",", "1"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "0"}], "}"}]}]], "[", "t", "]"}], "]"}]}], 
        ")"}], " ", 
       RowBox[{"ReducedME", "[", 
        RowBox[{"1", ",", 
         RowBox[{"{", 
          RowBox[{"Dipole", ",", "1"}], "}"}], ",", "2"}], "]"}]}], "a"]}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", 
      RowBox[{
       FractionBox["1", "a"], 
       RowBox[{"2", " ", 
        SqrtBox[
         FractionBox["2", "3"]], " ", "\[Pi]", " ", "\[Omega]", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Re", "[", 
           RowBox[{
            SubscriptBox["\[Rho]", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"1", ",", 
                RowBox[{"-", "1"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "0"}], "}"}]}]], "[", "t", "]"}], "]"}], "+",
           
          RowBox[{"Re", "[", 
           RowBox[{
            SubscriptBox["\[Rho]", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"1", ",", "1"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "0"}], "}"}]}]], "[", "t", "]"}], "]"}]}], 
         ")"}], " ", 
        RowBox[{"ReducedME", "[", 
         RowBox[{"1", ",", 
          RowBox[{"{", 
           RowBox[{"Dipole", ",", "1"}], "}"}], ",", "2"}], "]"}]}]}]}], ",", 
     
     FractionBox[
      RowBox[{"2", " ", 
       SqrtBox[
        FractionBox["2", "3"]], " ", "\[Pi]", " ", "\[Omega]", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Im", "[", 
          RowBox[{
           SubscriptBox["\[Rho]", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"1", ",", 
               RowBox[{"-", "1"}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "0"}], "}"}]}]], "[", "t", "]"}], "]"}], "+", 
         
         RowBox[{"Im", "[", 
          RowBox[{
           SubscriptBox["\[Rho]", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"1", ",", "1"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "0"}], "}"}]}]], "[", "t", "]"}], "]"}]}], 
        ")"}], " ", 
       RowBox[{"ReducedME", "[", 
        RowBox[{"1", ",", 
         RowBox[{"{", 
          RowBox[{"Dipole", ",", "1"}], "}"}], ",", "2"}], "]"}]}], "a"]}], 
    "}"}]}], "}"}]], "Output",
 ImageSize->{555, 209},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->150333598]
}, Open  ]],

Cell["", "SectionFooterSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]]
}, Closed]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "SeeAlsoSection",
 CellElementSpacings->{"CellMinHeight"->3},
 CellFrameLabels->{{
    FEPrivate`If[
     FEPrivate`Or[
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 
     Cell[
      TextData[
       ButtonBox[
       "SEE ALSO", BaseStyle -> None, Evaluator -> None, Method -> 
        "Preemptive", ButtonFunction :> (FrontEndExecute[{
           FrontEnd`SelectionMove[
            FrontEnd`SelectedNotebook[], All, ButtonCell], 
           FrontEndToken["OpenCloseGroup"], 
           FrontEnd`SelectionMove[
            FrontEnd`SelectedNotebook[], After, CellContents]}]& ), 
        ButtonFrame -> "None"]], "SeeAlsoSection", 
      CellSize -> {5000, Inherited}], 
     TextData[
      ButtonBox[
       Cell[
        TextData[{
          Cell[
           BoxData[
            InterpretationBox[
             StyleBox[
              
              GraphicsBox[{}, ImageSize -> {24, 0}, BaselinePosition -> 
               Baseline], "CacheGraphics" -> False], 
             Spacer[24]]]], "See Also"}], "SeeAlsoSection", 
        CellSize -> {5000, Inherited}], BaseStyle -> None, Evaluator -> None, 
       Method -> "Preemptive", ButtonFunction :> (FrontEndExecute[{
          FrontEnd`SelectionMove[
           FrontEnd`SelectedNotebook[], All, ButtonCell], 
          FrontEndToken["OpenCloseGroup"], 
          FrontEnd`SelectionMove[
           FrontEnd`SelectedNotebook[], After, CellContents]}]& ), 
       ButtonFrame -> "None"]]], None}, {None, None}},
 CellFrameLabelMargins->0,
 CellSize->{Inherited, 
   FEPrivate`If[
    FEPrivate`Or[
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 11, 14]},
 "WholeCellGroupOpener" -> True,
 CellID->1255426704],

Cell[TextData[{
 Cell[BoxData[
  StyleBox[
   ButtonBox["OpticalField",
    BaseStyle->"Link",
    ButtonData->"paclet:AtomicDensityMatrix/ref/OpticalField"],
   FontFamily->"Verdana"]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  StyleBox[
   ButtonBox["RotatingWaveApproximation",
    BaseStyle->"Link",
    ButtonData->"paclet:AtomicDensityMatrix/ref/RotatingWaveApproximation"],
   FontFamily->"Verdana"]], "InlineFormula"]
}], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "TutorialsSection",
 CellElementSpacings->{"CellMinHeight"->3},
 CellFrameLabels->{{
    FEPrivate`If[
     FEPrivate`Or[
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 
     Cell[
      TextData[
       ButtonBox[
       "TUTORIALS", BaseStyle -> None, Evaluator -> None, Method -> 
        "Preemptive", ButtonFunction :> (FrontEndExecute[{
           FrontEnd`SelectionMove[
            FrontEnd`SelectedNotebook[], All, ButtonCell], 
           FrontEndToken["OpenCloseGroup"], 
           FrontEnd`SelectionMove[
            FrontEnd`SelectedNotebook[], After, CellContents]}]& ), 
        ButtonFrame -> "None"]], "TutorialsSection", 
      CellSize -> {5000, Inherited}], 
     TextData[
      ButtonBox[
       Cell[
        TextData[{
          Cell[
           BoxData[
            InterpretationBox[
             StyleBox[
              
              GraphicsBox[{}, ImageSize -> {24, 0}, BaselinePosition -> 
               Baseline], "CacheGraphics" -> False], 
             Spacer[24]]]], "Tutorials"}], "TutorialsSection", 
        CellSize -> {5000, Inherited}], BaseStyle -> None, Evaluator -> None, 
       Method -> "Preemptive", ButtonFunction :> (FrontEndExecute[{
          FrontEnd`SelectionMove[
           FrontEnd`SelectedNotebook[], All, ButtonCell], 
          FrontEndToken["OpenCloseGroup"], 
          FrontEnd`SelectionMove[
           FrontEnd`SelectedNotebook[], After, CellContents]}]& ), 
       ButtonFrame -> "None"]]], None}, {None, None}},
 CellFrameLabelMargins->0,
 CellSize->{Inherited, 
   FEPrivate`If[
    FEPrivate`Or[
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 11, 14]},
 "WholeCellGroupOpener" -> True,
 CellID->250839057],

Cell["", "SectionHeaderSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]],

Cell[TextData[ButtonBox["Zeeman Structure: Nonlinear Magneto-Optical \
Rotation",
 BaseStyle->"Link",
 ButtonData->
  "paclet:AtomicDensityMatrix/tutorial/\
ZeemanStructureNonlinearMagnetoOpticalRotation"]], "Tutorials",
 CellID->341631938],

Cell["", "SectionFooterSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "MoreAboutSection",
 CellElementSpacings->{"CellMinHeight"->3},
 CellFrameLabels->{{
    FEPrivate`If[
     FEPrivate`Or[
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 
     Cell[
      TextData[
       ButtonBox[
       "MORE ABOUT", BaseStyle -> None, Evaluator -> None, Method -> 
        "Preemptive", ButtonFunction :> (FrontEndExecute[{
           FrontEnd`SelectionMove[
            FrontEnd`SelectedNotebook[], All, ButtonCell], 
           FrontEndToken["OpenCloseGroup"], 
           FrontEnd`SelectionMove[
            FrontEnd`SelectedNotebook[], After, CellContents]}]& ), 
        ButtonFrame -> "None"]], "MoreAboutSection", 
      CellSize -> {5000, Inherited}], 
     TextData[
      ButtonBox[
       Cell[
        TextData[{
          Cell[
           BoxData[
            InterpretationBox[
             StyleBox[
              
              GraphicsBox[{}, ImageSize -> {24, 0}, BaselinePosition -> 
               Baseline], "CacheGraphics" -> False], 
             Spacer[24]]]], "More About"}], "MoreAboutSection", 
        CellSize -> {5000, Inherited}], BaseStyle -> None, Evaluator -> None, 
       Method -> "Preemptive", ButtonFunction :> (FrontEndExecute[{
          FrontEnd`SelectionMove[
           FrontEnd`SelectedNotebook[], All, ButtonCell], 
          FrontEndToken["OpenCloseGroup"], 
          FrontEnd`SelectionMove[
           FrontEnd`SelectedNotebook[], After, CellContents]}]& ), 
       ButtonFrame -> "None"]]], None}, {None, None}},
 CellFrameLabelMargins->0,
 CellSize->{Inherited, 
   FEPrivate`If[
    FEPrivate`Or[
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 11, 14]},
 "WholeCellGroupOpener" -> True,
 CellID->38303248],

Cell["", "SectionHeaderSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]],

Cell[TextData[ButtonBox["AtomicDensityMatrix Package",
 BaseStyle->"Link",
 ButtonData->
  "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"]], "MoreAbout",
 CellID->272368996],

Cell["", "SectionFooterSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "RelatedLinksSection",
 CellElementSpacings->{"CellMinHeight"->3},
 CellFrameLabels->{{
    FEPrivate`If[
     FEPrivate`Or[
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 
     Cell[
      TextData[
       ButtonBox[
       "RELATED LINKS", BaseStyle -> None, Evaluator -> None, Method -> 
        "Preemptive", ButtonFunction :> (FrontEndExecute[{
           FrontEnd`SelectionMove[
            FrontEnd`SelectedNotebook[], All, ButtonCell], 
           FrontEndToken["OpenCloseGroup"], 
           FrontEnd`SelectionMove[
            FrontEnd`SelectedNotebook[], After, CellContents]}]& ), 
        ButtonFrame -> "None"]], "RelatedLinksSection", 
      CellSize -> {5000, Inherited}], 
     TextData[
      ButtonBox[
       Cell[
        TextData[{
          Cell[
           BoxData[
            InterpretationBox[
             StyleBox[
              
              GraphicsBox[{}, ImageSize -> {24, 0}, BaselinePosition -> 
               Baseline], "CacheGraphics" -> False], 
             Spacer[24]]]], "Related Links"}], "RelatedLinksSection", 
        CellSize -> {5000, Inherited}], BaseStyle -> None, Evaluator -> None, 
       Method -> "Preemptive", ButtonFunction :> (FrontEndExecute[{
          FrontEnd`SelectionMove[
           FrontEnd`SelectedNotebook[], All, ButtonCell], 
          FrontEndToken["OpenCloseGroup"], 
          FrontEnd`SelectionMove[
           FrontEnd`SelectedNotebook[], After, CellContents]}]& ), 
       ButtonFrame -> "None"]]], None}, {None, None}},
 CellFrameLabelMargins->0,
 CellSize->{Inherited, 
   FEPrivate`If[
    FEPrivate`Or[
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 11, 14]},
 "WholeCellGroupOpener" -> True,
 CellID->1584193535],

Cell["", "SectionHeaderSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]],

Cell["\<\
Auzinsh, M., Budker, D. and Rochester, S. M. (2010). Optically Polarized \
Atoms: Understanding Light--Atom Interactions. Oxford University Press. Sec. \
10.1\
\>", "RelatedLinks",
 CellID->1038487239],

Cell["", "SectionFooterSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"Observables - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, 
  "Metadata" -> {
   "built" -> "{2014, 2, 28, 1, 42, 13.9627095}", "context" -> 
    "AtomicDensityMatrix`", "keywords" -> {"ADM", "Atomic Density Matrix"}, 
    "index" -> True, "label" -> "AtomicDensityMatrix Paclet Symbol", 
    "language" -> "en", "paclet" -> "AtomicDensityMatrix", "status" -> "None",
     "summary" -> 
    "Observables[sys, \\[Omega], a] returns the differential change in \
optical parameters of probe light with frequency \\[Omega] and amplitude a \
upon propagation through a medium described by atomic system sys in terms of \
the rotating-frame density-matrix elements, assuming default light \
polarization and rotating-wave transform. Observables[sys, \\[Omega], a, pol] \
returns the change in optical parameters for probe light of polarization \
specified by parameters pol. Observables[sys, \\[Omega], (a, \\[CurlyPhi]}, \
pol] returns the change in optical parameters for probe light with phase \
\\[CurlyPhi]. Observables[sys, \\[Omega], a, pol, TransformMatrix -> u] \
returns the change in optical parameters in terms of rotating-frame \
density-matrix elements assuming the rotating-wave transform described by the \
matrix u. ", "synonyms" -> {}, "title" -> "Observables", "type" -> "Symbol", 
    "uri" -> "AtomicDensityMatrix/ref/Observables"}, "SearchTextTranslated" -> 
  "", "SearchText" -> ""},
CellContext->"Global`",
FrontEndVersion->"6.0 for Microsoft Windows (64-bit) (May 21, 2008)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "6.0 for Microsoft Windows (64-bit) (May 21, 2008)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[28092, 730, 2081, 51, 70, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->33338035]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 83037, 2366}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[568, 21, 76, 1, 3, "SymbolColorBar"],
Cell[647, 24, 220, 5, 70, "LinkTrail"],
Cell[870, 31, 10659, 224, 70, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[11554, 259, 54, 1, 70, "ObjectName",
 CellID->1224892054],
Cell[11611, 262, 3375, 93, 70, "Usage",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[15023, 360, 2151, 54, 70, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->2036815],
Cell[17177, 416, 804, 18, 70, "SectionHeaderSpacer"],
Cell[17984, 436, 360, 10, 70, "Notes",
 CellID->1067943069],
Cell[18347, 448, 1772, 55, 70, "Notes",
 CellID->526616807],
Cell[20122, 505, 423, 11, 70, "Notes",
 CellID->647906718],
Cell[20548, 518, 765, 26, 70, "Notes",
 CellID->459585102],
Cell[21316, 546, 1671, 39, 70, "3ColumnTableMod",
 CellID->105855555],
Cell[22990, 587, 768, 26, 70, "Notes",
 CellID->52361245],
Cell[23761, 615, 2312, 58, 70, "3ColumnTableMod",
 CellID->9140984],
Cell[26076, 675, 87, 1, 70, "Notes",
 CellID->89725684],
Cell[26166, 678, 1082, 27, 70, "3ColumnTableMod",
 CellID->73958713],
Cell[27251, 707, 804, 18, 70, "SectionFooterSpacer"]
}, Closed]],
Cell[CellGroupData[{
Cell[28092, 730, 2081, 51, 70, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->33338035],
Cell[CellGroupData[{
Cell[30198, 785, 181, 6, 70, "ExampleSection",
 CellID->376094452],
Cell[30382, 793, 128, 3, 70, "Input",
 CellID->144993820],
Cell[30513, 798, 385, 15, 70, "ExampleText",
 CellID->543065180],
Cell[CellGroupData[{
Cell[30923, 817, 906, 23, 70, "Input",
 CellID->114432431],
Cell[31832, 842, 1588, 41, 70, "Output",
 CellID->587053931]
}, Open  ]],
Cell[33435, 886, 745, 18, 70, "ExampleText",
 CellID->106371938],
Cell[CellGroupData[{
Cell[34205, 908, 191, 6, 70, "Input",
 CellID->248409325],
Cell[34399, 916, 3593, 112, 70, "Output",
 CellID->115531579]
}, Open  ]],
Cell[38007, 1031, 1136, 37, 70, "ExampleText",
 CellID->17349946],
Cell[CellGroupData[{
Cell[39168, 1072, 554, 18, 70, "Input",
 CellID->7996356],
Cell[39725, 1092, 3498, 105, 70, "Output",
 CellID->210332409]
}, Open  ]],
Cell[43238, 1200, 519, 12, 70, "ExampleText",
 CellID->214192953],
Cell[CellGroupData[{
Cell[43782, 1216, 124, 3, 70, "ExampleDelimiter",
 CellID->39714538],
Cell[43909, 1221, 128, 3, 70, "Input",
 CellID->305214818],
Cell[44040, 1226, 460, 11, 70, "ExampleText",
 CellID->273621177],
Cell[44503, 1239, 385, 15, 70, "ExampleText",
 CellID->635639878],
Cell[44891, 1256, 943, 24, 70, "Input",
 CellID->52825860],
Cell[45837, 1282, 293, 10, 70, "ExampleText",
 CellID->157927092],
Cell[CellGroupData[{
Cell[46155, 1296, 655, 18, 70, "Input",
 CellID->108232262],
Cell[46813, 1316, 1016, 31, 70, "Output",
 CellID->57416189]
}, Open  ]],
Cell[47844, 1350, 119, 3, 70, "ExampleText",
 CellID->346356808],
Cell[CellGroupData[{
Cell[47988, 1357, 272, 9, 70, "Input",
 CellID->128568647],
Cell[48263, 1368, 2317, 65, 70, "Output",
 CellID->73252563]
}, Open  ]],
Cell[50595, 1436, 113, 3, 70, "ExampleText",
 CellID->215977394],
Cell[CellGroupData[{
Cell[50733, 1443, 871, 25, 70, "Input",
 CellID->706355312],
Cell[51607, 1470, 6113, 178, 70, "Output",
 CellID->645925858]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[57781, 1655, 254, 8, 70, "ExampleSection",
 CellID->10282375],
Cell[CellGroupData[{
Cell[58060, 1667, 269, 8, 70, "ExampleSubsection",
 CellID->337009752],
Cell[58332, 1677, 128, 3, 70, "Input",
 CellID->346500437],
Cell[58463, 1682, 385, 15, 70, "ExampleText",
 CellID->309781151],
Cell[CellGroupData[{
Cell[58873, 1701, 906, 23, 70, "Input",
 CellID->412071112],
Cell[59782, 1726, 1587, 41, 70, "Output",
 CellID->11095354]
}, Open  ]],
Cell[61384, 1770, 135, 4, 70, "ExampleText",
 CellID->48646922],
Cell[CellGroupData[{
Cell[61544, 1778, 245, 7, 70, "Input",
 CellID->25711507],
Cell[61792, 1787, 4226, 133, 70, "Output",
 CellID->150333598]
}, Open  ]],
Cell[66033, 1923, 804, 18, 70, "SectionFooterSpacer"]
}, Closed]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[66898, 1948, 1929, 48, 70, "SeeAlsoSection",
 CellID->1255426704],
Cell[68830, 1998, 572, 18, 70, "SeeAlso",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[69439, 2021, 1936, 48, 70, "TutorialsSection",
 CellID->250839057],
Cell[71378, 2071, 804, 18, 70, "SectionHeaderSpacer"],
Cell[72185, 2091, 240, 6, 70, "Tutorials",
 CellID->341631938],
Cell[72428, 2099, 804, 18, 70, "SectionFooterSpacer"]
}, Open  ]],
Cell[CellGroupData[{
Cell[73269, 2122, 1937, 48, 70, "MoreAboutSection",
 CellID->38303248],
Cell[75209, 2172, 804, 18, 70, "SectionHeaderSpacer"],
Cell[76016, 2192, 181, 4, 70, "MoreAbout",
 CellID->272368996],
Cell[76200, 2198, 804, 18, 70, "SectionFooterSpacer"]
}, Open  ]],
Cell[CellGroupData[{
Cell[77041, 2221, 1954, 48, 70, "RelatedLinksSection",
 CellID->1584193535],
Cell[78998, 2271, 804, 18, 70, "SectionHeaderSpacer"],
Cell[79805, 2291, 211, 5, 70, "RelatedLinks",
 CellID->1038487239],
Cell[80019, 2298, 804, 18, 70, "SectionFooterSpacer"]
}, Open  ]],
Cell[80838, 2319, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

