(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     61583,       1302]
NotebookOptionsPosition[     57654,       1188]
NotebookOutlinePosition[     59650,       1238]
CellTagsIndexPosition[     59607,       1235]
WindowFrame->Normal
ContainsDynamic->True *)

(* Beginning of Notebook Content *)
Notebook[{
Cell[" ", "TutorialColorBar",
 CellMargins->{{Inherited, Inherited}, {-5, 0}}],

Cell[TextData[{
 ButtonBox["AtomicDensityMatrix Package",
  BaseStyle->{"Link", "LinkTrail"},
  ButtonData->"paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"],
 StyleBox[" > ", "LinkTrailSeparator"]
}], "LinkTrail"],

Cell[BoxData[GridBox[{
   {
    StyleBox[
     GraphicsBox[RasterBox[CompressedData["
1:eJy9lulTk1cUxp+Zfu+Xfu5MO9O/oF90povj0A6dVtupdRsBqwRCg+DCqCxF
LLIIoUAIyGLayqJCFZRYVJaAaDBsQkBCEhaVoCjEBAiLTSLJ7bmX0nEBhZZ6
5mbmTebN/d3nnOec930/cN+mwLcAvEefD+jDr9nrwul0DvabbdaxuwNm++Ox
197/r8PQrY/bLwnyxYFvEL0F8TtwOiNq9IHFYDC4XK5VBGmvaXasg/QLRH6H
xABkBiFXhvw9fCVJP7LZbKsFemwdC1gP2ZdcjnwXCvag9BAuxOByHC4dQUU0
dBfzV4vV0aoL+4orOv49ckNRHo3qeDQehy4NzWnQpvCv/W2aRf+70vSeK8o/
+C0vkDIEZYdx5SfclKM9Az05MOai9wQ6FahLwJT9ObeQkaqrq3t7e1fESo+W
/LgV8t1QhfPU1Seh5WfczoY5D4Mn0V/AoSSwNkfidjnpfofDUVVVpVKpFArF
5OTkiliZMZJ4PyiCceYg/ohDUyq6stCXhzsqziIicXVyXriyVMnQoHnt2rV+
fn5paWkmk2lFIAptrfqYHzceJZBy1ZaObiUGCjirL5/nsDWdl+yXvfw8R3e8
EyYLIVBhYSEJfMW25F6HCKeI+R+npxzJOzmLEtiQhFuZvEzEouzps9CQzN1C
5s8IQroE4VvWJB2NLsqKP3U8vCI7ytypm0/syzExMaFWqxMTE2NjY0NDQ6VS
aVNTk8vpVMVLToZxq9cnclZvLsd1KDiFtFA1Y7aAtKfuflsRFXA+YSMdifzT
ks7PdjXV1/7IspS69vZ2uVyeLYKqbLFYGmursqUoO8RzRSwqUJcSJRGcsssH
gZ/zYULaC/fzapJVhn7F47MYPw/b77CVYlCFe83qpXDUFw0NDSUlJZRPo9FY
U1OTk5kWfzjsVOQ6qg7t1piMw5uw/VPs/gx7N/JhQiBy42gJZi/iaS3YdTAd
WBtYEzwaTJbj0a0lcez5TrxvGcpOOFCsiCOxOTEBcdu5HN7jm3k7kG2ou20X
4KqDpxXsNlgPmAmsD6xfXLdh5jK8Txev3cthHbHkhWLfRq6FRhY1OMmZ92db
BkbPYk4LZgS7BzYMZhHr/sIaBNPDZX6VtGeDJvDWT3iBwjZwM5yQ8ZLdSMGA
CvZyeBrE+Qn0QLCGwO6KixGwh+JHwg0vi3X6t/xtArTvayT4o/gAauLRmYVH
xXBWgmnAOsEMYunBugSXEnhHqBsRi9Cji4/NZ6MgK3Xrx7xAVB3qIz7b0/jQ
mD4PTzXYNbBWjrBW4mExZtXw1nNLcKhRyLEIgXThMC8ndTvXI3Yb0gNx+Sjv
rNHT+FMN1igo3VzIXD0myjB5DtMV8F5ZOECXcMggF2hvW+OcedUkoYcXGTvY
lzucZi+BqLlmKjB3FV6dOLlZ7Ebb3oRXAzeZrUak9IYwPN3QK264jYfmG0ql
UqfTud3uRVl1V9TkOrKcUoq6YzDlwVEBz3V42xfyc0eUhjbsAGsB04qlE/QO
oYv8b5Iw19+KZmdnl9JVVX7m0CZkSXmNqP2fXIS3UezQt+DqAZFDk/BGm8A1
i9Uivhqj2IiGzS2rrcI30OjGuUgYcmAthUcr0jK44K57mGp511r1ITdDI7xa
Pi68VKkWibs5io3pl0mZj+wjkuwf+AgdL8VcrUiLSfTmiOigHlSejLTb7XNP
HJ6pMc+4hdFkWPZweCGMHbriCJjzMX1B2NggCjQkerYLTlufv79/T0/PUuVe
UdDTpzLJl56Jzkui3D0LxuuVOMctPj4+MpksOTlZr9f/dxbFU5dztFtjPcPN
7CUnd0cxq34+URERESEhISkpKTMzM6vC+ic8bucLg3p4eDgoKIjel1YXtGjQ
e0JwcDA94N4Ai6KoqGh8fPzNsFbFgf9r/AWVRIUY
       "], {{0, 0}, {36, 32}}, {0, 255},
       ColorFunction->RGBColor],
      ImageSize->{36, 32},
      PlotRange->{{0, 36}, {0, 32}}],
     Deployed->True,
     StripOnInput->False], Cell[
    "ATOMIC DENSITY MATRIX TUTORIAL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "Visualizing Polarization Moments and Quantum Beats", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/tutorial/\
VisualizingPolarizationMomentsAndQuantumBeats", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]]}, #, 2]& , Evaluator -> 
        Automatic], {
       1->"\<\"Visualizing Polarization Moments and Quantum Beats\"\>"}, 
       FrameBox["\<\"Related Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"Related Tutorials \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "AtomicDensityMatrix Package", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]]}, #, 2]& , Evaluator -> 
        Automatic], {1->"\<\"AtomicDensityMatrix Package\"\>"}, 
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"More About \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "AMPSPlot", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/ref/AMPSPlot", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]], 
          StringReplace[
           "MaxProjectionProbability", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/ref/MaxProjectionProbability", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]]}, #, 2]& , Evaluator -> 
        Automatic], {1->"\<\"AMPSPlot\"\>", 
       2->"\<\"MaxProjectionProbability\"\>"}, 
       FrameBox["\<\"Functions \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"Functions \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "AtomicDensityMatrix/tutorial/AngularMomentumProbabilitySurfaces", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> None, 
          StringReplace[
           "Copy Mathematica url", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> 
          Module[{DocumentationSearch`Private`nb$}, 
            DocumentationSearch`Private`nb$ = NotebookPut[
               Notebook[{
                 Cell[
                  StringReplace[
                  "AtomicDensityMatrix/tutorial/\
AngularMomentumProbabilitySurfaces", 
                   "http://reference.wolfram.com/mathematica/" -> 
                   "http://budker.berkeley.edu/ADM/"]]}, Visible -> False]]; 
            SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
            FrontEndTokenExecute[DocumentationSearch`Private`nb$, 
              StringReplace[
              "Copy", "http://reference.wolfram.com/mathematica/" -> 
               "http://budker.berkeley.edu/ADM/"]]; 
            NotebookClose[DocumentationSearch`Private`nb$]; Null], Delimiter, 
          StringReplace[
           "Copy web url", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> 
          Module[{DocumentationSearch`Private`nb$}, 
            DocumentationSearch`Private`nb$ = NotebookPut[
               Notebook[{
                 Cell[
                  BoxData[
                   MakeBoxes[
                    Hyperlink[
                    StringReplace[
                    "http://reference.wolfram.com/mathematica/\
AtomicDensityMatrix/tutorial/AngularMomentumProbabilitySurfaces.html", 
                    "http://reference.wolfram.com/mathematica/" -> 
                    "http://budker.berkeley.edu/ADM/"]], StandardForm]], 
                  StringReplace[
                  "Input", "http://reference.wolfram.com/mathematica/" -> 
                   "http://budker.berkeley.edu/ADM/"], TextClipboardType -> 
                  StringReplace[
                   "PlainText", "http://reference.wolfram.com/mathematica/" -> 
                    "http://budker.berkeley.edu/ADM/"]]}, Visible -> False]]; 
            SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
            FrontEndTokenExecute[DocumentationSearch`Private`nb$, 
              StringReplace[
              "Copy", "http://reference.wolfram.com/mathematica/" -> 
               "http://budker.berkeley.edu/ADM/"]]; 
            NotebookClose[DocumentationSearch`Private`nb$]; Null], 
          StringReplace[
           "Go to web url", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> FrontEndExecute[{
             NotebookLocate[{
               URL[
                StringJoin[
                 StringReplace[
                 "http://reference.wolfram.com/mathematica/", 
                  "http://reference.wolfram.com/mathematica/" -> 
                  "http://budker.berkeley.edu/ADM/"], 
                 StringReplace[
                 "AtomicDensityMatrix/tutorial/\
AngularMomentumProbabilitySurfaces", 
                  "http://reference.wolfram.com/mathematica/" -> 
                  "http://budker.berkeley.edu/ADM/"], 
                 StringReplace[
                 ".html", "http://reference.wolfram.com/mathematica/" -> 
                  "http://budker.berkeley.edu/ADM/"]]], None}]}]}, #, 2]& , 
        Evaluator -> Automatic], {
       1->"\<\"AtomicDensityMatrix/tutorial/\
AngularMomentumProbabilitySurfaces\"\>", 2->"\<\"Copy Mathematica url\"\>", 
       Delimiter, 4->"\<\"Copy web url\"\>", 5->"\<\"Go to web url\"\>"}, 
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"URL \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxAlignment->{"Columns" -> {{Left, Left, Right}}},
 GridBoxItemSize->{"Columns" -> {
     Scaled[0.05], 
     Scaled[0.3], {
      Scaled[0.64]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[CellGroupData[{

Cell["Angular-momentum Probability Surfaces", "Title",
 CellID->509267359],

Cell["\<\
The angular-momentum probability surface can be used as a graphical \
representation of the density matrix for a state with a particular \
total-angular-momentum quantum number.\
\>", "Text",
 CellID->1534169418],

Cell[BoxData[GridBox[{
   {
    RowBox[{
     ButtonBox["MaxProjectionProbability",
      BaseStyle->"Link",
      ButtonData->"paclet:AtomicDensityMatrix/ref/MaxProjectionProbability"], 
     "[", 
     RowBox[{
      StyleBox["dm", "TI"], ",", 
      StyleBox["\[Theta]", "TR"], ",", 
      StyleBox["\[Phi]", "TR"]}], "]"}], Cell[TextData[{
     "probability of finding the maximum possible projection of angular \
momentum along direction (",
     Cell[BoxData[
      StyleBox["\[Theta]", "TR"]], "InlineFormula"],
     ",",
     Cell[BoxData[
      StyleBox["\[Phi]", "TR"]], "InlineFormula"],
     ") for density matrix ",
     Cell[BoxData[
      StyleBox["dm", "TI"]], "InlineFormula"]
    }], "TableText"]},
   {
    RowBox[{
     ButtonBox["AMPSPlot",
      BaseStyle->"Link",
      ButtonData->"paclet:AtomicDensityMatrix/ref/AMPSPlot"], "[", 
     StyleBox["dm", "TI"], "]"}], Cell[
    "plot the angular-momentum probability surface", "TableText"]}
  }]], "DefinitionBox",
 CellID->219609462],

Cell["Plotting angular-momentum probability surfaces.", "Caption",
 CellID->232200977],

Cell["This loads the package.", "MathCaption",
 CellID->220621655],

Cell[BoxData[
 RowBox[{"<<", "AtomicDensityMatrix`"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->709080811],

Cell["\<\
Here is the formula for the angular-momentum probability surface for an \
aligned state.\
\>", "MathCaption",
 CellID->713144735],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MaxProjectionProbability", "[", 
  RowBox[{
   RowBox[{"(", GridBox[{
      {"0", "0", "0"},
      {"0", "1", "0"},
      {"0", "0", "0"}
     }], ")"}], ",", "\[Theta]", ",", "\[Phi]"}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->429015759],

Cell[BoxData[
 RowBox[{"2", " ", 
  SuperscriptBox[
   RowBox[{"Cos", "[", 
    FractionBox["\[Theta]", "2"], "]"}], "2"], " ", 
  SuperscriptBox[
   RowBox[{"Sin", "[", 
    FractionBox["\[Theta]", "2"], "]"}], "2"]}]], "Output",
 ImageSize->{121, 31},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->408410380]
}, Open  ]],

Cell[TextData[{
 StyleBox["AMPSPlot", "MR"],
 " can be used to plot the surface directly."
}], "MathCaption",
 CellID->8319411],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"AMPSPlot", "[", 
  RowBox[{"(", GridBox[{
     {"0", "0", "0"},
     {"0", "1", "0"},
     {"0", "0", "0"}
    }], ")"}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->193519329],

Cell[GraphicsData["CompressedBitmap", "\<\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\
\>"], "Output",
 Evaluatable->False,
 ImageSize->{180, 135},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->618318041]
}, Open  ]],

Cell[TextData[{
 "The function ",
 Cell[BoxData[
  ButtonBox["Axes3D",
   BaseStyle->"Link",
   ButtonData->"paclet:Graphics/ref/Axes3D"]], "InlineFormula"],
 " from the ",
 ButtonBox["Arrow3D",
  BaseStyle->"Link",
  ButtonData->"paclet:Graphics/guide/Arrow3D"],
 " package (supplied with the ",
 ButtonBox["AtomicDensityMatrix",
  BaseStyle->"Link",
  ButtonData->"paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"],
 " package) can be used to add axes to the plot. ",
 Cell[BoxData[
  ButtonBox["AMPSPlot",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/AMPSPlot"]], "InlineFormula"],
 " takes the same options as ",
 Cell[BoxData[
  ButtonBox["SphericalPlot3D",
   BaseStyle->"Link",
   ButtonData->"paclet:ref/SphericalPlot3D"]], "InlineFormula"],
 "."
}], "Text",
 CellID->191111689],

Cell["Load the package.", "MathCaption",
 CellID->475428436],

Cell[BoxData[
 RowBox[{"<<", "Graphics`Arrow3D`"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->679715168],

Cell["Plot the AMPS, including axes.", "MathCaption",
 CellID->411065876],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Axes3D", "[", 
  RowBox[{
   RowBox[{"AMPSPlot", "[", 
    RowBox[{
     RowBox[{"(", GridBox[{
        {"0", "0", "0"},
        {"0", "1", "0"},
        {"0", "0", "0"}
       }], ")"}], ",", 
     RowBox[{"Boxed", "\[Rule]", "False"}], ",", 
     RowBox[{"Axes", "\[Rule]", "False"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}], ",", 
   RowBox[{"BaseStyle", "\[Rule]", "Gray"}], ",", 
   RowBox[{"AutoLengthScale", "\[Rule]", "1.5"}]}], "]"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->92939516],

Cell[GraphicsData["CompressedBitmap", "\<\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\
\>"], "Output",
 Evaluatable->False,
 ImageSize->{180, 197},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->92765207]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "TutorialMoreAboutSection",
 CellElementSpacings->{"CellMinHeight"->3},
 CellFrameLabels->{{
    FEPrivate`If[
     FEPrivate`Or[
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 
     Cell[
     "MORE ABOUT", "TutorialMoreAboutSection", CellSize -> {5000, Inherited}],
      
     Cell[
      TextData[{
        Cell[
         BoxData[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {24, 0}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[24]]]], "More About"}], "TutorialMoreAboutSection", 
      CellSize -> {5000, Inherited}]], None}, {None, None}},
 CellFrameLabelMargins->0,
 CellSize->{Inherited, 
   FEPrivate`If[
    FEPrivate`Or[
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 11, 14]},
 "WholeCellGroupOpener" -> True,
 CellID->23220180],

Cell["", "SectionHeaderSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]],

Cell[TextData[ButtonBox["AtomicDensityMatrix Package",
 BaseStyle->"Link",
 ButtonData->
  "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"]], \
"TutorialMoreAbout",
 CellID->1567025153],

Cell["", "SectionFooterSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "RelatedTutorialsSection",
 CellElementSpacings->{"CellMinHeight"->3},
 CellFrameLabels->{{
    FEPrivate`If[
     FEPrivate`Or[
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 
     Cell[
     "RELATED TUTORIALS", "RelatedTutorialsSection", 
      CellSize -> {5000, Inherited}], 
     Cell[
      TextData[{
        Cell[
         BoxData[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {24, 0}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[24]]]], "Related Tutorials"}], "RelatedTutorialsSection", 
      CellSize -> {5000, Inherited}]], None}, {None, None}},
 CellFrameLabelMargins->0,
 CellSize->{Inherited, 
   FEPrivate`If[
    FEPrivate`Or[
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 11, 14]},
 "WholeCellGroupOpener" -> True,
 CellID->415694126],

Cell["", "SectionHeaderSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]],

Cell[TextData[ButtonBox["Visualizing Polarization Moments and Quantum Beats",
 BaseStyle->"Link",
 ButtonData->
  "paclet:AtomicDensityMatrix/tutorial/\
VisualizingPolarizationMomentsAndQuantumBeats"]], "RelatedTutorials",
 CellID->806871991],

Cell["", "SectionFooterSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]]
}, Open  ]]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"Angular-momentum Probability Surfaces - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, 
  "Metadata" -> {
   "built" -> "{2014, 2, 28, 1, 42, 25.7963864}", "context" -> 
    "AtomicDensityMatrix`", "keywords" -> {"Atomic Density Matrix", "ADM"}, 
    "index" -> True, "label" -> "Atomic Density Matrix Tutorial", "language" -> 
    "en", "paclet" -> "AtomicDensityMatrix", "status" -> "None", "summary" -> 
    "The angular-momentum probability surface can be used as a graphical \
representation of the density matrix for a state with a particular \
total-angular-momentum quantum number. Plotting angular-momentum probability \
surfaces. This loads the package.", "synonyms" -> {}, "title" -> 
    "Angular-momentum Probability Surfaces", "type" -> "Tutorial", "uri" -> 
    "AtomicDensityMatrix/tutorial/AngularMomentumProbabilitySurfaces"}, 
  "SearchTextTranslated" -> "", "SearchText" -> ""},
FrontEndVersion->"6.0 for Microsoft Windows (64-bit) (May 21, 2008)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"], 
   Cell[
    StyleData["TutorialMoreAboutSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}], 
   Cell[
    StyleData["RelatedTutorialsSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}], 
   Cell[
    StyleData["TutorialRelatedLinksSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}]}, Visible -> False, 
  FrontEndVersion -> "6.0 for Microsoft Windows (64-bit) (May 21, 2008)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[568, 21, 78, 1, 3, "TutorialColorBar"],
Cell[649, 24, 220, 5, 70, "LinkTrail"],
Cell[872, 31, 10792, 226, 70, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[11689, 261, 74, 1, 70, "Title",
 CellID->509267359],
Cell[11766, 264, 222, 5, 70, "Text",
 CellID->1534169418],
Cell[11991, 271, 1005, 30, 70, "DefinitionBox",
 CellID->219609462],
Cell[12999, 303, 86, 1, 70, "Caption",
 CellID->232200977],
Cell[13088, 306, 66, 1, 70, "MathCaption",
 CellID->220621655],
Cell[13157, 309, 107, 3, 70, "Input",
 CellID->709080811],
Cell[13267, 314, 139, 4, 70, "MathCaption",
 CellID->713144735],
Cell[CellGroupData[{
Cell[13431, 322, 271, 9, 70, "Input",
 CellID->429015759],
Cell[13705, 333, 361, 12, 70, "Output",
 CellID->408410380]
}, Open  ]],
Cell[14081, 348, 127, 4, 70, "MathCaption",
 CellID->8319411],
Cell[CellGroupData[{
Cell[14233, 356, 205, 8, 70, "Input",
 CellID->193519329],
Cell[14441, 366, 23506, 389, 70, "Output",
 Evaluatable->False,
 CellID->618318041]
}, Open  ]],
Cell[37962, 758, 815, 26, 70, "Text",
 CellID->191111689],
Cell[38780, 786, 60, 1, 70, "MathCaption",
 CellID->475428436],
Cell[38843, 789, 104, 3, 70, "Input",
 CellID->679715168],
Cell[38950, 794, 73, 1, 70, "MathCaption",
 CellID->411065876],
Cell[CellGroupData[{
Cell[39048, 799, 539, 16, 70, "Input",
 CellID->92939516],
Cell[39590, 817, 12041, 201, 70, "Output",
 Evaluatable->False,
 CellID->92765207]
}, Open  ]],
Cell[CellGroupData[{
Cell[51668, 1023, 1107, 30, 70, "TutorialMoreAboutSection",
 CellID->23220180],
Cell[52778, 1055, 804, 18, 70, "SectionHeaderSpacer"],
Cell[53585, 1075, 192, 5, 70, "TutorialMoreAbout",
 CellID->1567025153],
Cell[53780, 1082, 804, 18, 70, "SectionFooterSpacer"]
}, Open  ]],
Cell[CellGroupData[{
Cell[54621, 1105, 1120, 30, 70, "RelatedTutorialsSection",
 CellID->415694126],
Cell[55744, 1137, 804, 18, 70, "SectionHeaderSpacer"],
Cell[56551, 1157, 242, 5, 70, "RelatedTutorials",
 CellID->806871991],
Cell[56796, 1164, 804, 18, 70, "SectionFooterSpacer"]
}, Open  ]]
}, Open  ]],
Cell[57627, 1186, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

