(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[    132954,       3163]
NotebookOptionsPosition[    128875,       3041]
NotebookOutlinePosition[    130863,       3091]
CellTagsIndexPosition[    130820,       3088]
WindowFrame->Normal
ContainsDynamic->True *)

(* Beginning of Notebook Content *)
Notebook[{
Cell[" ", "TutorialColorBar",
 CellMargins->{{Inherited, Inherited}, {-5, 0}}],

Cell[TextData[{
 ButtonBox["AtomicDensityMatrix Package",
  BaseStyle->{"Link", "LinkTrail"},
  ButtonData->"paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"],
 StyleBox[" > ", "LinkTrailSeparator"]
}], "LinkTrail"],

Cell[BoxData[GridBox[{
   {
    StyleBox[
     GraphicsBox[RasterBox[CompressedData["
1:eJy9lulTk1cUxp+Zfu+Xfu5MO9O/oF90povj0A6dVtupdRsBqwRCg+DCqCxF
LLIIoUAIyGLayqJCFZRYVJaAaDBsQkBCEhaVoCjEBAiLTSLJ7bmX0nEBhZZ6
5mbmTebN/d3nnOec930/cN+mwLcAvEefD+jDr9nrwul0DvabbdaxuwNm++Ox
197/r8PQrY/bLwnyxYFvEL0F8TtwOiNq9IHFYDC4XK5VBGmvaXasg/QLRH6H
xABkBiFXhvw9fCVJP7LZbKsFemwdC1gP2ZdcjnwXCvag9BAuxOByHC4dQUU0
dBfzV4vV0aoL+4orOv49ckNRHo3qeDQehy4NzWnQpvCv/W2aRf+70vSeK8o/
+C0vkDIEZYdx5SfclKM9Az05MOai9wQ6FahLwJT9ObeQkaqrq3t7e1fESo+W
/LgV8t1QhfPU1Seh5WfczoY5D4Mn0V/AoSSwNkfidjnpfofDUVVVpVKpFArF
5OTkiliZMZJ4PyiCceYg/ohDUyq6stCXhzsqziIicXVyXriyVMnQoHnt2rV+
fn5paWkmk2lFIAptrfqYHzceJZBy1ZaObiUGCjirL5/nsDWdl+yXvfw8R3e8
EyYLIVBhYSEJfMW25F6HCKeI+R+npxzJOzmLEtiQhFuZvEzEouzps9CQzN1C
5s8IQroE4VvWJB2NLsqKP3U8vCI7ytypm0/syzExMaFWqxMTE2NjY0NDQ6VS
aVNTk8vpVMVLToZxq9cnclZvLsd1KDiFtFA1Y7aAtKfuflsRFXA+YSMdifzT
ks7PdjXV1/7IspS69vZ2uVyeLYKqbLFYGmursqUoO8RzRSwqUJcSJRGcsssH
gZ/zYULaC/fzapJVhn7F47MYPw/b77CVYlCFe83qpXDUFw0NDSUlJZRPo9FY
U1OTk5kWfzjsVOQ6qg7t1piMw5uw/VPs/gx7N/JhQiBy42gJZi/iaS3YdTAd
WBtYEzwaTJbj0a0lcez5TrxvGcpOOFCsiCOxOTEBcdu5HN7jm3k7kG2ou20X
4KqDpxXsNlgPmAmsD6xfXLdh5jK8Txev3cthHbHkhWLfRq6FRhY1OMmZ92db
BkbPYk4LZgS7BzYMZhHr/sIaBNPDZX6VtGeDJvDWT3iBwjZwM5yQ8ZLdSMGA
CvZyeBrE+Qn0QLCGwO6KixGwh+JHwg0vi3X6t/xtArTvayT4o/gAauLRmYVH
xXBWgmnAOsEMYunBugSXEnhHqBsRi9Cji4/NZ6MgK3Xrx7xAVB3qIz7b0/jQ
mD4PTzXYNbBWjrBW4mExZtXw1nNLcKhRyLEIgXThMC8ndTvXI3Yb0gNx+Sjv
rNHT+FMN1igo3VzIXD0myjB5DtMV8F5ZOECXcMggF2hvW+OcedUkoYcXGTvY
lzucZi+BqLlmKjB3FV6dOLlZ7Ebb3oRXAzeZrUak9IYwPN3QK264jYfmG0ql
UqfTud3uRVl1V9TkOrKcUoq6YzDlwVEBz3V42xfyc0eUhjbsAGsB04qlE/QO
oYv8b5Iw19+KZmdnl9JVVX7m0CZkSXmNqP2fXIS3UezQt+DqAZFDk/BGm8A1
i9Uivhqj2IiGzS2rrcI30OjGuUgYcmAthUcr0jK44K57mGp511r1ITdDI7xa
Pi68VKkWibs5io3pl0mZj+wjkuwf+AgdL8VcrUiLSfTmiOigHlSejLTb7XNP
HJ6pMc+4hdFkWPZweCGMHbriCJjzMX1B2NggCjQkerYLTlufv79/T0/PUuVe
UdDTpzLJl56Jzkui3D0LxuuVOMctPj4+MpksOTlZr9f/dxbFU5dztFtjPcPN
7CUnd0cxq34+URERESEhISkpKTMzM6vC+ic8bucLg3p4eDgoKIjel1YXtGjQ
e0JwcDA94N4Ai6KoqGh8fPzNsFbFgf9r/AWVRIUY
       "], {{0, 0}, {36, 32}}, {0, 255},
       ColorFunction->RGBColor],
      ImageSize->{36, 32},
      PlotRange->{{0, 36}, {0, 32}}],
     Deployed->True,
     StripOnInput->False], Cell[
    "ATOMIC DENSITY MATRIX TUTORIAL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "AtomicDensityMatrix Package", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]]}, #, 2]& , Evaluator -> 
        Automatic], {1->"\<\"AtomicDensityMatrix Package\"\>"}, 
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"More About \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "AtomicDensityMatrix/tutorial/LightPolarizationDemonstration", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> None, 
          StringReplace[
           "Copy Mathematica url", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> 
          Module[{DocumentationSearch`Private`nb$}, 
            DocumentationSearch`Private`nb$ = NotebookPut[
               Notebook[{
                 Cell[
                  StringReplace[
                  "AtomicDensityMatrix/tutorial/\
LightPolarizationDemonstration", "http://reference.wolfram.com/mathematica/" -> 
                   "http://budker.berkeley.edu/ADM/"]]}, Visible -> False]]; 
            SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
            FrontEndTokenExecute[DocumentationSearch`Private`nb$, 
              StringReplace[
              "Copy", "http://reference.wolfram.com/mathematica/" -> 
               "http://budker.berkeley.edu/ADM/"]]; 
            NotebookClose[DocumentationSearch`Private`nb$]; Null], Delimiter, 
          StringReplace[
           "Copy web url", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> 
          Module[{DocumentationSearch`Private`nb$}, 
            DocumentationSearch`Private`nb$ = NotebookPut[
               Notebook[{
                 Cell[
                  BoxData[
                   MakeBoxes[
                    Hyperlink[
                    StringReplace[
                    "http://reference.wolfram.com/mathematica/\
AtomicDensityMatrix/tutorial/LightPolarizationDemonstration.html", 
                    "http://reference.wolfram.com/mathematica/" -> 
                    "http://budker.berkeley.edu/ADM/"]], StandardForm]], 
                  StringReplace[
                  "Input", "http://reference.wolfram.com/mathematica/" -> 
                   "http://budker.berkeley.edu/ADM/"], TextClipboardType -> 
                  StringReplace[
                   "PlainText", "http://reference.wolfram.com/mathematica/" -> 
                    "http://budker.berkeley.edu/ADM/"]]}, Visible -> False]]; 
            SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
            FrontEndTokenExecute[DocumentationSearch`Private`nb$, 
              StringReplace[
              "Copy", "http://reference.wolfram.com/mathematica/" -> 
               "http://budker.berkeley.edu/ADM/"]]; 
            NotebookClose[DocumentationSearch`Private`nb$]; Null], 
          StringReplace[
           "Go to web url", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> FrontEndExecute[{
             NotebookLocate[{
               URL[
                StringJoin[
                 StringReplace[
                 "http://reference.wolfram.com/mathematica/", 
                  "http://reference.wolfram.com/mathematica/" -> 
                  "http://budker.berkeley.edu/ADM/"], 
                 StringReplace[
                 "AtomicDensityMatrix/tutorial/\
LightPolarizationDemonstration", "http://reference.wolfram.com/mathematica/" -> 
                  "http://budker.berkeley.edu/ADM/"], 
                 StringReplace[
                 ".html", "http://reference.wolfram.com/mathematica/" -> 
                  "http://budker.berkeley.edu/ADM/"]]], None}]}]}, #, 2]& , 
        Evaluator -> Automatic], {
       1->"\<\"AtomicDensityMatrix/tutorial/LightPolarizationDemonstration\"\>\
", 2->"\<\"Copy Mathematica url\"\>", Delimiter, 4->"\<\"Copy web url\"\>", 
       5->"\<\"Go to web url\"\>"}, 
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"URL \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxAlignment->{"Columns" -> {{Left, Left, Right}}},
 GridBoxItemSize->{"Columns" -> {
     Scaled[0.05], 
     Scaled[0.3], {
      Scaled[0.64]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[CellGroupData[{

Cell["Light Polarization Demonstration", "Title",
 CellID->196759130],

Cell["\<\
An interactive demonstration illustrating parameterizations for light \
polarization. Light polarization can be selected using the \
\[Alpha]-\[Epsilon], x-\[Phi], and Stokes parameterizations. The polarization \
ellipse and Poincar\[EAcute] sphere are plotted.\
\>", "Text",
 CellID->51546441],

Cell[CellGroupData[{

Cell["Demonstration code", "Section",
 CellID->44645273],

Cell[CellGroupData[{

Cell["Graphics setup", "SubsectionOpener",
 CellID->965371655],

Cell[BoxData[
 RowBox[{"<<", "Graphics`Arrow3D`"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->171085568],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MyNumberForm", "[", "x_", "]"}], ":=", 
   RowBox[{"NumberForm", "[", 
    RowBox[{
     RowBox[{"N", "[", 
      RowBox[{"x", ",", "2"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2"}], "}"}], ",", 
     RowBox[{"NumberSigns", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"\"\<-\>\"", ",", "\"\<   \>\""}], "}"}]}], ",", 
     RowBox[{"ExponentFunction", "\[Rule]", 
      RowBox[{"(", 
       RowBox[{"Null", "&"}], ")"}]}]}], "]"}]}], ";"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->109334777],

Cell[BoxData[
 RowBox[{"SetAttributes", "[", 
  RowBox[{"PaddedInputField", ",", "HoldAll"}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->343416248],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PaddedInputField", "[", 
    RowBox[{"x_", ",", "func_"}], "]"}], ":=", 
   RowBox[{"InputField", "[", 
    RowBox[{
     RowBox[{"Dynamic", "[", 
      RowBox[{
       RowBox[{"DisplayForm", "@", 
        RowBox[{"StyleBox", "[", 
         RowBox[{"ToString", "@", 
          RowBox[{"MyNumberForm", "[", "x", "]"}]}], "]"}]}], ",", "func"}], 
      "]"}], ",", 
     RowBox[{"FieldSize", "\[Rule]", "5"}]}], "]"}]}], ";"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->56403217],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PaddedInputField", "[", 
    RowBox[{"x_", ",", "func_", ",", "p_"}], "]"}], ":=", 
   RowBox[{"InputField", "[", 
    RowBox[{
     RowBox[{"Dynamic", "[", 
      RowBox[{
       RowBox[{"DisplayForm", "@", 
        RowBox[{"RowBox", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"ToString", "@", 
            RowBox[{"MyNumberForm", "[", 
             RowBox[{"x", "/", "p"}], "]"}]}], ",", 
           RowBox[{"TraditionalForm", "@", "p"}]}], "}"}], "]"}]}], ",", 
       "func"}], "]"}], ",", 
     RowBox[{"FieldSize", "\[Rule]", "5"}]}], "]"}]}], ";"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->11061968],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"Circle3D", ",", 
    RowBox[{"LabelPosition", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1.2", ",", "0"}], "}"}]}]}], "]"}], ";"}]], "Input",
 CellLabel->"In[6]:=",
 CellID->177524866],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "Arc", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Label", "\[Rule]", "None"}], ",", 
     RowBox[{"LabelPosition", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0", ",", "1.1"}], "}"}]}], ",", 
     RowBox[{"LabelStyle", "\[Rule]", 
      RowBox[{"{", "}"}]}]}], "}"}]}], ";"}]], "Input",
 CellLabel->"In[7]:=",
 CellID->228198244],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Arc", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"x_", ",", "y_"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"r1_", ",", "r2_"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\[Theta]1_", ",", "\[Theta]2_"}], "}"}], ",", 
     RowBox[{"OptionsPattern", "[", "]"}]}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"pos", "=", 
       RowBox[{"OptionValue", "@", "LabelPosition"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"\[Theta]1", "==", "\[Theta]2"}], ",", 
       RowBox[{"{", "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Arrow", "@@", 
          RowBox[{
           RowBox[{"Cases", "[", 
            RowBox[{
             RowBox[{"Flatten", "[", 
              RowBox[{
               RowBox[{"ParametricPlot", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"x", "+", 
                    RowBox[{"r1", " ", 
                    RowBox[{"Cos", "[", "\[Theta]", "]"}]}]}], ",", 
                   RowBox[{"y", "+", 
                    RowBox[{"r2", " ", 
                    RowBox[{"Sin", "[", "\[Theta]", "]"}]}]}]}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"\[Theta]", ",", "\[Theta]1", ",", "\[Theta]2"}], 
                  "}"}]}], "]"}], "\[LeftDoubleBracket]", "1", 
               "\[RightDoubleBracket]"}], "]"}], ",", 
             RowBox[{"Line", "[", "_", "]"}]}], "]"}], "\[LeftDoubleBracket]",
            "1", "\[RightDoubleBracket]"}]}], ",", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"OptionValue", "[", "Label", "]"}], "=!=", "None"}], ",", 
           
           RowBox[{"Rotate", "[", 
            RowBox[{
             RowBox[{"Text", "[", 
              RowBox[{
               RowBox[{"OptionValue", "[", "Label", "]"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Mean", "[", 
                   RowBox[{"{", 
                    RowBox[{"r1", ",", "r2"}], "}"}], "]"}], 
                  RowBox[{
                  "pos", "\[LeftDoubleBracket]", "2", 
                   "\[RightDoubleBracket]"}]}], ",", "0"}], "}"}]}], "]"}], 
             ",", 
             RowBox[{
              RowBox[{
               RowBox[{
               "pos", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
               
               RowBox[{"(", 
                RowBox[{"\[Theta]2", "-", "\[Theta]1"}], ")"}]}], "+", 
              RowBox[{"Mean", "[", 
               RowBox[{"{", 
                RowBox[{"\[Theta]1", ",", "\[Theta]2"}], "}"}], "]"}]}], ",", 
             
             RowBox[{"{", 
              RowBox[{"0", ",", "0"}], "}"}]}], "]"}], ",", 
           RowBox[{"{", "}"}]}], "]"}]}], "}"}]}], "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 CellLabel->"In[8]:=",
 CellID->338406235],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ColorAll", "[", "col_", "]"}], ":=", 
   RowBox[{"Sequence", "[", 
    RowBox[{"col", ",", 
     RowBox[{"Specularity", "[", "0", "]"}], ",", 
     RowBox[{"EdgeForm", "[", "col", "]"}], ",", 
     RowBox[{"FaceForm", "[", "Black", "]"}], ",", 
     RowBox[{"Glow", "[", "col", "]"}]}], "]"}]}], ";"}]], "Input",
 CellLabel->"In[9]:=",
 CellID->2931987],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"MyManipulator", ",", "HoldAll"}], "]"}], ";"}]], "Input",
 CellLabel->"In[10]:=",
 CellID->282891712],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MyManipulator", "[", 
    RowBox[{"var_", ",", "range_", ",", "func_", ",", 
     RowBox[{"Scale", "\[Rule]", "scale_"}]}], "]"}], ":=", 
   RowBox[{"Row", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Manipulator", "[", 
        RowBox[{
         RowBox[{"Dynamic", "[", 
          RowBox[{"var", ",", "func"}], "]"}], ",", "range"}], "]"}], ",", 
       RowBox[{"PaddedInputField", "[", 
        RowBox[{"var", ",", "func", ",", "scale"}], "]"}]}], "}"}], ",", 
     RowBox[{"Spacer", "[", "5", "]"}]}], "]"}]}], ";"}]], "Input",
 CellLabel->"In[11]:=",
 CellID->218396106],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MyManipulator", "[", 
    RowBox[{"var_", ",", "range_", ",", "func_"}], "]"}], ":=", 
   RowBox[{"Row", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Manipulator", "[", 
        RowBox[{
         RowBox[{"Dynamic", "[", 
          RowBox[{"var", ",", "func"}], "]"}], ",", "range"}], "]"}], ",", 
       RowBox[{"PaddedInputField", "[", 
        RowBox[{"var", ",", "func"}], "]"}]}], "}"}], ",", 
     RowBox[{"Spacer", "[", "5", "]"}]}], "]"}]}], ";"}]], "Input",
 CellLabel->"In[12]:=",
 CellID->74104170],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ColoredBar", "[", 
    RowBox[{"names_", ",", "color_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"CheckboxBar", "[", 
     RowBox[{"#", ",", 
      RowBox[{"MapThread", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"#1", "\[Rule]", 
          RowBox[{"Style", "[", 
           RowBox[{"#1", ",", "#2"}], "]"}]}], "&"}], ",", 
        RowBox[{"{", 
         RowBox[{"names", ",", 
          RowBox[{"Take", "[", 
           RowBox[{"color", ",", 
            RowBox[{"Length", "[", "names", "]"}]}], "]"}]}], "}"}]}], 
       "]"}]}], "]"}], "&"}]}], ";"}]], "Input",
 CellLabel->"In[13]:=",
 CellID->17081472]
}, Closed]],

Cell[CellGroupData[{

Cell["Generate demonstration", "SubsectionOpener",
 CellID->158617434],

Cell[BoxData[
 RowBox[{"<<", "AtomicDensityMatrix`"}]], "Input",
 CellLabel->"In[14]:=",
 CellID->75905070],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NormalizeStokes", "[", 
    RowBox[{"{", 
     RowBox[{"s1_", ",", "s2_", ",", "s3_"}], "}"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "a", "}"}], ",", 
     RowBox[{"Which", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"Abs", "[", "s2", "]"}], "<", ".01"}], "&&", 
        RowBox[{
         RowBox[{"Abs", "[", "s3", "]"}], "<", ".01"}]}], ",", 
       RowBox[{"{", 
        RowBox[{
         FractionBox[
          SqrtBox[
           RowBox[{"1", "-", 
            SuperscriptBox["s1", "2"]}]], 
          SqrtBox["2"]], ",", 
         FractionBox[
          SqrtBox[
           RowBox[{"1", "-", 
            SuperscriptBox["s1", "2"]}]], 
          SqrtBox["2"]]}], "}"}], ",", 
       RowBox[{
        RowBox[{"Abs", "[", "s1", "]"}], "\[Equal]", "1."}], ",", 
       RowBox[{"{", 
        RowBox[{"0.", ",", "0."}], "}"}], ",", "True", ",", 
       RowBox[{
        RowBox[{"a", "=", 
         SqrtBox[
          FractionBox[
           RowBox[{"1", "-", 
            SuperscriptBox["s1", "2"]}], 
           RowBox[{
            SuperscriptBox["s2", "2"], "+", 
            SuperscriptBox["s3", "2"]}]]]}], ";", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"s2", " ", "a"}], ",", 
          RowBox[{"s3", " ", "a"}]}], "}"}]}]}], "]"}]}], "]"}]}], 
  ";"}]], "Input",
 CellLabel->"In[15]:=",
 CellID->3740002],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"SToAE", "[", "st_", "]"}], ":=", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"S1", "\[Equal]", "S2", "\[Equal]", "0."}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       RowBox[{
        FractionBox["1", "4"], " ", "\[Pi]", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"KroneckerDelta", "[", "S3", "]"}], "+", 
          RowBox[{"Sign", "[", "S3", "]"}]}], ")"}]}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"ReparameterizeField", "[", 
      RowBox[{"st", ",", 
       RowBox[{"\"\<Stokes\>\"", "\[Rule]", "\"\<AngleEllipticity\>\""}]}], 
      "]"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SToRP", "[", "st_", "]"}], ":=", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"S2", "\[Equal]", "S3", "\[Equal]", "0."}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"ArcCos", "[", 
        FractionBox[
         SqrtBox[
          RowBox[{"1", "+", "S1"}]], 
         SqrtBox["2"]], "]"}], ",", 
       FractionBox["\[Pi]", "4"]}], "}"}], ",", 
     RowBox[{"ReparameterizeField", "[", 
      RowBox[{"st", ",", 
       RowBox[{"\"\<Stokes\>\"", "\[Rule]", "\"\<RatioPhase\>\""}]}], "]"}]}],
     "]"}]}], ";"}]}], "Input",
 CellLabel->"In[16]:=",
 CellID->13348457],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"RPToS", "[", "st_", "]"}], ":=", 
   RowBox[{"ReparameterizeField", "[", 
    RowBox[{"st", ",", 
     RowBox[{"\"\<RatioPhase\>\"", "\[Rule]", "\"\<Stokes\>\""}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"RPToAE", "[", "st_", "]"}], ":=", 
   RowBox[{"ReparameterizeField", "[", 
    RowBox[{"st", ",", 
     RowBox[{"\"\<RatioPhase\>\"", "\[Rule]", "\"\<AngleEllipticity\>\""}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"AEToRP", "[", "st_", "]"}], ":=", 
   RowBox[{"ReparameterizeField", "[", 
    RowBox[{"st", ",", 
     RowBox[{"\"\<AngleEllipticity\>\"", "\[Rule]", "\"\<RatioPhase\>\""}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"AEToS", "[", "st_", "]"}], ":=", 
   RowBox[{"ReparameterizeField", "[", 
    RowBox[{"st", ",", 
     RowBox[{"\"\<AngleEllipticity\>\"", "\[Rule]", "\"\<Stokes\>\""}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"NS", "=", "NormalizeStokes"}], ";"}]}], "Input",
 CellLabel->"In[18]:=",
 CellID->780677788],

Cell[BoxData[{
 RowBox[{
  RowBox[{"color", "=", 
   RowBox[{"ColorData", "[", 
    RowBox[{"1", ",", "\"\<ColorList\>\""}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"dash", "=", 
   RowBox[{"Dashing", "[", 
    RowBox[{"{", 
     RowBox[{".02", ",", ".02"}], "}"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ax", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"ColorAll", "@", "Black"}], ",", 
     RowBox[{"Axes3D", "[", 
      RowBox[{"1.3", ",", 
       RowBox[{"Label", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"\"\<\!\(\*SubscriptBox[
StyleBox[\"S\",
FontSlant->\"Italic\"], \"1\"]\)\>\"", ",", "\"\<\!\(\*SubscriptBox[
StyleBox[\"S\",
FontSlant->\"Italic\"], \"2\"]\)\>\"", ",", "\"\<\!\(\*SubscriptBox[
StyleBox[\"S\",
FontSlant->\"Italic\"], \"3\"]\)\>\""}], "}"}]}], ",", 
       RowBox[{"LabelStyle", "\[Rule]", 
        RowBox[{"{", "12", "}"}]}], ",", 
       RowBox[{"RenderStyle", "\[Rule]", "Flat"}], ",", 
       RowBox[{"Scale", "\[Rule]", "1"}], ",", 
       RowBox[{"LabelPosition", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{".9", ",", "13", ",", 
            FractionBox["\[Pi]", "4"]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{".9", ",", "10", ",", 
            FractionBox["\[Pi]", "4"]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{".9", ",", "13", ",", 
            FractionBox[
             RowBox[{"3", " ", "\[Pi]"}], "4"]}], "}"}]}], "}"}]}]}], "]"}]}],
     "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"arr3d", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"ColorAll", "@", 
      RowBox[{"color", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ",", 
     RowBox[{"Thickness", "[", ".007", "]"}], ",", 
     RowBox[{
      RowBox[{"RotateY", "[", 
       RowBox[{"\[Pi]", "/", "2"}], "]"}], "@", 
      RowBox[{"Arrow3D", "[", 
       RowBox[{"1", ",", 
        RowBox[{"RenderStyle", "\[Rule]", "Flat"}], ",", 
        RowBox[{"Scale", "\[Rule]", "1.5"}]}], "]"}]}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"EF", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"Cos", "[", "t", "]"}], " ", 
      RowBox[{"Cos", "[", "\[Chi]", "]"}]}], ",", 
     RowBox[{
      RowBox[{"Cos", "[", 
       RowBox[{"t", "-", "\[Phi]"}], "]"}], " ", 
      RowBox[{"Sin", "[", "\[Chi]", "]"}]}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"\[Alpha]\[Epsilon]F", "[", 
    RowBox[{"\[Alpha]_", ",", "\[Epsilon]_", ",", "t_"}], "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"Cos", "[", "t", "]"}], " ", 
       RowBox[{"Cos", "[", "\[Alpha]", "]"}], " ", 
       RowBox[{"Cos", "[", "\[Epsilon]", "]"}]}], "-", 
      RowBox[{
       RowBox[{"Sin", "[", "t", "]"}], " ", 
       RowBox[{"Sin", "[", "\[Alpha]", "]"}], " ", 
       RowBox[{"Sin", "[", "\[Epsilon]", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"Cos", "[", "t", "]"}], " ", 
       RowBox[{"Cos", "[", "\[Epsilon]", "]"}], " ", 
       RowBox[{"Sin", "[", "\[Alpha]", "]"}]}], "+", 
      RowBox[{
       RowBox[{"Cos", "[", "\[Alpha]", "]"}], " ", 
       RowBox[{"Sin", "[", "t", "]"}], " ", 
       RowBox[{"Sin", "[", "\[Epsilon]", "]"}]}]}]}], "}"}]}], 
  ";"}]}], "Input",
 CellLabel->"In[23]:=",
 CellID->415357996],

Cell[BoxData[
 RowBox[{"Manipulate", "[", 
  RowBox[{
   RowBox[{"Row", "[", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"e1", ",", "e2", ",", "e3", ",", "e4"}], "}"}], "=", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"\[Alpha]\[Epsilon]F", "[", 
           RowBox[{"\[Alpha]", ",", "\[Epsilon]", ",", "0"}], "]"}], ",", 
          RowBox[{"\[Alpha]\[Epsilon]F", "[", 
           RowBox[{"\[Alpha]", ",", "\[Epsilon]", ",", 
            RowBox[{"\[Pi]", "/", "2"}]}], "]"}], ",", 
          RowBox[{"\[Alpha]\[Epsilon]F", "[", 
           RowBox[{"\[Alpha]", ",", "\[Epsilon]", ",", "\[Pi]"}], "]"}], ",", 
          
          RowBox[{"\[Alpha]\[Epsilon]F", "[", 
           RowBox[{"\[Alpha]", ",", "\[Epsilon]", ",", 
            RowBox[{"3", 
             RowBox[{"\[Pi]", "/", "2"}]}]}], "]"}]}], "}"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"co", ",", "si"}], "}"}], "=", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Cos", "[", "\[Chi]", "]"}], ",", 
          RowBox[{"Sin", "[", "\[Chi]", "]"}]}], "}"}]}], ";", 
       RowBox[{"Graphics", "[", 
        RowBox[{
         RowBox[{"If", "[", 
          RowBox[{"plotEllipse", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Arrowheads", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"-", ".035"}], ",", ".035"}], "}"}], "]"}], ",", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"MemberQ", "[", 
                RowBox[{"labels", ",", "\"\<\[Alpha]\>\""}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{
                 "color", "\[LeftDoubleBracket]", "2", 
                  "\[RightDoubleBracket]"}], ",", 
                 RowBox[{"Arc", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"0", ",", "0"}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{".6", ",", ".6"}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"0", ",", "\[Alpha]"}], "}"}], ",", 
                   RowBox[{"Label", "\[Rule]", "\"\<\[Alpha]\>\""}]}], 
                  "]"}]}], "}"}], ",", 
               RowBox[{"{", "}"}]}], "]"}], ",", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"MemberQ", "[", 
                RowBox[{"labels", ",", "\"\<\[Epsilon]\>\""}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{
                 "color", "\[LeftDoubleBracket]", "3", 
                  "\[RightDoubleBracket]"}], ",", 
                 RowBox[{"Arc", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"0", ",", "0"}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{".6", ",", ".6"}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"\[Alpha]", ",", 
                    RowBox[{"\[Alpha]", "+", "\[Epsilon]"}]}], "}"}], ",", 
                   RowBox[{"Label", "\[Rule]", "\"\<\[Epsilon]\>\""}]}], 
                  "]"}], ",", 
                 RowBox[{"Arrow", "[", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"e3", "+", "e2"}], ",", "e2"}], "}"}], "]"}], ",",
                  
                 RowBox[{"Text", "[", 
                  RowBox[{"\"\<\!\(\*
StyleBox[\"a\",
FontSlant->\"Italic\"]\)\>\"", ",", 
                   RowBox[{
                    RowBox[{"e3", "/", "2"}], "+", "e2", "+", 
                    RowBox[{".08", 
                    RowBox[{"Normalize", "[", "e2", "]"}]}]}]}], "]"}], ",", 
                 RowBox[{"Arrow", "[", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"e3", "+", "e2"}], ",", "e3"}], "}"}], "]"}], ",",
                  
                 RowBox[{"Text", "[", 
                  RowBox[{"\"\<\!\(\*
StyleBox[\"b\",
FontSlant->\"Italic\"]\)\>\"", ",", 
                   RowBox[{
                    RowBox[{".08", 
                    RowBox[{"Normalize", "[", "e3", "]"}]}], "+", "e3", "+", 
                    RowBox[{"e2", "/", "2"}]}]}], "]"}], ",", "dash", ",", 
                 RowBox[{"Line", "[", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"e1", "+", "e2"}], ",", 
                    RowBox[{"e1", "+", "e4"}], ",", 
                    RowBox[{"e3", "+", "e4"}], ",", 
                    RowBox[{"e3", "+", "e2"}], ",", 
                    RowBox[{"e1", "+", "e2"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"0", ",", "0"}], "}"}]}], "}"}], "]"}], ",", 
                 RowBox[{"Line", "[", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"e1", "+", "e2"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"0", ",", "0"}], "}"}]}], "}"}], "]"}]}], "}"}], 
               ",", 
               RowBox[{"{", "}"}]}], "]"}], ",", "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"MemberQ", "[", 
                RowBox[{"labels", ",", 
                 RowBox[{"\"\<\[Epsilon]\>\"", "|", "\"\<\[Alpha]\>\""}]}], 
                "]"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{
                 "color", "\[LeftDoubleBracket]", "1", 
                  "\[RightDoubleBracket]"}], ",", "dash", ",", 
                 RowBox[{"Line", "[", 
                  RowBox[{"{", 
                   RowBox[{"e1", ",", "e3"}], "}"}], "]"}], ",", 
                 RowBox[{"Line", "[", 
                  RowBox[{"{", 
                   RowBox[{"e2", ",", "e4"}], "}"}], "]"}]}], "}"}], ",", 
               RowBox[{"{", "}"}]}], "]"}], ",", "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"MemberQ", "[", 
                RowBox[{"labels", ",", "\"\<\[Chi]\>\""}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{
                 "color", "\[LeftDoubleBracket]", "4", 
                  "\[RightDoubleBracket]"}], ",", 
                 RowBox[{"Arc", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"0", ",", "0"}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{".4", ",", ".4"}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"0", ",", "\[Chi]"}], "}"}], ",", 
                   RowBox[{"Label", "\[Rule]", "\"\<\[Chi]\>\""}]}], "]"}], 
                 ",", 
                 RowBox[{"Arrow", "[", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"0", ",", 
                    RowBox[{"-", 
                    RowBox[{"Sin", "[", "\[Chi]", "]"}]}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Cos", "[", "\[Chi]", "]"}], ",", 
                    RowBox[{"-", 
                    RowBox[{"Sin", "[", "\[Chi]", "]"}]}]}], "}"}]}], "}"}], 
                  "]"}], ",", 
                 RowBox[{"Text", "[", 
                  RowBox[{
                  "\"\<\!\(\*SubsuperscriptBox[\"\[ScriptCapitalE]\", 
StyleBox[\"x\",
FontSlant->\"Italic\"], \"0\"]\)\>\"", ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"co", "/", "2"}], ",", 
                    RowBox[{
                    RowBox[{"-", "si"}], "-", ".1"}]}], "}"}]}], "]"}], ",", 
                 RowBox[{"Arrow", "[", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"co", ",", "0"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"co", ",", 
                    RowBox[{"-", "si"}]}], "}"}]}], "}"}], "]"}], ",", 
                 RowBox[{"Text", "[", 
                  RowBox[{
                  "\"\<\!\(\*SubsuperscriptBox[\(\[ScriptCapitalE]\), \(y\), \
\(0\)]\)\>\"", ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"co", "+", ".1"}], ",", 
                    RowBox[{
                    RowBox[{"-", "si"}], "/", "2"}]}], "}"}]}], "]"}], ",", 
                 "dash", ",", 
                 RowBox[{"Line", "[", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"co", ",", "si"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "co"}], ",", "si"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "co"}], ",", 
                    RowBox[{"-", "si"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"co", ",", 
                    RowBox[{"-", "si"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"co", ",", "si"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"0", ",", "0"}], "}"}]}], "}"}], "]"}]}], "}"}], 
               ",", 
               RowBox[{"{", "}"}]}], "]"}], ",", "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Arrowheads", "[", 
                RowBox[{"Table", "[", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{".035", ",", "i"}], "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"i", ",", ".025", ",", 
                    RowBox[{"1", "-", ".025"}], ",", ".05"}], "}"}]}], "]"}], 
                "]"}], ",", 
               RowBox[{
                RowBox[{
                 RowBox[{"ParametricPlot", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Cos", "[", "t", "]"}], " ", "co"}], ",", 
                    RowBox[{
                    RowBox[{"Cos", "[", 
                    RowBox[{"t", "-", "\[Phi]"}], "]"}], "si"}]}], "}"}], 
                    RowBox[{"(*", 
                    RowBox[{",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"Cos", "[", "t", "]"}], " ", 
                    RowBox[{"Cos", "[", "\[Alpha]", "]"}], " ", 
                    RowBox[{"Cos", "[", "\[Epsilon]", "]"}]}], "-", 
                    RowBox[{
                    RowBox[{"Sin", "[", "t", "]"}], " ", 
                    RowBox[{"Sin", "[", "\[Alpha]", "]"}], " ", 
                    RowBox[{"Sin", "[", "\[Epsilon]", "]"}]}]}], ",", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Cos", "[", "t", "]"}], " ", 
                    RowBox[{"Cos", "[", "\[Epsilon]", "]"}], " ", 
                    RowBox[{"Sin", "[", "\[Alpha]", "]"}]}], "+", 
                    RowBox[{
                    RowBox[{"Cos", "[", "\[Alpha]", "]"}], " ", 
                    RowBox[{"Sin", "[", "t", "]"}], " ", 
                    RowBox[{"Sin", "[", "\[Epsilon]", "]"}]}]}]}], "}"}], ",",
                     
                    RowBox[{"Switch", "[", 
                    RowBox[{"S1", ",", "1.", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Cos", "[", "t", "]"}], ",", "0"}], "}"}], ",", 
                    RowBox[{"-", "1."}], ",", 
                    RowBox[{"{", 
                    RowBox[{"0", ",", 
                    RowBox[{"Cos", "[", "t", "]"}]}], "}"}], ",", "_", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    FractionBox[
                    RowBox[{
                    SqrtBox[
                    RowBox[{"1", "+", "S1"}]], " ", 
                    RowBox[{"Cos", "[", "t", "]"}]}], 
                    SqrtBox["2"]], ",", 
                    FractionBox[
                    RowBox[{
                    SqrtBox[
                    RowBox[{"1", "-", "S1"}]], " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"t", "-", 
                    RowBox[{"ArcTan", "[", 
                    RowBox[{"S2", ",", "S3"}], "]"}]}], "]"}]}], 
                    SqrtBox["2"]]}], "}"}]}], "]"}]}], "*)"}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"t", ",", "0", ",", 
                    RowBox[{"2", "\[Pi]"}]}], "}"}]}], "]"}], "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "/.", 
                RowBox[{"Line", "\[Rule]", "Arrow"}]}]}], "}"}]}], "}"}], ",",
            
           RowBox[{"{", "}"}]}], "]"}], ",", 
         RowBox[{"Frame", "\[Rule]", "True"}], ",", 
         RowBox[{"FrameLabel", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Style", "[", 
             RowBox[{"\"\<\!\(\*SubscriptBox[\"\[ScriptCapitalE]\", 
StyleBox[\"x\",
FontSlant->\"Italic\"]]\)\>\"", ",", "12"}], "]"}], ",", 
            RowBox[{"Style", "[", 
             RowBox[{
             "\"\<\!\(\*SubscriptBox[\(\[ScriptCapitalE]\), \(y\)]\)\>\"", 
              ",", "12"}], "]"}]}], "}"}]}], ",", 
         RowBox[{"PlotRange", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "1"}], "}"}]}], "}"}]}], ",", 
         RowBox[{"Axes", "\[Rule]", "True"}], ",", 
         RowBox[{"ImageSize", "\[Rule]", 
          RowBox[{"3.5", " ", "72"}]}]}], "]"}]}], ",", "\[IndentingNewLine]",
       
      RowBox[{"Graphics3D", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"ax", ",", "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{"plotPoincare", ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"MemberQ", "[", 
                  RowBox[{"labels", ",", "\"\<\[Alpha]\>\""}], "]"}], "&&", 
                 RowBox[{"\[Alpha]", "\[Element]", "Reals"}], "&&", 
                 RowBox[{"\[Alpha]", "\[NotEqual]", "0"}]}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"ColorAll", "@", 
                   RowBox[{
                   "color", "\[LeftDoubleBracket]", "2", 
                    "\[RightDoubleBracket]"}]}], ",", 
                  RowBox[{"Circle3D", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", ".5", ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"0.", ",", 
                    RowBox[{"2", "\[Alpha]"}]}], "}"}], ",", 
                    RowBox[{"Label", "\[Rule]", "\"\<2\[Alpha]\>\""}], ",", 
                    RowBox[{"Arrowheads", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "1"}], ",", "1"}], "}"}]}]}], "]"}]}], "}"}],
                 ",", 
                RowBox[{"{", "}"}]}], "]"}], ",", "\[IndentingNewLine]", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"MemberQ", "[", 
                  RowBox[{"labels", ",", "\"\<\[Epsilon]\>\""}], "]"}], "&&", 
                 
                 RowBox[{"\[Epsilon]", "\[NotEqual]", "0"}]}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"ColorAll", "@", 
                   RowBox[{
                   "color", "\[LeftDoubleBracket]", "3", 
                    "\[RightDoubleBracket]"}]}], ",", 
                  RowBox[{
                   RowBox[{"RotateZ", "[", 
                    RowBox[{"2", " ", "\[Alpha]"}], "]"}], "@", 
                   RowBox[{
                    RowBox[{"RotateX", "[", 
                    RowBox[{"\[Pi]", "/", "2"}], "]"}], "@", 
                    RowBox[{"Circle3D", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", ".5", ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"0", ",", 
                    RowBox[{"2", "\[Epsilon]"}]}], "}"}], ",", 
                    RowBox[{"Label", "\[Rule]", "\"\<2\[Epsilon]\>\""}], ",", 
                    
                    RowBox[{"Arrowheads", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "1"}], ",", "1"}], "}"}]}]}], "]"}]}]}]}], 
                 "}"}], ",", 
                RowBox[{"{", "}"}]}], "]"}], ",", "\[IndentingNewLine]", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"MemberQ", "[", 
                 RowBox[{"labels", ",", 
                  RowBox[{"\"\<\[Epsilon]\>\"", "|", "\"\<\[Alpha]\>\""}]}], 
                 "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{
                  "color", "\[LeftDoubleBracket]", "1", 
                   "\[RightDoubleBracket]"}], ",", 
                  RowBox[{"Line", "[", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"S1", ",", "S2", ",", "S3"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"S1", ",", "S2", ",", "0"}], "}"}]}], "}"}], 
                   "]"}], ",", 
                  RowBox[{
                   RowBox[{"RotateZ", "[", 
                    RowBox[{"2", " ", "\[Alpha]"}], "]"}], "@", 
                   RowBox[{"Line", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"1", ",", "0", ",", "0"}], "}"}]}], "}"}], 
                    "]"}]}]}], "}"}], ",", 
                RowBox[{"{", "}"}]}], "]"}], ",", "\[IndentingNewLine]", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"MemberQ", "[", 
                  RowBox[{"labels", ",", "\"\<\[Chi]\>\""}], "]"}], "&&", 
                 RowBox[{"\[Chi]", "\[NotEqual]", "0"}]}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"ColorAll", "@", 
                   RowBox[{
                   "color", "\[LeftDoubleBracket]", "4", 
                    "\[RightDoubleBracket]"}]}], ",", 
                  RowBox[{
                   RowBox[{"RotateX", "[", "\[Phi]", "]"}], "@", 
                   RowBox[{"Circle3D", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", ".5", ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"0", ",", 
                    RowBox[{"2", "\[Chi]"}]}], "}"}], ",", 
                    RowBox[{"Label", "\[Rule]", "\"\<2\[Chi]\>\""}], ",", 
                    RowBox[{"Arrowheads", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "1"}], ",", "1"}], "}"}]}]}], "]"}]}]}], 
                 "}"}], ",", 
                RowBox[{"{", "}"}]}], "]"}], ",", "\[IndentingNewLine]", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"MemberQ", "[", 
                  RowBox[{"labels", ",", "\"\<\[Phi]\>\""}], "]"}], "&&", 
                 RowBox[{"\[Phi]", "\[NotEqual]", "0"}]}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"ColorAll", "@", 
                   RowBox[{
                   "color", "\[LeftDoubleBracket]", "5", 
                    "\[RightDoubleBracket]"}]}], ",", 
                  RowBox[{"Line", "[", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
                    RowBox[{"Normalize", "@", 
                    RowBox[{"{", 
                    RowBox[{"0", ",", "S2", ",", "S3"}], "}"}]}]}], "}"}], 
                   "]"}], ",", 
                  RowBox[{"Line", "[", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"S1", ",", "S2", ",", "S3"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"0", ",", "S2", ",", "S3"}], "}"}]}], "}"}], 
                   "]"}], ",", 
                  RowBox[{
                   RowBox[{"RotateZ", "[", 
                    RowBox[{"\[Pi]", "/", "2"}], "]"}], "@", 
                   RowBox[{
                    RowBox[{"RotateX", "[", 
                    RowBox[{"\[Pi]", "/", "2"}], "]"}], "@", 
                    RowBox[{"Circle3D", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", ".5", ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"0", ",", "\[Phi]"}], "}"}], ",", 
                    RowBox[{"Label", "\[Rule]", "\"\<\[Phi]\>\""}], ",", 
                    RowBox[{"Arrowheads", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "1"}], ",", "1"}], "}"}]}]}], "]"}]}]}]}], 
                 "}"}], ",", 
                RowBox[{"{", "}"}]}], "]"}], ",", "\[IndentingNewLine]", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"MemberQ", "[", 
                 RowBox[{"loci", ",", "\"\<\[Alpha]\>\""}], "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{
                  "color", "\[LeftDoubleBracket]", "2", 
                   "\[RightDoubleBracket]"}], ",", 
                  RowBox[{
                   RowBox[{"RotateZ", "[", 
                    RowBox[{"2", "\[Alpha]"}], "]"}], "@", 
                   RowBox[{
                    RowBox[{"RotateX", "[", 
                    RowBox[{"\[Pi]", "/", "2"}], "]"}], "@", 
                    RowBox[{"Circle3D", "[", "1", "]"}]}]}]}], "}"}], ",", 
                RowBox[{"{", "}"}]}], "]"}], ",", "\[IndentingNewLine]", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"MemberQ", "[", 
                 RowBox[{"loci", ",", "\"\<\[Epsilon]\>\""}], "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{
                  "color", "\[LeftDoubleBracket]", "3", 
                   "\[RightDoubleBracket]"}], ",", 
                  RowBox[{
                   RowBox[{"TranslateZ", "[", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", "\[Epsilon]"}], "]"}], "]"}], "@", 
                   RowBox[{"Circle3D", "[", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", "\[Epsilon]"}], "]"}], "]"}]}]}], "}"}], ",",
                 
                RowBox[{"{", "}"}]}], "]"}], ",", "\[IndentingNewLine]", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"MemberQ", "[", 
                 RowBox[{"loci", ",", "\"\<\[Chi]\>\""}], "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{
                  "color", "\[LeftDoubleBracket]", "4", 
                   "\[RightDoubleBracket]"}], ",", 
                  RowBox[{
                   RowBox[{"TranslateX", "[", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"2", "\[Chi]"}], "]"}], "]"}], "@", 
                   RowBox[{
                    RowBox[{"RotateY", "[", 
                    RowBox[{"\[Pi]", "/", "2"}], "]"}], "@", 
                    RowBox[{"Circle3D", "[", 
                    RowBox[{"Sin", "[", 
                    RowBox[{"2", "\[Chi]"}], "]"}], "]"}]}]}]}], "}"}], ",", 
                RowBox[{"{", "}"}]}], "]"}], ",", "\[IndentingNewLine]", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"MemberQ", "[", 
                 RowBox[{"loci", ",", "\"\<\[Phi]\>\""}], "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{
                  "color", "\[LeftDoubleBracket]", "5", 
                   "\[RightDoubleBracket]"}], ",", 
                  RowBox[{
                   RowBox[{"RotateX", "[", "\[Phi]", "]"}], "@", 
                   RowBox[{"Circle3D", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", "1", ",", 
                    RowBox[{"{", 
                    RowBox[{"0", ",", "\[Pi]"}], "}"}]}], "]"}]}]}], "}"}], 
                ",", 
                RowBox[{"{", "}"}]}], "]"}], ",", 
              RowBox[{
               RowBox[{"RotateZ", "[", 
                RowBox[{"2", " ", "\[Alpha]"}], "]"}], "@", 
               RowBox[{
                RowBox[{"RotateY", "[", 
                 RowBox[{
                  RowBox[{"-", "2"}], " ", "\[Epsilon]"}], "]"}], "@", 
                "arr3d"}]}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"Opacity", "[", ".06", "]"}], ",", 
                RowBox[{"Specularity", "[", 
                 RowBox[{"White", ",", "5"}], "]"}], ",", "Blue", ",", 
                RowBox[{"Sphere", "[", "]"}]}], "}"}]}], "}"}], ",", 
            RowBox[{"{", "}"}]}], "]"}]}], "}"}], ",", 
        RowBox[{"Boxed", "\[Rule]", "False"}], ",", 
        RowBox[{"ViewPoint", "\[Rule]", 
         RowBox[{"10", 
          RowBox[{"{", 
           RowBox[{"1", ",", "1.2", ",", ".9"}], "}"}]}]}], ",", 
        RowBox[{"ViewVertical", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "1"}], "}"}]}], ",", 
        RowBox[{"PlotRange", "\[Rule]", "1.3"}], ",", 
        RowBox[{"PlotRegion", "\[Rule]", 
         RowBox[{"Crop", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{".21", ",", ".78"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{".25", ",", ".81"}], "}"}]}], "}"}], "]"}]}], ",", 
        RowBox[{"ImageSize", "\[Rule]", 
         RowBox[{"3.5", " ", "72"}]}], ",", 
        RowBox[{"Lighting", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"\"\<Point\>\"", ",", "White", ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", "5"}], "}"}]}], "}"}], "}"}]}]}], 
       "]"}]}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\[Alpha]", ",", "0.", ",", "\"\<\[Alpha]\>\""}], "}"}], ",", 
     RowBox[{
      RowBox[{"MyManipulator", "[", 
       RowBox[{"\[Alpha]", ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "\[Pi]"}], "/", "2."}], ",", 
          RowBox[{"\[Pi]", "/", "2."}]}], "}"}], ",", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"NumericQ", "[", "#", "]"}], ",", 
            RowBox[{
             RowBox[{
              RowBox[{"{", 
               RowBox[{"\[Chi]", ",", "\[Phi]"}], "}"}], "=", 
              RowBox[{"AEToRP", "[", 
               RowBox[{"{", 
                RowBox[{"#", ",", "\[Epsilon]"}], "}"}], "]"}]}], ";", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"S1", ",", "S2", ",", "S3"}], "}"}], "=", 
              RowBox[{"AEToS", "[", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"\[Alpha]", "=", "#"}], ",", "\[Epsilon]"}], "}"}], 
               "]"}]}]}]}], "]"}], ")"}], "&"}], ",", 
        RowBox[{"Scale", "\[Rule]", "\[Pi]"}]}], "]"}], "&"}]}], "}"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\[Epsilon]", ",", "0.", ",", "\"\<\[Epsilon]\>\""}], "}"}], 
     ",", 
     RowBox[{
      RowBox[{"MyManipulator", "[", 
       RowBox[{"\[Epsilon]", ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "\[Pi]"}], "/", "4."}], ",", 
          RowBox[{"\[Pi]", "/", "4."}]}], "}"}], ",", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"NumericQ", "[", "#", "]"}], ",", 
            RowBox[{
             RowBox[{
              RowBox[{"{", 
               RowBox[{"\[Chi]", ",", "\[Phi]"}], "}"}], "=", 
              RowBox[{"AEToRP", "[", 
               RowBox[{"{", 
                RowBox[{"\[Alpha]", ",", "#"}], "}"}], "]"}]}], ";", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"S1", ",", "S2", ",", "S3"}], "}"}], "=", 
              RowBox[{"AEToS", "[", 
               RowBox[{"{", 
                RowBox[{"\[Alpha]", ",", 
                 RowBox[{"\[Epsilon]", "=", "#"}]}], "}"}], "]"}]}]}]}], 
           "]"}], ")"}], "&"}], ",", 
        RowBox[{"Scale", "\[Rule]", "\[Pi]"}]}], "]"}], "&"}]}], "}"}], ",", 
   "\[IndentingNewLine]", "Delimiter", ",", "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\[Chi]", ",", "0."}], "}"}], ",", 
     RowBox[{
      RowBox[{"MyManipulator", "[", 
       RowBox[{"\[Chi]", ",", 
        RowBox[{"{", 
         RowBox[{"0.", ",", 
          RowBox[{"\[Pi]", "/", "2."}]}], "}"}], ",", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"NumericQ", "[", "#", "]"}], ",", 
            RowBox[{
             RowBox[{
              RowBox[{"{", 
               RowBox[{"\[Alpha]", ",", "\[Epsilon]"}], "}"}], "=", 
              RowBox[{"RPToAE", "[", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"\[Chi]", "=", "#"}], ",", "\[Phi]"}], "}"}], 
               "]"}]}], ";", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"S1", ",", "S2", ",", "S3"}], "}"}], "=", 
              RowBox[{"RPToS", "[", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"\[Chi]", "=", "#"}], ",", "\[Phi]"}], "}"}], 
               "]"}]}]}]}], "]"}], ")"}], "&"}], ",", 
        RowBox[{"Scale", "\[Rule]", "\[Pi]"}]}], "]"}], "&"}]}], "}"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\[Phi]", ",", "0."}], "}"}], ",", 
     RowBox[{
      RowBox[{"MyManipulator", "[", 
       RowBox[{"\[Phi]", ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "1."}], "\[Pi]"}], ",", 
          RowBox[{"1.", "\[Pi]"}]}], "}"}], ",", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"NumericQ", "[", "#", "]"}], ",", 
            RowBox[{
             RowBox[{
              RowBox[{"{", 
               RowBox[{"\[Alpha]", ",", "\[Epsilon]"}], "}"}], "=", 
              RowBox[{"RPToAE", "[", 
               RowBox[{"{", 
                RowBox[{"\[Chi]", ",", 
                 RowBox[{"\[Phi]", "=", "#"}]}], "}"}], "]"}]}], ";", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"S1", ",", "S2", ",", "S3"}], "}"}], "=", 
              RowBox[{"RPToS", "[", 
               RowBox[{"{", 
                RowBox[{"\[Chi]", ",", 
                 RowBox[{"\[Phi]", "=", "#"}]}], "}"}], "]"}]}]}]}], "]"}], 
          ")"}], "&"}], ",", 
        RowBox[{"Scale", "\[Rule]", "\[Pi]"}]}], "]"}], "&"}]}], "}"}], ",", 
   "\[IndentingNewLine]", "Delimiter", ",", "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"S1", ",", "1.", ",", "\"\<\!\(\*SubscriptBox[
StyleBox[\"S\",
FontSlant->\"Italic\"], \"1\"]\)\>\""}], "}"}], ",", 
     RowBox[{
      RowBox[{"MyManipulator", "[", 
       RowBox[{"S1", ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "1."}], ",", "1."}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"s2", "=", "S2"}], ";", 
             RowBox[{"s3", "=", "S3"}]}], ")"}], "&"}], ",", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"NumericQ", "[", "#", "]"}], ",", 
              RowBox[{
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"S2", ",", "S3"}], "}"}], "=", 
                RowBox[{"NS", "[", 
                 RowBox[{"{", 
                  RowBox[{"#", ",", "s2", ",", "s3"}], "}"}], "]"}]}], ";", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"\[Alpha]", ",", "\[Epsilon]"}], "}"}], "=", 
                RowBox[{"SToAE", "[", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"S1", "=", "#"}], ",", "S2", ",", "S3"}], "}"}], 
                 "]"}]}], ";", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Abs", "[", "#", "]"}], "<", "1"}], ",", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"\[Chi]", ",", "\[Phi]"}], "}"}], "=", 
                  RowBox[{"SToRP", "[", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"S1", "=", "#"}], ",", "S2", ",", "S3"}], "}"}], 
                   "]"}]}], ",", 
                 RowBox[{"\[Chi]", "=", 
                  RowBox[{
                   RowBox[{"SToRP", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"S1", "=", "#"}], ",", "S2", ",", "S3"}], "}"}], 
                    "]"}], "\[LeftDoubleBracket]", "1", 
                   "\[RightDoubleBracket]"}]}]}], "]"}]}]}], "]"}], ")"}], 
           "&"}], ",", "Identity"}], "}"}]}], "]"}], "&"}]}], "}"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "S2", ",", "0.", ",", "\"\<\!\(\*SubscriptBox[\(S\), \(2\)]\)\>\""}], 
      "}"}], ",", 
     RowBox[{
      RowBox[{"MyManipulator", "[", 
       RowBox[{"S2", ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "1."}], ",", "1."}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"s1", "=", "S1"}], ";", 
             RowBox[{"s3", "=", "S3"}]}], ")"}], "&"}], ",", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"NumericQ", "[", "#", "]"}], ",", 
              RowBox[{
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"S1", ",", "S3"}], "}"}], "=", 
                RowBox[{"NS", "[", 
                 RowBox[{"{", 
                  RowBox[{"#", ",", "S1", ",", "S3"}], "}"}], "]"}]}], ";", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"\[Alpha]", ",", "\[Epsilon]"}], "}"}], "=", 
                RowBox[{"SToAE", "[", 
                 RowBox[{"{", 
                  RowBox[{"S1", ",", 
                   RowBox[{"S2", "=", "#"}], ",", "S3"}], "}"}], "]"}]}], ";",
                
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"\[Chi]", ",", "\[Phi]"}], "}"}], "=", 
                RowBox[{"SToRP", "[", 
                 RowBox[{"{", 
                  RowBox[{"S1", ",", 
                   RowBox[{"S2", "=", "#"}], ",", "S3"}], "}"}], "]"}]}]}]}], 
             "]"}], ")"}], "&"}], ",", "Identity"}], "}"}]}], "]"}], "&"}]}], 
    "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"S3", ",", "0.", ",", "\"\<\!\(\*SubscriptBox[
StyleBox[\"S\",
FontSlant->\"Italic\"], \"3\"]\)\>\""}], "}"}], ",", 
     RowBox[{
      RowBox[{"MyManipulator", "[", 
       RowBox[{"S3", ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "1."}], ",", "1."}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"s1", "=", "S1"}], ";", 
             RowBox[{"s2", "=", "S2"}]}], ")"}], "&"}], ",", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"NumericQ", "[", "#", "]"}], ",", 
              RowBox[{
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"S1", ",", "S2"}], "}"}], "=", 
                RowBox[{"NS", "[", 
                 RowBox[{"{", 
                  RowBox[{"#", ",", "S1", ",", "S2"}], "}"}], "]"}]}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Abs", "[", "#", "]"}], "<", "1"}], ",", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"\[Alpha]", ",", "\[Epsilon]"}], "}"}], "=", 
                  RowBox[{"SToAE", "[", 
                   RowBox[{"{", 
                    RowBox[{"S1", ",", "S2", ",", 
                    RowBox[{"S3", "=", "#"}]}], "}"}], "]"}]}], ",", 
                 RowBox[{"\[Epsilon]", "=", 
                  RowBox[{
                   RowBox[{"SToAE", "[", 
                    RowBox[{"{", 
                    RowBox[{"S1", ",", "S2", ",", 
                    RowBox[{"S3", "=", "#"}]}], "}"}], "]"}], 
                   "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}]}],
                 "]"}], ";", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"\[Chi]", ",", "\[Phi]"}], "}"}], "=", 
                RowBox[{"SToRP", "[", 
                 RowBox[{"{", 
                  RowBox[{"S1", ",", "S2", ",", 
                   RowBox[{"S3", "=", "#"}]}], "}"}], "]"}]}]}]}], "]"}], 
            ")"}], "&"}], ",", "Identity"}], "}"}]}], "]"}], "&"}]}], "}"}], 
   ",", "\[IndentingNewLine]", "Delimiter", ",", "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "plotEllipse", ",", "True", ",", "\"\<Polarization ellipse:\>\""}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"True", ",", "False"}], "}"}]}], "}"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "plotPoincare", ",", "True", ",", "\"\<Poincar\[EAcute] sphere:\>\""}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"True", ",", "False"}], "}"}]}], "}"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"labels", ",", 
       RowBox[{"{", 
        RowBox[{"\"\<\[Alpha]\>\"", ",", "\"\<\[Epsilon]\>\""}], "}"}], ",", 
       "\"\<Angles:\>\""}], "}"}], ",", 
     RowBox[{"ColoredBar", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "\"\<\[Alpha]\>\"", ",", "\"\<\[Epsilon]\>\"", ",", "\"\<\[Chi]\>\"", 
         ",", "\"\<\[Phi]\>\""}], "}"}], ",", 
       RowBox[{"Rest", "@", "color"}]}], "]"}]}], "}"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"loci", ",", 
       RowBox[{"{", 
        RowBox[{"\"\<\[Alpha]\>\"", ",", "\"\<\[Epsilon]\>\""}], "}"}], ",", 
       "\"\<Loci:\>\""}], "}"}], ",", 
     RowBox[{"ColoredBar", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "\"\<\[Alpha]\>\"", ",", "\"\<\[Epsilon]\>\"", ",", "\"\<\[Chi]\>\"", 
         ",", "\"\<\[Phi]\>\""}], "}"}], ",", 
       RowBox[{"Rest", "@", "color"}]}], "]"}]}], "}"}], ",", 
   RowBox[{"SaveDefinitions", "\[Rule]", "True"}], ",", 
   RowBox[{"ControlPlacement", "\[Rule]", "Top"}]}], "]"}]], "Input",
 CellLabel->"In[29]:=",
 CellID->649053163]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Demonstration", "Section",
 CellID->30911599],

Cell[BoxData[
 TagBox[
  StyleBox[
   DynamicModuleBox[{$CellContext`labels$$ = {
    "\[Alpha]", "\[Epsilon]"}, $CellContext`loci$$ = {
    "\[Alpha]", "\[Epsilon]"}, $CellContext`plotEllipse$$ = 
    True, $CellContext`plotPoincare$$ = True, $CellContext`S1$$ = 
    0.1977954901308769, $CellContext`S2$$ = -0.30804822423173017`, \
$CellContext`S3$$ = 
    0.93058220251172, $CellContext`\[Alpha]$$ = -0.5, \
$CellContext`\[Epsilon]$$ = 0.5980000000000001, $CellContext`\[Phi]$$ = 
    1.8904701242088813`, $CellContext`\[Chi]$$ = 0.6858439299634093, 
    Typeset`show$$ = True, Typeset`bookmarkList$$ = {}, 
    Typeset`bookmarkMode$$ = "Menu", Typeset`animator$$, Typeset`animvar$$ = 
    1, Typeset`name$$ = "\"untitled\"", Typeset`specs$$ = {{{
       Hold[$CellContext`\[Alpha]$$], 0., "\[Alpha]"}, 
      Dynamic[$CellContext`MyManipulator[$CellContext`\[Alpha]$$, {(-Pi)/2., 
         Pi/2.}, If[
         NumericQ[#], {$CellContext`\[Chi]$$, $CellContext`\[Phi]$$} = \
$CellContext`AEToRP[{#, $CellContext`\[Epsilon]$$}]; {$CellContext`S1$$, \
$CellContext`S2$$, $CellContext`S3$$} = $CellContext`AEToS[{$CellContext`\
\[Alpha]$$ = #, $CellContext`\[Epsilon]$$}]]& , Scale -> Pi]& ]}, {{
       Hold[$CellContext`\[Epsilon]$$], 0., "\[Epsilon]"}, 
      Dynamic[$CellContext`MyManipulator[$CellContext`\[Epsilon]$$, {(-Pi)/4.,
          Pi/4.}, If[
         NumericQ[#], {$CellContext`\[Chi]$$, $CellContext`\[Phi]$$} = \
$CellContext`AEToRP[{$CellContext`\[Alpha]$$, #}]; {$CellContext`S1$$, \
$CellContext`S2$$, $CellContext`S3$$} = $CellContext`AEToS[{$CellContext`\
\[Alpha]$$, $CellContext`\[Epsilon]$$ = #}]]& , Scale -> Pi]& ]}, {{
       Hold[$CellContext`\[Chi]$$], 0.}, 
      Dynamic[$CellContext`MyManipulator[$CellContext`\[Chi]$$, {0., Pi/2.}, 
        If[
         NumericQ[#], {$CellContext`\[Alpha]$$, $CellContext`\[Epsilon]$$} = \
$CellContext`RPToAE[{$CellContext`\[Chi]$$ = #, $CellContext`\[Phi]$$}]; \
{$CellContext`S1$$, $CellContext`S2$$, $CellContext`S3$$} = \
$CellContext`RPToS[{$CellContext`\[Chi]$$ = #, $CellContext`\[Phi]$$}]]& , 
        Scale -> Pi]& ]}, {{
       Hold[$CellContext`\[Phi]$$], 0.}, 
      Dynamic[$CellContext`MyManipulator[$CellContext`\[Phi]$$, {-Pi, 1. Pi}, 
        If[
         NumericQ[#], {$CellContext`\[Alpha]$$, $CellContext`\[Epsilon]$$} = \
$CellContext`RPToAE[{$CellContext`\[Chi]$$, $CellContext`\[Phi]$$ = #}]; \
{$CellContext`S1$$, $CellContext`S2$$, $CellContext`S3$$} = \
$CellContext`RPToS[{$CellContext`\[Chi]$$, $CellContext`\[Phi]$$ = #}]]& , 
        Scale -> Pi]& ]}, {{
       Hold[$CellContext`S1$$], 1., 
       "\!\(\*SubscriptBox[\n StyleBox[\"S\",\nFontSlant->\"Italic\"], \"1\"]\
\)"}, 
      Dynamic[$CellContext`MyManipulator[$CellContext`S1$$, {-1., 
        1.}, {($CellContext`s2 = $CellContext`S2$$; $CellContext`s3 = \
$CellContext`S3$$)& , If[
          
          NumericQ[#], {$CellContext`S2$$, $CellContext`S3$$} = \
$CellContext`NS[{#, $CellContext`s2, $CellContext`s3}]; \
{$CellContext`\[Alpha]$$, $CellContext`\[Epsilon]$$} = \
$CellContext`SToAE[{$CellContext`S1$$ = #, $CellContext`S2$$, \
$CellContext`S3$$}]; 
          If[Abs[#] < 
            1, {$CellContext`\[Chi]$$, $CellContext`\[Phi]$$} = \
$CellContext`SToRP[{$CellContext`S1$$ = #, $CellContext`S2$$, \
$CellContext`S3$$}], $CellContext`\[Chi]$$ = Part[
              $CellContext`SToRP[{$CellContext`S1$$ = #, $CellContext`S2$$, \
$CellContext`S3$$}], 1]]]& , Identity}]& ]}, {{
       Hold[$CellContext`S2$$], 0., "\!\(\*SubscriptBox[\(S\), \(2\)]\)"}, 
      Dynamic[$CellContext`MyManipulator[$CellContext`S2$$, {-1., 
        1.}, {($CellContext`s1 = $CellContext`S1$$; $CellContext`s3 = \
$CellContext`S3$$)& , If[
          
          NumericQ[#], {$CellContext`S1$$, $CellContext`S3$$} = \
$CellContext`NS[{#, $CellContext`S1$$, $CellContext`S3$$}]; {$CellContext`\
\[Alpha]$$, $CellContext`\[Epsilon]$$} = \
$CellContext`SToAE[{$CellContext`S1$$, $CellContext`S2$$ = #, \
$CellContext`S3$$}]; {$CellContext`\[Chi]$$, $CellContext`\[Phi]$$} = \
$CellContext`SToRP[{$CellContext`S1$$, $CellContext`S2$$ = #, \
$CellContext`S3$$}]]& , Identity}]& ]}, {{
       Hold[$CellContext`S3$$], 0., 
       "\!\(\*SubscriptBox[\n StyleBox[\"S\",\nFontSlant->\"Italic\"], \"3\"]\
\)"}, 
      Dynamic[$CellContext`MyManipulator[$CellContext`S3$$, {-1., 
        1.}, {($CellContext`s1 = $CellContext`S1$$; $CellContext`s2 = \
$CellContext`S2$$)& , If[
          
          NumericQ[#], {$CellContext`S1$$, $CellContext`S2$$} = \
$CellContext`NS[{#, $CellContext`S1$$, $CellContext`S2$$}]; 
          If[Abs[#] < 
            1, {$CellContext`\[Alpha]$$, $CellContext`\[Epsilon]$$} = \
$CellContext`SToAE[{$CellContext`S1$$, $CellContext`S2$$, $CellContext`S3$$ = \
#}], $CellContext`\[Epsilon]$$ = Part[
              $CellContext`SToAE[{$CellContext`S1$$, $CellContext`S2$$, \
$CellContext`S3$$ = #}], 
              2]]; {$CellContext`\[Chi]$$, $CellContext`\[Phi]$$} = \
$CellContext`SToRP[{$CellContext`S1$$, $CellContext`S2$$, $CellContext`S3$$ = \
#}]]& , Identity}]& ]}, {{
       Hold[$CellContext`plotEllipse$$], True, "Polarization ellipse:"}, {
      True, False}}, {{
       Hold[$CellContext`plotPoincare$$], True, "Poincar\[EAcute] sphere:"}, {
      True, False}}, {{
       Hold[$CellContext`labels$$], {"\[Alpha]", "\[Epsilon]"}, "Angles:"}, 
      CheckboxBar[#, 
       MapThread[# -> 
        Style[#, #2]& , {{"\[Alpha]", "\[Epsilon]", "\[Chi]", "\[Phi]"}, 
         Take[{
           RGBColor[0.6, 0.24, 0.4428931686004542], 
           RGBColor[0.6, 0.5470136627990908, 0.24], 
           RGBColor[0.24, 0.6, 0.33692049419863584`], 
           RGBColor[0.24, 0.3531726744018182, 0.6], 
           RGBColor[0.6, 0.24, 0.5632658430022722], 
           RGBColor[0.6, 0.42664098839727194`, 0.24], 
           RGBColor[0.2634521802031821, 0.6, 0.24], 
           RGBColor[0.24, 0.47354534880363613`, 0.6], 
           RGBColor[0.5163614825959097, 0.24, 0.6], 
           RGBColor[0.6, 0.3062683139954558, 0.24], 
           RGBColor[0.3838248546049982, 0.6, 0.24], 
           RGBColor[0.24, 0.5939180232054561, 0.6], 
           RGBColor[0.39598880819409377`, 0.24, 0.6], 
           RGBColor[0.6, 0.24, 0.2941043604063603]}, 
          Length[{"\[Alpha]", "\[Epsilon]", "\[Chi]", "\[Phi]"}]]}]]& }, {{
       Hold[$CellContext`loci$$], {"\[Alpha]", "\[Epsilon]"}, "Loci:"}, 
      CheckboxBar[#, 
       MapThread[# -> 
        Style[#, #2]& , {{"\[Alpha]", "\[Epsilon]", "\[Chi]", "\[Phi]"}, 
         Take[{
           RGBColor[0.6, 0.24, 0.4428931686004542], 
           RGBColor[0.6, 0.5470136627990908, 0.24], 
           RGBColor[0.24, 0.6, 0.33692049419863584`], 
           RGBColor[0.24, 0.3531726744018182, 0.6], 
           RGBColor[0.6, 0.24, 0.5632658430022722], 
           RGBColor[0.6, 0.42664098839727194`, 0.24], 
           RGBColor[0.2634521802031821, 0.6, 0.24], 
           RGBColor[0.24, 0.47354534880363613`, 0.6], 
           RGBColor[0.5163614825959097, 0.24, 0.6], 
           RGBColor[0.6, 0.3062683139954558, 0.24], 
           RGBColor[0.3838248546049982, 0.6, 0.24], 
           RGBColor[0.24, 0.5939180232054561, 0.6], 
           RGBColor[0.39598880819409377`, 0.24, 0.6], 
           RGBColor[0.6, 0.24, 0.2941043604063603]}, 
          Length[{"\[Alpha]", "\[Epsilon]", "\[Chi]", "\[Phi]"}]]}]]& }}, 
    Typeset`size$$ = {504., {134., 138.}}, Typeset`update$$ = 0, 
    Typeset`initDone$$, Typeset`skipInitDone$$ = 
    False, $CellContext`plotEllipse$723$$ = 
    False, $CellContext`plotPoincare$728$$ = False}, 
    DynamicBox[Manipulate`ManipulateBoxes[
     1, StandardForm, 
      "Variables" :> {$CellContext`labels$$ = {
         "\[Alpha]", "\[Epsilon]"}, $CellContext`loci$$ = {
         "\[Alpha]", "\[Epsilon]"}, $CellContext`plotEllipse$$ = 
        True, $CellContext`plotPoincare$$ = True, $CellContext`S1$$ = 
        1., $CellContext`S2$$ = 0., $CellContext`S3$$ = 
        0., $CellContext`\[Alpha]$$ = 0., $CellContext`\[Epsilon]$$ = 
        0., $CellContext`\[Phi]$$ = 0., $CellContext`\[Chi]$$ = 0.}, 
      "ControllerVariables" :> {
        Hold[$CellContext`plotEllipse$$, $CellContext`plotEllipse$723$$, 
         False], 
        Hold[$CellContext`plotPoincare$$, $CellContext`plotPoincare$728$$, 
         False]}, 
      "OtherVariables" :> {
       Typeset`show$$, Typeset`bookmarkList$$, Typeset`bookmarkMode$$, 
        Typeset`animator$$, Typeset`animvar$$, Typeset`name$$, 
        Typeset`specs$$, Typeset`size$$, Typeset`update$$, Typeset`initDone$$,
         Typeset`skipInitDone$$}, "Body" :> 
      Row[{{$CellContext`e1, $CellContext`e2, $CellContext`e3, \
$CellContext`e4} = {
            $CellContext`\[Alpha]\[Epsilon]F[$CellContext`\[Alpha]$$, \
$CellContext`\[Epsilon]$$, 0], 
            $CellContext`\[Alpha]\[Epsilon]F[$CellContext`\[Alpha]$$, \
$CellContext`\[Epsilon]$$, Pi/2], 
            $CellContext`\[Alpha]\[Epsilon]F[$CellContext`\[Alpha]$$, \
$CellContext`\[Epsilon]$$, Pi], 
            $CellContext`\[Alpha]\[Epsilon]F[$CellContext`\[Alpha]$$, \
$CellContext`\[Epsilon]$$, 3 (Pi/2)]}; {$CellContext`co, $CellContext`si} = {
            Cos[$CellContext`\[Chi]$$], 
            Sin[$CellContext`\[Chi]$$]}; Graphics[
           If[$CellContext`plotEllipse$$, {
             Arrowheads[{-0.035, 0.035}], 
             If[
              MemberQ[$CellContext`labels$$, "\[Alpha]"], {
               Part[$CellContext`color, 2], 
               $CellContext`Arc[{0, 0}, {0.6, 0.6}, {
                0, $CellContext`\[Alpha]$$}, Label -> "\[Alpha]"]}, {}], 
             If[
              MemberQ[$CellContext`labels$$, "\[Epsilon]"], {
               Part[$CellContext`color, 3], 
               $CellContext`Arc[{0, 0}, {0.6, 
                0.6}, {$CellContext`\[Alpha]$$, $CellContext`\[Alpha]$$ + \
$CellContext`\[Epsilon]$$}, Label -> "\[Epsilon]"], 
               Arrow[{$CellContext`e3 + $CellContext`e2, $CellContext`e2}], 
               Text[
               "\!\(\*\nStyleBox[\"a\",\nFontSlant->\"Italic\"]\)", \
$CellContext`e3/2 + $CellContext`e2 + 0.08 Normalize[$CellContext`e2]], 
               Arrow[{$CellContext`e3 + $CellContext`e2, $CellContext`e3}], 
               Text[
               "\!\(\*\nStyleBox[\"b\",\nFontSlant->\"Italic\"]\)", 
                0.08 Normalize[$CellContext`e3] + $CellContext`e3 + \
$CellContext`e2/2], $CellContext`dash, 
               
               Line[{$CellContext`e1 + $CellContext`e2, $CellContext`e1 + \
$CellContext`e4, $CellContext`e3 + $CellContext`e4, $CellContext`e3 + \
$CellContext`e2, $CellContext`e1 + $CellContext`e2, {0, 0}}], 
               Line[{$CellContext`e1 + $CellContext`e2, {0, 0}}]}, {}], 
             If[
              MemberQ[$CellContext`labels$$, 
               Alternatives["\[Epsilon]", "\[Alpha]"]], {
               Part[$CellContext`color, 1], $CellContext`dash, 
               Line[{$CellContext`e1, $CellContext`e3}], 
               Line[{$CellContext`e2, $CellContext`e4}]}, {}], 
             If[
              MemberQ[$CellContext`labels$$, "\[Chi]"], {
               Part[$CellContext`color, 4], 
               $CellContext`Arc[{0, 0}, {0.4, 0.4}, {
                0, $CellContext`\[Chi]$$}, Label -> "\[Chi]"], 
               Arrow[{{0, -Sin[$CellContext`\[Chi]$$]}, {
                  Cos[$CellContext`\[Chi]$$], -Sin[$CellContext`\[Chi]$$]}}], 
               
               Text[
               "\!\(\*SubsuperscriptBox[\"\[ScriptCapitalE]\", \n \
StyleBox[\"x\",\nFontSlant->\"Italic\"], \"0\"]\)", {$CellContext`co/
                 2, -$CellContext`si - 0.1}], 
               
               Arrow[{{$CellContext`co, 
                  0}, {$CellContext`co, -$CellContext`si}}], 
               Text[
               "\!\(\*SubsuperscriptBox[\(\[ScriptCapitalE]\), \(y\), \
\(0\)]\)", {$CellContext`co + 0.1, (-$CellContext`si)/2}], $CellContext`dash, 
               
               
               Line[{{$CellContext`co, $CellContext`si}, {-$CellContext`co, \
$CellContext`si}, {-$CellContext`co, -$CellContext`si}, {$CellContext`co, \
-$CellContext`si}, {$CellContext`co, $CellContext`si}, {0, 0}}]}, {}], {
              Arrowheads[
               
               Table[{0.035, $CellContext`i}, {$CellContext`i, 0.025, 1 - 
                 0.025, 0.05}]], 
              ReplaceAll[
               Part[
                
                ParametricPlot[{{
                  Cos[AtomicDensityMatrix`UsageMessages`t] $CellContext`co, 
                   Cos[AtomicDensityMatrix`UsageMessages`t - $CellContext`\
\[Phi]$$] $CellContext`si}}, {AtomicDensityMatrix`UsageMessages`t, 0, 2 Pi}], 
                1], Line -> Arrow]}}, {}], Frame -> True, FrameLabel -> {
             Style[
             "\!\(\*SubscriptBox[\"\[ScriptCapitalE]\", \n StyleBox[\"x\",\n\
FontSlant->\"Italic\"]]\)", 12], 
             Style["\!\(\*SubscriptBox[\(\[ScriptCapitalE]\), \(y\)]\)", 12]},
            PlotRange -> {{-1, 1}, {-1, 1}}, Axes -> True, ImageSize -> 
           3.5 72], 
         Graphics3D[{$CellContext`ax, 
           If[$CellContext`plotPoincare$$, {
             If[
              And[
               MemberQ[$CellContext`labels$$, "\[Alpha]"], 
               
               Element[$CellContext`\[Alpha]$$, 
                Reals], $CellContext`\[Alpha]$$ != 0], {
               Graphics`Arrow3D`ColorAll[
                Part[$CellContext`color, 2]], 
               
               Graphics`Arrow3D`Circle3D[{0, 0, 0}, 0.5, {
                0., 2 $CellContext`\[Alpha]$$}, Label -> "2\[Alpha]", 
                Arrowheads -> {-1, 1}]}, {}], 
             If[
              And[
               
               MemberQ[$CellContext`labels$$, 
                "\[Epsilon]"], $CellContext`\[Epsilon]$$ != 0], {
               Graphics`Arrow3D`ColorAll[
                Part[$CellContext`color, 3]], 
               Graphics`GraphicsUtilities`RotateZ[2 $CellContext`\[Alpha]$$][
                Graphics`GraphicsUtilities`RotateX[Pi/2][
                 
                 Graphics`Arrow3D`Circle3D[{0, 0, 0}, 0.5, {
                  0, 2 $CellContext`\[Epsilon]$$}, Label -> "2\[Epsilon]", 
                  Arrowheads -> {-1, 1}]]]}, {}], 
             If[
              MemberQ[$CellContext`labels$$, 
               Alternatives["\[Epsilon]", "\[Alpha]"]], {
               Part[$CellContext`color, 1], 
               
               Line[{{$CellContext`S1$$, $CellContext`S2$$, \
$CellContext`S3$$}, {$CellContext`S1$$, $CellContext`S2$$, 0}}], 
               Graphics`GraphicsUtilities`RotateZ[2 $CellContext`\[Alpha]$$][
                Line[{{0, 0, 0}, {1, 0, 0}}]]}, {}], 
             If[
              And[
               
               MemberQ[$CellContext`labels$$, 
                "\[Chi]"], $CellContext`\[Chi]$$ != 0], {
               Graphics`Arrow3D`ColorAll[
                Part[$CellContext`color, 4]], 
               Graphics`GraphicsUtilities`RotateX[$CellContext`\[Phi]$$][
                
                Graphics`Arrow3D`Circle3D[{0, 0, 0}, 0.5, {
                 0, 2 $CellContext`\[Chi]$$}, Label -> "2\[Chi]", 
                 Arrowheads -> {-1, 1}]]}, {}], 
             If[
              And[
               
               MemberQ[$CellContext`labels$$, 
                "\[Phi]"], $CellContext`\[Phi]$$ != 0], {
               Graphics`Arrow3D`ColorAll[
                Part[$CellContext`color, 5]], 
               Line[{{0, 0, 0}, 
                 Normalize[{0, $CellContext`S2$$, $CellContext`S3$$}]}], 
               
               Line[{{$CellContext`S1$$, $CellContext`S2$$, \
$CellContext`S3$$}, {0, $CellContext`S2$$, $CellContext`S3$$}}], 
               Graphics`GraphicsUtilities`RotateZ[Pi/2][
                Graphics`GraphicsUtilities`RotateX[Pi/2][
                 
                 Graphics`Arrow3D`Circle3D[{0, 0, 0}, 0.5, {
                  0, $CellContext`\[Phi]$$}, Label -> "\[Phi]", 
                  Arrowheads -> {-1, 1}]]]}, {}], 
             If[
              MemberQ[$CellContext`loci$$, "\[Alpha]"], {
               Part[$CellContext`color, 2], 
               Graphics`GraphicsUtilities`RotateZ[2 $CellContext`\[Alpha]$$][
                Graphics`GraphicsUtilities`RotateX[Pi/2][
                 Graphics`Arrow3D`Circle3D[1]]]}, {}], 
             If[
              MemberQ[$CellContext`loci$$, "\[Epsilon]"], {
               Part[$CellContext`color, 3], 
               Graphics`GraphicsUtilities`TranslateZ[
                Sin[2 $CellContext`\[Epsilon]$$]][
                Graphics`Arrow3D`Circle3D[
                 Cos[2 $CellContext`\[Epsilon]$$]]]}, {}], 
             If[
              MemberQ[$CellContext`loci$$, "\[Chi]"], {
               Part[$CellContext`color, 4], 
               Graphics`GraphicsUtilities`TranslateX[
                Cos[2 $CellContext`\[Chi]$$]][
                Graphics`GraphicsUtilities`RotateY[Pi/2][
                 Graphics`Arrow3D`Circle3D[
                  Sin[2 $CellContext`\[Chi]$$]]]]}, {}], 
             If[
              MemberQ[$CellContext`loci$$, "\[Phi]"], {
               Part[$CellContext`color, 5], 
               Graphics`GraphicsUtilities`RotateX[$CellContext`\[Phi]$$][
                Graphics`Arrow3D`Circle3D[{0, 0, 0}, 1, {0, Pi}]]}, {}], 
             Graphics`GraphicsUtilities`RotateZ[2 $CellContext`\[Alpha]$$][
              
              Graphics`GraphicsUtilities`RotateY[(-2) \
$CellContext`\[Epsilon]$$][$CellContext`arr3d]], {
              Opacity[0.06], 
              Specularity[White, 5], Blue, 
              Sphere[]}}, {}]}, Boxed -> False, ViewPoint -> 10 {1, 1.2, 0.9},
           ViewVertical -> {0, 0, 1}, PlotRange -> 1.3, PlotRegion -> 
          Graphics`GraphicsUtilities`Crop[{{0.21, 0.78}, {0.25, 0.81}}], 
          ImageSize -> 3.5 72, Lighting -> {{"Point", White, {1, 2, 5}}}]}], 
      "Specifications" :> {{{$CellContext`\[Alpha]$$, 0., "\[Alpha]"}, 
         Dynamic[$CellContext`MyManipulator[$CellContext`\[Alpha]$$, {(-Pi)/
            2., Pi/2.}, If[
            
            NumericQ[#], {$CellContext`\[Chi]$$, $CellContext`\[Phi]$$} = \
$CellContext`AEToRP[{#, $CellContext`\[Epsilon]$$}]; {$CellContext`S1$$, \
$CellContext`S2$$, $CellContext`S3$$} = $CellContext`AEToS[{$CellContext`\
\[Alpha]$$ = #, $CellContext`\[Epsilon]$$}]]& , Scale -> 
           Pi]& ]}, {{$CellContext`\[Epsilon]$$, 0., "\[Epsilon]"}, 
         Dynamic[$CellContext`MyManipulator[$CellContext`\[Epsilon]$$, {(-Pi)/
            4., Pi/4.}, If[
            
            NumericQ[#], {$CellContext`\[Chi]$$, $CellContext`\[Phi]$$} = \
$CellContext`AEToRP[{$CellContext`\[Alpha]$$, #}]; {$CellContext`S1$$, \
$CellContext`S2$$, $CellContext`S3$$} = $CellContext`AEToS[{$CellContext`\
\[Alpha]$$, $CellContext`\[Epsilon]$$ = #}]]& , Scale -> Pi]& ]}, 
        Delimiter, {{$CellContext`\[Chi]$$, 0.}, 
         Dynamic[$CellContext`MyManipulator[$CellContext`\[Chi]$$, {
           0., Pi/2.}, If[
            
            NumericQ[#], {$CellContext`\[Alpha]$$, $CellContext`\[Epsilon]$$} = \
$CellContext`RPToAE[{$CellContext`\[Chi]$$ = #, $CellContext`\[Phi]$$}]; \
{$CellContext`S1$$, $CellContext`S2$$, $CellContext`S3$$} = \
$CellContext`RPToS[{$CellContext`\[Chi]$$ = #, $CellContext`\[Phi]$$}]]& , 
           Scale -> Pi]& ]}, {{$CellContext`\[Phi]$$, 0.}, 
         Dynamic[$CellContext`MyManipulator[$CellContext`\[Phi]$$, {-Pi, 1. 
            Pi}, If[
            
            NumericQ[#], {$CellContext`\[Alpha]$$, $CellContext`\[Epsilon]$$} = \
$CellContext`RPToAE[{$CellContext`\[Chi]$$, $CellContext`\[Phi]$$ = #}]; \
{$CellContext`S1$$, $CellContext`S2$$, $CellContext`S3$$} = \
$CellContext`RPToS[{$CellContext`\[Chi]$$, $CellContext`\[Phi]$$ = #}]]& , 
           Scale -> Pi]& ]}, 
        Delimiter, {{$CellContext`S1$$, 1., 
          "\!\(\*SubscriptBox[\n StyleBox[\"S\",\nFontSlant->\"Italic\"], \"1\
\"]\)"}, 
         Dynamic[$CellContext`MyManipulator[$CellContext`S1$$, {-1., 
           1.}, {($CellContext`s2 = $CellContext`S2$$; $CellContext`s3 = \
$CellContext`S3$$)& , If[
             
             NumericQ[#], {$CellContext`S2$$, $CellContext`S3$$} = \
$CellContext`NS[{#, $CellContext`s2, $CellContext`s3}]; \
{$CellContext`\[Alpha]$$, $CellContext`\[Epsilon]$$} = \
$CellContext`SToAE[{$CellContext`S1$$ = #, $CellContext`S2$$, \
$CellContext`S3$$}]; 
             If[Abs[#] < 
               1, {$CellContext`\[Chi]$$, $CellContext`\[Phi]$$} = \
$CellContext`SToRP[{$CellContext`S1$$ = #, $CellContext`S2$$, \
$CellContext`S3$$}], $CellContext`\[Chi]$$ = Part[
                 $CellContext`SToRP[{$CellContext`S1$$ = #, \
$CellContext`S2$$, $CellContext`S3$$}], 1]]]& , 
            Identity}]& ]}, {{$CellContext`S2$$, 0., 
          "\!\(\*SubscriptBox[\(S\), \(2\)]\)"}, 
         Dynamic[$CellContext`MyManipulator[$CellContext`S2$$, {-1., 
           1.}, {($CellContext`s1 = $CellContext`S1$$; $CellContext`s3 = \
$CellContext`S3$$)& , If[
             
             NumericQ[#], {$CellContext`S1$$, $CellContext`S3$$} = \
$CellContext`NS[{#, $CellContext`S1$$, $CellContext`S3$$}]; {$CellContext`\
\[Alpha]$$, $CellContext`\[Epsilon]$$} = \
$CellContext`SToAE[{$CellContext`S1$$, $CellContext`S2$$ = #, \
$CellContext`S3$$}]; {$CellContext`\[Chi]$$, $CellContext`\[Phi]$$} = \
$CellContext`SToRP[{$CellContext`S1$$, $CellContext`S2$$ = #, \
$CellContext`S3$$}]]& , Identity}]& ]}, {{$CellContext`S3$$, 0., 
          "\!\(\*SubscriptBox[\n StyleBox[\"S\",\nFontSlant->\"Italic\"], \"3\
\"]\)"}, 
         Dynamic[$CellContext`MyManipulator[$CellContext`S3$$, {-1., 
           1.}, {($CellContext`s1 = $CellContext`S1$$; $CellContext`s2 = \
$CellContext`S2$$)& , If[
             
             NumericQ[#], {$CellContext`S1$$, $CellContext`S2$$} = \
$CellContext`NS[{#, $CellContext`S1$$, $CellContext`S2$$}]; 
             If[Abs[#] < 
               1, {$CellContext`\[Alpha]$$, $CellContext`\[Epsilon]$$} = \
$CellContext`SToAE[{$CellContext`S1$$, $CellContext`S2$$, $CellContext`S3$$ = \
#}], $CellContext`\[Epsilon]$$ = Part[
                 $CellContext`SToAE[{$CellContext`S1$$, $CellContext`S2$$, \
$CellContext`S3$$ = #}], 
                 2]]; {$CellContext`\[Chi]$$, $CellContext`\[Phi]$$} = \
$CellContext`SToRP[{$CellContext`S1$$, $CellContext`S2$$, $CellContext`S3$$ = \
#}]]& , Identity}]& ]}, 
        Delimiter, {{$CellContext`plotEllipse$$, True, 
          "Polarization ellipse:"}, {
         True, False}}, {{$CellContext`plotPoincare$$, True, 
          "Poincar\[EAcute] sphere:"}, {
         True, False}}, {{$CellContext`labels$$, {"\[Alpha]", "\[Epsilon]"}, 
          "Angles:"}, CheckboxBar[#, 
          
          MapThread[# -> 
           Style[#, #2]& , {{"\[Alpha]", "\[Epsilon]", "\[Chi]", "\[Phi]"}, 
            Take[{
              RGBColor[0.6, 0.24, 0.4428931686004542], 
              RGBColor[0.6, 0.5470136627990908, 0.24], 
              RGBColor[0.24, 0.6, 0.33692049419863584`], 
              RGBColor[0.24, 0.3531726744018182, 0.6], 
              RGBColor[0.6, 0.24, 0.5632658430022722], 
              RGBColor[0.6, 0.42664098839727194`, 0.24], 
              RGBColor[0.2634521802031821, 0.6, 0.24], 
              RGBColor[0.24, 0.47354534880363613`, 0.6], 
              RGBColor[0.5163614825959097, 0.24, 0.6], 
              RGBColor[0.6, 0.3062683139954558, 0.24], 
              RGBColor[0.3838248546049982, 0.6, 0.24], 
              RGBColor[0.24, 0.5939180232054561, 0.6], 
              RGBColor[0.39598880819409377`, 0.24, 0.6], 
              RGBColor[0.6, 0.24, 0.2941043604063603]}, 
             
             Length[{"\[Alpha]", "\[Epsilon]", "\[Chi]", 
               "\[Phi]"}]]}]]& }, {{$CellContext`loci$$, {
          "\[Alpha]", "\[Epsilon]"}, "Loci:"}, CheckboxBar[#, 
          
          MapThread[# -> 
           Style[#, #2]& , {{"\[Alpha]", "\[Epsilon]", "\[Chi]", "\[Phi]"}, 
            Take[{
              RGBColor[0.6, 0.24, 0.4428931686004542], 
              RGBColor[0.6, 0.5470136627990908, 0.24], 
              RGBColor[0.24, 0.6, 0.33692049419863584`], 
              RGBColor[0.24, 0.3531726744018182, 0.6], 
              RGBColor[0.6, 0.24, 0.5632658430022722], 
              RGBColor[0.6, 0.42664098839727194`, 0.24], 
              RGBColor[0.2634521802031821, 0.6, 0.24], 
              RGBColor[0.24, 0.47354534880363613`, 0.6], 
              RGBColor[0.5163614825959097, 0.24, 0.6], 
              RGBColor[0.6, 0.3062683139954558, 0.24], 
              RGBColor[0.3838248546049982, 0.6, 0.24], 
              RGBColor[0.24, 0.5939180232054561, 0.6], 
              RGBColor[0.39598880819409377`, 0.24, 0.6], 
              RGBColor[0.6, 0.24, 0.2941043604063603]}, 
             Length[{"\[Alpha]", "\[Epsilon]", "\[Chi]", "\[Phi]"}]]}]]& }}, 
      "Options" :> {ControlPlacement -> Top}, "DefaultOptions" :> {}],
     ImageSizeCache->{552., {321., 326.}},
     SingleEvaluation->True],
    Deinitialization:>None,
    DynamicModuleValues:>{},
    Initialization:>({$CellContext`\[Alpha]\[Epsilon]F[
         Pattern[$CellContext`\[Alpha], 
          Blank[]], 
         Pattern[$CellContext`\[Epsilon], 
          Blank[]], 
         Pattern[AtomicDensityMatrix`UsageMessages`t, 
          Blank[]]] = {
        Cos[AtomicDensityMatrix`UsageMessages`t] Cos[$CellContext`\[Alpha]] 
          Cos[$CellContext`\[Epsilon]] - 
         Sin[AtomicDensityMatrix`UsageMessages`t] Sin[$CellContext`\[Alpha]] 
         Sin[$CellContext`\[Epsilon]], 
         Cos[AtomicDensityMatrix`UsageMessages`t] 
          Cos[$CellContext`\[Epsilon]] Sin[$CellContext`\[Alpha]] + 
         Cos[$CellContext`\[Alpha]] Sin[AtomicDensityMatrix`UsageMessages`t] 
          Sin[$CellContext`\[Epsilon]]}, 
       TagSet[AtomicDensityMatrix`UsageMessages`t, 
        MessageName[AtomicDensityMatrix`UsageMessages`t, "usage"], 
        "t is the default value for the option TimeVariable in DensityMatrix \
and other functions."], $CellContext`color = {
         RGBColor[0.24720000000000014`, 0.24, 0.6], 
         RGBColor[0.6, 0.24, 0.4428931686004542], 
         RGBColor[0.6, 0.5470136627990908, 0.24], 
         RGBColor[0.24, 0.6, 0.33692049419863584`], 
         RGBColor[0.24, 0.3531726744018182, 0.6], 
         RGBColor[0.6, 0.24, 0.5632658430022722], 
         RGBColor[0.6, 0.42664098839727194`, 0.24], 
         RGBColor[0.2634521802031821, 0.6, 0.24], 
         RGBColor[0.24, 0.47354534880363613`, 0.6], 
         RGBColor[0.5163614825959097, 0.24, 0.6], 
         RGBColor[0.6, 0.3062683139954558, 0.24], 
         RGBColor[0.3838248546049982, 0.6, 0.24], 
         RGBColor[0.24, 0.5939180232054561, 0.6], 
         RGBColor[0.39598880819409377`, 0.24, 0.6], 
         RGBColor[0.6, 0.24, 0.2941043604063603]}, $CellContext`Arc[{
          Pattern[$CellContext`x, 
           Blank[]], 
          Pattern[$CellContext`y, 
           Blank[]]}, {
          Pattern[$CellContext`r1, 
           Blank[]], 
          Pattern[$CellContext`r2, 
           Blank[]]}, {
          Pattern[$CellContext`\[Theta]1, 
           Blank[]], 
          Pattern[$CellContext`\[Theta]2, 
           Blank[]]}, 
         OptionsPattern[]] := 
       Module[{$CellContext`pos = 
          OptionValue[Graphics`Arrow3D`LabelPosition]}, 
         If[$CellContext`\[Theta]1 == $CellContext`\[Theta]2, {}, {
           Apply[Arrow, 
            Part[
             Cases[
              Flatten[
               Part[
                
                ParametricPlot[{$CellContext`x + $CellContext`r1 
                   Cos[$CellContext`\[Theta]], $CellContext`y + \
$CellContext`r2 
                   Sin[$CellContext`\[Theta]]}, {$CellContext`\[Theta], \
$CellContext`\[Theta]1, $CellContext`\[Theta]2}], 1]], 
              Line[
               Blank[]]], 1]], 
           If[OptionValue[Label] =!= None, 
            Rotate[
             Text[
              OptionValue[Label], {
              Mean[{$CellContext`r1, $CellContext`r2}] 
               Part[$CellContext`pos, 2], 0}], 
             Part[$CellContext`pos, 
                1] ($CellContext`\[Theta]2 - $CellContext`\[Theta]1) + 
             Mean[{$CellContext`\[Theta]1, $CellContext`\[Theta]2}], {0, 
             0}], {}]}]], 
       Options[$CellContext`Arc] = {
        Label -> None, Graphics`Arrow3D`LabelPosition -> {0, 1.1}, 
         LabelStyle -> {}}, 
       TagSet[Graphics`Arrow3D`LabelPosition, 
        MessageName[Graphics`Arrow3D`LabelPosition, "usage"], 
        ""], $CellContext`dash = Dashing[{0.02, 0.02}], $CellContext`ax = {
         GrayLevel[0], 
         Specularity[0], 
         EdgeForm[
          GrayLevel[0]], 
         FaceForm[
          GrayLevel[0]], 
         Glow[
          GrayLevel[0]], {
          Rotate[
           Translate[
            Rotate[{{
               Line[{{0, 0, 0}, {0, 0, 2.5}}]}, {
               Translate[
                Rotate[
                 Rotate[
                  Translate[
                   
                   Polygon[{{-0.03, 0, -0.01}, {0, 0, 0.1}, {
                    0.03, 0, -0.01}, {0, 0, 0}, {-0.03, 0, -0.01}}], {
                   0, 0, -0.1}], 0, {1, 0, 0}], 0, {0, 0, 1}], {0, 0, 2.6}]}, 
              
              Rotate[
               Style[
                Text[
                "\!\(\*SubscriptBox[\n StyleBox[\"S\",\n\
FontSlant->\"Italic\"], \"1\"]\)", {0.13, 0, 2.3400000000000003`}], {12}], Pi/
               4, {0, 0, 1}]}, {{0, 0, 1}, {1., 0, 0}}], {-1.3, 0, 0}], Pi/
           2, {1, 0, 0}], 
          Translate[
           Rotate[{{
              Line[{{0, 0, 0}, {0, 0, 2.5}}]}, {
              Translate[
               Rotate[
                Rotate[
                 Translate[
                  
                  Polygon[{{-0.03, 0, -0.01}, {0, 0, 0.1}, {0.03, 0, -0.01}, {
                    0, 0, 0}, {-0.03, 0, -0.01}}], {0, 0, -0.1}], 0, {1, 0, 
                 0}], 0, {0, 0, 1}], {0, 0, 2.6}]}, 
             Rotate[
              Style[
               Text[
               "\!\(\*SubscriptBox[\n StyleBox[\"S\",\n\
FontSlant->\"Italic\"], \"2\"]\)", {0.1, 0, 2.3400000000000003`}], {12}], Pi/
              4, {0, 0, 1}]}, {{0, 0, 1}, {0, 1., 0}}], {0, -1.3, 0}], 
          Translate[
           Rotate[{{
              Line[{{0, 0, 0}, {0, 0, 2.5}}]}, {
              Translate[
               Rotate[
                Rotate[
                 Translate[
                  
                  Polygon[{{-0.03, 0, -0.01}, {0, 0, 0.1}, {0.03, 0, -0.01}, {
                    0, 0, 0}, {-0.03, 0, -0.01}}], {0, 0, -0.1}], 0, {1, 0, 
                 0}], 0, {0, 0, 1}], {0, 0, 2.6}]}, 
             Rotate[
              Style[
               Text[
               "\!\(\*SubscriptBox[\n StyleBox[\"S\",\n\
FontSlant->\"Italic\"], \"3\"]\)", {0.13, 0, 2.3400000000000003`}], {12}], (3 
               Pi)/4, {0, 0, 1}]}, {{0, 0, 1}, {0, 0, 1.}}], {0, 0, -1.3}]}}, 
       Graphics`Arrow3D`ColorAll[
         Pattern[$CellContext`col, 
          Blank[]]] := Sequence[$CellContext`col, 
         Specularity[0], 
         EdgeForm[$CellContext`col], 
         FaceForm[Black], 
         Glow[$CellContext`col]], 
       TagSet[Graphics`Arrow3D`ColorAll, 
        MessageName[Graphics`Arrow3D`ColorAll, "usage"], ""], 
       Graphics`Arrow3D`Circle3D[
         Pattern[Graphics`Arrow3D`Private`r, 
          Blank[]], 
         Pattern[Graphics`Arrow3D`Private`opts, 
          BlankNullSequence[Rule]]] := 
       Graphics`Arrow3D`Circle3D[{0, 0, 0}, Graphics`Arrow3D`Private`r, {
         0, 2 Pi}, Graphics`Arrow3D`Private`opts], Graphics`Arrow3D`Circle3D[
         Pattern[Graphics`Arrow3D`Private`p, {
           Pattern[Graphics`Arrow3D`Private`x, 
            Blank[]], 
           Pattern[Graphics`Arrow3D`Private`y, 
            Blank[]], 
           Pattern[Graphics`Arrow3D`Private`z, 
            Blank[]]}], 
         Pattern[Graphics`Arrow3D`Private`r, 
          Blank[]], 
         Pattern[Graphics`Arrow3D`Private`opts, 
          BlankNullSequence[Rule]]] := 
       Graphics`Arrow3D`Circle3D[
        Graphics`Arrow3D`Private`p, Graphics`Arrow3D`Private`r, {0, 2 Pi}, 
         Graphics`Arrow3D`Private`opts], Graphics`Arrow3D`Circle3D[
         Pattern[Graphics`Arrow3D`Private`p, {
           Pattern[Graphics`Arrow3D`Private`x, 
            Blank[]], 
           Pattern[Graphics`Arrow3D`Private`y, 
            Blank[]], 
           Pattern[Graphics`Arrow3D`Private`z, 
            Blank[]]}], 
         Pattern[Graphics`Arrow3D`Private`r, 
          Blank[]], {
          Pattern[Graphics`Arrow3D`Private`t1, 
           Blank[]], 
          Pattern[Graphics`Arrow3D`Private`t2, 
           Blank[]]}, 
         Pattern[Graphics`Arrow3D`Private`opts, 
          OptionsPattern[]]] := 
       Module[{Graphics`Arrow3D`Private`lp = 
          OptionValue[Graphics`Arrow3D`LabelPosition], 
          Graphics`Arrow3D`Private`w, Graphics`Arrow3D`Private`rs = 
          OptionValue[Graphics`Arrow3D`RenderStyle], 
          Graphics`Arrow3D`Private`ppopts, Graphics`Arrow3D`Private`ah, 
          Graphics`Arrow3D`Private`t1a, Graphics`Arrow3D`Private`t2a, 
          Graphics`Arrow3D`Private`ppt = 
          OptionValue[PlotPoints]}, {Graphics`Arrow3D`Private`w} = 
          ReplaceAll[
            ReplaceAll[
             
             ReplaceAll[{Scale Graphics`Arrow3D`Width}, {
              Graphics`Arrow3D`Private`opts}], 
             Options[Graphics`Arrow3D`Circle3D]], Automatic -> 
            Graphics`Arrow3D`Private`r]; 
         Graphics`Arrow3D`Private`ah = Graphics`Arrow3D`fixArrowheadSpecs[
            OptionValue[Arrowheads], 
            OptionValue[Graphics`Arrow3D`ArrowShape], 
            OptionValue[Scale], 
            Sign[Graphics`Arrow3D`Private`t2 - Graphics`Arrow3D`Private`t1] 
            Graphics`Arrow3D`Private`r]; 
         Graphics`Arrow3D`Private`ppopts = DeleteCases[
            FilterRules[
             Join[{Graphics`Arrow3D`Private`opts}, 
              Options[Graphics`Arrow3D`Circle3D]], 
             Options[ParametricPlot3D]], PlotPoints -> Blank[]]; {
           Graphics`Arrow3D`Private`t1a, Graphics`Arrow3D`Private`t2a} = {
            Graphics`Arrow3D`Private`t1, Graphics`Arrow3D`Private`t2} - {
            If[
             And[
             Length[Graphics`Arrow3D`Private`ah] > 0, 
              Part[Graphics`Arrow3D`Private`ah, 1, 1] == 0, 
              Sign[Graphics`Arrow3D`Private`t2 - Graphics`Arrow3D`Private`t1] 
               Part[Graphics`Arrow3D`Private`ah, 1, 2, 1] < 0], 
             Part[Graphics`Arrow3D`Private`ah, 1, 2, 1]/
             Graphics`Arrow3D`Private`r, 0], 
            If[
             And[
             Length[Graphics`Arrow3D`Private`ah] > 0, 
              Part[Graphics`Arrow3D`Private`ah, -1, 1] == 1, 
              Sign[Graphics`Arrow3D`Private`t2 - Graphics`Arrow3D`Private`t1] 
               Part[Graphics`Arrow3D`Private`ah, -1, 2, 1] > 0], 
             Part[Graphics`Arrow3D`Private`ah, -1, 2, 1]/
             Graphics`Arrow3D`Private`r, 0]}; Translate[{
            Switch[Graphics`Arrow3D`Private`rs, Full, 
             Part[
              
              ParametricPlot3D[{(Graphics`Arrow3D`Private`r + 
                 Graphics`Arrow3D`Private`w Cos[Graphics`Arrow3D`Private`v]) 
                Cos[Graphics`Arrow3D`Private`u], (Graphics`Arrow3D`Private`r + 
                 Graphics`Arrow3D`Private`w Cos[Graphics`Arrow3D`Private`v]) 
                Sin[Graphics`Arrow3D`Private`u], Graphics`Arrow3D`Private`w 
                Sin[Graphics`Arrow3D`Private`v]}, {
               Graphics`Arrow3D`Private`u, Graphics`Arrow3D`Private`t1a, 
                Graphics`Arrow3D`Private`t2a}, {
               Graphics`Arrow3D`Private`v, 0, 2 Pi}, Mesh -> False, 
               PlotPoints -> Part[Graphics`Arrow3D`Private`ppt, 1], 
               Evaluate[
                Apply[Sequence, Graphics`Arrow3D`Private`ppopts]]], 1], Flat, 
             
             Graphics`GraphicsUtilities`GetLine[
              ParametricPlot3D[Graphics`Arrow3D`Private`r {
                 Cos[Graphics`Arrow3D`Private`t], 
                 Sin[Graphics`Arrow3D`Private`t], 0}, {
               Graphics`Arrow3D`Private`t, Graphics`Arrow3D`Private`t1a, 
                Graphics`Arrow3D`Private`t2a}, PlotPoints -> 
               Part[Graphics`Arrow3D`Private`ppt, 1], 
               Evaluate[Graphics`Arrow3D`Private`ppopts]]]], 
            Map[
            Graphics`GraphicsUtilities`RotateZ[
             Graphics`Arrow3D`Private`t1 + 
              Part[#, 1] (Graphics`Arrow3D`Private`t2 - 
                Graphics`Arrow3D`Private`t1)][
              Graphics`GraphicsUtilities`TranslateX[
              Graphics`Arrow3D`Private`r][
               Graphics`GraphicsUtilities`RotateX[-(Pi/2)][
                Graphics`GraphicsUtilities`RotateY[
                Part[#, 2, 1]/(2 Graphics`Arrow3D`Private`r)][
                 Switch[
                 Graphics`Arrow3D`Private`rs, Full, Graphics`Arrow3D`FatHead, 
                  Flat, Graphics`Arrow3D`FlatHead][
                  Apply[Sequence, 
                   Part[#, 2]], PlotPoints -> 
                  Part[Graphics`Arrow3D`Private`ppt, 2]]]]]]& , 
             Graphics`Arrow3D`Private`ah], 
            If[OptionValue[Label] =!= None, 
             
             Graphics`GraphicsUtilities`RotateZ[(Graphics`Arrow3D`Private`t1 + 
                Graphics`Arrow3D`Private`t2)/
               2 + (Part[Graphics`Arrow3D`Private`lp, 1] (
                 Graphics`Arrow3D`Private`t2 - Graphics`Arrow3D`Private`t1))/
               2][
              Text[
               OptionValue[Label], {
               Graphics`Arrow3D`Private`r 
                Part[Graphics`Arrow3D`Private`lp, 2], 0, 
                Graphics`Arrow3D`Private`r 
                Part[Graphics`Arrow3D`Private`lp, 3]}, 
               Apply[Sequence, 
                If[Length[Graphics`Arrow3D`Private`lp] > 3, 
                 Drop[Graphics`Arrow3D`Private`lp, 3], {}]], 
               (If[Head[#] === List, 
                Apply[Sequence, #], #]& )[
                OptionValue[LabelStyle]]]], {}]}, 
           Graphics`Arrow3D`Private`p]], 
       Options[Graphics`Arrow3D`Circle3D] := {
        Label -> None, Graphics`Arrow3D`LabelPosition -> {0, 1.2, 0}, 
         LabelStyle -> {}, Graphics`Arrow3D`RenderStyle -> Flat, 
         Graphics`Arrow3D`Width -> 0.01, Arrowheads -> {}, 
         Graphics`Arrow3D`ArrowShape -> {0.1, 0.03, 0.01}, Scale -> Automatic,
          PlotPoints -> {Automatic, Automatic}}, 
       TagSet[Graphics`Arrow3D`Circle3D, 
        MessageName[Graphics`Arrow3D`Circle3D, "usage"], ""], 
       TagSet[Graphics`Arrow3D`RenderStyle, 
        MessageName[Graphics`Arrow3D`RenderStyle, "usage"], ""], 
       TagSet[Graphics`Arrow3D`Width, 
        MessageName[Graphics`Arrow3D`Width, "usage"], ""], 
       Graphics`Arrow3D`fixArrowheadSpecs[
         Pattern[Graphics`Arrow3D`Private`s, 
          Blank[]], 
         Pattern[Graphics`Arrow3D`Private`default, 
          Blank[]], 
         Pattern[Graphics`Arrow3D`Private`scale, 
          Blank[]], 
         Pattern[Graphics`Arrow3D`Private`length, 
          Blank[]]] := 
       Module[{Graphics`Arrow3D`Private`heads = Graphics`Arrow3D`Private`s}, 
         Graphics`Arrow3D`Private`heads = 
          If[Head[Graphics`Arrow3D`Private`heads] =!= List, {
            Graphics`Arrow3D`Private`heads}, Graphics`Arrow3D`Private`heads]; 
         Graphics`Arrow3D`Private`heads = Sort[
            ReplaceAll[
             MapIndexed[Graphics`Arrow3D`Private`fixArrowheadSpec[#, 
               Part[#2, 1], 
               Length[Graphics`Arrow3D`Private`heads], 
               Graphics`Arrow3D`Private`default, 
               Graphics`Arrow3D`Private`scale]& , 
              Graphics`Arrow3D`Private`heads], Automatic -> 
             Graphics`Arrow3D`Private`length], OrderedQ[{
              Part[#, 2], 
              Part[#2, 2]}]& ]], 
       TagSet[Graphics`Arrow3D`fixArrowheadSpecs, 
        MessageName[Graphics`Arrow3D`fixArrowheadSpecs, "usage"], ""], 
       Graphics`Arrow3D`Private`fixArrowheadSpec[
         Pattern[Graphics`Arrow3D`Private`s, 
          Blank[]], 
         Pattern[Graphics`Arrow3D`Private`i, 
          Blank[]], 
         Pattern[Graphics`Arrow3D`Private`n, 
          Blank[]], 
         Pattern[Graphics`Arrow3D`Private`default, 
          Blank[]], 
         Pattern[Graphics`Arrow3D`Private`scale, 
          Blank[]]] := 
       Module[{Graphics`Arrow3D`Private`spec = Graphics`Arrow3D`Private`s, 
          Graphics`Arrow3D`Private`defs}, 
         If[Head[Graphics`Arrow3D`Private`spec] =!= List, 
           Graphics`Arrow3D`Private`spec = {Graphics`Arrow3D`Private`spec}]; 
         Graphics`Arrow3D`Private`defs = {1, 
            If[
            Graphics`Arrow3D`Private`n == 1, 
             1, (Graphics`Arrow3D`Private`i - 1)/(Graphics`Arrow3D`Private`n - 
             1)], Graphics`Arrow3D`Private`default, {0, 0}}; 
         Graphics`Arrow3D`Private`spec = Join[Graphics`Arrow3D`Private`spec, 
            Drop[Graphics`Arrow3D`Private`defs, 
             Length[Graphics`Arrow3D`Private`spec]]]; 
         Graphics`Arrow3D`Private`spec = 
          MapThread[
           ReplaceAll[#, Automatic -> #2]& , {
            Graphics`Arrow3D`Private`spec, Graphics`Arrow3D`Private`defs}]; {
           Part[Graphics`Arrow3D`Private`spec, 2], 
           Graphics`Arrow3D`Private`scale 
           Part[Graphics`Arrow3D`Private`spec, 1] 
           Part[Graphics`Arrow3D`Private`spec, 3], 
           Part[Graphics`Arrow3D`Private`spec, 4]}], 
       TagSet[Graphics`Arrow3D`ArrowShape, 
        MessageName[Graphics`Arrow3D`ArrowShape, "usage"], ""], 
       Graphics`GraphicsUtilities`GetLine[
         Pattern[Graphics`GraphicsUtilities`Private`g, 
          Blank[]]] := Cases[
         Flatten[
          Part[Graphics`GraphicsUtilities`Private`g, 1]], 
         Line[
          Blank[]]], Graphics`GraphicsUtilities`GetLine[
         Pattern[Graphics`GraphicsUtilities`Private`g, 
          Blank[]], 
         Pattern[Graphics`GraphicsUtilities`Private`spec, 
          Blank[]]] := Cases[
         Flatten[
          Part[Graphics`GraphicsUtilities`Private`g, 1]], 
         Line[
          Blank[]], Graphics`GraphicsUtilities`Private`spec], 
       TagSet[Graphics`GraphicsUtilities`GetLine, 
        MessageName[Graphics`GraphicsUtilities`GetLine, "usage"], ""], 
       Graphics`GraphicsUtilities`RotateZ[
         Pattern[Graphics`GraphicsUtilities`Private`theta, 
          Blank[]]][
         Pattern[Graphics`GraphicsUtilities`Private`g, 
          Blank[]]] := 
       Rotate[Graphics`GraphicsUtilities`Private`g, 
         Graphics`GraphicsUtilities`Private`theta, {0, 0, 1}], 
       TagSet[Graphics`GraphicsUtilities`RotateZ, 
        MessageName[Graphics`GraphicsUtilities`RotateZ, "usage"], ""], 
       Graphics`GraphicsUtilities`TranslateX[
         Pattern[Graphics`GraphicsUtilities`Private`x, 
          Blank[]]][
         Pattern[Graphics`GraphicsUtilities`Private`g, 
          Blank[]]] := 
       Translate[
        Graphics`GraphicsUtilities`Private`g, {
         Graphics`GraphicsUtilities`Private`x, 0, 0}], 
       TagSet[Graphics`GraphicsUtilities`TranslateX, 
        MessageName[Graphics`GraphicsUtilities`TranslateX, "usage"], ""], 
       Graphics`GraphicsUtilities`RotateX[
         Pattern[Graphics`GraphicsUtilities`Private`theta, 
          Blank[]]][
         Pattern[Graphics`GraphicsUtilities`Private`g, 
          Blank[]]] := 
       Rotate[Graphics`GraphicsUtilities`Private`g, 
         Graphics`GraphicsUtilities`Private`theta, {1, 0, 0}], 
       TagSet[Graphics`GraphicsUtilities`RotateX, 
        MessageName[Graphics`GraphicsUtilities`RotateX, "usage"], ""], 
       Graphics`GraphicsUtilities`RotateY[
         Pattern[Graphics`GraphicsUtilities`Private`theta, 
          Blank[]]][
         Pattern[Graphics`GraphicsUtilities`Private`g, 
          Blank[]]] := 
       Rotate[Graphics`GraphicsUtilities`Private`g, 
         Graphics`GraphicsUtilities`Private`theta, {0, 1, 0}], 
       TagSet[Graphics`GraphicsUtilities`RotateY, 
        MessageName[Graphics`GraphicsUtilities`RotateY, "usage"], ""], 
       Graphics`Arrow3D`FatHead[
         Pattern[Graphics`Arrow3D`Private`length, 
          Blank[]], 
         Pattern[Graphics`Arrow3D`Private`width, 
          Blank[]], 
         Pattern[Graphics`Arrow3D`Private`inset, 
          Blank[]], 
         Pattern[Graphics`Arrow3D`Private`opts, 
          BlankNullSequence[Rule]]] := 
       Graphics`GraphicsUtilities`TranslateZ[-Graphics`Arrow3D`Private`inset - 
         Graphics`Arrow3D`Private`length][{
          Graphics`Arrow3D`Cone3D[
          Graphics`Arrow3D`Private`width, Graphics`Arrow3D`Private`inset, 
           Graphics`Arrow3D`Opening -> Down, Graphics`Arrow3D`Private`opts], 
          Graphics`Arrow3D`Cone3D[
          Graphics`Arrow3D`Private`width, Graphics`Arrow3D`Private`inset + 
           Graphics`Arrow3D`Private`length, Graphics`Arrow3D`Opening -> Down, 
           Graphics`Arrow3D`Private`opts]}], 
       TagSet[Graphics`Arrow3D`FatHead, 
        MessageName[Graphics`Arrow3D`FatHead, "usage"], ""], 
       Graphics`GraphicsUtilities`TranslateZ[
         Pattern[Graphics`GraphicsUtilities`Private`x, 
          Blank[]]][
         Pattern[Graphics`GraphicsUtilities`Private`g, 
          Blank[]]] := 
       Translate[
        Graphics`GraphicsUtilities`Private`g, {
         0, 0, Graphics`GraphicsUtilities`Private`x}], 
       TagSet[Graphics`GraphicsUtilities`TranslateZ, 
        MessageName[Graphics`GraphicsUtilities`TranslateZ, "usage"], ""], 
       Graphics`Arrow3D`Cone3D[
         Pattern[Graphics`Arrow3D`Private`r, 
          Blank[]], 
         Pattern[Graphics`Arrow3D`Private`h, 
          Blank[]], 
         Pattern[Graphics`Arrow3D`Private`opts, 
          OptionsPattern[]]] := 
       Module[{Graphics`Arrow3D`Private`rp3dopts = FilterRules[
            Join[{Graphics`Arrow3D`Private`opts}, 
             Options[Graphics`Arrow3D`Cone3D]], 
            Options[RevolutionPlot3D]], Graphics`Arrow3D`Private`pp}, 
         If[OptionValue[Graphics`Arrow3D`RenderStyle] === Full, 
          If[OptionValue[Graphics`Arrow3D`Opening] === Down, 
           Part[
            RevolutionPlot3D[
            Graphics`Arrow3D`Private`h (1 - Graphics`Arrow3D`Private`t/
              Graphics`Arrow3D`Private`r), {
             Graphics`Arrow3D`Private`t, 0, Graphics`Arrow3D`Private`r}, Mesh -> 
             False, 
             Evaluate[
              Apply[Sequence, Graphics`Arrow3D`Private`rp3dopts]]], 1], 
           Part[
            RevolutionPlot3D[
            Graphics`Arrow3D`Private`h (Graphics`Arrow3D`Private`t/
              Graphics`Arrow3D`Private`r), {
             Graphics`Arrow3D`Private`t, 0, Graphics`Arrow3D`Private`r}, Mesh -> 
             False, 
             Evaluate[
              Apply[Sequence, Graphics`Arrow3D`Private`rp3dopts]]], 1]], 
          Graphics`Arrow3D`Private`pp = ReplaceAll[
             OptionValue[PlotPoints], Automatic -> 10]; 
          If[OptionValue[Graphics`Arrow3D`Opening] === Down, {
             Graphics`Arrow3D`Circle3D[{0, 0, 0}, Graphics`Arrow3D`Private`r],
              
             Table[
              
              Line[{{0, 0, Graphics`Arrow3D`Private`h}, {
                Graphics`Arrow3D`Private`r Sin[Graphics`Arrow3D`Private`t], 
                 Graphics`Arrow3D`Private`r Cos[Graphics`Arrow3D`Private`t], 
                 0}}], {Graphics`Arrow3D`Private`t, 0, 2 Pi - (2 Pi)/
               Graphics`Arrow3D`Private`pp, (2 Pi)/
               Graphics`Arrow3D`Private`pp}]}, {
             
             Graphics`Arrow3D`Circle3D[{0, 0, Graphics`Arrow3D`Private`h}, 
              Graphics`Arrow3D`Private`r], 
             Table[
              
              Line[{{0, 0, 0}, {
                Graphics`Arrow3D`Private`r Sin[Graphics`Arrow3D`Private`t], 
                 Graphics`Arrow3D`Private`r Cos[Graphics`Arrow3D`Private`t], 
                 Graphics`Arrow3D`Private`h}}], {
              Graphics`Arrow3D`Private`t, 0, 2 Pi - (2 Pi)/
               Graphics`Arrow3D`Private`pp, (2 Pi)/
               Graphics`Arrow3D`Private`pp}]}]]], 
       Options[Graphics`Arrow3D`Cone3D] = {
        Graphics`Arrow3D`Opening -> Down, PlotPoints -> Automatic, 
         Graphics`Arrow3D`RenderStyle -> Full}, 
       TagSet[Graphics`Arrow3D`Cone3D, 
        MessageName[Graphics`Arrow3D`Cone3D, "usage"], ""], 
       TagSet[Graphics`Arrow3D`Opening, 
        MessageName[Graphics`Arrow3D`Opening, "usage"], ""], 
       Graphics`Arrow3D`FlatHead[
         Pattern[Graphics`Arrow3D`Private`length, 
          Blank[]], 
         Pattern[Graphics`Arrow3D`Private`width, 
          Blank[]], 
         Pattern[Graphics`Arrow3D`Private`inset, 
          Blank[]], 
         Pattern[Graphics`Arrow3D`Private`opts, 
          BlankNullSequence[Rule]]] := 
       Graphics`GraphicsUtilities`TranslateZ[-
         Graphics`Arrow3D`Private`length][
         Polygon[{{-Graphics`Arrow3D`Private`width, 0, -
            Graphics`Arrow3D`Private`inset}, {
           0, 0, Graphics`Arrow3D`Private`length}, {
           Graphics`Arrow3D`Private`width, 0, -
            Graphics`Arrow3D`Private`inset}, {0, 0, 
           0}, {-Graphics`Arrow3D`Private`width, 0, -
            Graphics`Arrow3D`Private`inset}}]], 
       TagSet[Graphics`Arrow3D`FlatHead, 
        MessageName[Graphics`Arrow3D`FlatHead, "usage"], 
        ""], $CellContext`arr3d = {
         RGBColor[0.24720000000000014`, 0.24, 0.6], 
         Specularity[0], 
         EdgeForm[
          RGBColor[0.24720000000000014`, 0.24, 0.6]], 
         FaceForm[
          GrayLevel[0]], 
         Glow[
          RGBColor[0.24720000000000014`, 0.24, 0.6]], 
         Thickness[0.007], 
         Rotate[{{
            Line[{{0, 0, 0}, {0, 0, 0.85}}]}, {
            Translate[
             Rotate[
              Rotate[
               Translate[
                
                Polygon[{{-0.045, 0, -0.015}, {0, 0, 0.15000000000000002`}, {
                  0.045, 0, -0.015}, {0, 0, 0}, {-0.045, 0, -0.015}}], {
                0, 0, -0.15000000000000002`}], 0, {1, 0, 0}], 0, {0, 0, 1}], {
             0, 0, 1}]}, {}}, Pi/2, {0, 1, 0}]}, 
       Graphics`GraphicsUtilities`Crop[{{
           Pattern[Graphics`GraphicsUtilities`Private`xmin, 
            Blank[]], 
           Pattern[Graphics`GraphicsUtilities`Private`xmax, 
            Blank[]]}, {
           Pattern[Graphics`GraphicsUtilities`Private`ymin, 
            Blank[]], 
           Pattern[Graphics`GraphicsUtilities`Private`ymax, 
            Blank[]]}}] := {{0, 
          1} + {-Graphics`GraphicsUtilities`Private`xmin, 1 - 
            Graphics`GraphicsUtilities`Private`xmax}/(
          Graphics`GraphicsUtilities`Private`xmax - 
          Graphics`GraphicsUtilities`Private`xmin), {0, 
          1} + {-Graphics`GraphicsUtilities`Private`ymin, 1 - 
            Graphics`GraphicsUtilities`Private`ymax}/(
          Graphics`GraphicsUtilities`Private`ymax - 
          Graphics`GraphicsUtilities`Private`ymin)}, 
       TagSet[Graphics`GraphicsUtilities`Crop, 
        MessageName[Graphics`GraphicsUtilities`Crop, "usage"], ""], 
       Attributes[$CellContext`MyManipulator] = {
        HoldAll}, $CellContext`MyManipulator[
         Pattern[$CellContext`var, 
          Blank[]], 
         Pattern[$CellContext`range, 
          Blank[]], 
         Pattern[$CellContext`func, 
          Blank[]], Scale -> Pattern[$CellContext`scale, 
           Blank[]]] := Row[{
          Manipulator[
           
           Dynamic[$CellContext`var, $CellContext`func], $CellContext`range], \

          $CellContext`PaddedInputField[$CellContext`var, $CellContext`func, \
$CellContext`scale]}, 
         Spacer[5]], $CellContext`MyManipulator[
         Pattern[$CellContext`var, 
          Blank[]], 
         Pattern[$CellContext`range, 
          Blank[]], 
         Pattern[$CellContext`func, 
          Blank[]]] := Row[{
          Manipulator[
           
           Dynamic[$CellContext`var, $CellContext`func], $CellContext`range], \

          $CellContext`PaddedInputField[$CellContext`var, $CellContext`func]},
          
         Spacer[5]], 
       Attributes[$CellContext`PaddedInputField] = {
        HoldAll}, $CellContext`PaddedInputField[
         Pattern[$CellContext`x, 
          Blank[]], 
         Pattern[$CellContext`func, 
          Blank[]]] := InputField[
         Dynamic[
          DisplayForm[
           StyleBox[
            ToString[
             $CellContext`MyNumberForm[$CellContext`x]]]], $CellContext`func],
          FieldSize -> 5], $CellContext`PaddedInputField[
         Pattern[$CellContext`x, 
          Blank[]], 
         Pattern[$CellContext`func, 
          Blank[]], 
         Pattern[$CellContext`p, 
          Blank[]]] := InputField[
         Dynamic[
          DisplayForm[
           RowBox[{
             ToString[
              $CellContext`MyNumberForm[$CellContext`x/$CellContext`p]], 
             TraditionalForm[$CellContext`p]}]], $CellContext`func], 
         FieldSize -> 5], $CellContext`MyNumberForm[
         Pattern[$CellContext`x, 
          Blank[]]] := NumberForm[
         N[$CellContext`x, 2], {2, 2}, NumberSigns -> {"-", "   "}, 
         ExponentFunction -> (Null& )], $CellContext`AEToRP[
         Pattern[$CellContext`st, 
          Blank[]]] := 
       AtomicDensityMatrix`UsageMessages`ReparameterizeField[$CellContext`st, 
         "AngleEllipticity" -> "RatioPhase"], 
       AtomicDensityMatrix`UsageMessages`ReparameterizeField[{
          Pattern[AtomicDensityMatrix`AtomicDensityMatrix`Private`S1, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`AtomicDensityMatrix`Private`S2, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`AtomicDensityMatrix`Private`S3, 
           Blank[]]}, "Stokes" -> "RatioPhase"] := {
         ArcCos[
         Sqrt[1 + AtomicDensityMatrix`AtomicDensityMatrix`Private`S1]/Sqrt[
          2]], 
         If[
         N[AtomicDensityMatrix`AtomicDensityMatrix`Private`S2] === 
          N[AtomicDensityMatrix`AtomicDensityMatrix`Private`S3] === 0., Pi/4, 
          
          ArcTan[
          AtomicDensityMatrix`AtomicDensityMatrix`Private`S2, 
           AtomicDensityMatrix`AtomicDensityMatrix`Private`S3]]}, 
       AtomicDensityMatrix`UsageMessages`ReparameterizeField[{
          Pattern[AtomicDensityMatrix`AtomicDensityMatrix`Private`\[Chi], 
           Blank[]], 
          Pattern[AtomicDensityMatrix`AtomicDensityMatrix`Private`ph, 
           Blank[]]}, "RatioPhase" -> "Stokes"] := {
         Cos[2 AtomicDensityMatrix`AtomicDensityMatrix`Private`\[Chi]], 
         Cos[AtomicDensityMatrix`AtomicDensityMatrix`Private`ph] 
         Sin[2 AtomicDensityMatrix`AtomicDensityMatrix`Private`\[Chi]], 
         Sin[AtomicDensityMatrix`AtomicDensityMatrix`Private`ph] 
         Sin[2 AtomicDensityMatrix`AtomicDensityMatrix`Private`\[Chi]]}, 
       AtomicDensityMatrix`UsageMessages`ReparameterizeField[{
          Pattern[AtomicDensityMatrix`AtomicDensityMatrix`Private`al, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`AtomicDensityMatrix`Private`ep, 
           Blank[]]}, "AngleEllipticity" -> "Stokes"] := {
        Cos[2 AtomicDensityMatrix`AtomicDensityMatrix`Private`al] 
         Cos[2 AtomicDensityMatrix`AtomicDensityMatrix`Private`ep], 
         Cos[2 AtomicDensityMatrix`AtomicDensityMatrix`Private`ep] 
         Sin[2 AtomicDensityMatrix`AtomicDensityMatrix`Private`al], 
         Sin[2 AtomicDensityMatrix`AtomicDensityMatrix`Private`ep]}, 
       AtomicDensityMatrix`UsageMessages`ReparameterizeField[{
          Pattern[AtomicDensityMatrix`AtomicDensityMatrix`Private`S1, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`AtomicDensityMatrix`Private`S2, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`AtomicDensityMatrix`Private`S3, 
           Blank[]]}, "Stokes" -> "AngleEllipticity"] := {
         If[
         N[AtomicDensityMatrix`AtomicDensityMatrix`Private`S1] === 
          N[AtomicDensityMatrix`AtomicDensityMatrix`Private`S2] === 0., 
          0, (Sign[AtomicDensityMatrix`AtomicDensityMatrix`Private`S2] + 
           KroneckerDelta[AtomicDensityMatrix`AtomicDensityMatrix`Private`S2])
            ArcSin[
            Sqrt[
            1/2 - AtomicDensityMatrix`AtomicDensityMatrix`Private`S1/(2 
             Sqrt[AtomicDensityMatrix`AtomicDensityMatrix`Private`S1^2 + 
               AtomicDensityMatrix`AtomicDensityMatrix`Private`S2^2 + 
               0.1])]]], (
          Sign[AtomicDensityMatrix`AtomicDensityMatrix`Private`S3] + 
          KroneckerDelta[AtomicDensityMatrix`AtomicDensityMatrix`Private`S3]) 
         ArcCos[
           Sqrt[
           1/2 + (1 
              Sqrt[AtomicDensityMatrix`AtomicDensityMatrix`Private`S1^2 + 
                AtomicDensityMatrix`AtomicDensityMatrix`Private`S2^2])/2]]}, 
       AtomicDensityMatrix`UsageMessages`ReparameterizeField[{
          Pattern[AtomicDensityMatrix`AtomicDensityMatrix`Private`\[Chi], 
           Blank[]], 
          Pattern[AtomicDensityMatrix`AtomicDensityMatrix`Private`ph, 
           Blank[]]}, "RatioPhase" -> "AngleEllipticity"] := 
       AtomicDensityMatrix`UsageMessages`ReparameterizeField[
         AtomicDensityMatrix`UsageMessages`ReparameterizeField[{
          AtomicDensityMatrix`AtomicDensityMatrix`Private`\[Chi], 
           AtomicDensityMatrix`AtomicDensityMatrix`Private`ph}, "RatioPhase" -> 
          "Stokes"], "Stokes" -> "AngleEllipticity"], 
       AtomicDensityMatrix`UsageMessages`ReparameterizeField[{
          Pattern[AtomicDensityMatrix`AtomicDensityMatrix`Private`al, 
           Blank[]], 
          Pattern[AtomicDensityMatrix`AtomicDensityMatrix`Private`ep, 
           Blank[]]}, "AngleEllipticity" -> "RatioPhase"] := 
       AtomicDensityMatrix`UsageMessages`ReparameterizeField[
         AtomicDensityMatrix`UsageMessages`ReparameterizeField[{
          AtomicDensityMatrix`AtomicDensityMatrix`Private`al, 
           AtomicDensityMatrix`AtomicDensityMatrix`Private`ep}, 
          "AngleEllipticity" -> "Stokes"], "Stokes" -> "RatioPhase"], 
       TagSet[AtomicDensityMatrix`UsageMessages`ReparameterizeField, 
        MessageName[
        AtomicDensityMatrix`UsageMessages`ReparameterizeField, "usage"], 
        ""], $CellContext`AEToS[
         Pattern[$CellContext`st, 
          Blank[]]] := 
       AtomicDensityMatrix`UsageMessages`ReparameterizeField[$CellContext`st, 
         "AngleEllipticity" -> "Stokes"], $CellContext`RPToAE[
         Pattern[$CellContext`st, 
          Blank[]]] := 
       AtomicDensityMatrix`UsageMessages`ReparameterizeField[$CellContext`st, 
         "RatioPhase" -> "AngleEllipticity"], $CellContext`RPToS[
         Pattern[$CellContext`st, 
          Blank[]]] := 
       AtomicDensityMatrix`UsageMessages`ReparameterizeField[$CellContext`st, 
         "RatioPhase" -> 
         "Stokes"], $CellContext`NS = $CellContext`NormalizeStokes, \
$CellContext`NormalizeStokes[{
          Pattern[$CellContext`s1, 
           Blank[]], 
          Pattern[$CellContext`s2, 
           Blank[]], 
          Pattern[$CellContext`s3, 
           Blank[]]}] := Module[{$CellContext`a}, 
         Which[
          And[Abs[$CellContext`s2] < 0.01, Abs[$CellContext`s3] < 0.01], {
          Sqrt[1 - $CellContext`s1^2]/Sqrt[2], Sqrt[1 - $CellContext`s1^2]/
           Sqrt[2]}, Abs[$CellContext`s1] == 1., {0., 0.}, 
          True, $CellContext`a = 
           Sqrt[(1 - $CellContext`s1^2)/($CellContext`s2^2 + \
$CellContext`s3^2)]; {$CellContext`s2 $CellContext`a, $CellContext`s3 \
$CellContext`a}]], $CellContext`SToAE[
         Pattern[$CellContext`st$, 
          Blank[]]] := 
       If[$CellContext`S1$$ == $CellContext`S2$$ == 0., {
         0, (1/4) 
          Pi (KroneckerDelta[$CellContext`S3$$] + Sign[$CellContext`S3$$])}, 
         AtomicDensityMatrix`UsageMessages`ReparameterizeField[$CellContext`\
st$, "Stokes" -> "AngleEllipticity"]], $CellContext`SToRP[
         Pattern[$CellContext`st$, 
          Blank[]]] := If[$CellContext`S2$$ == $CellContext`S3$$ == 0., {
          ArcCos[Sqrt[1 + $CellContext`S1$$]/Sqrt[2]], Pi/4}, 
         AtomicDensityMatrix`UsageMessages`ReparameterizeField[$CellContext`\
st$, "Stokes" -> "RatioPhase"]]}; Typeset`initDone$$ = True),
    SynchronousInitialization->True,
    UnsavedVariables:>{Typeset`initDone$$},
    UntrackedVariables:>{Typeset`size$$}], "Manipulate",
   Deployed->True,
   StripOnInput->False],
  Manipulate`InterpretManipulate[1]]], "Output",
 ImageSize->{556, 649},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[29]=",
 CellID->97602260]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "TutorialMoreAboutSection",
 CellElementSpacings->{"CellMinHeight"->3},
 CellFrameLabels->{{
    FEPrivate`If[
     FEPrivate`Or[
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 
     Cell[
     "MORE ABOUT", "TutorialMoreAboutSection", CellSize -> {5000, Inherited}],
      
     Cell[
      TextData[{
        Cell[
         BoxData[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {24, 0}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[24]]]], "More About"}], "TutorialMoreAboutSection", 
      CellSize -> {5000, Inherited}]], None}, {None, None}},
 CellFrameLabelMargins->0,
 CellSize->{Inherited, 
   FEPrivate`If[
    FEPrivate`Or[
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 11, 14]},
 "WholeCellGroupOpener" -> True,
 CellID->23220180],

Cell["", "SectionHeaderSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]],

Cell[TextData[ButtonBox["AtomicDensityMatrix Package",
 BaseStyle->"Link",
 ButtonData->
  "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"]], \
"TutorialMoreAbout",
 CellID->1567025153],

Cell["", "SectionFooterSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]]
}, Open  ]]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"Light Polarization Demonstration - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, 
  "Metadata" -> {
   "built" -> "{2014, 2, 28, 1, 42, 55.6830958}", "context" -> 
    "AtomicDensityMatrix`", "keywords" -> {"Atomic Density Matrix", "ADM"}, 
    "index" -> True, "label" -> "Atomic Density Matrix Tutorial", "language" -> 
    "en", "paclet" -> "AtomicDensityMatrix", "status" -> "None", "summary" -> 
    "An interactive demonstration illustrating parameterizations for light \
polarization. Light polarization can be selected using the \
\\[Alpha]-\\[Epsilon], x-\\[Phi], and Stokes parameterizations. The \
polarization ellipse and Poincare' sphere are plotted.", "synonyms" -> {}, 
    "title" -> "Light Polarization Demonstration", "type" -> "Tutorial", 
    "uri" -> "AtomicDensityMatrix/tutorial/LightPolarizationDemonstration"}, 
  "SearchTextTranslated" -> "", "SearchText" -> ""},
FrontEndVersion->"6.0 for Microsoft Windows (64-bit) (May 21, 2008)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"], 
   Cell[
    StyleData["TutorialMoreAboutSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}], 
   Cell[
    StyleData["RelatedTutorialsSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}], 
   Cell[
    StyleData["TutorialRelatedLinksSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}]}, Visible -> False, 
  FrontEndVersion -> "6.0 for Microsoft Windows (64-bit) (May 21, 2008)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[568, 21, 78, 1, 3, "TutorialColorBar"],
Cell[649, 24, 220, 5, 70, "LinkTrail"],
Cell[872, 31, 7963, 162, 70, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[8860, 197, 69, 1, 70, "Title",
 CellID->196759130],
Cell[8932, 200, 304, 6, 70, "Text",
 CellID->51546441],
Cell[CellGroupData[{
Cell[9261, 210, 56, 1, 70, "Section",
 CellID->44645273],
Cell[CellGroupData[{
Cell[9342, 215, 62, 1, 70, "SubsectionOpener",
 CellID->965371655],
Cell[9407, 218, 104, 3, 70, "Input",
 CellID->171085568],
Cell[9514, 223, 561, 17, 70, "Input",
 CellID->109334777],
Cell[10078, 242, 153, 4, 70, "Input",
 CellID->343416248],
Cell[10234, 248, 524, 16, 70, "Input",
 CellID->56403217],
Cell[10761, 266, 679, 20, 70, "Input",
 CellID->11061968],
Cell[11443, 288, 263, 8, 70, "Input",
 CellID->177524866],
Cell[11709, 298, 409, 13, 70, "Input",
 CellID->228198244],
Cell[12121, 313, 3051, 82, 70, "Input",
 CellID->338406235],
Cell[15175, 397, 400, 11, 70, "Input",
 CellID->2931987],
Cell[15578, 410, 170, 5, 70, "Input",
 CellID->282891712],
Cell[15751, 417, 645, 18, 70, "Input",
 CellID->218396106],
Cell[16399, 437, 579, 17, 70, "Input",
 CellID->74104170],
Cell[16981, 456, 665, 21, 70, "Input",
 CellID->17081472]
}, Closed]],
Cell[CellGroupData[{
Cell[17683, 482, 70, 1, 70, "SubsectionOpener",
 CellID->158617434],
Cell[17756, 485, 107, 3, 70, "Input",
 CellID->75905070],
Cell[17866, 490, 1436, 47, 70, "Input",
 CellID->3740002],
Cell[19305, 539, 1306, 39, 70, "Input",
 CellID->13348457],
Cell[20614, 580, 1130, 32, 70, "Input",
 CellID->780677788],
Cell[21747, 614, 3387, 100, 70, "Input",
 CellID->415357996],
Cell[25137, 716, 40072, 981, 70, "Input",
 CellID->649053163]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[65258, 1703, 51, 1, 70, "Section",
 CellID->30911599],
Cell[65312, 1706, 60556, 1247, 70, "Output",
 CellID->97602260]
}, Open  ]],
Cell[CellGroupData[{
Cell[125905, 2958, 1107, 30, 70, "TutorialMoreAboutSection",
 CellID->23220180],
Cell[127015, 2990, 804, 18, 70, "SectionHeaderSpacer"],
Cell[127822, 3010, 192, 5, 70, "TutorialMoreAbout",
 CellID->1567025153],
Cell[128017, 3017, 804, 18, 70, "SectionFooterSpacer"]
}, Open  ]]
}, Open  ]],
Cell[128848, 3039, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

