(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     72875,       1859]
NotebookOptionsPosition[     66223,       1650]
NotebookOutlinePosition[     68471,       1704]
CellTagsIndexPosition[     68428,       1701]
WindowFrame->Normal
ContainsDynamic->True *)

(* Beginning of Notebook Content *)
Notebook[{
Cell[" ", "TutorialColorBar",
 CellMargins->{{Inherited, Inherited}, {-5, 0}}],

Cell[TextData[{
 ButtonBox["AtomicDensityMatrix Package",
  BaseStyle->{"Link", "LinkTrail"},
  ButtonData->"paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"],
 StyleBox[" > ", "LinkTrailSeparator"]
}], "LinkTrail"],

Cell[BoxData[GridBox[{
   {
    StyleBox[
     GraphicsBox[RasterBox[CompressedData["
1:eJy9lulTk1cUxp+Zfu+Xfu5MO9O/oF90povj0A6dVtupdRsBqwRCg+DCqCxF
LLIIoUAIyGLayqJCFZRYVJaAaDBsQkBCEhaVoCjEBAiLTSLJ7bmX0nEBhZZ6
5mbmTebN/d3nnOec930/cN+mwLcAvEefD+jDr9nrwul0DvabbdaxuwNm++Ox
197/r8PQrY/bLwnyxYFvEL0F8TtwOiNq9IHFYDC4XK5VBGmvaXasg/QLRH6H
xABkBiFXhvw9fCVJP7LZbKsFemwdC1gP2ZdcjnwXCvag9BAuxOByHC4dQUU0
dBfzV4vV0aoL+4orOv49ckNRHo3qeDQehy4NzWnQpvCv/W2aRf+70vSeK8o/
+C0vkDIEZYdx5SfclKM9Az05MOai9wQ6FahLwJT9ObeQkaqrq3t7e1fESo+W
/LgV8t1QhfPU1Seh5WfczoY5D4Mn0V/AoSSwNkfidjnpfofDUVVVpVKpFArF
5OTkiliZMZJ4PyiCceYg/ohDUyq6stCXhzsqziIicXVyXriyVMnQoHnt2rV+
fn5paWkmk2lFIAptrfqYHzceJZBy1ZaObiUGCjirL5/nsDWdl+yXvfw8R3e8
EyYLIVBhYSEJfMW25F6HCKeI+R+npxzJOzmLEtiQhFuZvEzEouzps9CQzN1C
5s8IQroE4VvWJB2NLsqKP3U8vCI7ytypm0/syzExMaFWqxMTE2NjY0NDQ6VS
aVNTk8vpVMVLToZxq9cnclZvLsd1KDiFtFA1Y7aAtKfuflsRFXA+YSMdifzT
ks7PdjXV1/7IspS69vZ2uVyeLYKqbLFYGmursqUoO8RzRSwqUJcSJRGcsssH
gZ/zYULaC/fzapJVhn7F47MYPw/b77CVYlCFe83qpXDUFw0NDSUlJZRPo9FY
U1OTk5kWfzjsVOQ6qg7t1piMw5uw/VPs/gx7N/JhQiBy42gJZi/iaS3YdTAd
WBtYEzwaTJbj0a0lcez5TrxvGcpOOFCsiCOxOTEBcdu5HN7jm3k7kG2ou20X
4KqDpxXsNlgPmAmsD6xfXLdh5jK8Txev3cthHbHkhWLfRq6FRhY1OMmZ92db
BkbPYk4LZgS7BzYMZhHr/sIaBNPDZX6VtGeDJvDWT3iBwjZwM5yQ8ZLdSMGA
CvZyeBrE+Qn0QLCGwO6KixGwh+JHwg0vi3X6t/xtArTvayT4o/gAauLRmYVH
xXBWgmnAOsEMYunBugSXEnhHqBsRi9Cji4/NZ6MgK3Xrx7xAVB3qIz7b0/jQ
mD4PTzXYNbBWjrBW4mExZtXw1nNLcKhRyLEIgXThMC8ndTvXI3Yb0gNx+Sjv
rNHT+FMN1igo3VzIXD0myjB5DtMV8F5ZOECXcMggF2hvW+OcedUkoYcXGTvY
lzucZi+BqLlmKjB3FV6dOLlZ7Ebb3oRXAzeZrUak9IYwPN3QK264jYfmG0ql
UqfTud3uRVl1V9TkOrKcUoq6YzDlwVEBz3V42xfyc0eUhjbsAGsB04qlE/QO
oYv8b5Iw19+KZmdnl9JVVX7m0CZkSXmNqP2fXIS3UezQt+DqAZFDk/BGm8A1
i9Uivhqj2IiGzS2rrcI30OjGuUgYcmAthUcr0jK44K57mGp511r1ITdDI7xa
Pi68VKkWibs5io3pl0mZj+wjkuwf+AgdL8VcrUiLSfTmiOigHlSejLTb7XNP
HJ6pMc+4hdFkWPZweCGMHbriCJjzMX1B2NggCjQkerYLTlufv79/T0/PUuVe
UdDTpzLJl56Jzkui3D0LxuuVOMctPj4+MpksOTlZr9f/dxbFU5dztFtjPcPN
7CUnd0cxq34+URERESEhISkpKTMzM6vC+ic8bucLg3p4eDgoKIjel1YXtGjQ
e0JwcDA94N4Ai6KoqGh8fPzNsFbFgf9r/AWVRIUY
       "], {{0, 0}, {36, 32}}, {0, 255},
       ColorFunction->RGBColor],
      ImageSize->{36, 32},
      PlotRange->{{0, 36}, {0, 32}}],
     Deployed->True,
     StripOnInput->False], Cell[
    "ATOMIC DENSITY MATRIX TUTORIAL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "AtomicDensityMatrix Package", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]]}, #, 2]& , Evaluator -> 
        Automatic], {1->"\<\"AtomicDensityMatrix Package\"\>"}, 
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"More About \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "AtomicDensityMatrix/tutorial/LinearAbsorptionFitting", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> None, 
          StringReplace[
           "Copy Mathematica url", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> 
          Module[{DocumentationSearch`Private`nb$}, 
            DocumentationSearch`Private`nb$ = NotebookPut[
               Notebook[{
                 Cell[
                  StringReplace[
                  "AtomicDensityMatrix/tutorial/LinearAbsorptionFitting", 
                   "http://reference.wolfram.com/mathematica/" -> 
                   "http://budker.berkeley.edu/ADM/"]]}, Visible -> False]]; 
            SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
            FrontEndTokenExecute[DocumentationSearch`Private`nb$, 
              StringReplace[
              "Copy", "http://reference.wolfram.com/mathematica/" -> 
               "http://budker.berkeley.edu/ADM/"]]; 
            NotebookClose[DocumentationSearch`Private`nb$]; Null], Delimiter, 
          StringReplace[
           "Copy web url", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> 
          Module[{DocumentationSearch`Private`nb$}, 
            DocumentationSearch`Private`nb$ = NotebookPut[
               Notebook[{
                 Cell[
                  BoxData[
                   MakeBoxes[
                    Hyperlink[
                    StringReplace[
                    "http://reference.wolfram.com/mathematica/\
AtomicDensityMatrix/tutorial/LinearAbsorptionFitting.html", 
                    "http://reference.wolfram.com/mathematica/" -> 
                    "http://budker.berkeley.edu/ADM/"]], StandardForm]], 
                  StringReplace[
                  "Input", "http://reference.wolfram.com/mathematica/" -> 
                   "http://budker.berkeley.edu/ADM/"], TextClipboardType -> 
                  StringReplace[
                   "PlainText", "http://reference.wolfram.com/mathematica/" -> 
                    "http://budker.berkeley.edu/ADM/"]]}, Visible -> False]]; 
            SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
            FrontEndTokenExecute[DocumentationSearch`Private`nb$, 
              StringReplace[
              "Copy", "http://reference.wolfram.com/mathematica/" -> 
               "http://budker.berkeley.edu/ADM/"]]; 
            NotebookClose[DocumentationSearch`Private`nb$]; Null], 
          StringReplace[
           "Go to web url", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> FrontEndExecute[{
             NotebookLocate[{
               URL[
                StringJoin[
                 StringReplace[
                 "http://reference.wolfram.com/mathematica/", 
                  "http://reference.wolfram.com/mathematica/" -> 
                  "http://budker.berkeley.edu/ADM/"], 
                 StringReplace[
                 "AtomicDensityMatrix/tutorial/LinearAbsorptionFitting", 
                  "http://reference.wolfram.com/mathematica/" -> 
                  "http://budker.berkeley.edu/ADM/"], 
                 StringReplace[
                 ".html", "http://reference.wolfram.com/mathematica/" -> 
                  "http://budker.berkeley.edu/ADM/"]]], None}]}]}, #, 2]& , 
        Evaluator -> Automatic], {
       1->"\<\"AtomicDensityMatrix/tutorial/LinearAbsorptionFitting\"\>", 
       2->"\<\"Copy Mathematica url\"\>", Delimiter, 
       4->"\<\"Copy web url\"\>", 5->"\<\"Go to web url\"\>"}, 
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"URL \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxAlignment->{"Columns" -> {{Left, Left, Right}}},
 GridBoxItemSize->{"Columns" -> {
     Scaled[0.05], 
     Scaled[0.3], {
      Scaled[0.64]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[CellGroupData[{

Cell["Linear Absorption Fitting", "Title",
 CellID->509267359],

Cell[TextData[{
 "The density of an atomic vapor can be determined by measuring the \
absorption of weak resonant light. In this example we use the ",
 Cell[BoxData[
  ButtonBox["LinearAbsorption",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/LinearAbsorption"]], 
  "InlineFormula"],
 " function from the ",
 ButtonBox["AtomicDensityMatrix",
  BaseStyle->"Link",
  ButtonData->"paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"],
 " package along with values from the ",
 Cell[BoxData["AtomicData`"], "InlineFormula"],
 " database to construct a fitting function for linear absorption on an \
alkali ",
 StyleBox["D",
  FontSlant->"Italic"],
 "-line. Fitting a linear absorption spectrum with this function allows the \
atomic density to be extracted."
}], "Text",
 CellID->667345311],

Cell["This loads the package.", "MathCaption",
 CellID->836781195],

Cell[BoxData[
 RowBox[{"<<", "AtomicDensityMatrix`"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->2058623809],

Cell["\<\
Choose a transition. The names of the upper and lower states are taken from a \
database.\
\>", "MathCaption",
 CellID->594387048],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{"gstate", ",", "estate"}], "}"}], "=", 
  RowBox[{"AtomicTransition", "[", 
   RowBox[{"\"\<Rb87\>\"", ",", "\"\<D1\>\""}], "]"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->255182439],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"Rb\"\>", ",", "87", ",", 
     RowBox[{"{", 
      RowBox[{"\<\"Kr\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"5", ",", "\<\"s\"\>"}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "\<\"S\"\>", ",", 
       FractionBox["1", "2"]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"Rb\"\>", ",", "87", ",", 
     RowBox[{"{", 
      RowBox[{"\<\"Kr\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"5", ",", "\<\"p\"\>"}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "\<\"P\"\>", ",", 
       FractionBox["1", "2"]}], "}"}]}], "}"}]}], "}"}]], "Output",
 ImageSize->{461, 30},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->535380923]
}, Open  ]],

Cell["\<\
Get all of the necessary atomic parameters from the database, and construct a \
list of all of the sublevels of the atomic system.\
\>", "MathCaption",
 CellID->331090632],

Cell[BoxData[
 RowBox[{
  RowBox[{"system", "=", 
   RowBox[{"Sublevels", "@", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"AtomicState", "[", 
       RowBox[{"1", ",", 
        RowBox[{"AtomicData", "[", 
         RowBox[{"gstate", ",", 
          RowBox[{"{", 
           RowBox[{
           "Energy", ",", "J", ",", "L", ",", "S", ",", "NuclearSpin", ",", 
            "HyperfineA", ",", "HyperfineB", ",", "NaturalWidth"}], "}"}]}], 
         "]"}]}], "]"}], ",", 
      RowBox[{"AtomicState", "[", 
       RowBox[{"2", ",", 
        RowBox[{"Append", "[", 
         RowBox[{
          RowBox[{"AtomicData", "[", 
           RowBox[{"estate", ",", 
            RowBox[{"{", 
             RowBox[{
             "J", ",", "L", ",", "S", ",", "NuclearSpin", ",", "HyperfineA", 
              ",", "HyperfineB", ",", "NaturalWidth"}], "}"}]}], "]"}], ",", 
          RowBox[{
           RowBox[{"BranchingRatio", "[", "1", "]"}], "\[Rule]", "1"}]}], 
         "]"}]}], "]"}]}], "}"}]}]}], ";"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->314100305],

Cell["\<\
Doppler width in \[Omega] units at 293 Kelvin. The width is given as the \
magnitude of the Doppler shift corresponding to the most probable speed in \
the Maxwell velocity distribution.\
\>", "MathCaption",
 CellID->48670516],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dw", "=", 
  RowBox[{"DopplerWidth", "[", 
   RowBox[{"gstate", ",", "estate", ",", "293"}], "]"}]}]], "Input",
 CellLabel->"In[4]:=",
 CellID->154363566],

Cell[BoxData[
 FractionBox[
  RowBox[{"1870.3833999502813`", " ", "Mega"}], "Second"]], "Output",
 ImageSize->{89, 30},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->394131143]
}, Open  ]],

Cell["\<\
Feed this list of sublevels to a function that calculates linear absorption. \
This is fractional absorption per unit atomic density and optical path \
length.\
\>", "MathCaption",
 CellID->372588276],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"abs", "=", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"LinearAbsorption", "[", 
      RowBox[{"system", ",", "dw", ",", 
       RowBox[{
        RowBox[{"Energy", "[", "2", "]"}], "+", 
        RowBox[{"2", "\[Pi]", " ", "\[CapitalDelta]", " ", 
         RowBox[{"Giga", "/", "Second"}]}]}]}], "]"}], "/.", 
     RowBox[{
      RowBox[{"Energy", "[", "2", "]"}], "\[Rule]", 
      RowBox[{"2", "\[Pi]", " ", 
       RowBox[{"Wavenumber", "[", "estate", "]"}]}]}]}], "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Mega", "\[Rule]", 
       SuperscriptBox["10", "6"]}], ",", 
      RowBox[{"Giga", "\[Rule]", 
       SuperscriptBox["10", "9"]}]}], "}"}]}], "//", "ExpandAll"}]}]], "Input",\

 CellLabel->"In[5]:=",
 CellID->294630237],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["Centimeter", "2"], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{"-", "5.3807796747572954`*^-12"}], " ", 
     RowBox[{"Re", "[", 
      RowBox[{
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{
         RowBox[{"-", "2.85850345348918`*^-19"}], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"1.4184768221654259`*^10", "+", 
              RowBox[{"1.806423642472633`*^7", " ", "\[ImaginaryI]"}]}], 
             ")"}], "+", 
            RowBox[{"6.283185307179586`*^9", " ", "\[CapitalDelta]"}]}], 
           ")"}], "2"]}]], " ", 
       RowBox[{"Erfc", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"0.009658039322422618`", "\[InvisibleSpace]", "-", 
           RowBox[{"7.583882653166895`", " ", "\[ImaginaryI]"}]}], ")"}], "-",
          
         RowBox[{
          RowBox[{"(", 
           RowBox[{"0.`", "\[InvisibleSpace]", "+", 
            RowBox[{"3.359303395948983`", " ", "\[ImaginaryI]"}]}], ")"}], 
          " ", "\[CapitalDelta]"}]}], "]"}]}], "]"}]}], "-", 
    RowBox[{"5.3807796747572954`*^-12", " ", 
     RowBox[{"Re", "[", 
      RowBox[{
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{
         RowBox[{"-", "2.85850345348918`*^-19"}], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"1.930229699064589`*^10", "+", 
              RowBox[{"1.806423642472633`*^7", " ", "\[ImaginaryI]"}]}], 
             ")"}], "+", 
            RowBox[{"6.283185307179586`*^9", " ", "\[CapitalDelta]"}]}], 
           ")"}], "2"]}]], " ", 
       RowBox[{"Erfc", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"0.009658039322422618`", "\[InvisibleSpace]", "-", 
           RowBox[{"10.319968083099424`", " ", "\[ImaginaryI]"}]}], ")"}], 
         "-", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"0.`", "\[InvisibleSpace]", "+", 
            RowBox[{"3.359303395948983`", " ", "\[ImaginaryI]"}]}], ")"}], 
          " ", "\[CapitalDelta]"}]}], "]"}]}], "]"}]}], "-", 
    RowBox[{"1.0761559349514592`*^-12", " ", 
     RowBox[{"Re", "[", 
      RowBox[{
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{
         RowBox[{"-", "2.85850345348918`*^-19"}], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"2.364128036942376`*^10", "-", 
              RowBox[{"1.806423642472633`*^7", " ", "\[ImaginaryI]"}]}], 
             ")"}], "-", 
            RowBox[{"6.283185307179586`*^9", " ", "\[CapitalDelta]"}]}], 
           ")"}], "2"]}]], " ", 
       RowBox[{"Erfc", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"0.009658039322422618`", "\[InvisibleSpace]", "+", 
           RowBox[{"12.639804421944822`", " ", "\[ImaginaryI]"}]}], ")"}], 
         "-", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"0.`", "\[InvisibleSpace]", "+", 
            RowBox[{"3.359303395948983`", " ", "\[ImaginaryI]"}]}], ")"}], 
          " ", "\[CapitalDelta]"}]}], "]"}]}], "]"}]}], "-", 
    RowBox[{"5.3807796747572954`*^-12", " ", 
     RowBox[{"Re", "[", 
      RowBox[{
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{
         RowBox[{"-", "2.85850345348918`*^-19"}], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"2.875880913841539`*^10", "-", 
              RowBox[{"1.806423642472633`*^7", " ", "\[ImaginaryI]"}]}], 
             ")"}], "-", 
            RowBox[{"6.283185307179586`*^9", " ", "\[CapitalDelta]"}]}], 
           ")"}], "2"]}]], " ", 
       RowBox[{"Erfc", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"0.009658039322422618`", "\[InvisibleSpace]", "+", 
           RowBox[{"15.375889851877352`", " ", "\[ImaginaryI]"}]}], ")"}], 
         "-", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"0.`", "\[InvisibleSpace]", "+", 
            RowBox[{"3.359303395948983`", " ", "\[ImaginaryI]"}]}], ")"}], 
          " ", "\[CapitalDelta]"}]}], "]"}]}], "]"}]}]}], ")"}]}]], "Output",
 ImageSize->{510, 207},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->15539507]
}, Open  ]],

Cell[TextData[{
 "The line shape of each resonance is given in terms of the natural line \
width ",
 Cell[BoxData["\[CapitalGamma]"], "InlineFormula"],
 " and ",
 StyleBox["the",
  Deletable->True],
 " Doppler width ",
 Cell[BoxData[
  SubscriptBox["\[CapitalGamma]", "D"]], "InlineFormula"],
 " by the Voigt profile, which is a convolution of a Lorentzian and a \
Gaussian profile."
}], "MathCaption",
 CellID->458096647],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Voigt", "[", 
  RowBox[{"\[CapitalDelta]\[Omega]", ",", 
   RowBox[{"\[CapitalGamma]", "/", "2"}], ",", 
   SubscriptBox["\[CapitalGamma]", "D"]}], "]"}]], "Input",
 CellLabel->"In[6]:=",
 CellID->528267889],

Cell[BoxData[
 FractionBox[
  RowBox[{"Re", "[", 
   RowBox[{
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{"-", 
      FractionBox[
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          FractionBox[
           RowBox[{"\[ImaginaryI]", " ", "\[CapitalGamma]"}], "2"], "+", 
          "\[CapitalDelta]\[Omega]"}], ")"}], "2"], 
       SubsuperscriptBox["\[CapitalGamma]", "D", "2"]]}]], " ", 
    RowBox[{"Erfc", "[", 
     RowBox[{"-", 
      FractionBox[
       RowBox[{"\[ImaginaryI]", " ", 
        RowBox[{"(", 
         RowBox[{
          FractionBox[
           RowBox[{"\[ImaginaryI]", " ", "\[CapitalGamma]"}], "2"], "+", 
          "\[CapitalDelta]\[Omega]"}], ")"}]}], 
       SubscriptBox["\[CapitalGamma]", "D"]]}], "]"}]}], "]"}], 
  RowBox[{
   SqrtBox["\[Pi]"], " ", 
   SubscriptBox["\[CapitalGamma]", "D"]}]]], "Output",
 ImageSize->{201, 72},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[6]=",
 CellID->348412543]
}, Open  ]],

Cell[TextData[{
 "Here \[CapitalGamma] is the full width at half maximum (FWHM) of the \
Lorentzian profile, which we can show by solving for the FWHM in the special \
case of ",
 Cell[BoxData[
  RowBox[{
   SubscriptBox["\[CapitalGamma]", "D"], "=", "0"}]], "InlineFormula"],
 "."
}], "MathCaption",
 CellID->23128620],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Solve", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Voigt", "[", 
     RowBox[{"\[CapitalDelta]\[Omega]", ",", 
      RowBox[{"\[CapitalGamma]", "/", "2"}], ",", "0"}], "]"}], "\[Equal]", 
    RowBox[{
     RowBox[{"1", "/", "2"}], 
     RowBox[{"Voigt", "[", 
      RowBox[{"0", ",", 
       RowBox[{"\[CapitalGamma]", "/", "2"}], ",", "0"}], "]"}]}]}], ",", 
   "\[CapitalDelta]\[Omega]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"-", 
  RowBox[{"Subtract", "@@", 
   RowBox[{"(", 
    RowBox[{"\[CapitalDelta]\[Omega]", "/.", "%"}], ")"}]}]}]}], "Input",
 CellLabel->"In[7]:=",
 CellID->582682611],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\[CapitalDelta]\[Omega]", "\[Rule]", 
     RowBox[{"-", 
      FractionBox["\[CapitalGamma]", "2"]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\[CapitalDelta]\[Omega]", "\[Rule]", 
     FractionBox["\[CapitalGamma]", "2"]}], "}"}]}], "}"}]], "Output",
 ImageSize->{148, 30},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[7]=",
 CellID->310634791],

Cell[BoxData["\[CapitalGamma]"], "Output",
 ImageSize->{11, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[7]=",
 CellID->446930324]
}, Open  ]],

Cell[TextData[{
 "Solving for the FWHM in the special case of ",
 Cell[BoxData[
  RowBox[{"\[CapitalGamma]", "=", "0"}]], "InlineFormula"],
 ", we find the FWHM for the Gaussian profile in terms of the Doppler width \
",
 Cell[BoxData[
  SubscriptBox["\[CapitalGamma]", "D"]], "InlineFormula"],
 "."
}], "MathCaption",
 CellID->109364325],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Solve", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Voigt", "[", 
     RowBox[{"\[CapitalDelta]\[Omega]", ",", "0", ",", 
      SubscriptBox["\[CapitalGamma]", "D"]}], "]"}], "\[Equal]", 
    RowBox[{
     RowBox[{"1", "/", "2"}], 
     RowBox[{"Voigt", "[", 
      RowBox[{"0", ",", "0", ",", 
       SubscriptBox["\[CapitalGamma]", "D"]}], "]"}]}]}], ",", 
   "\[CapitalDelta]\[Omega]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"-", 
  RowBox[{"Subtract", "@@", 
   RowBox[{"(", 
    RowBox[{"\[CapitalDelta]\[Omega]", "/.", "%"}], ")"}]}]}]}], "Input",
 CellLabel->"In[8]:=",
 CellID->557904801],

Cell[BoxData[
 RowBox[{
  RowBox[{"Solve", "::", "\<\"ifun\"\>"}], ":", 
  " ", "\<\"Inverse functions are being used by \\!\\(Solve\\), so some \
solutions may not be found; use Reduce for complete solution information. \\!\
\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/Solve/ifun\\\", \
ButtonNote -> \\\"Solve::ifun\\\"]\\)\"\>"}]], "Message", "MSG",
 CellLabel->"During evaluation of In[8]:=",
 CellID->110622848],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\[CapitalDelta]\[Omega]", "\[Rule]", 
     RowBox[{
      RowBox[{"-", 
       SqrtBox[
        RowBox[{"Log", "[", "2", "]"}]]}], " ", 
      SubscriptBox["\[CapitalGamma]", "D"]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\[CapitalDelta]\[Omega]", "\[Rule]", 
     RowBox[{
      SqrtBox[
       RowBox[{"Log", "[", "2", "]"}]], " ", 
      SubscriptBox["\[CapitalGamma]", "D"]}]}], "}"}]}], "}"}]], "Output",
 ImageSize->{274, 22},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[8]=",
 CellID->255017739],

Cell[BoxData[
 RowBox[{"2", " ", 
  SqrtBox[
   RowBox[{"Log", "[", "2", "]"}]], " ", 
  SubscriptBox["\[CapitalGamma]", "D"]}]], "Output",
 ImageSize->{89, 17},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[8]=",
 CellID->1812425]
}, Open  ]],

Cell[TextData[{
 "For atomic vapors with multiple species (e.g., the vapor from a sample with \
multiple isotopes in natural abundance), we can calculate absorption due to \
each species and add the absorption formulas together. For the case of \
natural abundance, we can multiply the term for each isotope by the relative \
abundance, found from ",
 Cell[BoxData[
  RowBox[{
   ButtonBox["Abundance",
    BaseStyle->"Link",
    ButtonData->"paclet:AtomicDensityMatrix/ref/Abundance"], "[", 
   StyleBox["gstate", "TI"], "]"}]], "InlineFormula"],
 "."
}], "MathCaption",
 CellID->89274621],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Abundance", "[", "gstate", "]"}]], "Input",
 CellLabel->"In[9]:=",
 CellID->93901605],

Cell[BoxData["0.27835`"], "Output",
 ImageSize->{53, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[9]=",
 CellID->401259096]
}, Open  ]],

Cell["\<\
To speed up computations, create an interpolating function from the \
absorption. The minimum and maximum limits here may need to be adjusted.\
\>", "MathCaption",
 CellID->7922972],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"absi", "=", 
  RowBox[{"FunctionInterpolation", "[", 
   RowBox[{
    RowBox[{"Expand", "[", 
     RowBox[{"abs", "/", 
      SuperscriptBox["Centimeter", "2"]}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"\[CapitalDelta]", ",", 
      RowBox[{"-", "17"}], ",", "17"}], "}"}], ",", 
    RowBox[{"AccuracyGoal", "\[Rule]", "16"}], ",", 
    RowBox[{"MaxRecursion", "\[Rule]", "8"}]}], "]"}]}]], "Input",
 CellLabel->"In[10]:=",
 CellID->21926477],

Cell[BoxData[
 TagBox[
  RowBox[{"InterpolatingFunction", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "17.`"}], ",", "17.`"}], "}"}], "}"}], 
    ",", "\<\"<>\"\>"}], "]"}],
  False,
  Editable->False]], "Output",
 ImageSize->{280, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[10]=",
 CellID->23837349]
}, Open  ]],

Cell["Plot the interpolating function", "MathCaption",
 CellID->347578903],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"absi", "[", "\[CapitalDelta]", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"\[CapitalDelta]", ",", 
     RowBox[{"-", "6"}], ",", "8"}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
   RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}]], "Input",
 CellLabel->"In[11]:=",
 CellID->634410102],

Cell[GraphicsData["CompressedBitmap", "\<\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\
\>"], "Output",
 Evaluatable->False,
 ImageSize->{288, 162},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[11]=",
 CellID->118404727]
}, Open  ]],

Cell[TextData[{
 "To find transmission for a possibly optically thick medium, take ",
 Cell[BoxData[
  RowBox[{"Exp", "[", 
   RowBox[{"n", " ", "length", " ", "abs"}], "]"}]], "InlineFormula"],
 ", where ",
 Cell[BoxData["n"], "InlineFormula"],
 " is atomic density and ",
 Cell[BoxData["length"], "InlineFormula"],
 " is the optical path length through the vapor cell. The length could be set \
to the correct value in centimeters here. Or it can be left at 1, in which \
case we will extract density times path length in ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["cm", 
    RowBox[{"-", "2"}]], TraditionalForm]]],
 " from the fit, rather than density in ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["cm", 
    RowBox[{"-", "3"}]], TraditionalForm]]],
 "."
}], "Text",
 CellID->502388490],

Cell[TextData[{
 "We also include four more parameters that allow shifting and scaling the ",
 StyleBox["x",
  FontSlant->"Italic"],
 " and ",
 StyleBox["y",
  FontSlant->"Italic"],
 " axes so that the data can be fit: ",
 Cell[BoxData["a"], "InlineFormula"],
 " shifts the ",
 StyleBox["x",
  FontSlant->"Italic"],
 " axis, ",
 Cell[BoxData["b"], "InlineFormula"],
 " stretches the ",
 StyleBox["x",
  FontSlant->"Italic"],
 " axis, ",
 Cell[BoxData["c"], "InlineFormula"],
 " scales the ",
 StyleBox["y",
  FontSlant->"Italic"],
 " axis, and ",
 Cell[BoxData["d"], "InlineFormula"],
 " produces a background slope."
}], "Text",
 CellID->257531597],

Cell["Create the transmission function.", "MathCaption",
 CellID->148742438],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"transmission", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"c", "+", 
      RowBox[{"d", " ", "\[CapitalDelta]"}]}], ")"}], " ", 
    RowBox[{"Exp", "[", 
     RowBox[{"n", " ", "length", " ", 
      RowBox[{"absi", "[", 
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "\[CapitalDelta]"}]}], "]"}]}], "]"}]}], "/.", 
   RowBox[{"length", "\[Rule]", "1"}]}]}]], "Input",
 CellLabel->"In[12]:=",
 CellID->7421138],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["\[ExponentialE]", 
   RowBox[{"n", " ", 
    RowBox[{
     TagBox[
      RowBox[{"InterpolatingFunction", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "17.`"}], ",", "17.`"}], "}"}], "}"}], 
        ",", "\<\"<>\"\>"}], "]"}],
      False,
      Editable->False], "[", 
     RowBox[{"a", "+", 
      RowBox[{"b", " ", "\[CapitalDelta]"}]}], "]"}]}]], " ", 
  RowBox[{"(", 
   RowBox[{"c", "+", 
    RowBox[{"d", " ", "\[CapitalDelta]"}]}], ")"}]}]], "Output",
 ImageSize->{295, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[12]=",
 CellID->407204031]
}, Open  ]],

Cell["Here we make some fake data for testing.", "MathCaption",
 CellID->189786912],

Cell[BoxData[
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\[CapitalDelta]", ",", 
       RowBox[{
        RowBox[{"transmission", "+", 
         RowBox[{"RandomReal", "[", ".002", "]"}]}], "/.", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"n", "\[Rule]", 
           RowBox[{"2.", " ", 
            SuperscriptBox["10", "9"]}]}], ",", 
          RowBox[{"a", "\[Rule]", 
           RowBox[{"-", "1"}]}], ",", 
          RowBox[{"b", "\[Rule]", ".9"}], ",", 
          RowBox[{"c", "\[Rule]", "2"}], ",", 
          RowBox[{"d", "\[Rule]", ".002"}]}], "}"}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\[CapitalDelta]", ",", 
       RowBox[{"-", "5"}], ",", "8", ",", ".1"}], "}"}]}], "]"}]}], 
  ";"}]], "Input",
 CellLabel->"In[13]:=",
 CellID->30348389],

Cell["Plot the data.", "MathCaption",
 CellID->173186174],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ListLinePlot", "[", 
  RowBox[{"data", ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
   RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}]], "Input",
 CellLabel->"In[14]:=",
 CellID->395387101],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJw91QlM01cYAPBytEApvQu15SqdDWpIKAyCEfK+ofNIhkNcpm7uQEQdw+GF
ww0dyjGPImhwExWEKeKUDeaBOtT/Q2dQBCwqMRwZgqNyiEesSAO2+9v69SVN
8/K+7/d97/X/f9WsyEhKdeVwOLns5+23Y8jpYklq6fF/beRQ6dsho/4bh7Jf
dttIpH3IaJncT7Gty0ZaW94OKX0WqzOGPLSRVfYhpZZN1yfXs+sOT0p7jE26
+B70JLS9Ki10bQ96EqoctJhO9qMnpiMLDhv0A+iJ6eO6GtWXJvTEdOByvja6
F/NFNDU+N8n1EcYL6cVvo4Rb+rCeD73e07G3achG7HyLgCY3mBMuOT0BrTTS
Jfkm9LzptK3Hxp8Po8enXtfFy14MoudFf04rz+WPoudJZ/3JfzY4jJ4nPcj1
uF88gp4HfW943C1yBD0eVfTIM0zsfu1cKZeeL8z07u5Az536GV//MeM2eu40
47/xyJVn0XOjbUV7X3aWoedKoxJ9PW4eRs+FMrevpvtXosehgls6EalHj0N/
j7/7k74N862MlZtfVfwA4yeZV1mD4hK2nwh7vQnmtDL9aGyLjRy0+xameUdh
T/UF9MaZVmP1YVKD3hjTQKMrmAr0zIxcHzpKT6H3kqk+PV3RdwW9F8zGlvGc
zHb0njMFVXM+ucD+/jft+U+Yta8fbyo2Y/wQk1xXp180YSNr7PVMDHjtOKOz
2Ei43X/EqOvDUr6woveQESyda5JzOFBsz+9krG8a7pZaMf4eQxI3i4/YbCTH
vn6LKfp6T4KAjXfMLzHGnRf129k5viEZWcu/+ZudU8c6qRL2+tay8wpHPmnt
4V6d7sIBcPgkQb4k8zcXXO8kD6502Ka6o/eQdBeujy9040CMo3/CEc/N0bHr
7/ZH2mbFRezjYf4QOcm7/X0JG290nA9JzY3bfYaL3nOynPtVfzebf8RxvmT+
gZ3rwjw58L7j/MnIjdItOh7mm4nqRKk5jYf1xshZXVV/pSd648R9tCRqlid6
FtK84o74phd6E8SSngNWpzdJLl3zC/iQj56VKJNXhnY5PQ64ftY8R8Sutzme
T0i/ta4mjJ073i8XaNclbUj3wnxXCG/UChP4WM8NDCm26K0+6LlDEs2e1+70
3KFWnd14SIgeF9JUypwuIXo80FSVu931Rs8DsspinspF6HnCxOriGwNs/Lv3
G5p/+PVcjQ/u3wsOvDo287IIPT7wFZt3eYnR84blH83vuyhBTwDPkg1QLkFP
AOsGNoQESNHzAb1JY1ooRk8IhpbYBbFOTwQu9xf7G8ToieGvqCfhmWz+u/sR
8uJ099IkuH8x+E6/EW+VY74Eyk2y6HlyPA8J/GMZqV0mQ08Kgymvwo/KsL4U
FvXlu6bI0ZNCdUxGZK0MPRl4zLwsN0vRk0HDj91H2xToyWFO4379fqcnB/H2
Va31zv7kUPDU8MJfgp4Cupo2lZ3wQU8BWdN+0YY79+sLq9d8bh6ToucLDcvy
IrbJ0POF0D07R2ql6PlBaIUgfqMIPT/Il24P2ctDTwnBd2K/KzHj/aEETfLi
Q2Hs/e7wlCDSMPtOsf9/Dm8KqDqKdtcP4/0/BRrJ2rACC94vKigwLs3udT6v
KlA3FMWdc56fCnrP75gR6Yf9qeHjPtIwVY39qSGvafUbbSD25w+Gexp1UxB6
/jAa0T/WGoCeP+RZD/KvBKEXANW5ncExQegFwNbj/Rmzg9ELhGsLL3xqc3qB
oD+fuMugQS8Qis/oOcla9IJgkl/WXKlFLwjKEmcvqtGiFwx1H2TlBIdw4H+q
dWSV
     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 1.98},
  Frame->True,
  PlotRange->{All, All},
  PlotRangeClipping->True,
  PlotRangePadding->{Automatic, Automatic}]], "Output",
 ImageSize->{184, 114},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[14]=",
 CellID->757330287]
}, Open  ]],

Cell[TextData[{
 "To fit the data we can use  the ",
 Cell[BoxData[
  ButtonBox["PlotAndFit",
   BaseStyle->"Link",
   ButtonData->"paclet:DataAnalysis/ref/PlotAndFit"]], "InlineFormula"],
 " function from the ",
 Cell[BoxData["DataAnalysis`PlotAndFit`"], "InlineFormula"],
 " package, which makes it somewhat more convenient to adjust the fit \
starting parameters by hand prior to fitting. "
}], "Text",
 CellID->520485174],

Cell["Load the package.", "MathCaption",
 CellID->127315084],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<DataAnalysis`PlotAndFit`\>\"", "]"}]], "Input",
 CellLabel->"In[15]:=",
 CellID->1007878803],

Cell[TextData[{
 "Fit the data. If ",
 Cell[BoxData[
  RowBox[{
   ButtonBox["DoFit",
    BaseStyle->"Link",
    ButtonData->"paclet:DataAnalysis/ref/DoFit"], "->", 
   ButtonBox["False",
    BaseStyle->"Link",
    ButtonData->"paclet:ref/False"]}]], "InlineFormula"],
 " is chosen, the fitting function is plotted using the initial values. This \
allows the initial values to be adjusted by hand until they are close enough \
to the true values for the fitting routine to work properly. The shift \
parameter ",
 Cell[BoxData["a"], "InlineFormula"],
 " is particularly important to get fairly close."
}], "MathCaption",
 CellID->340874833],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PlotAndFit", "[", 
  RowBox[{"data", ",", "transmission", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"n", ",", 
       RowBox[{"1.5", " ", 
        SuperscriptBox["10", "9"]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"a", ",", 
       RowBox[{"-", ".9"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"b", ",", ".8"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"c", ",", "1."}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"d", ",", "0"}], "}"}]}], "}"}], ",", "\[CapitalDelta]", ",", 
   RowBox[{"DoFit", "\[Rule]", "True"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
   RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}]], "Input",
 CellLabel->"In[16]:=",
 CellID->94520556],

Cell[BoxData[
 GraphicsBox[{
   {Hue[0.67, 0.6, 0.6], PointBox[CompressedData["
1:eJw91QlM01cYAPBytEApvQu15SqdDWpIKAyCEfK+ofNIhkNcpm7uQEQdw+GF
ww0dyjGPImhwExWEKeKUDeaBOtT/Q2dQBCwqMRwZgqNyiEesSAO2+9v69SVN
8/K+7/d97/X/f9WsyEhKdeVwOLns5+23Y8jpYklq6fF/beRQ6dsho/4bh7Jf
dttIpH3IaJncT7Gty0ZaW94OKX0WqzOGPLSRVfYhpZZN1yfXs+sOT0p7jE26
+B70JLS9Ki10bQ96EqoctJhO9qMnpiMLDhv0A+iJ6eO6GtWXJvTEdOByvja6
F/NFNDU+N8n1EcYL6cVvo4Rb+rCeD73e07G3achG7HyLgCY3mBMuOT0BrTTS
Jfkm9LzptK3Hxp8Po8enXtfFy14MoudFf04rz+WPoudJZ/3JfzY4jJ4nPcj1
uF88gp4HfW943C1yBD0eVfTIM0zsfu1cKZeeL8z07u5Az536GV//MeM2eu40
47/xyJVn0XOjbUV7X3aWoedKoxJ9PW4eRs+FMrevpvtXosehgls6EalHj0N/
j7/7k74N862MlZtfVfwA4yeZV1mD4hK2nwh7vQnmtDL9aGyLjRy0+xameUdh
T/UF9MaZVmP1YVKD3hjTQKMrmAr0zIxcHzpKT6H3kqk+PV3RdwW9F8zGlvGc
zHb0njMFVXM+ucD+/jft+U+Yta8fbyo2Y/wQk1xXp180YSNr7PVMDHjtOKOz
2Ei43X/EqOvDUr6woveQESyda5JzOFBsz+9krG8a7pZaMf4eQxI3i4/YbCTH
vn6LKfp6T4KAjXfMLzHGnRf129k5viEZWcu/+ZudU8c6qRL2+tay8wpHPmnt
4V6d7sIBcPgkQb4k8zcXXO8kD6502Ka6o/eQdBeujy9040CMo3/CEc/N0bHr
7/ZH2mbFRezjYf4QOcm7/X0JG290nA9JzY3bfYaL3nOynPtVfzebf8RxvmT+
gZ3rwjw58L7j/MnIjdItOh7mm4nqRKk5jYf1xshZXVV/pSd648R9tCRqlid6
FtK84o74phd6E8SSngNWpzdJLl3zC/iQj56VKJNXhnY5PQ64ftY8R8Sutzme
T0i/ta4mjJ073i8XaNclbUj3wnxXCG/UChP4WM8NDCm26K0+6LlDEs2e1+70
3KFWnd14SIgeF9JUypwuIXo80FSVu931Rs8DsspinspF6HnCxOriGwNs/Lv3
G5p/+PVcjQ/u3wsOvDo287IIPT7wFZt3eYnR84blH83vuyhBTwDPkg1QLkFP
AOsGNoQESNHzAb1JY1ooRk8IhpbYBbFOTwQu9xf7G8ToieGvqCfhmWz+u/sR
8uJ099IkuH8x+E6/EW+VY74Eyk2y6HlyPA8J/GMZqV0mQ08Kgymvwo/KsL4U
FvXlu6bI0ZNCdUxGZK0MPRl4zLwsN0vRk0HDj91H2xToyWFO4379fqcnB/H2
Va31zv7kUPDU8MJfgp4Cupo2lZ3wQU8BWdN+0YY79+sLq9d8bh6ToucLDcvy
IrbJ0POF0D07R2ql6PlBaIUgfqMIPT/Il24P2ctDTwnBd2K/KzHj/aEETfLi
Q2Hs/e7wlCDSMPtOsf9/Dm8KqDqKdtcP4/0/BRrJ2rACC94vKigwLs3udT6v
KlA3FMWdc56fCnrP75gR6Yf9qeHjPtIwVY39qSGvafUbbSD25w+Gexp1UxB6
/jAa0T/WGoCeP+RZD/KvBKEXANW5ncExQegFwNbj/Rmzg9ELhGsLL3xqc3qB
oD+fuMugQS8Qis/oOcla9IJgkl/WXKlFLwjKEmcvqtGiFwx1H2TlBIdw4H+q
dWSV
     "]]}, {{}, {}, 
    {RGBColor[1, 0, 0], LineBox[CompressedData["
1:eJwl23k4VN8fB/Ax9j0zY4xdIksoS7LPiUIULZaUqGRJWUIqSiVJRbTYsuYr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      "]]}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  Frame->True,
  PlotRange->All,
  PlotRangeClipping->True]], "Print",
 CellLabel->"During evaluation of In[18]:=",
 CellID->416636683],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"n", ",", "1.99055437291613`*^9"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", 
     RowBox[{"-", "0.9997548764892304`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"b", ",", "0.8997303332388961`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"c", ",", "2.0009547069753677`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"d", ",", "0.0020101787548080724`"}], "}"}]}], "}"}]], "Output",
 ImageSize->{536, 18},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[16]=",
 CellID->312830339]
}, Open  ]],

Cell[TextData[{
 "If the length parameter was set to the correct value above, then the fitted \
value for ",
 Cell[BoxData["n"], "InlineFormula"],
 " is the atomic density in ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["cm", 
    RowBox[{"-", "3"}]], TraditionalForm]]],
 "."
}], "Text",
 CellID->255481261],

Cell["\<\
Note that it is very important that the signal voltage goes to zero when the \
light is completely blocked. Otherwise the background offset will throw off \
the density results. Also, if the light power is too high, the absorption \
will not be in the linear regime, which will also skew the results.\
\>", "Text",
 CellID->130535449],

Cell[TextData[{
 "The ",
 Cell[BoxData[
  ButtonBox["GUIPlotAndFit",
   BaseStyle->"Link",
   ButtonData->"paclet:DataAnalysis/ref/GUIPlotAndFit"]], "InlineFormula"],
 " version of the function brings up a dialog that provides a little more \
interactivity."
}], "MathCaption",
 CellID->295699766],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"GUIPlotAndFit", "[", 
  RowBox[{"data", ",", "transmission", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"n", ",", 
       RowBox[{"1.5", " ", 
        SuperscriptBox["10", "9"]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"a", ",", 
       RowBox[{"-", ".9"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"b", ",", ".8"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"c", ",", "1."}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"d", ",", "0"}], "}"}]}], "}"}], ",", "\[CapitalDelta]"}], 
  "]"}]], "Input",
 CellLabel->"In[17]:=",
 CellID->977365307],

Cell[BoxData[
 DynamicModuleBox[{
  DataAnalysis`PlotAndFit`Private`params1$$ = {{$CellContext`n, 1.5*^9, 
    1}, {$CellContext`a, -0.9, 1}, {$CellContext`b, 0.8, 1}, {$CellContext`c, 
    1., 1}, {$CellContext`d, 0, 1}}, 
  DataAnalysis`PlotAndFit`Private`fitq$$ = {True, True, True, True, True}, 
  DataAnalysis`PlotAndFit`Private`names$$ = {$CellContext`n, $CellContext`a, \
$CellContext`b, $CellContext`c, $CellContext`d}, 
  DataAnalysis`PlotAndFit`Private`ivalues$$ = {1.5*^9, -0.9, 0.8, 1., 0}, 
  DataAnalysis`PlotAndFit`Private`fvalues$$ = {
  1.99055437291613*^9, -0.9997548764892304, 0.8997303332388961, 
  2.0009547069753677`, 0.0020101787548080724`}, 
  DataAnalysis`PlotAndFit`Private`evalues$$ = {1.7621503154098738`*^7, 
  0.002646224510799645, 0.0006491809848941373, 0.00006261831743128186, 
  0.000013799408189741413`}, DataAnalysis`PlotAndFit`Private`nv$$ = 5, 
  DataAnalysis`PlotAndFit`Private`doFit$$ = False, 
  DataAnalysis`PlotAndFit`Private`fitDone$$ = True, 
  DataAnalysis`PlotAndFit`Private`setvals$$ = {}, 
  DataAnalysis`PlotAndFit`Private`newparams$$ = {{$CellContext`n, 
    1.5*^9}, {$CellContext`a, -0.9}, {$CellContext`b, 0.8}, {$CellContext`c, 
    1.}, {$CellContext`d, 0}}, 
  DataAnalysis`PlotAndFit`Private`setvals1$$ = {$CellContext`n -> {
    1.5*^9, 0}, $CellContext`a -> {-0.9, 0}, $CellContext`b -> {
    0.8, 0}, $CellContext`c -> {1., 0}, $CellContext`d -> {0, 0}}}, 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"n", ",", "1.99055437291613`*^9"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"a", ",", 
      RowBox[{"-", "0.9997548764892304`"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"b", ",", "0.8997303332388961`"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"c", ",", "2.0009547069753677`"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"d", ",", "0.0020101787548080724`"}], "}"}]}], "}"}],
  DynamicModuleValues:>{}]], "Output",
 ImageSize->{536, 18},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[17]=",
 CellID->263646275]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "TutorialMoreAboutSection",
 CellElementSpacings->{"CellMinHeight"->3},
 CellFrameLabels->{{
    FEPrivate`If[
     FEPrivate`Or[
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 
     Cell[
     "MORE ABOUT", "TutorialMoreAboutSection", CellSize -> {5000, Inherited}],
      
     Cell[
      TextData[{
        Cell[
         BoxData[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {24, 0}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[24]]]], "More About"}], "TutorialMoreAboutSection", 
      CellSize -> {5000, Inherited}]], None}, {None, None}},
 CellFrameLabelMargins->0,
 CellSize->{Inherited, 
   FEPrivate`If[
    FEPrivate`Or[
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 11, 14]},
 "WholeCellGroupOpener" -> True,
 CellID->23220180],

Cell["", "SectionHeaderSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]],

Cell[TextData[ButtonBox["AtomicDensityMatrix Package",
 BaseStyle->"Link",
 ButtonData->
  "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"]], \
"TutorialMoreAbout",
 CellID->1567025153],

Cell["", "SectionFooterSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]]
}, Open  ]]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"Linear Absorption Fitting - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, 
  "Metadata" -> {
   "built" -> "{2014, 2, 28, 1, 42, 57.4481967}", "context" -> 
    "AtomicDensityMatrix`", "keywords" -> {"Atomic Density Matrix", "ADM"}, 
    "index" -> True, "label" -> "Atomic Density Matrix Tutorial", "language" -> 
    "en", "paclet" -> "AtomicDensityMatrix", "status" -> "None", "summary" -> 
    "The density of an atomic vapor can be determined by measuring the \
absorption of weak resonant light. In this example we use the \
LinearAbsorption function from the AtomicDensityMatrix package along with \
values from the AtomicData` database to construct a fitting function for \
linear absorption on an alkali D-line. Fitting a linear absorption spectrum \
with this function allows the atomic density to be extracted. This loads the \
package. Choose a transition. The names of the upper and lower states are \
taken from a database.", "synonyms" -> {}, "title" -> 
    "Linear Absorption Fitting", "type" -> "Tutorial", "uri" -> 
    "AtomicDensityMatrix/tutorial/LinearAbsorptionFitting"}, 
  "SearchTextTranslated" -> "", "SearchText" -> ""},
FrontEndVersion->"6.0 for Microsoft Windows (64-bit) (May 21, 2008)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"], 
   Cell[
    StyleData["TutorialMoreAboutSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}], 
   Cell[
    StyleData["RelatedTutorialsSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}], 
   Cell[
    StyleData["TutorialRelatedLinksSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}]}, Visible -> False, 
  FrontEndVersion -> "6.0 for Microsoft Windows (64-bit) (May 21, 2008)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[568, 21, 78, 1, 3, "TutorialColorBar"],
Cell[649, 24, 220, 5, 70, "LinkTrail"],
Cell[872, 31, 7969, 162, 70, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[8866, 197, 62, 1, 70, "Title",
 CellID->509267359],
Cell[8931, 200, 813, 21, 70, "Text",
 CellID->667345311],
Cell[9747, 223, 66, 1, 70, "MathCaption",
 CellID->836781195],
Cell[9816, 226, 108, 3, 70, "Input",
 CellID->2058623809],
Cell[9927, 231, 140, 4, 70, "MathCaption",
 CellID->594387048],
Cell[CellGroupData[{
Cell[10092, 239, 236, 7, 70, "Input",
 CellID->255182439],
Cell[10331, 248, 810, 25, 70, "Output",
 CellID->535380923]
}, Open  ]],
Cell[11156, 276, 181, 4, 70, "MathCaption",
 CellID->331090632],
Cell[11340, 282, 1051, 29, 70, "Input",
 CellID->314100305],
Cell[12394, 313, 236, 5, 70, "MathCaption",
 CellID->48670516],
Cell[CellGroupData[{
Cell[12655, 322, 178, 5, 70, "Input",
 CellID->154363566],
Cell[12836, 329, 227, 7, 70, "Output",
 CellID->394131143]
}, Open  ]],
Cell[13078, 339, 210, 5, 70, "MathCaption",
 CellID->372588276],
Cell[CellGroupData[{
Cell[13313, 348, 770, 23, 70, "Input",
 CellID->294630237],
Cell[14086, 373, 4338, 114, 70, "Output",
 CellID->15539507]
}, Open  ]],
Cell[18439, 490, 422, 13, 70, "MathCaption",
 CellID->458096647],
Cell[CellGroupData[{
Cell[18886, 507, 231, 6, 70, "Input",
 CellID->528267889],
Cell[19120, 515, 993, 31, 70, "Output",
 CellID->348412543]
}, Open  ]],
Cell[20128, 549, 319, 9, 70, "MathCaption",
 CellID->23128620],
Cell[CellGroupData[{
Cell[20472, 562, 624, 18, 70, "Input",
 CellID->582682611],
Cell[21099, 582, 456, 14, 70, "Output",
 CellID->310634791],
Cell[21558, 598, 172, 5, 70, "Output",
 CellID->446930324]
}, Open  ]],
Cell[21745, 606, 338, 10, 70, "MathCaption",
 CellID->109364325],
Cell[CellGroupData[{
Cell[22108, 620, 622, 18, 70, "Input",
 CellID->557904801],
Cell[22733, 640, 497, 9, 70, "Message",
 CellID->110622848],
Cell[23233, 651, 616, 20, 70, "Output",
 CellID->255017739],
Cell[23852, 673, 267, 9, 70, "Output",
 CellID->1812425]
}, Open  ]],
Cell[24134, 685, 590, 14, 70, "MathCaption",
 CellID->89274621],
Cell[CellGroupData[{
Cell[24749, 703, 109, 3, 70, "Input",
 CellID->93901605],
Cell[24861, 708, 165, 5, 70, "Output",
 CellID->401259096]
}, Open  ]],
Cell[25041, 716, 191, 4, 70, "MathCaption",
 CellID->7922972],
Cell[CellGroupData[{
Cell[25257, 724, 471, 13, 70, "Input",
 CellID->21926477],
Cell[25731, 739, 390, 15, 70, "Output",
 CellID->23837349]
}, Open  ]],
Cell[26136, 757, 74, 1, 70, "MathCaption",
 CellID->347578903],
Cell[CellGroupData[{
Cell[26235, 762, 361, 10, 70, "Input",
 CellID->634410102],
Cell[26599, 774, 5675, 97, 70, "Output",
 Evaluatable->False,
 CellID->118404727]
}, Open  ]],
Cell[32289, 874, 798, 23, 70, "Text",
 CellID->502388490],
Cell[33090, 899, 649, 26, 70, "Text",
 CellID->257531597],
Cell[33742, 927, 76, 1, 70, "MathCaption",
 CellID->148742438],
Cell[CellGroupData[{
Cell[33843, 932, 456, 14, 70, "Input",
 CellID->7421138],
Cell[34302, 948, 698, 24, 70, "Output",
 CellID->407204031]
}, Open  ]],
Cell[35015, 975, 83, 1, 70, "MathCaption",
 CellID->189786912],
Cell[35101, 978, 841, 25, 70, "Input",
 CellID->30348389],
Cell[35945, 1005, 57, 1, 70, "MathCaption",
 CellID->173186174],
Cell[CellGroupData[{
Cell[36027, 1010, 222, 6, 70, "Input",
 CellID->395387101],
Cell[36252, 1018, 2291, 46, 70, "Output",
 CellID->757330287]
}, Open  ]],
Cell[38558, 1067, 425, 11, 70, "Text",
 CellID->520485174],
Cell[38986, 1080, 60, 1, 70, "MathCaption",
 CellID->127315084],
Cell[39049, 1083, 134, 3, 70, "Input",
 CellID->1007878803],
Cell[39186, 1088, 640, 17, 70, "MathCaption",
 CellID->340874833],
Cell[CellGroupData[{
Cell[39851, 1109, 752, 22, 70, "Input",
 CellID->94520556],
Cell[40606, 1133, 18358, 308, 70, "Print",
 CellID->416636683],
Cell[58967, 1443, 595, 18, 70, "Output",
 CellID->312830339]
}, Open  ]],
Cell[59577, 1464, 310, 11, 70, "Text",
 CellID->255481261],
Cell[59890, 1477, 344, 6, 70, "Text",
 CellID->130535449],
Cell[60237, 1485, 297, 9, 70, "MathCaption",
 CellID->295699766],
Cell[CellGroupData[{
Cell[60559, 1498, 615, 20, 70, "Input",
 CellID->977365307],
Cell[61177, 1520, 2039, 42, 70, "Output",
 CellID->263646275]
}, Open  ]],
Cell[CellGroupData[{
Cell[63253, 1567, 1107, 30, 70, "TutorialMoreAboutSection",
 CellID->23220180],
Cell[64363, 1599, 804, 18, 70, "SectionHeaderSpacer"],
Cell[65170, 1619, 192, 5, 70, "TutorialMoreAbout",
 CellID->1567025153],
Cell[65365, 1626, 804, 18, 70, "SectionFooterSpacer"]
}, Open  ]]
}, Open  ]],
Cell[66196, 1648, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

