(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     54397,       1581]
NotebookOptionsPosition[     46266,       1331]
NotebookOutlinePosition[     49071,       1392]
CellTagsIndexPosition[     49028,       1389]
WindowFrame->Normal
ContainsDynamic->True *)

(* Beginning of Notebook Content *)
Notebook[{
Cell[" ", "TutorialColorBar",
 CellMargins->{{Inherited, Inherited}, {-5, 0}}],

Cell[TextData[{
 ButtonBox["AtomicDensityMatrix Package",
  BaseStyle->{"Link", "LinkTrail"},
  ButtonData->"paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"],
 StyleBox[" > ", "LinkTrailSeparator"]
}], "LinkTrail"],

Cell[BoxData[GridBox[{
   {
    StyleBox[
     GraphicsBox[RasterBox[CompressedData["
1:eJy9lulTk1cUxp+Zfu+Xfu5MO9O/oF90povj0A6dVtupdRsBqwRCg+DCqCxF
LLIIoUAIyGLayqJCFZRYVJaAaDBsQkBCEhaVoCjEBAiLTSLJ7bmX0nEBhZZ6
5mbmTebN/d3nnOec930/cN+mwLcAvEefD+jDr9nrwul0DvabbdaxuwNm++Ox
197/r8PQrY/bLwnyxYFvEL0F8TtwOiNq9IHFYDC4XK5VBGmvaXasg/QLRH6H
xABkBiFXhvw9fCVJP7LZbKsFemwdC1gP2ZdcjnwXCvag9BAuxOByHC4dQUU0
dBfzV4vV0aoL+4orOv49ckNRHo3qeDQehy4NzWnQpvCv/W2aRf+70vSeK8o/
+C0vkDIEZYdx5SfclKM9Az05MOai9wQ6FahLwJT9ObeQkaqrq3t7e1fESo+W
/LgV8t1QhfPU1Seh5WfczoY5D4Mn0V/AoSSwNkfidjnpfofDUVVVpVKpFArF
5OTkiliZMZJ4PyiCceYg/ohDUyq6stCXhzsqziIicXVyXriyVMnQoHnt2rV+
fn5paWkmk2lFIAptrfqYHzceJZBy1ZaObiUGCjirL5/nsDWdl+yXvfw8R3e8
EyYLIVBhYSEJfMW25F6HCKeI+R+npxzJOzmLEtiQhFuZvEzEouzps9CQzN1C
5s8IQroE4VvWJB2NLsqKP3U8vCI7ytypm0/syzExMaFWqxMTE2NjY0NDQ6VS
aVNTk8vpVMVLToZxq9cnclZvLsd1KDiFtFA1Y7aAtKfuflsRFXA+YSMdifzT
ks7PdjXV1/7IspS69vZ2uVyeLYKqbLFYGmursqUoO8RzRSwqUJcSJRGcsssH
gZ/zYULaC/fzapJVhn7F47MYPw/b77CVYlCFe83qpXDUFw0NDSUlJZRPo9FY
U1OTk5kWfzjsVOQ6qg7t1piMw5uw/VPs/gx7N/JhQiBy42gJZi/iaS3YdTAd
WBtYEzwaTJbj0a0lcez5TrxvGcpOOFCsiCOxOTEBcdu5HN7jm3k7kG2ou20X
4KqDpxXsNlgPmAmsD6xfXLdh5jK8Txev3cthHbHkhWLfRq6FRhY1OMmZ92db
BkbPYk4LZgS7BzYMZhHr/sIaBNPDZX6VtGeDJvDWT3iBwjZwM5yQ8ZLdSMGA
CvZyeBrE+Qn0QLCGwO6KixGwh+JHwg0vi3X6t/xtArTvayT4o/gAauLRmYVH
xXBWgmnAOsEMYunBugSXEnhHqBsRi9Cji4/NZ6MgK3Xrx7xAVB3qIz7b0/jQ
mD4PTzXYNbBWjrBW4mExZtXw1nNLcKhRyLEIgXThMC8ndTvXI3Yb0gNx+Sjv
rNHT+FMN1igo3VzIXD0myjB5DtMV8F5ZOECXcMggF2hvW+OcedUkoYcXGTvY
lzucZi+BqLlmKjB3FV6dOLlZ7Ebb3oRXAzeZrUak9IYwPN3QK264jYfmG0ql
UqfTud3uRVl1V9TkOrKcUoq6YzDlwVEBz3V42xfyc0eUhjbsAGsB04qlE/QO
oYv8b5Iw19+KZmdnl9JVVX7m0CZkSXmNqP2fXIS3UezQt+DqAZFDk/BGm8A1
i9Uivhqj2IiGzS2rrcI30OjGuUgYcmAthUcr0jK44K57mGp511r1ITdDI7xa
Pi68VKkWibs5io3pl0mZj+wjkuwf+AgdL8VcrUiLSfTmiOigHlSejLTb7XNP
HJ6pMc+4hdFkWPZweCGMHbriCJjzMX1B2NggCjQkerYLTlufv79/T0/PUuVe
UdDTpzLJl56Jzkui3D0LxuuVOMctPj4+MpksOTlZr9f/dxbFU5dztFtjPcPN
7CUnd0cxq34+URERESEhISkpKTMzM6vC+ic8bucLg3p4eDgoKIjel1YXtGjQ
e0JwcDA94N4Ai6KoqGh8fPzNsFbFgf9r/AWVRIUY
       "], {{0, 0}, {36, 32}}, {0, 255},
       ColorFunction->RGBColor],
      ImageSize->{36, 32},
      PlotRange->{{0, 36}, {0, 32}}],
     Deployed->True,
     StripOnInput->False], Cell[
    "ATOMIC DENSITY MATRIX TUTORIAL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "Inner Products and Matrix Multiplication", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/tutorial/\
InnerProductsAndMatrixMultiplication", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]]}, #, 2]& , Evaluator -> 
        Automatic], {1->"\<\"Inner Products and Matrix Multiplication\"\>"}, 
       FrameBox["\<\"Related Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"Related Tutorials \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "AtomicDensityMatrix Package", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]]}, #, 2]& , Evaluator -> 
        Automatic], {1->"\<\"AtomicDensityMatrix Package\"\>"}, 
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"More About \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "CartesianQ", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/ref/CartesianQ", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]], 
          StringReplace[
           "ContravariantQ", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/ref/ContravariantQ", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]], 
          StringReplace[
           "CovariantQ", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/ref/CovariantQ", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]], 
          StringReplace[
           "OperatorQ", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/ref/OperatorQ", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]], 
          StringReplace[
           "ScalarQ", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/ref/ScalarQ", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]], 
          StringReplace[
           "SphericalTensorQ", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/ref/SphericalTensorQ", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]], 
          StringReplace[
           "TensorDecompositionQ", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/ref/TensorDecompositionQ", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]]}, #, 2]& , Evaluator -> 
        Automatic], {1->"\<\"CartesianQ\"\>", 2->"\<\"ContravariantQ\"\>", 
       3->"\<\"CovariantQ\"\>", 4->"\<\"OperatorQ\"\>", 5->"\<\"ScalarQ\"\>", 
       6->"\<\"SphericalTensorQ\"\>", 7->"\<\"TensorDecompositionQ\"\>"}, 
       FrameBox["\<\"Functions \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"Functions \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "AtomicDensityMatrix/tutorial/MatrixNotation", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> None, 
          StringReplace[
           "Copy Mathematica url", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> 
          Module[{DocumentationSearch`Private`nb$}, 
            DocumentationSearch`Private`nb$ = NotebookPut[
               Notebook[{
                 Cell[
                  StringReplace[
                  "AtomicDensityMatrix/tutorial/MatrixNotation", 
                   "http://reference.wolfram.com/mathematica/" -> 
                   "http://budker.berkeley.edu/ADM/"]]}, Visible -> False]]; 
            SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
            FrontEndTokenExecute[DocumentationSearch`Private`nb$, 
              StringReplace[
              "Copy", "http://reference.wolfram.com/mathematica/" -> 
               "http://budker.berkeley.edu/ADM/"]]; 
            NotebookClose[DocumentationSearch`Private`nb$]; Null], Delimiter, 
          StringReplace[
           "Copy web url", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> 
          Module[{DocumentationSearch`Private`nb$}, 
            DocumentationSearch`Private`nb$ = NotebookPut[
               Notebook[{
                 Cell[
                  BoxData[
                   MakeBoxes[
                    Hyperlink[
                    StringReplace[
                    "http://reference.wolfram.com/mathematica/\
AtomicDensityMatrix/tutorial/MatrixNotation.html", 
                    "http://reference.wolfram.com/mathematica/" -> 
                    "http://budker.berkeley.edu/ADM/"]], StandardForm]], 
                  StringReplace[
                  "Input", "http://reference.wolfram.com/mathematica/" -> 
                   "http://budker.berkeley.edu/ADM/"], TextClipboardType -> 
                  StringReplace[
                   "PlainText", "http://reference.wolfram.com/mathematica/" -> 
                    "http://budker.berkeley.edu/ADM/"]]}, Visible -> False]]; 
            SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
            FrontEndTokenExecute[DocumentationSearch`Private`nb$, 
              StringReplace[
              "Copy", "http://reference.wolfram.com/mathematica/" -> 
               "http://budker.berkeley.edu/ADM/"]]; 
            NotebookClose[DocumentationSearch`Private`nb$]; Null], 
          StringReplace[
           "Go to web url", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> FrontEndExecute[{
             NotebookLocate[{
               URL[
                StringJoin[
                 StringReplace[
                 "http://reference.wolfram.com/mathematica/", 
                  "http://reference.wolfram.com/mathematica/" -> 
                  "http://budker.berkeley.edu/ADM/"], 
                 StringReplace[
                 "AtomicDensityMatrix/tutorial/MatrixNotation", 
                  "http://reference.wolfram.com/mathematica/" -> 
                  "http://budker.berkeley.edu/ADM/"], 
                 StringReplace[
                 ".html", "http://reference.wolfram.com/mathematica/" -> 
                  "http://budker.berkeley.edu/ADM/"]]], None}]}]}, #, 2]& , 
        Evaluator -> Automatic], {
       1->"\<\"AtomicDensityMatrix/tutorial/MatrixNotation\"\>", 
       2->"\<\"Copy Mathematica url\"\>", Delimiter, 
       4->"\<\"Copy web url\"\>", 5->"\<\"Go to web url\"\>"}, 
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"URL \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxAlignment->{"Columns" -> {{Left, Left, Right}}},
 GridBoxItemSize->{"Columns" -> {
     Scaled[0.05], 
     Scaled[0.3], {
      Scaled[0.64]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[CellGroupData[{

Cell["Matrix Notation", "Title",
 CellID->157786782],

Cell[TextData[{
 "In quantum-mechanical matrix notation, the expansion coefficients of a \
general ket in a particular basis are notated as a column vector, expansion \
coefficients of a bra are notated as a row vector, and operators are notated \
as a square matrix. This notation is adapted for use in the ",
 ButtonBox["Atomic Density Matrix",
  BaseStyle->"Link",
  ButtonData->"paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"],
 " package."
}], "Text",
 CellID->119359661],

Cell[TextData[{
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " does not distinguish between row and column vectors. Therefore ",
 Cell[BoxData[
  FormBox[
   StyleBox[
    RowBox[{"n", "\[Times]", "1"}], "InlineMath"], TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[
   StyleBox[
    RowBox[{"1", "\[Times]", "n"}], "InlineMath"], TraditionalForm]]],
 " matrices are used for this purpose. The expansion coefficients of a ket \
with a particular value of ",
 Cell[BoxData[
  FormBox[
   StyleBox["j", "InlineMath"], TraditionalForm]]],
 " in terms of the ",
 Cell[BoxData[
  FormBox[
   StyleBox[
    RowBox[{
     RowBox[{"|", 
      RowBox[{"j", " ", "m"}]}], "\[RightAngleBracket]"}], "InlineMath"], 
   TraditionalForm]]],
 " basis form a contravariant irreducible tensor set. Therefore we represent \
the contravariant components of any irreducible tensor in the spherical basis \
as a column vector. Likewise, the covariant components of an irreducible \
tensor in the spherical basis are represented as a row vector. Operators are \
represented by ",
 Cell[BoxData[
  FormBox[
   StyleBox[
    RowBox[{"n", "\[Times]", "n"}], "InlineMath"], TraditionalForm]]],
 " square matrices. A ",
 Cell[BoxData[
  FormBox[
   StyleBox[
    RowBox[{"1", "\[Times]", "1"}], "InlineMath"], TraditionalForm]]],
 " matrix satisfies the form of a covariant or contravariant tensor, or an \
operator. However, since in any case the object transforms as a scalar, this \
does not cause difficulty."
}], "Text",
 CellID->467033419],

Cell[TextData[Cell[BoxData[GridBox[{
   {
    RowBox[{
     ButtonBox["CartesianQ",
      BaseStyle->"Link",
      ButtonData->"paclet:AtomicDensityMatrix/ref/CartesianQ"], "[", 
     StyleBox["expr", "TI"], "]"}], 
    StyleBox[
     RowBox[{"cartesian", " ", "vector"}], "TableText"]},
   {
    RowBox[{
     ButtonBox["CovariantQ",
      BaseStyle->"Link",
      ButtonData->"paclet:AtomicDensityMatrix/ref/CovariantQ"], "[", 
     StyleBox["expr", "TI"], "]"}], 
    StyleBox[
     RowBox[{
     "covariant", " ", "tensor", " ", "or", " ", "state", " ", "vector"}], 
     "TableText"]},
   {
    RowBox[{
     ButtonBox["ContravariantQ",
      BaseStyle->"Link",
      ButtonData->"paclet:AtomicDensityMatrix/ref/ContravariantQ"], "[", 
     StyleBox["expr", "TI"], "]"}], 
    StyleBox[
     RowBox[{
     "contravariant", " ", "tensor", " ", "or", " ", "state", " ", "vector"}],
      "TableText"]},
   {
    RowBox[{
     ButtonBox["SphericalTensorQ",
      BaseStyle->"Link",
      ButtonData->"paclet:AtomicDensityMatrix/ref/SphericalTensorQ"], "[", 
     StyleBox["expr", "TI"], "]"}], 
    StyleBox[
     RowBox[{
     "covariant", " ", "or", " ", "contravariant", " ", "spherical", " ", 
      "tensor", " ", "or", " ", "state", " ", "vector"}], "TableText"]},
   {
    RowBox[{
     ButtonBox["OperatorQ",
      BaseStyle->"Link",
      ButtonData->"paclet:AtomicDensityMatrix/ref/OperatorQ"], "[", 
     StyleBox["expr", "TI"], "]"}], 
    StyleBox[
     RowBox[{"matrix", " ", "operator"}], "TableText"]},
   {
    RowBox[{
     ButtonBox["TensorDecompositionQ",
      BaseStyle->"Link",
      ButtonData->"paclet:AtomicDensityMatrix/ref/TensorDecompositionQ"], "[",
      
     StyleBox["expr", "TI"], "]"}], 
    StyleBox[
     RowBox[{"tensor", " ", "decomposition"}], "TableText"]},
   {
    RowBox[{
     ButtonBox["ScalarQ",
      BaseStyle->"Link",
      ButtonData->"paclet:AtomicDensityMatrix/ref/ScalarQ"], "[", 
     StyleBox["expr", "TI"], "]"}], 
    StyleBox["scalar", "TableText"]}
  }]]]], "DefinitionBox",
 CellID->38109372],

Cell["Checking for various structures in matrix notation.", "Caption",
 CellID->263362929],

Cell["This loads the package.", "MathCaption",
 CellID->264458498],

Cell[BoxData[
 RowBox[{"<<", "AtomicDensityMatrix`"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->141058412],

Cell[TextData[{
 "Cartesian vectors are represented as standard ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " vectors: one-dimensional lists."
}], "Text",
 CellID->316100511],

Cell["Here is a Cartesian vector.", "MathCaption",
 CellID->799887710],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"x", ",", "y", ",", "z"}], "}"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->194661486],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"x", ",", "y", ",", "z"}], "}"}]], "Output",
 ImageSize->{62, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->43537561]
}, Open  ]],

Cell["This checks for the form of a Cartesian vector.", "MathCaption",
 CellID->68215183],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CartesianQ", "[", "%", "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->78223916],

Cell[BoxData["True"], "Output",
 ImageSize->{32, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->27276792]
}, Open  ]],

Cell[TextData[{
 "Here is a contravariant state vector (a ",
 Cell[BoxData[
  RowBox[{"3", "\[Cross]", "1"}]]],
 " array). In ",
 Cell[BoxData[
  ButtonBox["MatrixForm",
   BaseStyle->"Link",
   ButtonData->"paclet:ref/MatrixForm"]], "TR"],
 " it is displayed as a column vector."
}], "MathCaption",
 CellID->235371674],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", "1", "}"}], ",", 
    RowBox[{"{", "0", "}"}], ",", 
    RowBox[{"{", "0", "}"}]}], "}"}], "//", "MatrixForm"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->293828320],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1"},
     {"0"},
     {"0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{31, 43},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]//MatrixForm=",
 CellID->202281586]
}, Open  ]],

Cell[TextData[{
 "This checks if the expression is in contravariant (",
 Cell[BoxData[
  FormBox[
   StyleBox[
    RowBox[{"n", "\[Times]", "1"}], "InlineMath"], TraditionalForm]]],
 ") form."
}], "MathCaption",
 CellID->657161314],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ContravariantQ", "[", "%", "]"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->468393156],

Cell[BoxData["True"], "Output",
 ImageSize->{32, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->523312146]
}, Open  ]],

Cell[TextData[{
 "Here is a covariant state vector (a ",
 Cell[BoxData[
  StyleBox[
   RowBox[{"1", "\[Cross]", "3"}], "InlineMath"]]],
 " array). In ",
 ButtonBox["MatrixForm",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/MatrixForm"],
 " it is displayed as a row vector."
}], "MathCaption",
 CellID->133770833],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0", ",", "0"}], "}"}], "}"}], "//", 
  "MatrixForm"}]], "Input",
 CellLabel->"In[6]:=",
 CellID->543305708],

Cell[GraphicsData["CompressedBitmap", "\<\
eJy1VFFuwjAMNSstYkziCv2fOEBzgPHFISo0Cz6mTcBBfBpfJofx0jRJTddG
8LFKbZP3HPvl1emhvZ0+v9rb+djW+0v7czofr/XH98VBxQIAGndva+jG4obh
0YCIGy39qwBLCGTFz94DJpYAyfpZH9eBPSUMFKhdSkHAIilChzOl7H2mCsjA
6MJu+drTpS8+RBi//DXDVUo08aQKdgJtEBjDyWASHdNrL6IHOS6VFutMYV36
ZYJaZUprrPMYDWW5mIuZAy6h5pOlq1F6ifN1ni7n955sx2HlvO3/KEB3X+67
P2v+Ay3nQ5FV4y994yOnDWxSZ3m8r8AI5q7r/nKxura3mD/URdLgFA3H7S3A
jHencDMNl2rHoz9Dk3nB4hfKBipQ\
\>"], "Output",
 Evaluatable->False,
 ImageSize->{57, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[6]//MatrixForm=",
 CellID->310483769]
}, Open  ]],

Cell[TextData[{
 "This checks if the expression is in covariant (",
 Cell[BoxData[
  FormBox[
   StyleBox[
    RowBox[{"1", "\[Times]", "n"}], "InlineMath"], TraditionalForm]]],
 ") form."
}], "MathCaption",
 CellID->31096462],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CovariantQ", "[", "%", "]"}]], "Input",
 CellLabel->"In[7]:=",
 CellID->493468906],

Cell[BoxData["True"], "Output",
 ImageSize->{32, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[7]=",
 CellID->260140013]
}, Open  ]],

Cell[TextData[{
 "Operators are represented by ",
 Cell[BoxData[
  FormBox[
   StyleBox[
    RowBox[{"(", 
     RowBox[{"n", "\[Times]", "n"}], ")"}], "InlineMath"], 
   TraditionalForm]]],
 "-dimensional lists."
}], "Text",
 CellID->772453979],

Cell["Here is an operator.", "MathCaption",
 CellID->70293462],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "0"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0", ",", 
      RowBox[{"-", "1"}]}], "}"}]}], "}"}], "//", "MatrixForm"}]], "Input",
 CellLabel->"In[8]:=",
 CellID->615144825],

Cell[GraphicsData["CompressedBitmap", "\<\
eJy9VUtOwzAQnTZNUJH4KLBkkQUC1l3mALDiEFGF1S4QqPQgcxpfxocxE9ex
J4ntVm0hUhLbz35vxh7PvDfb1cdns10vm+pt03yv1suf6vVrQ0PZBAAW9D5U
0LY1Ne1nAVrrFjS/mfll9JWAqEzv0Y4pRJDUanuzwXSJgEq7xRpy0Aqhhu6p
DV4arAD0gH1ES+3oaCnKoJIkI5TuKykUTr1dKsjwezsDa+GMzt0qRc5JTp8x
v4XgUN6jMHiNMOdU1pmp+WadM8zEvhlF1BVvxmgDioEZuuvfJRTGx+IVGHSK
AjN0oDAOl/BWhk7qSHrVHoU9PS0F1BQIpZ2xg5xTF4FAHyjw88ktC5HygC2d
PPnihz25D7QE+dPZpk8D0EuAYvrv08UOfv7TnfGBHEwvV4nMdLlfiUdcF6A8
aK8T6cjTR8PtUPrQHXL0Vm7PhY/TR5PAnClEbiSHTlFIJC2WnY/dokDWjdeW
Udq4SWSaXk3ol5d4nRzljttwpgnt/5D8sJptKz1MfgHbY+wD\
\>"], "Output",
 Evaluatable->False,
 ImageSize->{50, 28},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[8]//MatrixForm=",
 CellID->315277382]
}, Open  ]],

Cell[TextData[{
 "This checks for the (",
 Cell[BoxData[
  FormBox[
   StyleBox[
    RowBox[{"n", "\[Times]", "n"}], "InlineMath"], TraditionalForm]]],
 ") form of an operator."
}], "MathCaption",
 CellID->170262075],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"OperatorQ", "[", "%", "]"}]], "Input",
 CellLabel->"In[9]:=",
 CellID->29535841],

Cell[BoxData["True"], "Output",
 ImageSize->{32, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[9]=",
 CellID->142473074]
}, Open  ]],

Cell["\<\
The components of a cartesian vector or spherical tensor can themselves be \
operators. \
\>", "Text",
 CellID->185612426],

Cell[TextData[{
 "Here are the spherical components of the ",
 Cell[BoxData[
  FormBox[
   StyleBox[
    RowBox[{"J", "=", 
     RowBox[{"1", "/", "2"}]}], "InlineMath"], TraditionalForm]]],
 " representation of the angular momentum operator, which make up a covariant \
rank-1 tensor. ",
 ButtonBox["MatrixForm",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/MatrixForm"],
 " displays it as a row vector of matrix operators."
}], "MathCaption",
 CellID->577405562],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"WignerEckart", "[", 
   RowBox[{
    RowBox[{"1", "/", "2"}], ",", 
    RowBox[{"{", 
     RowBox[{"J", ",", "1"}], "}"}]}], "]"}], "//", "MatrixForm"}]], "Input",
 CellLabel->"In[10]:=",
 CellID->389040090],

Cell[GraphicsData["CompressedBitmap", "\<\
eJzVWj1QG0cUPnToLxJCiBg84cdCtjMpYuJJ5aFKlaTJTCZVSognGlx4onE8
GWZS4I4SdZSUlHSipKSkpFBBSUlJqejtz7t9d9+thHwiNjMS3O7e7vd9+97b
fbv8svN+98+3O+/fvN5p/vRup7P75vXfzR//ejcsCmeCIOgPPy+aAf09GP5p
vvrBYDCgSvXrX/UrH/S7W4H7s9XtB1+ruvDxzc2N+os+3+vX8rpq+/j4mKt+
02W7R0dHXLauy4bfvaBN/bZ7QVmXle7u7vj9FV328vLycu/g4EA9vdBlH/b3
97m/UA8/qx++ubq6+vns7Ew9lcDwOcNu0O8GEb+toNsfBMueugUAsa7LaDxW
ZMOA6rWVZC4Ogs3t6gBbMZKQy1tg3FLUjuQBMqBuBcyQJ7mt6Km2Q9rt4SQv
e+oagMq8LuscHh7ymC07Sq8X9CSO5vX1NeObB9hUu5xiJom0wODFSJ+Dvb09
V4swquJuSgCr1aK71WasyjqH07fsqWsAPrXIan84Pz9XT03XrIbWrvoY2gc5
VBngqYEyTXPWllHfZOrRNCZ9dQXAM/TJoUgWxyO0CrlXFxcXJcBB21UhpsPA
Pi/5qxuA0VxUxlA2zFjKedSPeh2JNAdAapHyZBu/np6e0lP99vb295OTE2sM
IuyspwqtDJIETiikTTJufoLF1LTiOEifTV1G5BgN0rSgy0gQfj8XBZCYF8jA
tZoukAi0UiARnosA+uyEDreYTln0X3AdLhbHn+r2ZDNk66l9GFtiGc1HSVaw
gjnBbQVgc2ITSz2hVMrBY7Fj2VO3mE5TjFngPpKxXkmVoy5qAFlFfZeVczkC
wSi3CtCgxXlmpDiiLI/DxWNcvBinA4VAdldhB+kHNtDm1HdoO3fdioYY2M1V
qL85RjHuVCRmNIpssQiUoLTKHZVBR/dU89UY+qRGrdY4lMgRbGAOWp8J9mrk
2Fy28dDYsV0+stYk4hzFgoHeWHzqpNKjWigIj0WGLeuByRSxb07Mg5z+sNPp
qLqS+g5pG8PtlrLkpjenMqN75IXZujexZ9BO9XpczJLME10mcsYlL7SmmTy7
ahlSX4zFBy2a0+AjEkI/H5F+mqXJT8bk7WLRqutF63h7e5vblU1rFIgyJa12
5Sj985vl5hhTlroEFDInkMzVxFYulqvNfSbU1jQHmGGZo4fAzbDmP4LXHIwa
enVrPJQxmp3ryOzJknezp4+ZVHMuIgha0mjVzJS0mWWY+xTtLDu5TzVjootG
0tiKmilHEyjFDkicDcYE9k+m2NDEfDuRRo3kvz4FoiKdCLHA43CU/v18DA9O
LK5PpkBPpBZfelGVgKv656jmvmEW1UxJtIAx+tPVMnBDfx7z8v8FLM5kYr7l
V38awEWu4Aeesr1/eMwj84KSF5I/DGcK2O500H7/u08NJNrE+0Gueej5l8Kp
EEB7IA4PE5xYoc1/YSxBkJT3FEQcNY8WBJyVpm6ENyPXpzsR9ZR+JDr6FK/m
0T/BWgDFO1ttQA1PXREwcO4CU3SjHIrjhHNfcU/dRCqGTszX/N1U0uUHdx2+
20dP4o1vPmk8jvjyAJ6uMPgOVW8w6YQ675nbr+AM6bwE3eoikuNplexGgfMZ
3sjECCtkc1SgEJkOi4esTdxB4oN/AcfseCmHZE1qTK7oUddHrgrI1QDaql/5
BX91HmB3rpTjd6qe23gCFbsxxMf7WD0aLX4BL3gWwbu+BLICmM0DqJnoJ9A7
/x3BzV391FGQaUQweNP5DFCsRe04ONUBDSRPStpZSVdcwKlO6JZ5AFlv5cjt
tGnYRsiSxNGtvUGPpVwOXl4K6oADkmUD4FsAQ1c81uWzvDzAhi4HQ6GEGPpb
08BN0J6CdrNYnRZAYA+G0SVisrgOBjN4/wDY/tFV5h+ugpn/AN7eTmA=\
\>"], "Output",
 Evaluatable->False,
 ImageSize->{219, 45},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[10]//MatrixForm=",
 CellID->364383010]
}, Open  ]],

Cell["It has the form of a covariant tensor.", "MathCaption",
 CellID->200532541],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CovariantQ", "[", "%", "]"}]], "Input",
 CellLabel->"In[11]:=",
 CellID->206120459],

Cell[BoxData["True"], "Output",
 ImageSize->{32, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[11]=",
 CellID->63161981]
}, Open  ]],

Cell[TextData[{
 "The contravariant components are obtained by taking the Hermitian \
conjugate. ",
 ButtonBox["MatrixForm",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/MatrixForm"],
 " displays the resulting expression as a column vector of matrix operators."
}], "MathCaption",
 CellID->991054870],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  SuperscriptBox[
   RowBox[{"WignerEckart", "[", 
    RowBox[{
     RowBox[{"1", "/", "2"}], ",", 
     RowBox[{"{", 
      RowBox[{"J", ",", "1"}], "}"}]}], "]"}], "\[Dagger]"], "//", 
  "MatrixForm"}]], "Input",
 CellLabel->"In[12]:=",
 CellID->938914144],

Cell[GraphicsData["CompressedBitmap", "\<\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\
\>"], "Output",
 Evaluatable->False,
 ImageSize->{87, 137},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[12]//MatrixForm=",
 CellID->786976318]
}, Open  ]],

Cell["Now it has the form of a contravariant tensor.", "MathCaption",
 CellID->40919291],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ContravariantQ", "[", "%", "]"}]], "Input",
 CellLabel->"In[13]:=",
 CellID->244759098],

Cell[BoxData["True"], "Output",
 ImageSize->{32, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[13]=",
 CellID->126309790]
}, Open  ]],

Cell[TextData[{
 "Here are the Cartesian components (proportional to the Pauli matrices). To \
display the components as matrices, we use the ",
 Cell[BoxData[
  ButtonBox["TensorForm",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/TensorForm"]], 
  "InlineFormula"],
 " function, which is equivalent in this case to applying ",
 ButtonBox["MatrixForm",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/MatrixForm"],
 " to each component. ",
 Cell[BoxData[
  ButtonBox["TensorForm",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/TensorForm"]], 
  "InlineFormula"],
 " can also be used in the above cases to produce the same result as ",
 ButtonBox["MatrixForm",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/MatrixForm"],
 "."
}], "MathCaption",
 CellID->82123178],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"cartj", "=", 
    RowBox[{"ToCartesian", "[", 
     RowBox[{"WignerEckart", "[", 
      RowBox[{
       RowBox[{"1", "/", "2"}], ",", 
       RowBox[{"{", 
        RowBox[{"J", ",", "1"}], "}"}]}], "]"}], "]"}]}], ")"}], "//", 
  "TensorForm"}]], "Input",
 CellLabel->"In[14]:=",
 CellID->19339165],

Cell[GraphicsData["CompressedBitmap", "\<\
eJzFWj1s20YUpvVP2UlsJWmaWK4pOUGMDm6AokCgqVPbpUDGolONoISCoKiQ
pIA3d/NobR49evRGjx6dzaMHDR49evTI8v4e76SPx6NlpgZE6453733fu/fe
ke/06/an4Z9/bX9693Y7+PnD9mj47u3H4Ke/PyRd1QXP8z4nn+8Cj32Pk6/y
8tmL4+TbG/6v7k3GA0//G4wn3kcx5KFlyGt+r5pcIy9knWHk/aNPM299L/qG
BwcH/Bv7NOS4KOQyeasn+lo3Nzd/HB4e8tYPFhiPhcolMY2mZIlfFX3/7u7u
0riO6Pvl5OTk66urK95qKQpR5EVyXC+dS+PkXNZm83lrHdD3Rd+r8/PzN8fH
x7y1KKCLf9XNi4sLEoHUP0spMjG6+tH+/j7RqavrZOwNEtW8P7EBs1ZfjA8u
Ly9pJZCMHjCdxLQ/Go1oXNugYCyuDcZqush7Ozs7vLWSWujH09NT3mrya03A
4H8hM8cGQLwM/GYDWFGIrLJFIDWSRTsVQUwyEHTF0J29vT02XEfAUFHfVjbS
346OjsiNAouxfOCyvoa48vrs7Gwz9WHmSLoiBpImbgHlywBkD/P2wVAdi/AB
kvwSuDZCtabTT8PbG09iFdlssRhRXYZhEmRqE5ox/KlFpQ98CalUsCfjkM/j
/Ym8MFk1DrvCUK+AmQ2L9g0QTA5EEIg2EPUgEw63cay2iaq4UpCwz32pazwI
KaB4lktShBthhFISZqamwLEQdgXbtoBFcpFh1qRGU0as2otOnBGARZWa4omn
drUKv1ZVrPERFUey9dSGLLm7OU0mL5RySjJP5uR+NqOqTE60wSYGncRxtTyi
OF7FE0hnzqDIsUDLsID4KJ/hw2q6UdiWPaAIqxWgEkb2+HYNmSZ5dpTIGXC5
xnPk1PbmljcQoscWJj7wHmUhfZMVfSrMhGnHkR5SBhz1XKbDuW8hN4/RHskl
nNqCXfPsLJgnADyyU0150piHlZaH5rLTA8xnHhM9t9oi49ntfzbDWqGUoyU5
4dl2yv0vx43wyWiSKr8RN42hygkT/EtA0hZRoggVg3lrEcwIsO52OUyV5wk/
EoYVNJuzNHkuEhkYIW/qOkMB6fks/xwpPYCoJPKbWUS1l1sEESyqy4xbEJDZ
zU7A7FNzgf0ySNSKzMggwXIyy1oaCbn/KH9vOuJH+SLFihIDwlXXOClcC/Mb
927AWYxWzHXLBDdHXKWvbbM1Ldct0Q68YdGwUSYpM9RRxkdkAgtc34GoqfVF
OQRX9TQg62KuqxUAmPY3pBbQVtLKdSngo+kHh1xifQDTvmI+0Ibe9+4wzlBl
zXXlUB2x5RR7SGtJK/hMCrrl43VuBbLoY3ZBmq6vr65J3VbALJTrLW+NBeoQ
d7kXuVYEsotnuPBY7M3EUrzMxN+1zLwHbJ9bBcQFRUnEKAXbiGQWJXOJoJka
keXr62tXIqjCIUoL+dW/RqrSifAXq0hmGrDuKMVWkboHWM8eRtAa5FTb5NbO
fI9O6FDR36Vop9M2Djq69slLwHFNRuwYhU7/3BgxLNYzIbdCLDMKBSYS48bN
cqzBVopMnx8W1sKfcQqHDrhuU1jUTuMMGtqJHum0lVlX8p3asKw0k+2UFdX7
JCxUDDI8mo/jp4hNi7SvKD+k9Td0voQOYlEdbMWiS/oKg0TnhvpRc4WFQMZz
B2ItHtaYbz0EOaOBBSHC0nzsgJO8qQNENgGIDlYjuR4Mh0NyHskVhczTLHpT
4zRUJDbIZsTYTP+ogRmZjlwRo15qjekfNSyltwjSE2mAqaqdD4Z2UidiUcVb
62q6WRBtpUMpaB4BkTWsvQ+GSg7y9Nqo+ayD4d+mCGiz6YK5r4TY97QKaQnw
d3FL/jLHW/gP4yHT+g==\
\>"], "Output",
 Evaluatable->False,
 ImageSize->{200, 47},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[14]=",
 CellID->61748069]
}, Open  ]],

Cell["The components form a Cartesian vector.", "MathCaption",
 CellID->123589575],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CartesianQ", "[", "cartj", "]"}]], "Input",
 CellLabel->"In[15]:=",
 CellID->343814476],

Cell[BoxData["True"], "Output",
 ImageSize->{32, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[15]=",
 CellID->140629333]
}, Open  ]],

Cell[TextData[{
 "Any operator representation on a space with angular momentum ",
 Cell[BoxData[
  StyleBox["J", "InlineMath",
   FontSlant->"Italic"]]],
 " can be decomposed into a sum of irreducible tensor operators. The \
resulting decomposition is represented as a list of spherical tensors with \
ranks zero through ",
 Cell[BoxData[
  FormBox[
   StyleBox[
    RowBox[{"2", "J"}], "InlineMath"], TraditionalForm]]],
 "."
}], "Text",
 CellID->74694002],

Cell[TextData[{
 "Here is the tensor decomposition of an operator on a ",
 Cell[BoxData[
  FormBox[
   StyleBox[
    RowBox[{"J", "=", "1"}], "InlineMath"], TraditionalForm]]],
 " space (e.g., the density matrix for a ",
 Cell[BoxData[
  FormBox[
   StyleBox[
    RowBox[{"J", "=", "1"}], "InlineMath"], TraditionalForm]]],
 " state). It consists of a rank-zero, rank-one and rank-two operator."
}], "MathCaption",
 CellID->19974654],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"decomp", "=", 
    RowBox[{"Decomposition", "[", 
     TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"0", "0", "0"},
         {"0", "1", "0"},
         {"0", "0", "4"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
      Function[BoxForm`e$, 
       MatrixForm[BoxForm`e$]]], "]"}]}], ")"}], "//", 
  "TensorForm"}]], "Input",
 CellLabel->"In[16]:=",
 CellID->42712533],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {
        FractionBox["5", 
         SqrtBox["3"]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]], ",", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0"},
       {
        RowBox[{
         RowBox[{"-", "2"}], " ", 
         SqrtBox["2"]}]},
       {"0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]], ",", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0"},
       {"0"},
       {
        SqrtBox[
         FractionBox["2", "3"]]},
       {"0"},
       {"0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}], "}"}]], "Output",
 ImageSize->{195, 99},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[16]=",
 CellID->175514127]
}, Open  ]],

Cell["\<\
A tensor decomposition is a list of irreducible tensors of increasing rank.\
\>", "MathCaption",
 CellID->84009289],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TensorDecompositionQ", "[", "decomp", "]"}]], "Input",
 CellLabel->"In[17]:=",
 CellID->160773661],

Cell[BoxData["True"], "Output",
 ImageSize->{32, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[17]=",
 CellID->61167938]
}, Open  ]],

Cell["\<\
An expression is considered to be a scalar if it does not match any of the \
tensor forms listed above.\
\>", "Text",
 CellID->19065310],

Cell["Any unknown variable is considered to be a scalar.", "MathCaption",
 CellID->752027172],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ScalarQ", "[", "x", "]"}]], "Input",
 CellLabel->"In[18]:=",
 CellID->89104936],

Cell[BoxData["True"], "Output",
 ImageSize->{32, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[18]=",
 CellID->111837868]
}, Open  ]],

Cell["Clean up symbols.", "MathCaption",
 CellID->369105056],

Cell[BoxData[
 RowBox[{"Remove", "[", 
  RowBox[{"decomp", ",", "cartj"}], "]"}]], "Input",
 CellLabel->"In[19]:=",
 CellID->476537455],

Cell[CellGroupData[{

Cell["", "TutorialMoreAboutSection",
 CellElementSpacings->{"CellMinHeight"->3},
 CellFrameLabels->{{
    FEPrivate`If[
     FEPrivate`Or[
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 
     Cell[
     "MORE ABOUT", "TutorialMoreAboutSection", CellSize -> {5000, Inherited}],
      
     Cell[
      TextData[{
        Cell[
         BoxData[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {24, 0}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[24]]]], "More About"}], "TutorialMoreAboutSection", 
      CellSize -> {5000, Inherited}]], None}, {None, None}},
 CellFrameLabelMargins->0,
 CellSize->{Inherited, 
   FEPrivate`If[
    FEPrivate`Or[
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 11, 14]},
 "WholeCellGroupOpener" -> True,
 CellID->23220180],

Cell["", "SectionHeaderSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]],

Cell[TextData[ButtonBox["AtomicDensityMatrix Package",
 BaseStyle->"Link",
 ButtonData->
  "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"]], \
"TutorialMoreAbout",
 CellID->1567025153],

Cell["", "SectionFooterSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "RelatedTutorialsSection",
 CellElementSpacings->{"CellMinHeight"->3},
 CellFrameLabels->{{
    FEPrivate`If[
     FEPrivate`Or[
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 
     Cell[
     "RELATED TUTORIALS", "RelatedTutorialsSection", 
      CellSize -> {5000, Inherited}], 
     Cell[
      TextData[{
        Cell[
         BoxData[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {24, 0}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[24]]]], "Related Tutorials"}], "RelatedTutorialsSection", 
      CellSize -> {5000, Inherited}]], None}, {None, None}},
 CellFrameLabelMargins->0,
 CellSize->{Inherited, 
   FEPrivate`If[
    FEPrivate`Or[
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 11, 14]},
 "WholeCellGroupOpener" -> True,
 CellID->415694126],

Cell["", "SectionHeaderSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]],

Cell[TextData[ButtonBox["Inner Products and Matrix Multiplication",
 BaseStyle->"Link",
 ButtonData->
  "paclet:AtomicDensityMatrix/tutorial/InnerProductsAndMatrixMultiplication"]]\
, "RelatedTutorials",
 CellID->806871991],

Cell["", "SectionFooterSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]]
}, Open  ]]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"Matrix Notation - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, 
  "Metadata" -> {
   "built" -> "{2014, 2, 28, 1, 42, 59.2733011}", "context" -> 
    "AtomicDensityMatrix`", "keywords" -> {"Atomic Density Matrix", "ADM"}, 
    "index" -> True, "label" -> "Atomic Density Matrix Tutorial", "language" -> 
    "en", "paclet" -> "AtomicDensityMatrix", "status" -> "None", "summary" -> 
    "In quantum-mechanical matrix notation, the expansion coefficients of a \
general ket in a particular basis are notated as a column vector, expansion \
coefficients of a bra are notated as a row vector, and operators are notated \
as a square matrix. This notation is adapted for use in the Atomic Density \
Matrix package. Mathematica does not distinguish between row and column \
vectors. Therefore nx1 and 1xn matrices are used for this purpose. The \
expansion coefficients of a ket with a particular value of j in terms of the \
|j m> basis form a contravariant irreducible tensor set. Therefore we \
represent the contravariant components of any irreducible tensor in the \
spherical basis as a column vector. Likewise, the covariant components of an \
irreducible tensor in the spherical basis are represented as a row vector. \
Operators are represented by nxn square matrices. A 1x1 matrix satisfies the \
form of a covariant or contravariant tensor, or an operator. However, since \
in any case the object transforms as a scalar, this does not cause \
difficulty. Checking for various structures in matrix notation.", 
    "synonyms" -> {}, "title" -> "Matrix Notation", "type" -> "Tutorial", 
    "uri" -> "AtomicDensityMatrix/tutorial/MatrixNotation"}, 
  "SearchTextTranslated" -> "", "SearchText" -> ""},
FrontEndVersion->"6.0 for Microsoft Windows (64-bit) (May 21, 2008)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"], 
   Cell[
    StyleData["TutorialMoreAboutSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}], 
   Cell[
    StyleData["RelatedTutorialsSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}], 
   Cell[
    StyleData["TutorialRelatedLinksSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}]}, Visible -> False, 
  FrontEndVersion -> "6.0 for Microsoft Windows (64-bit) (May 21, 2008)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[568, 21, 78, 1, 3, "TutorialColorBar"],
Cell[649, 24, 220, 5, 70, "LinkTrail"],
Cell[872, 31, 12657, 259, 70, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[13554, 294, 52, 1, 70, "Title",
 CellID->157786782],
Cell[13609, 297, 483, 10, 70, "Text",
 CellID->119359661],
Cell[14095, 309, 1531, 44, 70, "Text",
 CellID->467033419],
Cell[15629, 355, 2056, 64, 70, "DefinitionBox",
 CellID->38109372],
Cell[17688, 421, 90, 1, 70, "Caption",
 CellID->263362929],
Cell[17781, 424, 66, 1, 70, "MathCaption",
 CellID->264458498],
Cell[17850, 427, 107, 3, 70, "Input",
 CellID->141058412],
Cell[17960, 432, 183, 6, 70, "Text",
 CellID->316100511],
Cell[18146, 440, 70, 1, 70, "MathCaption",
 CellID->799887710],
Cell[CellGroupData[{
Cell[18241, 445, 125, 4, 70, "Input",
 CellID->194661486],
Cell[18369, 451, 212, 7, 70, "Output",
 CellID->43537561]
}, Open  ]],
Cell[18596, 461, 89, 1, 70, "MathCaption",
 CellID->68215183],
Cell[CellGroupData[{
Cell[18710, 466, 105, 3, 70, "Input",
 CellID->78223916],
Cell[18818, 471, 160, 5, 70, "Output",
 CellID->27276792]
}, Open  ]],
Cell[18993, 479, 319, 11, 70, "MathCaption",
 CellID->235371674],
Cell[CellGroupData[{
Cell[19337, 494, 234, 8, 70, "Input",
 CellID->293828320],
Cell[19574, 504, 729, 23, 70, "Output",
 CellID->202281586]
}, Open  ]],
Cell[20318, 530, 231, 8, 70, "MathCaption",
 CellID->657161314],
Cell[CellGroupData[{
Cell[20574, 542, 110, 3, 70, "Input",
 CellID->468393156],
Cell[20687, 547, 161, 5, 70, "Output",
 CellID->523312146]
}, Open  ]],
Cell[20863, 555, 314, 11, 70, "MathCaption",
 CellID->133770833],
Cell[CellGroupData[{
Cell[21202, 570, 187, 7, 70, "Input",
 CellID->543305708],
Cell[21392, 579, 617, 14, 70, "Output",
 Evaluatable->False,
 CellID->310483769]
}, Open  ]],
Cell[22024, 596, 226, 8, 70, "MathCaption",
 CellID->31096462],
Cell[CellGroupData[{
Cell[22275, 608, 106, 3, 70, "Input",
 CellID->493468906],
Cell[22384, 613, 161, 5, 70, "Output",
 CellID->260140013]
}, Open  ]],
Cell[22560, 621, 244, 10, 70, "Text",
 CellID->772453979],
Cell[22807, 633, 62, 1, 70, "MathCaption",
 CellID->70293462],
Cell[CellGroupData[{
Cell[22894, 638, 273, 10, 70, "Input",
 CellID->615144825],
Cell[23170, 650, 759, 16, 70, "Output",
 Evaluatable->False,
 CellID->315277382]
}, Open  ]],
Cell[23944, 669, 216, 8, 70, "MathCaption",
 CellID->170262075],
Cell[CellGroupData[{
Cell[24185, 681, 104, 3, 70, "Input",
 CellID->29535841],
Cell[24292, 686, 161, 5, 70, "Output",
 CellID->142473074]
}, Open  ]],
Cell[24468, 694, 132, 4, 70, "Text",
 CellID->185612426],
Cell[24603, 700, 466, 14, 70, "MathCaption",
 CellID->577405562],
Cell[CellGroupData[{
Cell[25094, 718, 242, 8, 70, "Input",
 CellID->389040090],
Cell[25339, 728, 2172, 39, 70, "Output",
 Evaluatable->False,
 CellID->364383010]
}, Open  ]],
Cell[27526, 770, 81, 1, 70, "MathCaption",
 CellID->200532541],
Cell[CellGroupData[{
Cell[27632, 775, 107, 3, 70, "Input",
 CellID->206120459],
Cell[27742, 780, 161, 5, 70, "Output",
 CellID->63161981]
}, Open  ]],
Cell[27918, 788, 302, 8, 70, "MathCaption",
 CellID->991054870],
Cell[CellGroupData[{
Cell[28245, 800, 282, 10, 70, "Input",
 CellID->938914144],
Cell[28530, 812, 2433, 44, 70, "Output",
 Evaluatable->False,
 CellID->786976318]
}, Open  ]],
Cell[30978, 859, 88, 1, 70, "MathCaption",
 CellID->40919291],
Cell[CellGroupData[{
Cell[31091, 864, 111, 3, 70, "Input",
 CellID->244759098],
Cell[31205, 869, 162, 5, 70, "Output",
 CellID->126309790]
}, Open  ]],
Cell[31382, 877, 809, 24, 70, "MathCaption",
 CellID->82123178],
Cell[CellGroupData[{
Cell[32216, 905, 350, 12, 70, "Input",
 CellID->19339165],
Cell[32569, 919, 2123, 39, 70, "Output",
 Evaluatable->False,
 CellID->61748069]
}, Open  ]],
Cell[34707, 961, 82, 1, 70, "MathCaption",
 CellID->123589575],
Cell[CellGroupData[{
Cell[34814, 966, 111, 3, 70, "Input",
 CellID->343814476],
Cell[34928, 971, 162, 5, 70, "Output",
 CellID->140629333]
}, Open  ]],
Cell[35105, 979, 457, 14, 70, "Text",
 CellID->74694002],
Cell[35565, 995, 433, 13, 70, "MathCaption",
 CellID->19974654],
Cell[CellGroupData[{
Cell[36023, 1012, 869, 26, 70, "Input",
 CellID->42712533],
Cell[36895, 1040, 2165, 68, 70, "Output",
 CellID->175514127]
}, Open  ]],
Cell[39075, 1111, 125, 3, 70, "MathCaption",
 CellID->84009289],
Cell[CellGroupData[{
Cell[39225, 1118, 122, 3, 70, "Input",
 CellID->160773661],
Cell[39350, 1123, 161, 5, 70, "Output",
 CellID->61167938]
}, Open  ]],
Cell[39526, 1131, 146, 4, 70, "Text",
 CellID->19065310],
Cell[39675, 1137, 93, 1, 70, "MathCaption",
 CellID->752027172],
Cell[CellGroupData[{
Cell[39793, 1142, 103, 3, 70, "Input",
 CellID->89104936],
Cell[39899, 1147, 162, 5, 70, "Output",
 CellID->111837868]
}, Open  ]],
Cell[40076, 1155, 60, 1, 70, "MathCaption",
 CellID->369105056],
Cell[40139, 1158, 135, 4, 70, "Input",
 CellID->476537455],
Cell[CellGroupData[{
Cell[40299, 1166, 1107, 30, 70, "TutorialMoreAboutSection",
 CellID->23220180],
Cell[41409, 1198, 804, 18, 70, "SectionHeaderSpacer"],
Cell[42216, 1218, 192, 5, 70, "TutorialMoreAbout",
 CellID->1567025153],
Cell[42411, 1225, 804, 18, 70, "SectionFooterSpacer"]
}, Open  ]],
Cell[CellGroupData[{
Cell[43252, 1248, 1120, 30, 70, "RelatedTutorialsSection",
 CellID->415694126],
Cell[44375, 1280, 804, 18, 70, "SectionHeaderSpacer"],
Cell[45182, 1300, 223, 5, 70, "RelatedTutorials",
 CellID->806871991],
Cell[45408, 1307, 804, 18, 70, "SectionFooterSpacer"]
}, Open  ]]
}, Open  ]],
Cell[46239, 1329, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

