(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     61495,       1626]
NotebookOptionsPosition[     54589,       1426]
NotebookOutlinePosition[     57693,       1493]
CellTagsIndexPosition[     57650,       1490]
WindowFrame->Normal
ContainsDynamic->True *)

(* Beginning of Notebook Content *)
Notebook[{
Cell[" ", "TutorialColorBar",
 CellMargins->{{Inherited, Inherited}, {-5, 0}}],

Cell[TextData[{
 ButtonBox["AtomicDensityMatrix Package",
  BaseStyle->{"Link", "LinkTrail"},
  ButtonData->"paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"],
 StyleBox[" > ", "LinkTrailSeparator"]
}], "LinkTrail"],

Cell[BoxData[GridBox[{
   {
    StyleBox[
     GraphicsBox[RasterBox[CompressedData["
1:eJy9lulTk1cUxp+Zfu+Xfu5MO9O/oF90povj0A6dVtupdRsBqwRCg+DCqCxF
LLIIoUAIyGLayqJCFZRYVJaAaDBsQkBCEhaVoCjEBAiLTSLJ7bmX0nEBhZZ6
5mbmTebN/d3nnOec930/cN+mwLcAvEefD+jDr9nrwul0DvabbdaxuwNm++Ox
197/r8PQrY/bLwnyxYFvEL0F8TtwOiNq9IHFYDC4XK5VBGmvaXasg/QLRH6H
xABkBiFXhvw9fCVJP7LZbKsFemwdC1gP2ZdcjnwXCvag9BAuxOByHC4dQUU0
dBfzV4vV0aoL+4orOv49ckNRHo3qeDQehy4NzWnQpvCv/W2aRf+70vSeK8o/
+C0vkDIEZYdx5SfclKM9Az05MOai9wQ6FahLwJT9ObeQkaqrq3t7e1fESo+W
/LgV8t1QhfPU1Seh5WfczoY5D4Mn0V/AoSSwNkfidjnpfofDUVVVpVKpFArF
5OTkiliZMZJ4PyiCceYg/ohDUyq6stCXhzsqziIicXVyXriyVMnQoHnt2rV+
fn5paWkmk2lFIAptrfqYHzceJZBy1ZaObiUGCjirL5/nsDWdl+yXvfw8R3e8
EyYLIVBhYSEJfMW25F6HCKeI+R+npxzJOzmLEtiQhFuZvEzEouzps9CQzN1C
5s8IQroE4VvWJB2NLsqKP3U8vCI7ytypm0/syzExMaFWqxMTE2NjY0NDQ6VS
aVNTk8vpVMVLToZxq9cnclZvLsd1KDiFtFA1Y7aAtKfuflsRFXA+YSMdifzT
ks7PdjXV1/7IspS69vZ2uVyeLYKqbLFYGmursqUoO8RzRSwqUJcSJRGcsssH
gZ/zYULaC/fzapJVhn7F47MYPw/b77CVYlCFe83qpXDUFw0NDSUlJZRPo9FY
U1OTk5kWfzjsVOQ6qg7t1piMw5uw/VPs/gx7N/JhQiBy42gJZi/iaS3YdTAd
WBtYEzwaTJbj0a0lcez5TrxvGcpOOFCsiCOxOTEBcdu5HN7jm3k7kG2ou20X
4KqDpxXsNlgPmAmsD6xfXLdh5jK8Txev3cthHbHkhWLfRq6FRhY1OMmZ92db
BkbPYk4LZgS7BzYMZhHr/sIaBNPDZX6VtGeDJvDWT3iBwjZwM5yQ8ZLdSMGA
CvZyeBrE+Qn0QLCGwO6KixGwh+JHwg0vi3X6t/xtArTvayT4o/gAauLRmYVH
xXBWgmnAOsEMYunBugSXEnhHqBsRi9Cji4/NZ6MgK3Xrx7xAVB3qIz7b0/jQ
mD4PTzXYNbBWjrBW4mExZtXw1nNLcKhRyLEIgXThMC8ndTvXI3Yb0gNx+Sjv
rNHT+FMN1igo3VzIXD0myjB5DtMV8F5ZOECXcMggF2hvW+OcedUkoYcXGTvY
lzucZi+BqLlmKjB3FV6dOLlZ7Ebb3oRXAzeZrUak9IYwPN3QK264jYfmG0ql
UqfTud3uRVl1V9TkOrKcUoq6YzDlwVEBz3V42xfyc0eUhjbsAGsB04qlE/QO
oYv8b5Iw19+KZmdnl9JVVX7m0CZkSXmNqP2fXIS3UezQt+DqAZFDk/BGm8A1
i9Uivhqj2IiGzS2rrcI30OjGuUgYcmAthUcr0jK44K57mGp511r1ITdDI7xa
Pi68VKkWibs5io3pl0mZj+wjkuwf+AgdL8VcrUiLSfTmiOigHlSejLTb7XNP
HJ6pMc+4hdFkWPZweCGMHbriCJjzMX1B2NggCjQkerYLTlufv79/T0/PUuVe
UdDTpzLJl56Jzkui3D0LxuuVOMctPj4+MpksOTlZr9f/dxbFU5dztFtjPcPN
7CUnd0cxq34+URERESEhISkpKTMzM6vC+ic8bucLg3p4eDgoKIjel1YXtGjQ
e0JwcDA94N4Ai6KoqGh8fPzNsFbFgf9r/AWVRIUY
       "], {{0, 0}, {36, 32}}, {0, 255},
       ColorFunction->RGBColor],
      ImageSize->{36, 32},
      PlotRange->{{0, 36}, {0, 32}}],
     Deployed->True,
     StripOnInput->False], Cell[
    "ATOMIC DENSITY MATRIX TUTORIAL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "Electromagnetically Induced Transparency and Atomic Polarization",
             "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/tutorial/\
ElectromagneticallyInducedTransparencyAndAtomicPolarization", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]]}, #, 2]& , Evaluator -> 
        Automatic], {
       1->"\<\"Electromagnetically Induced Transparency and Atomic \
Polarization\"\>"}, 
       FrameBox["\<\"Related Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"Related Tutorials \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "AtomicDensityMatrix Package", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> Documentation`HelpLookup[
            StringReplace[
            "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix", 
             "http://reference.wolfram.com/mathematica/" -> 
             "http://budker.berkeley.edu/ADM/"]]}, #, 2]& , Evaluator -> 
        Automatic], {1->"\<\"AtomicDensityMatrix Package\"\>"}, 
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"More About \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      PopupMenuBox[Dynamic[{
         StringReplace[
         "ActionMenu", "http://reference.wolfram.com/mathematica/" -> 
          "http://budker.berkeley.edu/ADM/"], None}, 
        Part[{StringReplace[
           "AtomicDensityMatrix/tutorial/\
ThreeLevelSystemElectromagneticallyInducedTransparency", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> None, 
          StringReplace[
           "Copy Mathematica url", 
            "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> 
          Module[{DocumentationSearch`Private`nb$}, 
            DocumentationSearch`Private`nb$ = NotebookPut[
               Notebook[{
                 Cell[
                  StringReplace[
                  "AtomicDensityMatrix/tutorial/\
ThreeLevelSystemElectromagneticallyInducedTransparency", 
                   "http://reference.wolfram.com/mathematica/" -> 
                   "http://budker.berkeley.edu/ADM/"]]}, Visible -> False]]; 
            SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
            FrontEndTokenExecute[DocumentationSearch`Private`nb$, 
              StringReplace[
              "Copy", "http://reference.wolfram.com/mathematica/" -> 
               "http://budker.berkeley.edu/ADM/"]]; 
            NotebookClose[DocumentationSearch`Private`nb$]; Null], Delimiter, 
          StringReplace[
           "Copy web url", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> 
          Module[{DocumentationSearch`Private`nb$}, 
            DocumentationSearch`Private`nb$ = NotebookPut[
               Notebook[{
                 Cell[
                  BoxData[
                   MakeBoxes[
                    Hyperlink[
                    StringReplace[
                    "http://reference.wolfram.com/mathematica/\
AtomicDensityMatrix/tutorial/\
ThreeLevelSystemElectromagneticallyInducedTransparency.html", 
                    "http://reference.wolfram.com/mathematica/" -> 
                    "http://budker.berkeley.edu/ADM/"]], StandardForm]], 
                  StringReplace[
                  "Input", "http://reference.wolfram.com/mathematica/" -> 
                   "http://budker.berkeley.edu/ADM/"], TextClipboardType -> 
                  StringReplace[
                   "PlainText", "http://reference.wolfram.com/mathematica/" -> 
                    "http://budker.berkeley.edu/ADM/"]]}, Visible -> False]]; 
            SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
            FrontEndTokenExecute[DocumentationSearch`Private`nb$, 
              StringReplace[
              "Copy", "http://reference.wolfram.com/mathematica/" -> 
               "http://budker.berkeley.edu/ADM/"]]; 
            NotebookClose[DocumentationSearch`Private`nb$]; Null], 
          StringReplace[
           "Go to web url", "http://reference.wolfram.com/mathematica/" -> 
            "http://budker.berkeley.edu/ADM/"] :> FrontEndExecute[{
             NotebookLocate[{
               URL[
                StringJoin[
                 StringReplace[
                 "http://reference.wolfram.com/mathematica/", 
                  "http://reference.wolfram.com/mathematica/" -> 
                  "http://budker.berkeley.edu/ADM/"], 
                 StringReplace[
                 "AtomicDensityMatrix/tutorial/\
ThreeLevelSystemElectromagneticallyInducedTransparency", 
                  "http://reference.wolfram.com/mathematica/" -> 
                  "http://budker.berkeley.edu/ADM/"], 
                 StringReplace[
                 ".html", "http://reference.wolfram.com/mathematica/" -> 
                  "http://budker.berkeley.edu/ADM/"]]], None}]}]}, #, 2]& , 
        Evaluator -> Automatic], {
       1->"\<\"AtomicDensityMatrix/tutorial/\
ThreeLevelSystemElectromagneticallyInducedTransparency\"\>", 
       2->"\<\"Copy Mathematica url\"\>", Delimiter, 
       4->"\<\"Copy web url\"\>", 5->"\<\"Go to web url\"\>"}, 
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], 
       StyleBox[
        FrameBox["\<\"URL \[RightGuillemet]\"\>",
         StripOnInput->False],
        Background->Automatic],
       Appearance->Automatic,
       ImageSize->Automatic,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxAlignment->{"Columns" -> {{Left, Left, Right}}},
 GridBoxItemSize->{"Columns" -> {
     Scaled[0.05], 
     Scaled[0.3], {
      Scaled[0.64]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[CellGroupData[{

Cell["Three-level System: Electromagnetically Induced Transparency", "Title",
 CellID->509267359],

Cell[TextData[{
 "Consider an atomic \[CapitalLambda]-system: a three-level system with two \
same-parity lower states |1\[RightAngleBracket] and |2\[RightAngleBracket],  \
and an upper state |3\[RightAngleBracket] with opposite parity. A \
near-resonant light field consisting of two phase-coherent components of \
frequency ",
 Cell[BoxData[
  FormBox[
   StyleBox[
    SubscriptBox["\[Omega]", "a"], "InlineMath"], TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[
   StyleBox[
    SubscriptBox["\[Omega]", "b"], "InlineMath"], TraditionalForm]]],
 " is applied. When the difference frequency ",
 Cell[BoxData[
  FormBox[
   StyleBox[
    RowBox[{
     SubscriptBox[
      StyleBox["\[CapitalDelta]", "InlineMath"], 
      RowBox[{"a", "\[VeryThinSpace]", "b"}]], "=", 
     RowBox[{
      SubscriptBox["\[Omega]", "a"], "-", 
      SubscriptBox["\[Omega]", "b"]}]}], "InlineMath"], TraditionalForm]]],
 " is equal to the frequency splitting ",
 Cell[BoxData[
  FormBox[
   StyleBox[
    SubscriptBox["\[CapitalDelta]", "12"], "InlineMath"], TraditionalForm]]],
 " of the two lower levels (the Raman resonance condition), the system is \
pumped into a coherent superposition of the two lower states which no longer \
absorbs the bichromatic field. When one frequency component of the light \
field is much stronger than the other, it is referred to as a \"coupling\" or \
\"drive\" field, and the reduction of the absorption of the weaker probe \
field is called \"electromagnetically induced transparency\". Other names \
used to refer to this situation are \"dark resonance\" and \"coherent \
population trapping\". "
}], "Text",
 CellID->1534169418],

Cell["This loads the package.", "MathCaption",
 CellID->836781195],

Cell[BoxData[
 RowBox[{"<<", "AtomicDensityMatrix`"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->2058623809],

Cell[TextData[{
 "We define an atomic system consisting of two even-parity lower states and \
an odd-parity upper state. We apply a light field with components at \
frequencies ",
 Cell[BoxData[
  FormBox[
   StyleBox[
    SubscriptBox["\[Omega]", "a"], "InlineMath"], TraditionalForm]]],
 " (near resonant with the ",
 Cell[BoxData[
  StyleBox[
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"|", "1"}], "\[RightAngleBracket]"}], "\[Rule]", 
     RowBox[{"|", "3"}]}], "\[RightAngleBracket]"}], "InlineMath"]]],
 " transition) and ",
 Cell[BoxData[
  FormBox[
   StyleBox[
    SubscriptBox["\[Omega]", "b"], "InlineMath"], TraditionalForm]]],
 " (near resonant with the ",
 Cell[BoxData[
  StyleBox[
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"|", "2"}], "\[RightAngleBracket]"}], "\[Rule]", 
     RowBox[{"|", "3"}]}], "\[RightAngleBracket]"}], "InlineMath"]]],
 " transition)."
}], "Text",
 CellID->525777075],

Cell["Define the atomic system.", "MathCaption",
 CellID->429217524],

Cell[BoxData[
 RowBox[{
  RowBox[{"system", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"AtomicState", "[", 
      RowBox[{"1", ",", 
       RowBox[{"NaturalWidth", "\[Rule]", "0"}], ",", 
       RowBox[{"Parity", "\[Rule]", "Even"}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"AtomicState", "[", 
      RowBox[{"2", ",", 
       RowBox[{"NaturalWidth", "\[Rule]", "0"}], ",", 
       RowBox[{"Parity", "\[Rule]", "Even"}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"AtomicState", "[", 
      RowBox[{"3", ",", 
       RowBox[{"Energy", "\[Rule]", "0"}], ",", 
       RowBox[{
        RowBox[{"BranchingRatio", "[", "1", "]"}], "\[Rule]", 
        RowBox[{"1", "/", "2"}]}], ",", 
       RowBox[{
        RowBox[{"BranchingRatio", "[", "2", "]"}], "\[Rule]", 
        RowBox[{"1", "/", "2"}]}], ",", 
       RowBox[{"NaturalWidth", "\[Rule]", "\[CapitalGamma]"}], ",", 
       RowBox[{"Parity", "\[Rule]", "Odd"}]}], "]"}]}], "\[IndentingNewLine]",
     "}"}]}], ";"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->433132487],

Cell["Remove explicit time dependence from the density matrix.", "MathCaption",
 CellID->690131918],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SetOptions", "[", 
  RowBox[{"DensityMatrix", ",", 
   RowBox[{"TimeDependence", "\[Rule]", "False"}]}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->718931880],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"TimeDependence", "\[Rule]", "False"}], ",", 
   RowBox[{"Representation", "\[Rule]", "Zeeman"}], ",", 
   RowBox[{"DMSymbol", "\[Rule]", "\[Rho]"}], ",", 
   RowBox[{"DMLabel", "\[Rule]", "None"}], ",", 
   RowBox[{"ComplexExpandVariables", "\[Rule]", "False"}], ",", 
   RowBox[{"TimeVariable", "\[Rule]", "t"}]}], "}"}]], "Output",
 ImageSize->{446, 33},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->420618736]
}, Open  ]],

Cell["Here is what the density matrix looks like.", "MathCaption",
 CellID->272609152],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"DensityMatrix", "[", "system", "]"}], "//", 
  "MatrixForm"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->611420683],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      SubscriptBox["\[Rho]", 
       RowBox[{"1", ",", "1"}]], 
      SubscriptBox["\[Rho]", 
       RowBox[{"1", ",", "2"}]], 
      SubscriptBox["\[Rho]", 
       RowBox[{"1", ",", "3"}]]},
     {
      SubscriptBox["\[Rho]", 
       RowBox[{"2", ",", "1"}]], 
      SubscriptBox["\[Rho]", 
       RowBox[{"2", ",", "2"}]], 
      SubscriptBox["\[Rho]", 
       RowBox[{"2", ",", "3"}]]},
     {
      SubscriptBox["\[Rho]", 
       RowBox[{"3", ",", "1"}]], 
      SubscriptBox["\[Rho]", 
       RowBox[{"3", ",", "2"}]], 
      SubscriptBox["\[Rho]", 
       RowBox[{"3", ",", "3"}]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{109, 45},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]//MatrixForm=",
 CellID->401286723]
}, Open  ]],

Cell[TextData[{
 "Define the optical field with two frequencies, ",
 Cell[BoxData[
  FormBox[
   StyleBox[
    SubscriptBox["\[Omega]", "a"], "InlineMath"], TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[
   StyleBox[
    SubscriptBox["\[Omega]", "b"], "InlineMath"], TraditionalForm]]],
 "."
}], "MathCaption",
 CellID->133602844],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"field", "=", 
  RowBox[{
   RowBox[{"OpticalField", "[", 
    RowBox[{"\[Omega]a", ",", 
     RowBox[{"\[CapitalOmega]Ra", "/", 
      RowBox[{"ReducedME", "[", 
       RowBox[{"1", ",", 
        RowBox[{"{", 
         RowBox[{"Dipole", ",", "1"}], "}"}], ",", "3"}], "]"}]}]}], "]"}], 
   "+", 
   RowBox[{"OpticalField", "[", 
    RowBox[{"\[Omega]b", ",", 
     RowBox[{"\[CapitalOmega]Rb", "/", 
      RowBox[{"ReducedME", "[", 
       RowBox[{"2", ",", 
        RowBox[{"{", 
         RowBox[{"Dipole", ",", "1"}], "}"}], ",", "3"}], "]"}]}]}], 
    "]"}]}]}]], "Input",
 CellLabel->"In[5]:=",
 CellID->534530029],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    FractionBox[
     RowBox[{
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "\[ImaginaryI]"}], " ", "t", " ", "\[Omega]a"}]], " ", 
      "\[CapitalOmega]Ra"}], 
     RowBox[{"ReducedME", "[", 
      RowBox[{"1", ",", 
       RowBox[{"{", 
        RowBox[{"Dipole", ",", "1"}], "}"}], ",", "3"}], "]"}]], "+", 
    FractionBox[
     RowBox[{
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "\[ImaginaryI]"}], " ", "t", " ", "\[Omega]b"}]], " ", 
      "\[CapitalOmega]Rb"}], 
     RowBox[{"ReducedME", "[", 
      RowBox[{"2", ",", 
       RowBox[{"{", 
        RowBox[{"Dipole", ",", "1"}], "}"}], ",", "3"}], "]"}]]}], ",", "0", 
   ",", "0"}], "}"}]], "Output",
 ImageSize->{451, 36},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->448570257]
}, Open  ]],

Cell["\<\
The Hamiltonian for the system subject to the optical field. Each field is \
assumed to interact with only one transition\[LongDash]the other terms are \
set to zero.\
\>", "MathCaption",
 CellID->462076121],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MatrixForm", "[", 
  RowBox[{"H", "=", 
   RowBox[{
    RowBox[{"Expand", "@", 
     RowBox[{"Hamiltonian", "[", 
      RowBox[{"system", ",", 
       RowBox[{"ElectricField", "\[Rule]", "field"}]}], "]"}]}], "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"Cos", "[", 
         RowBox[{"t", " ", "\[Omega]a"}], "]"}], " ", 
        RowBox[{"ReducedME", "[", 
         RowBox[{"2", ",", 
          RowBox[{"{", 
           RowBox[{"Dipole", ",", "1"}], "}"}], ",", "3"}], "]"}]}], 
       "\[Rule]", "0"}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"Cos", "[", 
         RowBox[{"t", " ", "\[Omega]b"}], "]"}], " ", 
        RowBox[{"ReducedME", "[", 
         RowBox[{"1", ",", 
          RowBox[{"{", 
           RowBox[{"Dipole", ",", "1"}], "}"}], ",", "3"}], "]"}]}], 
       "\[Rule]", "0"}]}], "}"}]}]}], "]"}]], "Input",
 CellLabel->"In[6]:=",
 CellID->494599775],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"Energy", "[", "1", "]"}], "0", 
      RowBox[{
       RowBox[{"-", "\[CapitalOmega]Ra"}], " ", 
       RowBox[{"Cos", "[", 
        RowBox[{"t", " ", "\[Omega]a"}], "]"}]}]},
     {"0", 
      RowBox[{"Energy", "[", "2", "]"}], 
      RowBox[{
       RowBox[{"-", "\[CapitalOmega]Rb"}], " ", 
       RowBox[{"Cos", "[", 
        RowBox[{"t", " ", "\[Omega]b"}], "]"}]}]},
     {
      RowBox[{
       RowBox[{"-", "\[CapitalOmega]Ra"}], " ", 
       RowBox[{"Cos", "[", 
        RowBox[{"t", " ", "\[Omega]a"}], "]"}]}], 
      RowBox[{
       RowBox[{"-", "\[CapitalOmega]Rb"}], " ", 
       RowBox[{"Cos", "[", 
        RowBox[{"t", " ", "\[Omega]b"}], "]"}]}], "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{313, 43},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[6]//MatrixForm=",
 CellID->34586496]
}, Open  ]],

Cell["The level diagram for the system.", "MathCaption",
 CellID->358620443],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LevelDiagram", "[", 
  RowBox[{"system", ",", 
   RowBox[{"H", "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"Energy", "[", "1", "]"}], "\[Rule]", 
       RowBox[{"-", "1"}]}], ",", 
      RowBox[{
       RowBox[{"Energy", "[", "2", "]"}], "\[Rule]", 
       RowBox[{"-", "1.5"}]}]}], "}"}]}]}], "]"}]], "Input",
 CellLabel->"In[7]:=",
 CellID->167259034],

Cell[BoxData[
 GraphicsBox[{{{{}, LineBox[{{-0.9, -1}, {-0.09999999999999998, -1}}]}, {{}, 
     LineBox[{{-0.9, -1.5}, {-0.09999999999999998, -1.5}}]}, {{}, 
     LineBox[{{0.09999999999999998, 0}, {0.9, 0}}]}}, {{}, {}, {}}, 
   {Arrowheads[{-0.07659574468085106, 0.07659574468085106}], 
    ArrowBox[{{-0.45999999999999996`, -1}, {0.45999999999999996`, 0.}}], 
    ArrowBox[{{-0.45999999999999996`, -1.5}, {0.45999999999999996`, 0.}}]}, 
   {PointSize[0.0225]}},
  ImagePadding->{{2, 2}, {2, 2}},
  ImageSize->94.]], "Output",
 ImageSize->{98, 79},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[7]=",
 CellID->3804605]
}, Open  ]],

Cell["Apply the rotating-wave approximation to the Hamiltonian.", \
"MathCaption",
 CellID->577766068],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"Hrwa", "=", 
    RowBox[{"RotatingWaveApproximation", "[", 
     RowBox[{"system", ",", "H", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"\[Omega]a", ",", 
          RowBox[{"1", "\[Rule]", "3"}], ",", "\[CapitalDelta]a"}], "}"}], 
        ",", 
        RowBox[{"{", 
         RowBox[{"\[Omega]b", ",", 
          RowBox[{"2", "\[Rule]", "3"}], ",", "\[CapitalDelta]b"}], "}"}]}], 
       "}"}], ",", 
      RowBox[{"Method", "\[Rule]", "\"\<ShiftLowerState\>\""}]}], "]"}]}], 
   ")"}], "//", "MatrixForm"}]], "Input",
 CellLabel->"In[8]:=",
 CellID->353525722],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"\[CapitalDelta]a", "0", 
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]Ra", "2"]}]},
     {"0", "\[CapitalDelta]b", 
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]Rb", "2"]}]},
     {
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]Ra", "2"]}], 
      RowBox[{"-", 
       FractionBox["\[CapitalOmega]Rb", "2"]}], "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{121, 69},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[8]//MatrixForm=",
 CellID->175162430]
}, Open  ]],

Cell[TextData[{
 Cell[BoxData[
  ButtonBox["IntrinsicRelaxation",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/IntrinsicRelaxation"]], 
  "InlineFormula"],
 " and ",
 Cell[BoxData[
  ButtonBox["TransitRelaxation",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/TransitRelaxation"]], 
  "InlineFormula"],
 " supply the relaxation matrices."
}], "MathCaption",
 CellID->610306692],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MatrixForm", "[", 
  RowBox[{"relax", "=", 
   RowBox[{
    RowBox[{"IntrinsicRelaxation", "[", "system", "]"}], "+", 
    RowBox[{"TransitRelaxation", "[", 
     RowBox[{"system", ",", "\[Gamma]"}], "]"}]}]}], "]"}]], "Input",
 CellLabel->"In[9]:=",
 CellID->645617687],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"\[Gamma]", "0", "0"},
     {"0", "\[Gamma]", "0"},
     {"0", "0", 
      RowBox[{"\[Gamma]", "+", "\[CapitalGamma]"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{81, 43},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[9]//MatrixForm=",
 CellID->86682478]
}, Open  ]],

Cell[TextData[{
 Cell[BoxData[
  ButtonBox["OpticalRepopulation",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/OpticalRepopulation"]], 
  "InlineFormula"],
 " and ",
 Cell[BoxData[
  ButtonBox["TransitRepopulation",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/TransitRepopulation"]], 
  "InlineFormula"],
 " supply the repopulation matrices."
}], "MathCaption",
 CellID->854192725],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MatrixForm", "[", 
  RowBox[{"repop", "=", 
   RowBox[{
    RowBox[{"OpticalRepopulation", "[", "system", "]"}], "+", 
    RowBox[{"TransitRepopulation", "[", 
     RowBox[{"system", ",", "\[Gamma]"}], "]"}]}]}], "]"}]], "Input",
 CellLabel->"In[10]:=",
 CellID->465762594],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       FractionBox["\[Gamma]", "2"], "+", 
       RowBox[{
        FractionBox["1", "2"], " ", "\[CapitalGamma]", " ", 
        SubscriptBox["\[Rho]", 
         RowBox[{"3", ",", "3"}]]}]}], "0", "0"},
     {"0", 
      RowBox[{
       FractionBox["\[Gamma]", "2"], "+", 
       RowBox[{
        FractionBox["1", "2"], " ", "\[CapitalGamma]", " ", 
        SubscriptBox["\[Rho]", 
         RowBox[{"3", ",", "3"}]]}]}], "0"},
     {"0", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{185, 61},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[10]//MatrixForm=",
 CellID->397232309]
}, Open  ]],

Cell["Here are the evolution equations.", "MathCaption",
 CellID->314466782],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TableForm", "[", 
  RowBox[{"eqs", "=", 
   RowBox[{"LiouvilleEquation", "[", 
    RowBox[{"system", ",", "Hrwa", ",", "relax", ",", "repop"}], "]"}]}], 
  "]"}]], "Input",
 CellLabel->"In[11]:=",
 CellID->298399236],

Cell[GraphicsData["CompressedBitmap", "\<\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\
\>"], "Output",
 Evaluatable->False,
 ImageSize->{471, 213},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[11]//TableForm=",
 CellID->529778740]
}, Open  ]],

Cell[TextData[{
 Cell[BoxData[
  ButtonBox["Observables",
   BaseStyle->"Link",
   ButtonData->"paclet:AtomicDensityMatrix/ref/Observables"]], 
  "InlineFormula"],
 " supplies the absorption and phase shift experienced by the light in terms \
of the density-matrix elements."
}], "MathCaption",
 CellID->33276359],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"obs", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"Observables", "[", 
     RowBox[{"system", ",", 
      RowBox[{"Energy", "[", "1", "]"}], ",", 
      RowBox[{"\[CapitalOmega]Ra", "/", 
       RowBox[{"ReducedME", "[", 
        RowBox[{"1", ",", 
         RowBox[{"{", 
          RowBox[{"Dipole", ",", "1"}], "}"}], ",", "3"}], "]"}]}], ",", 
      RowBox[{"TransformMatrix", "\[Rule]", 
       RowBox[{"MatrixExp", "[", 
        RowBox[{
         RowBox[{"-", "\[ImaginaryI]"}], " ", "t", " ", 
         RowBox[{"DiagonalMatrix", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Energy", "[", "1", "]"}], ",", "0", ",", "0"}], "}"}], 
          "]"}]}], "]"}]}]}], "]"}], "/.", 
    RowBox[{
     RowBox[{"Energy", "[", "1", "]"}], "\[Rule]", 
     RowBox[{"2", 
      RowBox[{"\[Pi]", "/", "\[Lambda]"}]}]}]}], "//", 
   "FullSimplify"}]}]], "Input",
 CellLabel->"In[12]:=",
 CellID->14642222],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     FractionBox[
      RowBox[{"3", " ", "\[CapitalGamma]", " ", 
       SuperscriptBox["\[Lambda]", "2"], " ", 
       RowBox[{"Im", "[", 
        SubscriptBox["\[Rho]", 
         RowBox[{"1", ",", "3"}]], "]"}]}], 
      RowBox[{"8", " ", "\[Pi]", " ", "\[CapitalOmega]Ra"}]], ",", 
     RowBox[{"-", 
      FractionBox[
       RowBox[{"3", " ", "\[CapitalGamma]", " ", 
        SuperscriptBox["\[Lambda]", "2"], " ", 
        RowBox[{"Re", "[", 
         SubscriptBox["\[Rho]", 
          RowBox[{"1", ",", "3"}]], "]"}]}], 
       RowBox[{"8", " ", "\[Pi]", " ", "\[CapitalOmega]Ra"}]]}]}], "}"}], ",",
    
   RowBox[{"{", 
    RowBox[{"0", ",", "0"}], "}"}]}], "}"}]], "Output",
 ImageSize->{283, 34},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[12]=",
 CellID->446010804]
}, Open  ]],

Cell["\<\
Here is the probe absorption spectrum as a function of probe detuning.\
\>", "MathCaption",
 CellID->551099716],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"params", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"\[CapitalGamma]", "\[Rule]", "1"}], ",", 
     RowBox[{"\[Gamma]", "\[Rule]", ".01"}], ",", 
     RowBox[{"\[CapitalOmega]Ra", "\[Rule]", ".1"}], ",", 
     RowBox[{"\[CapitalOmega]Rb", "\[Rule]", ".5"}], ",", 
     RowBox[{"\[CapitalDelta]b", "\[Rule]", ".5"}], ",", 
     RowBox[{"\[Lambda]", "\[Rule]", "1"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"obs", "\[LeftDoubleBracket]", 
      RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}], "/.", "params"}], "/.",
     
    RowBox[{"Chop", "@", 
     RowBox[{
      RowBox[{"NSolve", "[", 
       RowBox[{
        RowBox[{"eqs", "/.", "params"}], ",", 
        RowBox[{"DMVariables", "[", "system", "]"}]}], "]"}], 
      "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"\[CapitalDelta]a", ",", 
     RowBox[{"-", "8"}], ",", "8"}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
   RowBox[{"Frame", "\[Rule]", "True"}], ",", 
   RowBox[{"FrameLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "\"\<Probe detuning \!\(\*SubscriptBox[\(\[CapitalDelta]\), \(a\)]\)/\
\[CapitalGamma]\>\"", ",", "\"\<\[CapitalDelta]E (arb. units)\>\""}], 
     "}"}]}]}], "]"}]}], "Input",
 CellLabel->"In[13]:=",
 CellID->889304850],

Cell[GraphicsData["CompressedBitmap", "\<\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\
\>"], "Output",
 Evaluatable->False,
 ImageSize->{180, 122},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[13]=",
 CellID->98617469]
}, Open  ]],

Cell["\<\
The increased transmission at the Raman resonance is associated with \
coherence induced between the |1\[RightAngleBracket] and |2\
\[RightAngleBracket] states. Here is a plot of the coherence as a function of \
probe frequency.\
\>", "MathCaption",
 CellID->517847783],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"params", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"\[CapitalGamma]", "\[Rule]", "1"}], ",", 
     RowBox[{"\[Gamma]", "\[Rule]", ".01"}], ",", 
     RowBox[{"\[CapitalOmega]Ra", "\[Rule]", ".1"}], ",", 
     RowBox[{"\[CapitalOmega]Rb", "\[Rule]", ".5"}], ",", 
     RowBox[{"\[CapitalDelta]b", "\[Rule]", ".5"}], ",", 
     RowBox[{"\[Lambda]", "\[Rule]", "1"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Im", "[", 
     SubscriptBox["\[Rho]", 
      RowBox[{"1", ",", "2"}]], "]"}], "/.", 
    RowBox[{"Chop", "@", 
     RowBox[{
      RowBox[{"NSolve", "[", 
       RowBox[{
        RowBox[{"eqs", "/.", "params"}], ",", 
        RowBox[{"DMVariables", "[", "system", "]"}]}], "]"}], 
      "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"\[CapitalDelta]a", ",", 
     RowBox[{"-", "8"}], ",", "8"}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
   RowBox[{"Frame", "\[Rule]", "True"}], ",", 
   RowBox[{"FrameLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "\"\<Probe detuning \!\(\*SubscriptBox[\(\[CapitalDelta]\), \(a\)]\)/\
\[CapitalGamma]\>\"", ",", 
      RowBox[{"Im", "[", 
       SubscriptBox["\[Rho]", 
        RowBox[{"1", ",", "2"}]], "]"}]}], "}"}]}]}], "]"}]}], "Input",
 CellLabel->"In[14]:=",
 CellID->26195282],

Cell[GraphicsData["CompressedBitmap", "\<\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\
\>"], "Output",
 Evaluatable->False,
 ImageSize->{180, 116},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[14]=",
 CellID->99816135]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "TutorialMoreAboutSection",
 CellElementSpacings->{"CellMinHeight"->3},
 CellFrameLabels->{{
    FEPrivate`If[
     FEPrivate`Or[
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 
     Cell[
     "MORE ABOUT", "TutorialMoreAboutSection", CellSize -> {5000, Inherited}],
      
     Cell[
      TextData[{
        Cell[
         BoxData[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {24, 0}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[24]]]], "More About"}], "TutorialMoreAboutSection", 
      CellSize -> {5000, Inherited}]], None}, {None, None}},
 CellFrameLabelMargins->0,
 CellSize->{Inherited, 
   FEPrivate`If[
    FEPrivate`Or[
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 11, 14]},
 "WholeCellGroupOpener" -> True,
 CellID->23220180],

Cell["", "SectionHeaderSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]],

Cell[TextData[ButtonBox["AtomicDensityMatrix Package",
 BaseStyle->"Link",
 ButtonData->
  "paclet:AtomicDensityMatrix/guide/AtomicDensityMatrix"]], \
"TutorialMoreAbout",
 CellID->1567025153],

Cell["", "SectionFooterSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "RelatedTutorialsSection",
 CellElementSpacings->{"CellMinHeight"->3},
 CellFrameLabels->{{
    FEPrivate`If[
     FEPrivate`Or[
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
      FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 
     Cell[
     "RELATED TUTORIALS", "RelatedTutorialsSection", 
      CellSize -> {5000, Inherited}], 
     Cell[
      TextData[{
        Cell[
         BoxData[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {24, 0}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[24]]]], "Related Tutorials"}], "RelatedTutorialsSection", 
      CellSize -> {5000, Inherited}]], None}, {None, None}},
 CellFrameLabelMargins->0,
 CellSize->{Inherited, 
   FEPrivate`If[
    FEPrivate`Or[
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
     FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 11, 14]},
 "WholeCellGroupOpener" -> True,
 CellID->415694126],

Cell["", "SectionHeaderSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]],

Cell[TextData[ButtonBox["Electromagnetically Induced Transparency and Atomic \
Polarization",
 BaseStyle->"Link",
 ButtonData->
  "paclet:AtomicDensityMatrix/tutorial/\
ElectromagneticallyInducedTransparencyAndAtomicPolarization"]], \
"RelatedTutorials",
 CellID->806871991],

Cell["", "SectionFooterSpacer",
 ShowCellBracket->False,
 ShowSelection->False,
 CellMargins->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 0, Inherited],
 CellElementSpacings->{"CellMinHeight"->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], 1, Inherited]},
 CellSize->FEPrivate`If[
   FEPrivate`Or[
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "6.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "7.0"], 
    FEPrivate`SameQ[FEPrivate`$ProductVersion, "8.0"]], {Inherited, 1}, 
   Inherited]]
}, Open  ]]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"Three-level System: Electromagnetically Induced Transparency - \
Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, 
  "Metadata" -> {
   "built" -> "{2014, 2, 28, 1, 43, 31.7941612}", "context" -> 
    "AtomicDensityMatrix`", "keywords" -> {"Atomic Density Matrix", "ADM"}, 
    "index" -> True, "label" -> "Atomic Density Matrix Tutorial", "language" -> 
    "en", "paclet" -> "AtomicDensityMatrix", "status" -> "None", "summary" -> 
    "Consider an atomic \\[CapitalLambda]-system: a three-level system with \
two same-parity lower states |1> and |2>, and an upper state |3> with \
opposite parity. A near-resonant light field consisting of two phase-coherent \
components of frequency \\[Omega]_a and \\[Omega]_b is applied. When the \
difference frequency \\[CapitalDelta]_a b=\\[Omega]_a-\\[Omega]_b is equal to \
the frequency splitting \\[CapitalDelta]_12 of the two lower levels (the \
Raman resonance condition), the system is pumped into a coherent \
superposition of the two lower states which no longer absorbs the bichromatic \
field. When one frequency component of the light field is much stronger than \
the other, it is referred to as a \"coupling\" or \"drive\" field, and the \
reduction of the absorption of the weaker probe field is called \
\"electromagnetically induced transparency\". Other names used to refer to \
this situation are \"dark resonance\" and \"coherent population trapping\". \
This loads the package. We define an atomic system consisting of two \
even-parity lower states and an odd-parity upper state. We apply a light \
field with components at frequencies \\[Omega]_a (near resonant with the \
|1>->|3> transition) and \\[Omega]_b (near resonant with the |2>->|3> \
transition).", "synonyms" -> {}, "title" -> 
    "Three-level System: Electromagnetically Induced Transparency", "type" -> 
    "Tutorial", "uri" -> 
    "AtomicDensityMatrix/tutorial/\
ThreeLevelSystemElectromagneticallyInducedTransparency"}, 
  "SearchTextTranslated" -> "", "SearchText" -> ""},
FrontEndVersion->"6.0 for Microsoft Windows (64-bit) (May 21, 2008)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"], 
   Cell[
    StyleData["TutorialMoreAboutSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}], 
   Cell[
    StyleData["RelatedTutorialsSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}], 
   Cell[
    StyleData["TutorialRelatedLinksSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}]}, Visible -> False, 
  FrontEndVersion -> "6.0 for Microsoft Windows (64-bit) (May 21, 2008)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[568, 21, 78, 1, 3, "TutorialColorBar"],
Cell[649, 24, 220, 5, 70, "LinkTrail"],
Cell[872, 31, 9416, 196, 70, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[10313, 231, 97, 1, 70, "Title",
 CellID->509267359],
Cell[10413, 234, 1661, 40, 70, "Text",
 CellID->1534169418],
Cell[12077, 276, 66, 1, 70, "MathCaption",
 CellID->836781195],
Cell[12146, 279, 108, 3, 70, "Input",
 CellID->2058623809],
Cell[12257, 284, 928, 31, 70, "Text",
 CellID->525777075],
Cell[13188, 317, 68, 1, 70, "MathCaption",
 CellID->429217524],
Cell[13259, 320, 1080, 28, 70, "Input",
 CellID->433132487],
Cell[14342, 350, 99, 1, 70, "MathCaption",
 CellID->690131918],
Cell[CellGroupData[{
Cell[14466, 355, 188, 5, 70, "Input",
 CellID->718931880],
Cell[14657, 362, 516, 13, 70, "Output",
 CellID->420618736]
}, Open  ]],
Cell[15188, 378, 86, 1, 70, "MathCaption",
 CellID->272609152],
Cell[CellGroupData[{
Cell[15299, 383, 150, 5, 70, "Input",
 CellID->611420683],
Cell[15452, 390, 1291, 41, 70, "Output",
 CellID->401286723]
}, Open  ]],
Cell[16758, 434, 339, 13, 70, "MathCaption",
 CellID->133602844],
Cell[CellGroupData[{
Cell[17122, 451, 642, 20, 70, "Input",
 CellID->534530029],
Cell[17767, 473, 910, 29, 70, "Output",
 CellID->448570257]
}, Open  ]],
Cell[18692, 505, 217, 5, 70, "MathCaption",
 CellID->462076121],
Cell[CellGroupData[{
Cell[18934, 514, 944, 29, 70, "Input",
 CellID->494599775],
Cell[19881, 545, 1385, 41, 70, "Output",
 CellID->34586496]
}, Open  ]],
Cell[21281, 589, 76, 1, 70, "MathCaption",
 CellID->358620443],
Cell[CellGroupData[{
Cell[21382, 594, 402, 13, 70, "Input",
 CellID->167259034],
Cell[21787, 609, 657, 14, 70, "Output",
 CellID->3804605]
}, Open  ]],
Cell[22459, 626, 102, 2, 70, "MathCaption",
 CellID->577766068],
Cell[CellGroupData[{
Cell[22586, 632, 651, 19, 70, "Input",
 CellID->353525722],
Cell[23240, 653, 1046, 31, 70, "Output",
 CellID->175162430]
}, Open  ]],
Cell[24301, 687, 424, 14, 70, "MathCaption",
 CellID->610306692],
Cell[CellGroupData[{
Cell[24750, 705, 294, 8, 70, "Input",
 CellID->645617687],
Cell[25047, 715, 820, 24, 70, "Output",
 CellID->86682478]
}, Open  ]],
Cell[25882, 742, 430, 14, 70, "MathCaption",
 CellID->854192725],
Cell[CellGroupData[{
Cell[26337, 760, 297, 8, 70, "Input",
 CellID->465762594],
Cell[26637, 770, 1165, 35, 70, "Output",
 CellID->397232309]
}, Open  ]],
Cell[27817, 808, 76, 1, 70, "MathCaption",
 CellID->314466782],
Cell[CellGroupData[{
Cell[27918, 813, 240, 7, 70, "Input",
 CellID->298399236],
Cell[28161, 822, 7199, 122, 70, "Output",
 Evaluatable->False,
 CellID->529778740]
}, Open  ]],
Cell[35375, 947, 313, 9, 70, "MathCaption",
 CellID->33276359],
Cell[CellGroupData[{
Cell[35713, 960, 941, 27, 70, "Input",
 CellID->14642222],
Cell[36657, 989, 887, 27, 70, "Output",
 CellID->446010804]
}, Open  ]],
Cell[37559, 1019, 121, 3, 70, "MathCaption",
 CellID->551099716],
Cell[CellGroupData[{
Cell[37705, 1026, 1408, 38, 70, "Input",
 CellID->889304850],
Cell[39116, 1066, 4426, 77, 70, "Output",
 Evaluatable->False,
 CellID->98617469]
}, Open  ]],
Cell[43557, 1146, 279, 6, 70, "MathCaption",
 CellID->517847783],
Cell[CellGroupData[{
Cell[43861, 1156, 1412, 39, 70, "Input",
 CellID->26195282],
Cell[45276, 1197, 3258, 57, 70, "Output",
 Evaluatable->False,
 CellID->99816135]
}, Open  ]],
Cell[CellGroupData[{
Cell[48571, 1259, 1107, 30, 70, "TutorialMoreAboutSection",
 CellID->23220180],
Cell[49681, 1291, 804, 18, 70, "SectionHeaderSpacer"],
Cell[50488, 1311, 192, 5, 70, "TutorialMoreAbout",
 CellID->1567025153],
Cell[50683, 1318, 804, 18, 70, "SectionFooterSpacer"]
}, Open  ]],
Cell[CellGroupData[{
Cell[51524, 1341, 1120, 30, 70, "RelatedTutorialsSection",
 CellID->415694126],
Cell[52647, 1373, 804, 18, 70, "SectionHeaderSpacer"],
Cell[53454, 1393, 274, 7, 70, "RelatedTutorials",
 CellID->806871991],
Cell[53731, 1402, 804, 18, 70, "SectionFooterSpacer"]
}, Open  ]]
}, Open  ]],
Cell[54562, 1424, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

